{*******************************************************************}
{                                                                   }
{    Staff Assignment form for assigning staff members to           }
{    team positions in Primary Care Management.                     }
{                                                                   }
{    Management Information Products Group                          }
{    Albany NY (SCK)                                                }
{    Dept. of Veteran Affairs                                       }
{    March 1996                                                     }
{                                                                   }
{    Last updated: 28 May 2002 (J. Peterson)                         }
{                                                                   }
{*******************************************************************}

unit Asgnstaf;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Fmcntrls, OvcSc, OvcBase, OvcDT, OvcData,
  OvcEF, OvcPB, OvcPF, OvcCal, Scutbrk, Scut2, Scut3, MFunstr,
  ExtCtrls, Scutdef, Pcmm1, Trpcb, Fmcmpnts, Menus, OvcDate {,Gtsize32,
  GTVASzr - PDR}, Diaccess, Fmlookup;

type
  TStaffRecord = Record
     Name : string[35];
     Ien  : string[20];
     Hien : string[20];
  end;


  TAssignRecord = Record
     Date   : string;
     Name   : string;
     Status : string;
     ListStr: string;
     img    : Tgraphic;
  end;


  TfrmStaff = class(TForm)
    Label3: TLabel;
    lstAssignments: TFMListBox;
    cmdStaffOk: TBitBtn;
    cmdStaffCancel: TBitBtn;
    cmdDeleteAssignment: TBitBtn;
    cmdClose: TBitBtn;
    cmdHelp: TBitBtn;
    grpDate: TGroupBox;
    lblStaffDate: TLabel;
    txtStaffDT: TOvcPictureField;
    lblStaffStatus: TLabel;
    cboStaffStatus: TFMComboBox;
    lblStaffReason: TLabel;
    cboStaffReason: TFMComboBox;
    txtStaffDate: TFMLabel;
    pnlCalendar: TPanel;
    Calendar: TOvcCalendar;
    imgYes: TImage;
    imgNo: TImage;
    GetStaff: TFMGets;
    ltrAssign: TFMLister;
    flrStaff: TFMFiler;
    OvcController1: TOvcController;
    ltrStaffReason: TFMLister;
    PopupMenu1: TPopupMenu;
    OvcDTSpin: TOvcSpinner;
    lblStaff: TLabel;
    lblStaffEntry: TFMLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    AssignMember1: TMenuItem;
    InactivateMember1: TMenuItem;
    hdrStaff: THeader;
    AssignMember2: TMenuItem;
    InactivateMember2: TMenuItem;
    N2: TMenuItem;
    DeleteAssignment1: TMenuItem;
    cmdAssign: TBitBtn;
    imgbtnYes: TImage;
    imgbtnNo: TImage;
    ltrStaffStatus: TFMLister;
    lkpPreceptor: TFMLookUp;
    FMValidator1: TFMValidator;
    lblFTEE: TLabel;
    FMEdit1: TFMEdit;
    {GTVAForm1: GTVAForm - PDR;}
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure cboStaffReasonChange(Sender: TObject);
    procedure cboStaffStatusChange(Sender: TObject);
    procedure txtStaffDTExit(Sender: TObject);
    procedure cmdStaffOkClick(Sender: TObject);
    procedure DeleteAssignmentClick(Sender: TObject);
    procedure cmdStaffCancelClick(Sender: TObject);
    procedure lstAssignmentsMeasureItem(Control: TWinControl;
     Index: Integer; var Height: Integer);
    procedure lstAssignmentsDrawItem(Control: TWinControl;
     Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure lstAssignmentsClick(Sender: TObject);
    procedure lstAssignmentsKeyDown(Sender: TObject;
     var Key: Word; Shift: TShiftState);
    procedure txtStaffDTKeyDown(Sender: TObject; var Key: Word;
     Shift: TShiftState);
    procedure PopUpCalendar(Sender: TObject);
    procedure ChangeMonth(Sender: TObject);
    procedure CalendarClick(Sender: TObject);
    procedure CalendarKeyDown(Sender: TObject; var Key: Word;
     Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure cmdCloseClick(Sender: TObject);
    procedure cboKeyDown(Sender: TObject; var Key: Word;
     Shift: TShiftState);
    procedure lstAssignmentsExit(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure RPCBroker1NetError(Sender: TObject; var Error: EBrokerError);
    procedure AssignMember1Click(Sender: TObject);
    procedure UpdateMenus(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure InactivateMember1Click(Sender: TObject);
    procedure OvcDTSpinClick(Sender: TObject; State: TOvcSpinState;
      Delta: Double; Wrap: Boolean);
    procedure cboStaffReasonExit(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmdHelpClick(Sender: TObject);
    procedure txtStaffDTChange(Sender: TObject);
    procedure FMEdit1Exit(Sender: TObject);
    procedure FMEdit1KeyPress(Sender: TObject; var Key: Char);

  private
    { Private declarations }
    SList : TStringList;
    pf: TOvcPictureField;
    NewAssign, NetError, DeleteKey : Boolean;
    CurrNdx : integer;
    flrStaffFMMode:FMModes;
    flrStaffUpdateIen: string;
    function SetDateVal : string;
    procedure PreceptHistMods;
    procedure ParseHistStr(s1: string);
    function ValidFMData: boolean;
  public
    { Public declarations }
    Staff: TStaff;
    StaffRec : TStaffRecord;
    function Execute(tprf: TProfile): boolean;
    function StaffReasonChangeOk: boolean;
    function StatusStaffChangeOk(status: integer): boolean;
    function StaffDateChangeOk: boolean;
    procedure SetStaffButtons(Sok: boolean; Scncl: boolean; Sadd: boolean;
     Sdel: boolean);
    function AddNewStaff: boolean;
    procedure DisableStaff(status: boolean);
    procedure LoadStaff;
    function DeleteStaffOk: boolean;
    function CheckReqd: boolean;
    procedure LoadSettings;
    procedure FormLoad;
  end;

Const
  DEBUG = false;

var
  frmStaff:     TfrmStaff;
  ParentShow:   boolean;
  psProfile:    TProfile;
  AssignRecord: TAssignRecord;

implementation

uses Pstndef1, Stafflkp, PreceptorLkp;

{$R *.DFM}

function TfrmStaff.Execute(tprf: TProfile): boolean;
var
  frm: TfrmStaff;
begin
  Result := False ;
  try
     frmMain.AssignStaff1.enabled := false;
     ParentShow := frmMain.ShowMenu;
     frmMain.ShowMenu := false;
     PsProfile := tprf;
     frm := TfrmStaff.Create(self);
     {Application.Handle := PsProfile.handle;}
     frm.show;
     {frm.FormLoad;}
     result := true;
  except
     on E: Exception do
        messageDlg(E.Classname, mtWarning, [mbOk], 0);
  end;
end;

procedure TfrmStaff.FormResize(Sender: TObject);
begin
  Clientwidth := 492;
end;

procedure TfrmStaff.FormLoad;
begin
  {frmMain.AssignStaff1.enabled := false;
  ParentShow := frmMain.ShowMenu;
  frmMain.ShowMenu := false;}
  {Font.Assign(FrmMain.FontDialog1.Font);
  SList := TStringList.Create;
  NetError := false;
  LoadSettings;}
end;

procedure TfrmStaff.FormCreate(Sender: TObject);
begin

  Font.Assign(FrmMain.FontDialog1.Font);
  SList := TStringList.Create;
  NetError := false;
  LoadSettings;
  cmdHelp.HelpContext := 41600;
  //bp/cmf 177
  if PsProfile.Link = true then
   begin
    FMEdit1.Visible := False;
    lblFTEE.Visible := False;
    PreceptHistMods;
   end;
   if psProfile.Link <> true then
      begin
      FMEdit1.Visible := True;
      lblFTEE.Visible := True;
      end;
   psProfile.PC := Piece(GlobalNode(RPCBrokerMain,'^SCTM(404.57,'+ psProfile.PositionIen + ',0)'),U,4);
   FMEdit1.Enabled := False;
  //bp/cmf 177
end;

procedure TfrmStaff.LoadSettings;
begin
  DeleteKey := SecurityKeyOk(RPCBrokerMain, DELETE_KEY);
end;

//bp/cmf 177 runtime edit FMControls to point to 404.53
procedure TfrmStaff.PreceptHistMods;
var
scfile: string;
begin
  Caption := 'Preceptor Assignment Add/Edit';
  scfile := '404.53';
  cmdHelp.HelpContext := 41150;

  with GetStaff do
   begin
    FileNumber := scfile;
    FieldNumbers.SetText('.01' + #13 +
                         '.04' + #13 +
                         '.05' + #13 +
                         '.06' + #13 +
                         '.02' + #13);
   end;

  with ltrAssign do
   begin
    FileNumber := scfile;
    FieldNumbers.SetText('.01' + #13 +
                         '.02' + #13 +
                         '.04' + #13 +
                         '.05' + #13 +
                         '.06' + #13);
    DisplayFields.SetText('.01' + #13 +
                          '.06' + #13);
   end;

  ltrStaffReason.Screen := 'IF $$RSNDICS^SCAPMCU1("ZM6")';

  ltrStaffStatus.FileNumber := scfile;

  with lstAssignments do
   begin
    FMFile := scfile;
    FMField := '.06';
   end;

  with lblStaffEntry do
   begin
    FMFile := scfile;
    FMField := '.06';
   end;

  txtStaffDate.FMFile := scfile;

  cboStaffStatus.FMFile := scfile;

  cboStaffReason.FMFile := scfile;

end;
//bp/cmf 177

procedure TfrmStaff.FormShow(Sender: TObject);
begin
  NetError := false;
  if not (psProfile.Parent = nil) then
     (psProfile.Parent as TForm).enabled := false;

  hdrStaff.Sections[1] := psProfile.TeamName;
  hdrStaff.Sections[3] := psProfile.PositionName;
  cboStaffReason.GetList;
  LoadStaff;
  UpdateMenus(nil) ;
end;

procedure TfrmStaff.FormClose(Sender: TObject; var Action: TCloseAction);
begin

  if not (PsProfile.Parent = nil) then
   begin
     (PsProfile.Parent as TForm).enabled := true;
     //bp/cmf 177
     //orig/frmassigned.cmdAssignStaff.Enabled := true;

       with frmAssigned do
        begin
         cmdAssignStaff.Enabled := true;
         cmdPreceptor.Enabled := true;
         getTeamPosition;
        end;
  //bp/cmf 177 begin
  with frmMain do
   begin
    ShowMenu := ParentShow;
    //AssignStaff1.enabled := true;
   end;
  {///bp/cmf 177/ orig code begin
  frmMain.ShowMenu := ParentShow;
  frmMain.AssignStaff1.enabled := true;
  ///bp/cmf 177/ orig code end}
  //bp/cmf 177 end
  Action := cafree;
end;
end;


procedure TfrmStaff.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin

  if not NetError then
     case CheckSave(flrStaff) of
        Save: CMdStaffOkClick(Sender);
        Abort: CanClose := false;
     end;
  //bp/cmf 177 begin
   if not frmAssigned.getteamposition then
    begin
     showmessage('Unable to validate preceptor link variables');
     exit;
    end;

   if PsProfile.PreceptorB then
     begin
      if (frmAssigned.FMlblPreceptor.Caption = '')
       and (flrStaffUpdateIen <> '')
       and PsProfile.Link then
        begin
         if messagedlg('Position requires a preceptor.' + #13 +
             'Changes will not be saved if you click OK.',
             mtWarning,
             [mbOK,mbCancel],0) = mrCancel then
              begin
               CanClose := false;
               exit;
              end;
           if Deleter(RPCBrokerMain,
             '^SCTM(404.53,', flrStaffUpdateIen)
            then frmMain.StatusMsg(
             'Preceptor change deleted.', false)
            else frmMain.StatusMsg(
             'Preceptor change not deleted.  <<Error>>', true);
        {if PsProfile.DeleteKey then
         begin
          if Messagedlg('A precepted Team Position with Patient Assignment(s) ' + #13 +
                        'made after the position became precepted' + #13 +
                        'must always have an assigned Preceptor Position.' + #13 +
                        'Do you wish to exit without an assigned Preceptor?',
                        mtWarning,[mbNo,mbYes],0)
           = mrNo then
                       begin
                        CanClose := false;
                        Exit;
                       end;

         end
        else
         begin
          showmessage('A precepted Team Position with Patient Assignment(s)' + #13 +
                      'made after the position became precepted' + #13 +
                      'must always have an assigned Preceptor Position.' + #13 +
                      'You will be returned to the Preceptor Assignment screen');
          CanClose := false;
          cmdAssign.Enabled := true;
          exit;
         end;}
       end;
     end; //if preceptorb

    if PsProfile.LinkActive then
     begin
      if(frmAssigned.hdrStats.Sections[5] =
          'No Current Staff Member')
       and not PsProfile.PreceptorB
       and (flrStaffUpdateIen <> '') then
        begin
         if messagedlg('Preceptor Position requires a staff assignment.' + #13 +
             'Changes will not be saved if you click OK.',
             mtWarning,
             [mbOK,mbCancel],0) = mrCancel then
              begin
               CanClose := false;
               exit;
              end;
           if Deleter(RPCBrokerMain,
             '^SCTM(404.52,', flrStaffUpdateIen)
            then frmMain.StatusMsg(
             'Staff change deleted.', false)
            else frmMain.StatusMsg(
             'Staff change not deleted.  <<Error>>', true);
      end;//if PsProfile.LinkActive
     end;
    {if PsProfile.LinkActive then
     begin
      if frmAssigned.hdrStats.Sections[5] =
       'No Current Staff Member' then
       begin
        if PsProfile.DeleteKey then
         begin
          if Messagedlg('A Preceptor Team Position' + #13 +
                        'must always have a Staff Assignment.' + #13 +
                        'Do you wish to exit without staff assigned?',
                        mtWarning,[mbNo,mbYes],0)
           = mrNo then
                       begin
                        CanClose := false;
                        Exit;
                       end;
         end
        else
         begin
          showmessage('A Preceptor Team Position' + #13 +
                      'must always have a Staff Assignment.' + #13 +
                      'You will be returned to the Staff Assignment screen');
          CanClose := false;
          cmdAssign.Enabled := true;
          exit;
        end;
       end;
     end; //if LinkActive}

  //bp/cmf 177 end
end;

procedure TfrmStaff.FormDestroy(Sender: TObject);
var
  i : integer;
begin
  SList.free;

  {if frmAssigned.visible then
     frmAssigned.cmdAssignStaff.enabled := true;}

end;
{ @@@
  Load staff history for position into lstAssignment list box. Load active
  staff member into staff record and display information.

  SList:  TStringlist of staff assignments.
  string Format:
     History Ien,(#404.52) ^ .01  Position ^ .02  Effective Date ^
       .03  Staff Member ^ .04  Status ^ .05  Status Reason

  ActiveStaff Format:
}
procedure TfrmStaff.LoadStaff;
var
  i, index: integer;
  s1, s2: string;
  img: TGraphic;
begin
  getStaff.ClearCtrlData;
  txtStaffDt.AsString := emptystr;
  lstAssignments.clear;

  //bp/cmf 177
  with ltrAssign do
    begin
     Screen := 'IF $P(^(0),U,1)="'
               + PsProfile.PositionIen + '"';
     with Partlist do
      begin
       Clear;
       Insert(0,PsProfile.PositionName);
      end;
     GetList(nil);

  if results.count > 0 then
     begin
        for i := 0 to pred(results.count) do
           begin
              ParseHistStr(GetFMDelimRec(ltrAssign,i));
              lstAssignments.items.AddObject
               (AssignRecord.ListStr, AssignRecord.img);
           end;
     end;
    end;
  {//bp/cmf 177 orig begin
  ltrAssign.Screen := 'IF $P(^(0),U,1)="' + PsProfile.PositionIen + '"';
  ltrAssign.Partlist.clear;
  ltrAssign.Partlist.Insert(0,PsProfile.PositionName);
  ltrAssign.GetList(nil);

  if ltrAssign.results.count > 0 then
     begin
        for i := 0 to pred(ltrAssign.results.count) do
           begin
              //bp/cmf debug hack
              messagedlg(GetFMDelimRec(ltrAssign,i),mtInformation,[mbok],0);
              //bp/cmf debug hack
              s1 := '  '  + FMDateToStr(ExtDateToFM(Piece(GetFMDelimRec(ltrAssign,i), U, 3))) +
                    ' - ' + Piece(GetFMDelimRec(ltrAssign,i), U, 4);
              if Piece(GetFMDelimRec(ltrAssign,i), U, 5) = 'ACTIVE' then
                 img := imgYes.Picture.graphic
              else
                 img := imgNo.Picture.graphic;
              lstAssignments.items.AddObject(s1, img)

           end;
     end;
  //bp/cmf 177 orig end}
  //bp/cmf 177

  DisableStaff(true);
  flrStaff.CLear;
  SetStaffButtons(false, false, true, false);
end;

//bp/cmf 177
procedure TfrmStaff.ParseHistStr(s1: string);
begin
 with AssignRecord do
  begin
   Date := FMDateToStr(ExtDateToFM(Piece(s1, U, 3)));
   if PsProfile.Link = true then  //404.53
    begin
     Name := Piece(s1, U, 6);
     Status := Piece(s1, U, 4);
    end
   else //404.52
    begin
     Name := Piece(s1, U, 4);
     Status := Piece (s1, U, 5);
    end;
   ListStr := ' ' + Date + ' - ' + Name;
   if Status = 'ACTIVE' then
      img := imgYes.Picture.Graphic
   else img := imgNo.Picture.Graphic;
  end;
end;
//bp/cmf 177

{
  Change action for the Staff assignment reason list box.
}
procedure TfrmStaff.cboStaffReasonChange(Sender: TObject);
begin
  if not cboStaffReason.FMModified then exit;

  if StaffReasonChangeOk then
     begin
        cboStaffReason.FMCtrlInternal{FMInternal - PDR} :=
          Piece(GetFMDelimRec(cboStaffReason.FMLister,cboStaffReason.ItemIndex), '^', 1);{Piece(cboStaffReason.FMLister.Results[cboStaffReason.ItemIndex], '^', 1); - PDR}
        cmdStaffOk.enabled := ((cboStaffStatus.ItemIndex > -1) and
          (txtStaffDT.AsString <> '') and not (lblStaffEntry.Caption = emptyStr));
        if cmdStaffOk.enabled then cmdStaffOk.SetFocus;
     end
  else
     begin
        cboStaffReason.ItemIndex := cboStaffReason.FMTag;
        cboStaffReason.FMModified := false;
     end;
end;

{
  confirm that changing the staff assignment reason is ok.  This function
  call is reserved for a future release
}
function TfrmStaff.StaffReasonChangeOk: boolean;
begin
  result := true;
end;

{
  Change the status for the Staff assignment if ok to do so.
}
procedure TfrmStaff.cboStaffStatusChange(Sender: TObject);
begin
  if cmdStaffCancel.focused then exit;

  if not cboStaffStatus.FMmodified then exit;

  if StatusStaffChangeOk(cboStaffStatus.ItemIndex) then
     begin
        cboStaffStatus.FMCtrlInternal{FMInternal - PDR} := IntToStr(cboStaffStatus.ItemIndex);
        cmdStaffOk.enabled := ((cboStaffReason.ItemIndex > -1) and
              (txtStaffDT.AsString <> '') and not (lblStaffEntry.Caption = emptyStr));
     end
  else
     begin
        cboStaffStatus.ItemIndex := cboStaffStatus.FMTag;
        cboStaffStatus.FMModified := false;
        cboStaffStatus.SetFocus;
     end;
end;

{  @@@ confirm API
  updated 1/15/96
  Confirm that changing the status of a staff member is ok.  For a new staff
  assignment call the API for a new assignment, otherwise, call the API for
  changing an assignment.
}
function TfrmStaff.StatusStaffChangeOk(status: integer): boolean;
var
  msg: string;
begin
  msg := '';
  result := true;

  if NewAssign then
     result := HistoryStatusOk(RPCBrokerMain, cboStaffStatus.FMFile,
         PsProfile.PositionIen, StrToFMDate(txtStaffDT.AsString), Status, msg);

  if length(msg) > 0 then
     frmMain.StatusMsg(msg, true);
end;

{  updated 1/10/96
   On exiting the staff date edit field, hide the calendar if it's still
  visible.  Exit the procedure if the next active gadget is the
  cancel button.  If the date entered is valid, and is different
  from the current date, then update the  date field and set the
  Ok  button enabled properties.
}
procedure TfrmStaff.txtStaffDTExit(Sender: TObject);
begin
  if ActiveCOntrol = cmdStaffCancel then exit;
  if ActiveControl = cmdClose then exit;//bp/cmf 204
  if Calendar.focused then exit;

  if pnlCalendar.Visible then
     pnlCalendar.visible := false;

 if (CompareText(StrToFMDate(txtStaffDT.asString),
              txtStaffDate.FMCtrlInternal ) = 0) then exit;

 if txtStaffDT.isValid then
     begin
        if StaffDateChangeOk then
           begin
              cmdStaffOk.Enabled := true;
              if not NewAssign then
                 begin
                    if messagedlg(
                       'You are changing the date of an existing Assignment.  This'
                       + RETURN +
                       'may cause problems with other applications that rely on '
                       + RETURN +
                       'this information.   Do you wish to continue?',
                       mtConfirmation, [mbYes,mbCancel,mbHelp], 80000) = mrCancel then
                       begin
                          txtStaffDT.asString := FMToStr(txtStaffDate.FMCtrlInternal);
                          exit;
                       end;
                 end;

              txtStaffDate.FMCtrlInternal := StrToFMDate(txtStaffDT.AsString);
              cmdStaffOk.enabled := ((cboStaffReason.ItemIndex > -1) and
              (cboStaffStatus.ItemIndex > -1) and not (lblStaffEntry.Caption = emptystr));
           end
        else
           begin
            txtStaffDT.AsString := txtStaffDate.FMCtrlInternal;

            txtStaffDT.SetFocus;
            setStaffButtons(false,true,false,false);
            
           end;
     end
  else
     frmMain.StatusMsg('Invalid Date',true);
     txtStaffDT.SetFocus;
end;

{ @@@ Confirm API
  updated 1/15/96
  Call API to confirm changing the date is ok
}
function TfrmStaff.StaffDateChangeOk: boolean;
var
  msg: string;
begin
  if NewAssign then
     result := NewHistoryOk(RPCBrokerMain, cboStaffStatus.FMFile,
              PsProfile.PositionIen, StrToFMDate(txtStaffDt.AsString), msg)
  else
     result := HistoryChangeOk(RPCBrokerMain, cboStaffStatus.FMFile,
             PsProfile.PositionIen, Piece(GetFMDelimRec(ltrAssign,CurrNdx),'^',1),
             StrToFMDate(txtStaffDT.AsString), msg);

  if length(msg) > 0 then
   begin
     frmMain.StatusMsg(msg, true);
   end;
end;

{ New 1/15/96
  set enabled status of command buttons on the staff assignment tab page.
}
procedure TfrmStaff.SetStaffButtons(Sok: boolean; Scncl: boolean;
          Sadd: boolean; Sdel: boolean);
begin
  cmdStaffOk.enabled := Sok;
  cmdStaffCancel.Enabled := Scncl;
end;

{ @@@  Confirm API
  check rules to see if it's okay to add another staff member.  ie. if there
  is already an active, staff member, do not allow another active member.
}
function TfrmStaff.AddNewStaff: boolean;
begin
  result := true;
end;

{  updated 1/15/96
  Add staff entry to the display list, lstAssigned, and add data to the fmfiler
  for processing with the save action.  Disable the Ok and cancel buttons, enable
  the form save and undo buttons.
}
procedure TfrmStaff.cmdStaffOkClick(Sender: TObject);
//bp/cmf 177
var
scfile: string;
s: string;
begin
 if PsProfile.Link = true
  then
   begin
    scfile := '404.53';
    s := 'Preceptor';
   end
  else
   begin
    scfile := '404.52';
    s := 'Staff';
   end;
  //bp/cmf 204 change begin
  if not StaffDateChangeOk then
   begin
    txtStaffDt.SetFocus;
    exit;
   end;

   //bp/cmf 204 change end
   if ValidFMData then
    if newAssign then
     with flrStaff do
      begin
       AddFDA(scfile,NEW_ENTRY,'.01', PsProfile.PositionIen);
       AddChgdControl(lblStaffEntry);
       AddChgdControl(cboStaffReason);
       AddChgdControl(txtStaffDate);
       AddChgdControl(cboStaffStatus);
       AddChgdControl(FMEdit1);
       if Update then
        begin
         frmMain.StatusMsg(s + ' Assignment filed', false);
         flrStaffUpdateIen := FindIen('+1,');
         NewAssign := false;
         LoadStaff;
         if not (PsProfile.Parent = nil) then
            frmAssigned.LoadStaff;
      end
    else
      messageDlg(s + ' Assignment was not updated!',
                 mtWarning, [mbOk,mbHelp], 80000);
     end;//with flrStaff
   setStaffButtons(false,false,true,false);
   FMEdit1.Enabled := FALSE;
   UpdateMenus(nil) ;
   cmdAssign.Enabled := True ;
end;

function TfrmStaff.ValidFMData: boolean;
var
s,se,si: string;
scfile: string;
begin
 result := true;

 if PsProfile.Link = true
  then scfile := '^SCTM(404.57,'
   else scfile := '^VA(200,';

 with lblStaffEntry do
  begin
   se := Caption;
   si := FMCtrlInternal;
  end;

  s := '';
   if si <> ''
    then s := piece(globalnode(RPCBrokerMain,scfile+si+',0)'),U,1);
  if s = UNDEFINED_NODE then s := '';
  if s = ''  then
   begin
    result := false;
    MessageDlg('[' + se +
               '] ' + ' is not a valid name.'
               ,mtWarning,[mbOk],0);
    exit;
   end;
end;

{
  disable staff assignment edit fields.
}
procedure TfrmStaff.DisableStaff(status: boolean);
begin
  OvcDTSpin.enabled := not status;
  cboStaffReason.enabled := not status;
  txtStaffDT.enabled := not status;
  cboStaffStatus.enabled := not status;
end;

{
  Delete Staff assignment
}
procedure TfrmStaff.DeleteAssignmentClick(Sender: TObject);
var
scfile: string;
s: string;
begin
 if PsProfile.Link = true
  then
   begin
    exit;//bp/cmf remove exit to allow preceptor assignment deletions
    scfile := '404.53';
    s := 'Preceptor';
   end
  else
   begin
    scfile := '404.52';
    s := 'Staff';
   end;
 {if cboStaff.text = '' then exit;}

  if DeleteStaffOk then
     begin
        if messagedlg('You are about to delete the ' +
                      s + ' assignment for ' +
                      lblStaffEntry.Caption + '.' + #13 +
                      'Do you want to do this?',
                      mtConfirmation, [mbYes,mbNo], 0)
        = mrYes then
           //bp/cmf 177/if Deleter(RPCBrokerMain, '^SCTM(404.52,',
           if Deleter(RPCBrokerMain, '^SCTM(' + scfile + ',',
            Piece(GetFMDelimRec(LtrAssign,CurrNdx), U, 1))
            then
             begin
              frmMain.StatusMsg(s + ' assignment deleted.', false);
              LoadStaff;
             end
            else
             messageDlg(s + ' entry was not deleted!', mtWarning, [mbOk], 0);
     end
  else
     begin
        frmMain.StatusMsg(s + ' assignment cannot be deleted.', false);
     end;

  if not (psProfile.Parent = nil) then
     frmAssigned.LoadStaff;

  SetStaffButtons(false, false, false, false);
  UpdateMenus(nil) ;
  DisableStaff(true);
end;

{ @@@ Confirm API

}
function TfrmStaff.DeleteStaffOk: boolean;
var
  msg: string;

begin

  result := DeleteHistoryOk(RPCBrokerMain, cboStaffStatus.FMFile,
                            psProfile.PositionIen,
                            Piece(GetFMDelimRec(LtrAssign,CurrNdx),
                             U, 1), msg);

  if length(msg) > 0 then
     frmMain.StatusMsg(msg, true);
end;

{ ***
  Cancel the addiiton of a new staff member to the position
}
procedure TfrmStaff.cmdStaffCancelClick(Sender: TObject);
begin
  try
    if pnlCalendar.Visible then
        pnlCalendar.visible := false;

     SetStaffButtons(false, false, true, false);
     getStaff.ClearCtrlData;
     txtStaffDT.AsString := emptyStr;
     cboStaffStatus.FMCtrlInternal
                   := IntToStr(cboStaffStatus.FMTag);
     cboStaffReason.FMCtrlInternal
                   := IntToStr(cboStaffReason.FMTag);
     DisableStaff(true);
     cmdAssign.Enabled := True ;
     FMEdit1.Enabled := FALSE;
  except
     on E: Exception do
        MessageDlg('Error: ' + E.ClassName + ' in Staff list', mtInformation,
              [mbok], 0);
  end;
end;

{
  set height of list items in the staff selection list.
}
procedure TfrmStaff.lstAssignmentsMeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
  Height := 20;
end;

{
  draw appropriate icon for list item and add date and staff member's name
  to the list.
}
procedure TfrmStaff.lstAssignmentsDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  bm: TBitmap;
begin
  with (Control as TFMListBox).Canvas do
     begin
        FillRect(Rect);
        bm := TBitmap(lstAssignments.Items.Objects[Index]);

        if bm <> nil then
           begin
              BrushCopy(Bounds(Rect.Left + 2, Rect.Top + 2, bm.Width,
                 bm.Height), bm, Bounds(0, 0, bm.Width, bm.Height),
                 clBackground);
              TextOut(Rect.Left + 2 + bm.width, Rect.Top + 2,
              lstAssignments.Items[index]);
           end;
     end;
end;

{  updated 1/15/96
  select and load staff edit fields with data for the selected staff assignment
}
procedure TfrmStaff.lstAssignmentsClick(Sender: TObject);
begin
  CurrNdx := lstAssignments.ItemIndex;
  getStaff.IENS :=Piece(GetFMDelimRec(ltrAssign,CurrNdx{bp/cmf 177/lstAssignments.ItemIndex}), U, 1);
  getStaff.GetAndFill;
  txtStaffDT.AsString := FMDateToStr(txtStaffDate.FMCtrlInternal);
  disableStaff(false);
  cboStaffStatus.enabled := false;
  SetStaffButtons(false, true,false, true);
end;

{
  trigger double click event from key board
}
procedure TfrmStaff.lstAssignmentsKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_SPACE then lstAssignmentsClick(Sender);
end;

procedure TfrmStaff.txtStaffDTKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = VK_F2 then PopUpCalendar(txtStaffDT);
end;

function TfrmStaff.CheckReqd: boolean;
var
  i: integer;
begin
  result := true;
  for i := 0 to ComponentCount - 1 do
     begin
        if Components[i] is TFMEdit then
           begin
              if TFMEdit(Components[i]).FMRequired and
                 (TFMEdit(Components[i]).Text = '') then
                 begin
                    result := false;
                    exit;
                 end;
           end

        else if Components[i] is TFMComboBox then
           begin
              if TFMComboBox(Components[i]).FMRequired and
                (TFMComboBox(Components[i]).Text = '') then
                 begin
                    result := false;
                    exit;
                 end;
           end

        else if Components[i] is TFMComboBoxLookUp then
           begin
              if TFMComboBoxLookUp(Components[i]).FMRequired and
                (TFMComboBoxLookUp(Components[i]).Text = '') then
                 begin
                    result := false;
                    exit;
                 end;
           end;
     end;
end;


{

}
procedure TfrmStaff.PopUpCalendar(Sender: TObject);
var
  d: TOvcDate;
begin
  pf := TOvcPictureField(Sender);

  if pnlcalendar.visible then
        pnlCalendar.visible := false
  else begin
     pnlCalendar.top := hdrStaff.Height + (pf.Top + pf.Height);
     pnlCalendar.left := grpDate.left + pf.left;
     d := pf.AsOvcDate;
     if d = BadDate then
        d := CurrentDate;
     Calendar.AsStDate := d;
     pnlCalendar.visible := true;
     Calendar.Setfocus;
  end;
end;

procedure TfrmStaff.ChangeMonth(Sender: TObject);
begin
end;


{

}
procedure TfrmStaff.CalendarClick(Sender: TObject);
begin
  pf.AsOvcDate := Calendar.AsStDate;
  pnlCalendar.visible := false;
  pf.Setfocus;
  setStaffButtons(staffDateChangeOK,true,false,false);
end;

{

}
procedure TfrmStaff.CalendarKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_SPACE then CalendarClick(Sender);
end;

procedure TfrmStaff.cboKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ShowDropDown(Sender, key, shift);
end;


procedure TfrmStaff.cmdCloseClick(Sender: TObject);
begin
  Close;
end;


procedure TfrmStaff.lstAssignmentsExit(Sender: TObject);
begin
  lstAssignments.ItemIndex := -1;
end;

procedure TfrmStaff.PopupMenu1Popup(Sender: TObject);
begin
  UpdateMenus(nil);
end;

procedure TfrmStaff.RPCBroker1NetError(Sender: TObject;
  var Error: EBrokerError);
var
  msg: string;
begin
  msg := 'A Network error has been encountered.  Please make' + RETURN +
         'a note of your current entry.  You will need to' + RETURN +
         'logon to VistA before continuing';
  messageDlg(msg, mtError, [mbOk], 0);
  NetError := true;
  Halt;
end;

procedure TfrmStaff.AssignMember1Click(Sender: TObject);
var
Link, lkpResult: boolean;
begin

 Link := PsProfile.Link;

 with Application do
  begin
   if Link then
    CreateForm(TfrmPreceptLkp, frmPreceptLkp)
   else CreateForm(TfrmStaffLookup, frmStaffLookup);
  end;

 try
  cmdAssign.enabled := false;
  if Link then
   begin
    with frmPreceptLkp do
     begin
      PreceptedPsIen := PsProfile.PositionIen;
      ShowModal;
      lkpResult := ModalResult = mrOk;
     end;
   end
  else
   begin
    with frmStaffLookup do
     begin
      Userclass := psProfile.UserClass;
      PC := Piece(GlobalNode(RPCBrokerMain,'^SCTM(404.57,'+ psProfile.PositionIen + ',0)'),U,4);
      role := Piece(GlobalNode(RPCBrokerMain,'^SCTM(404.57,'+ psProfile.PositionIen + ',0)'),U,3);
      ShowModal;
      lkpResult := ModalResult = mrOk;
     end;
   end;

  if lkpResult then
   begin

    getStaff.SetUpNewEntry(NEW_ENTRY);
    FMEdit1.Enabled := FALSE;

    with lblStaffEntry do
     begin
      if Link then
       begin
        Caption        := frmPreceptLkp.PreceptorPsName;
        FMCtrlInternal := frmPreceptLkp.PreceptorPsIen;
        Staff.Name     := frmPreceptLkp.PreceptorPsName;
       end
      else
       begin
        Caption        := frmStaffLookup.LookupName;
        FMCtrlInternal := frmStaffLookup.LookupIen;
        Staff.Name     := frmStaffLookup.LookupName;
       end;
     end; // with lblStaffEntry

    with cboStaffStatus do
     begin
        ItemIndex := 1;
        FMCtrlInternal := '1';
     end;

    with cboStaffReason do
     begin
      if Link then
            ItemIndex := Items.IndexOf
                      ('ACTIVATE PRECEPTOR LINK')
       else ItemIndex := Items.IndexOf
                      ('EMPLOYEE ASSIGNED TO POSITION');

      FMCtrlInternal :=
         Piece(GetFMDelimRec(cboStaffReason.FMLister
                  ,cboStaffReason.ItemIndex), U, 1);
     end;

     SetStaffButtons(false, true, false, false);
     flrStaff.Clear;
     flrStaffFMMode := AddEntry;
     NewAssign := true;
     IF psProfile.PC = '1' THEN FMEdit1.Enabled := TRUE;

     txtStaffDT.AsString := SetDateVal;
     txtStaffDate.FMCtrlInternal := StrToFMDate(txtStaffDT.AsString);

     if DEBUG then showmessage ('Internal Date: ' + txtStaffDate.FMCtrlInternal);

     OvcDTSpin.enabled := true;
     cboStaffReason.enabled := true;
     txtStaffDT.enabled := true;
     cmdStaffCancel.Enabled := true;

     with cmdStaffOk do
      begin
       ENabled := true;
       Setfocus;
      end;

   end; //if lkpResult

 finally
  if Link then frmPreceptLkp.free
   else frmStaffLookup.free;
 end;

end;

function TfrmStaff.SetDateVal : string;
var
  dtStr    : TScStr20;
  dt, dt2  : TOvcDate;
  dtout    :TDateTime;
begin
  if debug then showmessage('List count: ' + IntToStr(ltrAssign.Results.count{Slist.Count)}));

  if ltrAssign.Results.Count > 0  then
   begin

      dt := CurrentDate;
     dt2 := CurrentDate;

     dtStr := FMDateToStr(ExtDateToFM(Piece(GetFMDelimRec
           (ltrAssign,LtrAssign.Results.count-1), U, 3)));

     if dtStr <> '' then
        begin
         dt  := DateTimeToOvcDate(StrToDate(dtStr));
        end;
     if cmdAssign.Caption = 'Inactivate' then
      begin
       if dt > dt2 then dt2 := dt + 1
       else
        if dt2 <> dt then dt2 := dt2 - 1;
      end
     else//cmdAssign.Caption = 'Assign'
      begin
       dt2 := dt + 1;
      end;
       {else
       if dt = dt2 then
        dt2 := CurrentDate + 1;
      end;}

     dtout := OvcDateToDateTime(dt2);
     result := FormatDateTime('mm/dd/yyyy', dtout);
   end //count > 0
  else
     result := FormatDateTime('mm/dd/yyyy', Now);

  {if ltrAssign.Results.Count > 0  then begin  //if SList.Count > 0  then begin
     dtStr := FMDateToStr(ExtDateToFM(Piece(GetFMDelimRec(ltrAssign,LtrAssign.Results.count-1), U, 3)));
     showmessage(dtStr);//bp/cmf 177 hack
     if dtStr <> '' then
      dt := DateTimeToOvcDate(StrToDate(dtStr))
     else
      dt := CurrentDate;
     dt2 := CurrentDate;
     if dt = dt2 then
        dt2 := CurrentDate + 1;
     dtout := OvcDateToDateTime(dt2);
     result := FormatDateTime('mm/dd/yyyy', dtout);
  end
  else
     result := FormatDateTime('mm/dd/yyyy', Now);}
  if debug then showmessage('Result: ' + result);
end;

procedure TfrmStaff.InactivateMember1Click(Sender: TObject);
var
  DefName, s : string;
  Link: boolean;
begin

  Link := PsProfile.Link = true;
  cmdAssign.Enabled := False ;

  s := GetActiveStaff(RPCBrokerMain, PsProfile.PositionIen, '', '');
  if length(s) > 0 then begin
     getStaff.SetUpNewEntry(NEW_ENTRY);
     NewAssign := true;
     //bp/cmf 177
     with lblStaffEntry do
      begin
       if Link = false then
        begin
         Caption := Piece(s, U, 2);
         FMCtrlInternal := Piece(s, U, 1);
        end
       else
        begin
         Caption := Piece(s, U, 13);
         FMCtrlInternal := Piece(s, U, 12);
        end
      end;
     //bp/cmf 177
     cboStaffStatus.ItemIndex := 0;
     cboStaffStatus.FMCtrlInternal := '0';

    with cboStaffReason do
     begin
      if Link then
            ItemIndex := Items.IndexOf
                      ('CHANGE PRECEPTOR LINK')
       else ItemIndex := Items.IndexOf
                      ('EMPLOYEE LEAVES POSITION');

      FMCtrlInternal :=
         Piece(GetFMDelimRec(cboStaffReason.FMLister
                  ,cboStaffReason.ItemIndex), U, 1);
     end;


     {cboStaffReason.ItemIndex := cboStaffReason.Items.IndexOf
                                    ('EMPLOYEE LEAVES POSITION');
     cboStaffReason.FMCtrlInternal :=
         Piece(GetFMDelimRec(cboStaffReason.FMLister,cboStaffReason.ItemIndex), U, 1);}
     txtStaffDT.AsString := SetDateVal;
     txtStaffDate.FMCtrlInternal := StrToFMDate(txtStaffDT.AsString);
     flrStaff.Clear;
     flrStaffFMMode := AddEntry;
     OvcDTSpin.enabled := true;
     cboStaffReason.enabled := true;
     txtStaffDT.enabled := true;
     cmdStaffOk.Enabled := true;
     cmdStaffCancel.Enabled := true;
     cmdStaffOk.setFocus;
  end;
end;


procedure TfrmStaff.UpdateMenus(Sender: TObject);
begin
  if lstAssignments.Items.Count > 0 then
//bp/cmf 177 begin
   begin
     ParseHistStr(GetFMDelimrec
       (ltrAssign,lstAssignments.Items.Count - 1));

     with cmdAssign do
      begin
       if AssignRecord.Status = 'ACTIVE' then
        begin
         AssignMember1.Enabled := false ;
         Caption := 'Inactivate' ;
         Glyph := imgbtnNo.Picture.BitMap ;
        end
       else
        begin
         AssignMember1.Enabled := True;
         Caption := 'Assign' ;
         Glyph := imgbtnYes.Picture.BitMap ;
        end
   end
   end
  else
   begin
     with cmdAssign do
      begin
       Caption := 'Assign' ;
       Glyph := imgbtnYes.Picture.BitMap ;
      end;
     AssignMember1.Enabled := True;
   end;

  with cmdAssign do
   begin
    if Caption = 'Assign' then
       OnClick := AssignMember1Click
    else
       OnClick := InactivateMember1Click ;
   end;

     {///bp/cmf 177 old code begin
      if Piece(GetFMDelimrec(ltrAssign,lstAssignments.Items.Count - 1), U, 5) = 'ACTIVE' then
       begin
        AssignMember1.Enabled := false ;
        cmdAssign.Caption := 'Inactivate' ;
        cmdAssign.Glyph := imgbtnNo.Picture.BitMap ;
       end
     else
       begin
        AssignMember1.Enabled := True;
        cmdAssign.Caption := 'Assign' ;
        cmdAssign.Glyph := imgbtnYes.Picture.BitMap ;
       end
   end
  else
   begin
     cmdAssign.Caption := 'Assign' ;
     cmdAssign.Glyph := imgbtnYes.Picture.BitMap ;
     AssignMember1.Enabled := True;
   end;

  if cmdAssign.Caption = 'Assign' then
     cmdAssign.OnClick := AssignMember1Click
  else
     cmdAssign.OnClick := InactivateMember1Click ;
  ///bp/cmf 177 old code end}
//bp/cmf 177 end

  AssignMember2.Enabled := AssignMember1.Enabled;
  InactivateMember1.ENabled := not AssignMember1.Enabled;
  InactivateMember2.ENabled := not AssignMember1.Enabled;
  DeleteAssignment1.Enabled := DeleteKey
   and not (lblStaffEntry.caption = emptystr)
   and (PsProfile.Link = false);//bp/cmf remove last and to allow preceptor deletions
end;

procedure TfrmStaff.Exit1Click(Sender: TObject);
begin
  close;
end;


procedure TfrmStaff.OvcDTSpinClick(Sender: TObject; State: TOvcSpinState;
  Delta: Double; Wrap: Boolean);
begin
  case state of
     ssUpBtn   : IncDate(txtStaffDT.AsOvcDate, 1, 0, 0);
     ssDownBtn : IncDate(txtStaffDT.AsOvcDate, -1, 0, 0);
  end;
end;

procedure TfrmStaff.cboStaffReasonExit(Sender: TObject);
begin
  if cmdStaffOk.enabled then
     cmdStaffOk.SetFocus;
end;

procedure TfrmStaff.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key = VK_F10) and (Shift = [ssShift])  then
        sendMessage(Handle, WM_RBUTTONDOWN, 0, 0)
end;

procedure TfrmStaff.cmdHelpClick(Sender: TObject);
begin
 application.HelpContext(41350);
end;

procedure TfrmStaff.txtStaffDTChange(Sender: TObject);
begin
 setStaffButtons(staffDateChangeOK, true, false, false);
end;
procedure TfrmStaff.FMEdit1Exit(Sender: TObject);
begin
 IF FMEDIT1.Text ='' THEN EXIT ;
 IF StrToFloat(FMEdit1.Text)>1 then
        begin
        MessageDlg('Cannot be greater than 1', mtWarning, [mbOk], 0) ;
        fmedit1.SetFocus;
        exit ;
        end;
 if length(piece(FMEdit1.Text,'.',2))>2 then
         begin
         MessageDlg('Only two decimal places allowed', mtWarning,[mbOK],0);
         FMEdit1.SetFocus;
         EXIT;
         END;

 FMEdit1.FMModified := true;
 FMEdit1.FMCtrlInternal:=FMEdit1.Text ;
 with ( Sender as TFMEdit) do begin
     if FMModified then begin

        //if Validate then
           FMFiler.AddChgdControl(Sender){Add(Sender)- PDR}
        //else begin
         //  messageDlg('Entry was not validated by Data Dictionary', mtInformation, [mbOk], 0);
         //  text := FMTag;
       // end;
     end;
  end;
end;

procedure TfrmStaff.FMEdit1KeyPress(Sender: TObject; var Key: Char);
begin
 if key= #8 then exit;
 IF (KEY='.') AND (POS('.',(FMEDIT1.Text))>0 ) THEN BEGIN
        KEY:=#0;
        EXIT ;
        END;
 IF Length(FMEdit1.Text)>3 THEN BEGIN
        KEY:=#0;
        EXIT;
        END;
 if key  in ['1','2','3','4','5','6','7','8','9','0','.'] then exit;
 key:=#0;
end;


end.
