{*******************************************************************}
{                                                                   }
{    Staff Assignment form for assigning staff members to           }
{    team positions in Primary Care Management.                     }
{                                                                   }
{    Management Information Products Group                          }
{    Albany NY (SCK)                                                }
{    Dept. of Veteran Affairs                                       }
{    March 1996                                                     }
{                                                                   }
{    Last updated: 28 May 2002 (J. Peterson)                         }
{                                                                   }
{*******************************************************************}

unit Asgnstaf1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Fmcntrls, OvcSc, OvcBase, OvcDT, OvcData,
  OvcEF, OvcPB, OvcPF, OvcCal, Scutbrk, Scut2, Scut3, MFunstr,
  ExtCtrls, Scutdef, Pcmm1, Trpcb, Fmcmpnts, Menus, OvcDate {,Gtsize32,
  GTVASzr - PDR}, Diaccess;

type
  TStaffRecord = Record
     Name : string[35];
     Ien  : string[20];
     Hien : string[20];
  end;

  TfrmStaff1 = class(TForm)
    Label3: TLabel;
    lstAssignments: TFMListBox;
    cmdStaffOk: TBitBtn;
    cmdStaffCancel: TBitBtn;
    cmdDeleteAssignment: TBitBtn;
    cmdClose: TBitBtn;
    cmdHelp: TBitBtn;
    grpDate: TGroupBox;
    lblStaffDate: TLabel;
    txtStaffDT: TOvcPictureField;
    lblStaffStatus: TLabel;
    cboStaffStatus: TFMComboBox;
    lblStaffReason: TLabel;
    cboStaffReason: TFMComboBox;
    txtStaffDate: TFMLabel;
    pnlCalendar: TPanel;
    Calendar: TOvcCalendar;
    imgYes: TImage;
    imgNo: TImage;
    GetStaff: TFMGets;
    ltrAssign: TFMLister;
    flrStaff: TFMFiler;
    OvcController1: TOvcController;
    ltrStaffReason: TFMLister;
    PopupMenu1: TPopupMenu;
    OvcDTSpin: TOvcSpinner;
    lblStaff: TLabel;
    lblStaffEntry: TFMLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    AssignMember1: TMenuItem;
    InactivateMember1: TMenuItem;
    hdrStaff: THeader;
    AssignMember2: TMenuItem;
    InactivateMember2: TMenuItem;
    N2: TMenuItem;
    DeleteAssignment1: TMenuItem;
    cmdAssign: TBitBtn;
    imgbtnYes: TImage;
    imgbtnNo: TImage;
    ltrStaffStatus: TFMLister;
    Label1: TLabel;
    FMEdit1: TFMEdit;
    {GTVAForm1: GTVAForm - PDR;}
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure cboStaffReasonChange(Sender: TObject);
    procedure cboStaffStatusChange(Sender: TObject);
    procedure txtStaffDTExit(Sender: TObject);
    procedure cmdStaffOkClick(Sender: TObject);
    procedure DeleteAssignmentClick(Sender: TObject);
    procedure cmdStaffCancelClick(Sender: TObject);
    procedure lstAssignmentsMeasureItem(Control: TWinControl;
     Index: Integer; var Height: Integer);
    procedure lstAssignmentsDrawItem(Control: TWinControl;
     Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure lstAssignmentsClick(Sender: TObject);
    procedure lstAssignmentsKeyDown(Sender: TObject;
     var Key: Word; Shift: TShiftState);
    procedure txtStaffDTKeyDown(Sender: TObject; var Key: Word;
     Shift: TShiftState);
    procedure PopUpCalendar(Sender: TObject);
    procedure ChangeMonth(Sender: TObject);
    procedure CalendarClick(Sender: TObject);
    procedure CalendarKeyDown(Sender: TObject; var Key: Word;
     Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure cmdCloseClick(Sender: TObject);
    procedure cboKeyDown(Sender: TObject; var Key: Word;
     Shift: TShiftState);
    procedure lstAssignmentsExit(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure RPCBroker1NetError(Sender: TObject; var Error: EBrokerError);
    procedure AssignMember1Click(Sender: TObject);
    procedure UpdateMenus(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure InactivateMember1Click(Sender: TObject);
    procedure OvcDTSpinClick(Sender: TObject; State: TOvcSpinState;
      Delta: Double; Wrap: Boolean);
    procedure cboStaffReasonExit(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmdHelpClick(Sender: TObject);
    procedure txtStaffDTChange(Sender: TObject);
    procedure FMEdit1Exit(Sender: TObject);
    procedure FMEdit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    SList : TStringList;
    pf: TOvcPictureField;
    NewAssign, NetError, DeleteKey : Boolean;
    CurrNdx : integer;
    {PDR 5/27/98}
    flrStaffFMMode:FMModes;
    function SetDateVal : string;
  public
    { Public declarations }
    Staff: TStaff;
    StaffRec : TStaffRecord;
    function Execute(tprf: TProfile): boolean;
    function StaffReasonChangeOk: boolean;
    function StatusStaffChangeOk(status: integer): boolean;
    function StaffDateChangeOk: boolean;
    procedure SetStaffButtons(Sok: boolean; Scncl: boolean; Sadd: boolean;
     Sdel: boolean);
    function AddNewStaff: boolean;
    procedure DisableStaff(status: boolean);
    procedure LoadStaff;
    function DeleteStaffOk: boolean;
    function CheckReqd: boolean;
    procedure LoadSettings;
    procedure FormLoad;
  end;

Const
  DEBUG = false;

var
  frmStaff1: TfrmStaff1;
  ParentShow : boolean;
  psProfile : TProfile;

implementation

uses Pstndef1, Stafflkp;

{$R *.DFM}

function TfrmStaff1.Execute(tprf: TProfile): boolean;
var
  frm: TfrmStaff1;
begin
  Result := False ;
  try
     frmMain.AssignStaff1.enabled := false;
     ParentShow := frmMain.ShowMenu;
     frmMain.ShowMenu := false;
     PsProfile := tprf;
     frm := TfrmStaff1.Create(self);
     {Application.Handle := PsProfile.handle;}
     frm.show;
     {frm.FormLoad;}
     result := true;
  except
     on E: Exception do
        messageDlg(E.Classname, mtWarning, [mbOk], 0);
  end;
end;

procedure TfrmStaff1.FormResize(Sender: TObject);
begin
  Clientwidth := 492;
end;

procedure TfrmStaff1.FormLoad;
begin
  {frmMain.AssignStaff1.enabled := false;
  ParentShow := frmMain.ShowMenu;
  frmMain.ShowMenu := false;}
  {Font.Assign(FrmMain.FontDialog1.Font);
  SList := TStringList.Create;
  NetError := false;
  LoadSettings;}
end;

procedure TfrmStaff1.FormCreate(Sender: TObject);
begin
  Font.Assign(FrmMain.FontDialog1.Font);
  SList := TStringList.Create;
  NetError := false;
  LoadSettings;
  psProfile.PC := Piece(GlobalNode(RPCBrokerMain,'^SCTM(404.57,'+ psProfile.PositionIen + ',0)'),U,4);

  FMEdit1.Enabled := False;
end;

procedure TfrmStaff1.LoadSettings;
begin
  DeleteKey := SecurityKeyOk(RPCBrokerMain, DELETE_KEY);
end;

procedure TfrmStaff1.FormShow(Sender: TObject);
begin
  NetError := false;
  if not (psProfile.Parent = nil) then
     (psProfile.Parent as TForm).enabled := false;

  hdrStaff.Sections[1] := psProfile.TeamName;
  hdrStaff.Sections[3] := psProfile.PositionName;
  cboStaffReason.GetList;
  LoadStaff;
  UpdateMenus(nil) ;
end;

procedure TfrmStaff1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if not (PsProfile.Parent = nil) then begin
     (PsProfile.Parent as TForm).enabled := true;
     frmassigned.cmdAssignStaff.Enabled := true;
  end;

  frmMain.ShowMenu := ParentShow;
  frmMain.AssignStaff1.enabled := true;

  Action := cafree;
end;

procedure TfrmStaff1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if not NetError then
     case CheckSave(flrStaff) of
        Save: CMdStaffOkClick(Sender);
        Abort: CanClose := false;
     end;
end;

procedure TfrmStaff1.FormDestroy(Sender: TObject);
var
  i : integer;
begin
  SList.free;

  {if frmAssigned.visible then
     frmAssigned.cmdAssignStaff.enabled := true;}
end;

{ @@@
  Load staff history for position into lstAssignment list box. Load active
  staff member into staff record and display information.

  SList:  TStringlist of staff assignments.
  string Format:
     History Ien,(#404.52) ^ .01  Position ^ .02  Effective Date ^
       .03  Staff Member ^ .04  Status ^ .05  Status Reason

  ActiveStaff Format:
}
procedure TfrmStaff1.LoadStaff;
var
  i, index: integer;
  s1, s2: string;
  img: TGraphic;
begin
  getStaff.ClearCtrlData;{Cleardata; - PDR}
  txtStaffDt.AsString := emptystr;
  {SList.clear;  - don't use anymore - PDR}
  lstAssignments.clear;

  ltrAssign.Screen := 'IF $P(^(0),U,1)="' + PsProfile.PositionIen + '"';
  ltrAssign.Partlist.clear; {pdr}
  ltrAssign.Partlist.Insert(0,PsProfile.PositionName);{Part := PsProfile.PositionName; - PDR}
  ltrAssign.GetList(nil);
  {SList.Assign(ltrAssign.Results);  - don't use anymore - PDR}

  if ltrAssign.results.count{SList.Count - pdr} > 0 then
     begin
        for i := 0 to pred(ltrAssign.results.count){SList.Count - 1 - pdr} do
           begin
              s1 := '  '  + FMDateToStr(ExtDateToFM(Piece(GetFMDelimRec(ltrAssign,i), U, 3){Piece(SList[i], U, 3)})) +
                    ' - ' + Piece(GetFMDelimRec(ltrAssign,i), U, 4);
              if Piece(GetFMDelimRec(ltrAssign,i), U, 5) = 'ACTIVE' then
                 img := imgYes.Picture.graphic
              else
                 img := imgNo.Picture.graphic;
              lstAssignments.items.AddObject(s1, img)

           end;
  end;

  DisableStaff(true);
  flrStaff.CLear;
  SetStaffButtons(false, false, true, false);
end;


{
  Change action for the Staff assignment reason list box.
}
procedure TfrmStaff1.cboStaffReasonChange(Sender: TObject);
begin
  if not cboStaffReason.FMModified then exit;

  if StaffReasonChangeOk then
     begin
        cboStaffReason.FMCtrlInternal{FMInternal - PDR} :=
          Piece(GetFMDelimRec(cboStaffReason.FMLister,cboStaffReason.ItemIndex), '^', 1);{Piece(cboStaffReason.FMLister.Results[cboStaffReason.ItemIndex], '^', 1); - PDR}
        cmdStaffOk.enabled := ((cboStaffStatus.ItemIndex > -1) and
          (txtStaffDT.AsString <> '') and not (lblStaffEntry.Caption = emptyStr));
        if cmdStaffOk.enabled then cmdStaffOk.SetFocus;
     end
  else
     begin
        cboStaffReason.ItemIndex := cboStaffReason.FMTag;
        cboStaffReason.FMModified := false;
     end;
end;

{
  confirm that changing the staff assignment reason is ok.  This function
  call is reserved for a future release
}
function TfrmStaff1.StaffReasonChangeOk: boolean;
begin
  result := true;
end;

{
  Change the status for the Staff assignment if ok to do so.
}
procedure TfrmStaff1.cboStaffStatusChange(Sender: TObject);
begin
  if cmdStaffCancel.focused then exit;

  if not cboStaffStatus.FMmodified then exit;

  if StatusStaffChangeOk(cboStaffStatus.ItemIndex) then
     begin
        cboStaffStatus.FMCtrlInternal{FMInternal - PDR} := IntToStr(cboStaffStatus.ItemIndex);
        cmdStaffOk.enabled := ((cboStaffReason.ItemIndex > -1) and
              (txtStaffDT.AsString <> '') and not (lblStaffEntry.Caption = emptyStr));
     end
  else
     begin
        cboStaffStatus.ItemIndex := cboStaffStatus.FMTag;
        cboStaffStatus.FMModified := false;
        cboStaffStatus.SetFocus;
     end;
end;

{  @@@ confirm API
  updated 1/15/96
  Confirm that changing the status of a staff member is ok.  For a new staff
  assignment call the API for a new assignment, otherwise, call the API for
  changing an assignment.
}
function TfrmStaff1.StatusStaffChangeOk(status: integer): boolean;
var
  msg: string;
begin
  msg := '';
  result := true;

  if NewAssign then
     result := HistoryStatusOk(RPCBrokerMain, cboStaffStatus.FMFile,
         PsProfile.PositionIen, StrToFMDate(txtStaffDT.AsString), Status, msg);

  if length(msg) > 0 then
     frmMain.StatusMsg(msg, true);
end;

{  updated 1/10/96
   On exiting the staff date edit field, hide the calendar if it's still
  visible.  Exit the procedure if the next active gadget is the
  cancel button.  If the date entered is valid, and is different
  from the current date, then update the  date field and set the
  Ok  button enabled properties.
}
procedure TfrmStaff1.txtStaffDTExit(Sender: TObject);
begin
  if ActiveCOntrol = cmdStaffCancel then exit;
  if ActiveControl = cmdClose then exit;
  if Calendar.focused then exit;

  if pnlCalendar.Visible then
     pnlCalendar.visible := false;

 if (CompareText(StrToFMDate(txtStaffDT.asString),
              txtStaffDate.FMCtrlInternal{FMInternal - PDR} ) = 0) then exit;

 if txtStaffDT.isValid then
     begin
        if StaffDateChangeOk then
           begin
              if not NewAssign then
                 begin
                    if messagedlg(
                       'You are changing the date of an existing Assignment.  This'
                       + RETURN +
                       'may cause problems with other applications that rely on '
                       + RETURN +
                       'this information.   Do you wish to continue?',
                       mtConfirmation, [mbYes,mbCancel,mbHelp], 80000) = mrCancel then
                       begin
                          txtStaffDT.asString := FMToStr(txtStaffDate.FMCtrlInternal{FMInternal - PDR});
                          exit;
                       end;
                 end;

              txtStaffDate.FMCtrlInternal{FMInternal - PDR} := StrToFMDate(txtStaffDT.AsString);
              cmdStaffOk.enabled := ((cboStaffReason.ItemIndex > -1) and
              (cboStaffStatus.ItemIndex > -1) and not (lblStaffEntry.Caption = emptystr));
           end
        else begin
           txtStaffDT.AsString := txtStaffDate.FMCtrlInternal{FMInternal - PDR};
           txtStaffDT.SetFocus;
           end;
     end
  else
     frmMain.StatusMsg('Invalid Date',true);
     txtStaffDT.SetFocus;
     setStaffButtons(false,true,false,false);
end;

{ @@@ Confirm API
  updated 1/15/96
  Call API to confirm changing the date is ok
}
function TfrmStaff1.StaffDateChangeOk: boolean;
var
  msg: string;
begin
  if NewAssign then
     result := NewHistoryOk(RPCBrokerMain, cboStaffStatus.FMFile,
              PsProfile.PositionIen, StrToFMDate(txtStaffDt.AsString), msg)
  else
     result := HistoryChangeOk(RPCBrokerMain, cboStaffStatus.FMFile,
             PsProfile.PositionIen, Piece(GetFMDelimRec(ltrAssign,CurrNdx),'^',1),{Piece(Slist[CurrNdx], '^', 1),}
             StrToFMDate(txtStaffDT.AsString), msg);

  if length(msg) > 0 then
     frmMain.StatusMsg(msg, true);
end;

{ New 1/15/96
  set enabled status of command buttons on the staff assignment tab page.
}
procedure TfrmStaff1.SetStaffButtons(Sok: boolean; Scncl: boolean;
          Sadd: boolean; Sdel: boolean);
begin
  cmdStaffOk.enabled := Sok;
  cmdStaffCancel.Enabled := Scncl;
end;

{ @@@  Confirm API
  check rules to see if it's okay to add another staff member.  ie. if there
  is already an active, staff member, do not allow another active member.
}
function TfrmStaff1.AddNewStaff: boolean;
begin
  result := true;
end;

{  updated 1/15/96
  Add staff entry to the display list, lstAssigned, and add data to the fmfiler
  for processing with the save action.  Disable the Ok and cancel buttons, enable
  the form save and undo buttons.
}
procedure TfrmStaff1.cmdStaffOkClick(Sender: TObject);
begin
  //bp/cmf 204 change begin
  if not StaffDateChangeOk then
   begin
    txtStaffDt.SetFocus;
   end
   else
   //bp/cmf 204 change end
  if newAssign then
   with flrStaff do
    begin
     AddFDA('404.52',NEW_ENTRY,'.01', PsProfile.PositionIen);
     AddChgdControl(lblStaffEntry);
     AddChgdControl(cboStaffReason);
     AddChgdControl(txtStaffDate);
     AddChgdControl(cboStaffStatus);
     AddChgdControl(FMEdit1);
     if Update then
      begin
        frmMain.StatusMsg('Staff Assignment filed', false);
        NewAssign := false;
        FMEdit1.Enabled := FALSE;
        LoadStaff;
        if not (PsProfile.Parent = nil) then
           frmAssigned.LoadStaff;
      end
     else
      messageDlg('Staff Assignment was not updated!', mtWarning, [mbOk,mbHelp],
                 80000);
  end;// with flrStaff

  setStaffButtons(false,false,true,false);
  flrStaff.Update;
  UpdateMenus(nil) ;
  cmdAssign.Enabled := True ;
end;


{
  disable staff assignment edit fields.
}
procedure TfrmStaff1.DisableStaff(status: boolean);
begin
  OvcDTSpin.enabled := not status;
  cboStaffReason.enabled := not status;
  txtStaffDT.enabled := not status;
  cboStaffStatus.enabled := not status;
  //FMEdit1.Enabled := NOT STATUS;

end;

{
  Delete Staff assignment
}
procedure TfrmStaff1.DeleteAssignmentClick(Sender: TObject);
begin
 {if cboStaff.text = '' then exit;}

  if DeleteStaffOk then
     begin
        if messagedlg('You are about to delete the staff assignment for ' +
          lblStaffEntry.Caption + '.' + RETURN + 'Do you want to do this?',
          mtConfirmation, [mbYes,mbNo], 0) = mrYes then
           if Deleter(RPCBrokerMain, '^SCTM(404.52,',
            Piece(GetFMDelimRec(LtrAssign,lstAssignments.ItemIndex), U, 1)) then{Piece(LtrAssign.Results[lstAssignments.ItemIndex], U, 1)) then - PDR}
              begin
                 frmMain.StatusMsg('Staff assignment deleted.', false);
                 LoadStaff;
              end
           else
              messageDlg('Staff Entry was not deleted!', mtWarning, [mbOk], 0);
     end
  else
     begin
        frmMain.StatusMsg('Staff assignment cannot be deleted.', false);
     end;

  if not (psProfile.Parent = nil) then
     frmAssigned.LoadStaff;

  SetStaffButtons(false, false, false, false);
  UpdateMenus(nil) ;
  DisableStaff(true);
end;

{ @@@ Confirm API

}
function TfrmStaff1.DeleteStaffOk: boolean;
var
  msg: string;
begin
  result := DeleteHistoryOk(RPCBrokerMain, cboStaffStatus.FMFile,
                            psProfile.PositionIen,
                            Piece(GetFMDelimRec(LtrAssign,lstAssignments.ItemIndex),
                             U, 1), msg);
                            {Piece(LtrAssign.Results[lstAssignments.ItemIndex],
                             U, 1), msg); - PDR}
  if length(msg) > 0 then
     frmMain.StatusMsg(msg, true);
end;

{ ***
  Cancel the addiiton of a new staff member to the position
}
procedure TfrmStaff1.cmdStaffCancelClick(Sender: TObject);
begin
  try
    if pnlCalendar.Visible then
        pnlCalendar.visible := false;

     SetStaffButtons(false, false, true, false);
     getStaff.ClearCtrlData;{ClearData; - PDR}
     txtStaffDT.AsString := emptyStr;
{     txtStaffDT.AsOvcDate := CurrentDate; }
     cboStaffStatus.FMCtrlInternal{FMInternal - PDR} := IntToStr(cboStaffStatus.FMTag);
     cboStaffReason.FMCtrlInternal{FMInternal - PDR} := IntToStr(cboStaffReason.FMTag);
     {cboStaff.FMInternal := cboStaff.FMTag;}
     {lstStaff.Clear;}
     DisableStaff(true);
     cmdAssign.Enabled := True ;
     FMEdit1.Enabled := FALSE;
  except
     on E: Exception do
        MessageDlg('Error: ' + E.ClassName + ' in Staff list', mtInformation,
              [mbok], 0);
  end;
end;

{
  set height of list items in the staff selection list.
}
procedure TfrmStaff1.lstAssignmentsMeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
  Height := 20;
end;

{
  draw appropriate icon for list item and add date and staff member's name
  to the list.
}
procedure TfrmStaff1.lstAssignmentsDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  bm: TBitmap;
begin
  with (Control as TFMListBox).Canvas do
     begin
        FillRect(Rect);
        bm := TBitmap(lstAssignments.Items.Objects[Index]);

        if bm <> nil then
           begin
              BrushCopy(Bounds(Rect.Left + 2, Rect.Top + 2, bm.Width,
                 bm.Height), bm, Bounds(0, 0, bm.Width, bm.Height),
                 clBackground);
              TextOut(Rect.Left + 2 + bm.width, Rect.Top + 2,
              lstAssignments.Items[index]);
           end;
     end;
end;

{  updated 1/15/96
  select and load staff edit fields with data for the selected staff assignment
}
procedure TfrmStaff1.lstAssignmentsClick(Sender: TObject);
begin
  CurrNdx := lstAssignments.ItemIndex;
  getStaff.IENS :=Piece(GetFMDelimRec(ltrAssign,lstAssignments.ItemIndex), U, 1);{Piece(SList[lstAssignments.ItemIndex], U, 1); - PDR}
  getStaff.GetAndFill;
  txtStaffDT.AsString := FMDateToStr(txtStaffDate.FMCtrlInternal{FMInternal - PDR});
  disableStaff(false);
  cboStaffStatus.enabled := false;
  SetStaffButtons(false, true,false, true);
  FMEdit1.Enabled := True;
end;

{
  trigger double click event from key board
}
procedure TfrmStaff1.lstAssignmentsKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_SPACE then lstAssignmentsClick(Sender);
end;

procedure TfrmStaff1.txtStaffDTKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = VK_F2 then PopUpCalendar(txtStaffDT);
end;

function TfrmStaff1.CheckReqd: boolean;
var
  i: integer;
begin
  result := true;
  for i := 0 to ComponentCount - 1 do
     begin
        if Components[i] is TFMEdit then
           begin
              if TFMEdit(Components[i]).FMRequired and
                 (TFMEdit(Components[i]).Text = '') then
                 begin
                    result := false;
                    exit;
                 end;
           end

        else if Components[i] is TFMComboBox then
           begin
              if TFMComboBox(Components[i]).FMRequired and
                (TFMComboBox(Components[i]).Text = '') then
                 begin
                    result := false;
                    exit;
                 end;
           end

        else if Components[i] is TFMComboBoxLookUp then
           begin
              if TFMComboBoxLookUp(Components[i]).FMRequired and
                (TFMComboBoxLookUp(Components[i]).Text = '') then
                 begin
                    result := false;
                    exit;
                 end;
           end;
     end;
end;


{

}
procedure TfrmStaff1.PopUpCalendar(Sender: TObject);
var
  d: TOvcDate;
begin
  pf := TOvcPictureField(Sender);

  if pnlcalendar.visible then
        pnlCalendar.visible := false
  else begin
     pnlCalendar.top := hdrStaff.Height + (pf.Top + pf.Height);
     pnlCalendar.left := grpDate.left + pf.left;
     d := pf.AsOvcDate;
     if d = BadDate then
        d := CurrentDate;
     Calendar.AsStDate := d;
     pnlCalendar.visible := true;
     Calendar.Setfocus;
  end;
end;

procedure TfrmStaff1.ChangeMonth(Sender: TObject);
begin
end;


{

}
procedure TfrmStaff1.CalendarClick(Sender: TObject);
begin
  pf.AsOvcDate := Calendar.AsStDate;
  pnlCalendar.visible := false;
  pf.Setfocus;
  setStaffButtons(staffDateChangeOK,true,false,false);
end;

{

}
procedure TfrmStaff1.CalendarKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_SPACE then CalendarClick(Sender);
end;

procedure TfrmStaff1.cboKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ShowDropDown(Sender, key, shift);
end;


procedure TfrmStaff1.cmdCloseClick(Sender: TObject);
begin
  Close;
end;


procedure TfrmStaff1.lstAssignmentsExit(Sender: TObject);
begin
  lstAssignments.ItemIndex := -1;
end;

procedure TfrmStaff1.PopupMenu1Popup(Sender: TObject);
begin
  UpdateMenus(nil);
end;

procedure TfrmStaff1.RPCBroker1NetError(Sender: TObject;
  var Error: EBrokerError);
var
  msg: string;
begin
  msg := 'A Network error has been encountered.  Please make' + RETURN +
         'a note of your current entry.  You will need to' + RETURN +
         'logon to VistA before continuing';
  messageDlg(msg, mtError, [mbOk], 0);
  NetError := true;
  Halt;
end;

procedure TfrmStaff1.AssignMember1Click(Sender: TObject);
begin
  application.CreateForm(TfrmStaffLookup, frmStaffLookup);
  try
     cmdAssign.Enabled := False ;
     FMEdit1.Enabled := FALSE;
     psProfile.PC := Piece(GlobalNode(RPCBrokerMain,'^SCTM(404.57,'+ psProfile.PositionIen + ',0)'),U,4);
     frmStaffLookup.Userclass := psProfile.UserClass;
     frmStaffLookUp.pc := psProfile.PC ;
     frmStaffLookUp.role := Piece(GlobalNode(RPCBrokerMain,'^SCTM(404.57,'+ psProfile.PositionIen + ',0)'),U,3);
     frmStaffLookup.ShowModal;
     if frmStaffLookup.ModalResult = mrOk then begin
        getStaff.SetUpNewEntry(NEW_ENTRY);
        lblStaffEntry.Caption := frmStaffLookup.LookupName;
        lblStaffEntry.FMCtrlInternal{FMInternal - PDR} := frmStaffLookup.LookupIen;
        cboStaffStatus.ItemIndex := 1;
        cboStaffStatus.FMCtrlInternal{FMInternal - PDR} := '1';
        cboStaffReason.ItemIndex := cboStaffReason.Items.IndexOf
                                 ('EMPLOYEE ASSIGNED TO POSITION');
        cboStaffReason.FMCtrlInternal{FMInternal - PDR} :=
         Piece(GetFMDelimRec(cboStaffReason.FMLister,cboStaffReason.ItemIndex), U, 1);{Piece(cboStaffReason.FMLister.Results[cboStaffReason.ItemIndex], U, 1); - PDR}

        SetStaffButtons(false, true, false, false);
        flrStaff.Clear;
        flrStaffFMMode{flrStaff.FMMode - PDR} := AddEntry;
        NewAssign := true;
        IF psProfile.PC ='1' THEN FMEdit1.Enabled := TRUE;
        {txtStaffDT.AsOvcDate := CurrentDate;}
        txtStaffDT.AsString := SetDateVal;

        txtStaffDate.FMCtrlInternal{FMInternal - PDR} := StrToFMDate(txtStaffDT.AsString);
        if DEBUG then showmessage ('Internal Date: ' + txtStaffDate.FMCtrlInternal{FMInternal - PDR});

        OvcDTSpin.enabled := true;
        cboStaffReason.enabled := true;
        txtStaffDT.enabled := true;
        //FMEdit1.Enabled := TRUE;
        cmdStaffCancel.Enabled := true;
        cmdStaffOk.ENabled := true;
        cmdStaffOk.Setfocus;
     end;
  finally
     frmStaffLookup.free;
  end;
end;

function TfrmStaff1.SetDateVal : string;
var
  dtStr    : TScStr20;
  dt, dt2  : TOvcDate;
  dtout    :TDateTime;
begin
  if debug then showmessage('List count: ' + IntToStr(ltrAssign.Results.count{Slist.Count)}));
  if ltrAssign.Results.Count > 0  then
   begin

      dt := CurrentDate;
     dt2 := CurrentDate;

     dtStr := FMDateToStr(ExtDateToFM(Piece(GetFMDelimRec
           (ltrAssign,LtrAssign.Results.count-1), U, 3)));

     if dtStr <> '' then
        begin
         dt  := DateTimeToOvcDate(StrToDate(dtStr));
        end;
     if cmdAssign.Caption = 'Inactivate' then
      begin
       if dt > dt2 then dt2 := dt + 1
       else
        if dt2 <> dt then dt2 := dt2 - 1;
      end
     else//cmdAssign.Caption = 'Assign'
      begin
       dt2 := dt + 1;
      end;
       {else
       if dt = dt2 then
        dt2 := CurrentDate + 1;
      end;}

     dtout := OvcDateToDateTime(dt2);
     result := FormatDateTime('mm/dd/yyyy', dtout);
   end //count > 0
  else
     result := FormatDateTime('mm/dd/yyyy', Now);

  if debug then showmessage('Result: ' + result);
end;

procedure TfrmStaff1.InactivateMember1Click(Sender: TObject);
var
  DefName, s : string;
begin
  cmdAssign.Enabled := False ;
  s := GetActiveStaff(RPCBrokerMain, PsProfile.PositionIen, '', '');
  if length(s) > 0 then begin
     getStaff.SetUpNewEntry(NEW_ENTRY);
     NewAssign := true;
     lblStaffEntry.Caption := Piece(S, U, 2);
     lblStaffEntry.FMCtrlInternal{FMInternal - PDR} := Piece(S, U, 1);
     cboStaffStatus.ItemIndex := 0;
     cboStaffStatus.FMCtrlInternal{FMInternal - PDR} := '0';
     cboStaffReason.ItemIndex := cboStaffReason.Items.IndexOf
                                    ('EMPLOYEE LEAVES POSITION');
     cboStaffReason.FMCtrlInternal{FMInternal - PDR} :=
         Piece(GetFMDelimRec(cboStaffReason.FMLister,cboStaffReason.ItemIndex), U, 1);{Piece(cboStaffReason.FMLister.Results[cboStaffReason.ItemIndex], U, 1); - PDR}
     {txtStaffDT.AsOvcDate := CurrentDate;}
     txtStaffDT.AsString := SetDateVal;
     txtStaffDate.FMCtrlInternal{FMInternal - PDR} := StrToFMDate(txtStaffDT.AsString);
     flrStaff.Clear;
     flrStaffFMMode{flrStaff.FMMode - PDR} := AddEntry;
     OvcDTSpin.enabled := true;
     cboStaffReason.enabled := true;
     txtStaffDT.enabled := true;
     cmdStaffOk.Enabled := true;
     cmdStaffCancel.Enabled := true;
     cmdStaffOk.setFocus;
  end;
end;


procedure TfrmStaff1.UpdateMenus(Sender: TObject);
begin
  if lstAssignments.Items.Count > 0 then begin
     if Piece(GetFMDelimrec(ltrAssign,lstAssignments.Items.Count - 1), U, 5) = 'ACTIVE' then{Piece(SList[lstAssignments.Items.Count - 1], U, 5) = 'ACTIVE' then - pdr}
       begin
        AssignMember1.Enabled := false ;
        cmdAssign.Caption := 'Inactivate' ;
        cmdAssign.Glyph := imgbtnNo.Picture.BitMap ;
       end
     else
       begin
        AssignMember1.Enabled := True;
        cmdAssign.Caption := 'Assign' ;
        cmdAssign.Glyph := imgbtnYes.Picture.BitMap ;
       end
  end
  else begin
     cmdAssign.Caption := 'Assign' ;
     cmdAssign.Glyph := imgbtnYes.Picture.BitMap ;
     AssignMember1.Enabled := True;
  end;

  if cmdAssign.Caption = 'Assign' then
     cmdAssign.OnClick := AssignMember1Click
  else
     cmdAssign.OnClick := InactivateMember1Click ;


  AssignMember2.Enabled := AssignMember1.Enabled;
  InactivateMember1.ENabled := not AssignMember1.Enabled;
  InactivateMember2.ENabled := not AssignMember1.Enabled;
  DeleteAssignment1.Enabled := DeleteKey and not (lblStaffEntry.caption = emptystr);
end;

procedure TfrmStaff1.Exit1Click(Sender: TObject);
begin
  close;
end;


procedure TfrmStaff1.OvcDTSpinClick(Sender: TObject; State: TOvcSpinState;
  Delta: Double; Wrap: Boolean);
begin
  case state of
     ssUpBtn   : IncDate(txtStaffDT.AsOvcDate, 1, 0, 0);
     ssDownBtn : IncDate(txtStaffDT.AsOvcDate, -1, 0, 0);
  end;
end;

procedure TfrmStaff1.cboStaffReasonExit(Sender: TObject);
begin
  if cmdStaffOk.enabled then
     cmdStaffOk.SetFocus;
end;

procedure TfrmStaff1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key = VK_F10) and (Shift = [ssShift])  then
        sendMessage(Handle, WM_RBUTTONDOWN, 0, 0)
end;

procedure TfrmStaff1.cmdHelpClick(Sender: TObject);
begin
 application.HelpContext(41350);
end;

procedure TfrmStaff1.txtStaffDTChange(Sender: TObject);
begin
 setStaffButtons(staffDateChangeOK, true, false, false);
end;

procedure TfrmStaff1.FMEdit1Exit(Sender: TObject);
begin
 IF FMEDIT1.Text ='' THEN EXIT ;
 IF StrToFloat(FMEdit1.Text)>1 then
        begin
        MessageDlg('Cannot be greater than 1', mtWarning, [mbOk], 0) ;
        FMEdit1.Enabled := TRUE ;
        fmedit1.SetFocus;
        FMEdit1.Enabled := TRUE;
        exit ;
        end;
 if length(piece(FMEdit1.Text,'.',2))>2 then
         begin
         MessageDlg('Only two decimal places allowed', mtWarning,[mbOK],0);

         FMEdit1.SetFocus;
         
         EXIT;
         END;
 FMEdit1.FMModified := true;
 FMEdit1.FMCtrlInternal:=FMEdit1.Text ;
 with ( Sender as TFMEdit) do begin
     if FMModified then begin
         cmdStaffOk.Enabled := TRUE;
        //if Validate then
           FMFiler.AddChgdControl(Sender);{Add(Sender)- PDR}
           //FMFiler.Update;
        //else begin
         //  messageDlg('Entry was not validated by Data Dictionary', mtInformation, [mbOk], 0);
         //  text := FMTag;
       // end;
     end;
  end;
end;

procedure TfrmStaff1.FMEdit1KeyPress(Sender: TObject; var Key: Char);
begin
 if key= #8 then exit;
 IF (KEY='.') AND (POS('.',(FMEDIT1.Text))>0 ) THEN BEGIN
        KEY:=#0;
        EXIT ;
        END;
 IF Length(FMEdit1.Text)>3 THEN BEGIN
        KEY:=#0;
        EXIT;
        END;
 if key  in ['1','2','3','4','5','6','7','8','9','0','.'] then exit;
 key:=#0;
end;

end.
