{*******************************************************************}
{                                                                   }
{    Utility Date range selection form for the Multiple Team        }
{    Assignment and Discharges                                      }
{    for Primary Care Management.                                   }
{                                                                   }
{    Scheduling ver 5.3 AUG 13, 1993                                 }      
{    Management Information Products Group                          }
{    Albany NY (SCK)                                                }
{    Dept. of Veteran Affairs                                       }
{                                                                   }
{    Last updated: 8 May 2002 (J. Peterson)                         }
{                                                                   }
{*******************************************************************}

unit Dtrange;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, OvcSc, OvcBase, OvcEF, OvcPB, OvcPF, Dialogs,
  OvcDt, OvcDate, SysUtils {,Gtsize32, GTVASzr - PDR};

type
  TfrmDateRange = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    txtDtBegin: TOvcPictureField;
    OvcController1: TOvcController;
    txtDtEnd: TOvcPictureField;
    Label1: TLabel;
    Label2: TLabel;
    OvcSpinner1: TOvcSpinner;
    OvcSpinner2: TOvcSpinner;
    {GTVAForm1: GTVAForm - PDR;}
    procedure txtDtDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure txtDtBeginChange(Sender: TObject);
    procedure txtDtBeginExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDateRange: TfrmDateRange;

implementation

uses EnterDt, Scut3;

{$R *.DFM}

procedure TfrmDateRange.txtDtDblClick(Sender: TObject);
begin
  frmEnterDate.Caption := 'Select Date:';
  if TOvcPictureField(Sender).Name = 'txtDtBegin' then
    begin
      if txtDtBegin.AsOvcDate = BadDate then
        frmEnterDate.initDate := SysUtils.Date
      else
        frmEnterDate.initDate := txtDtBegin.AsDateTime;
    end
  else
    begin
      if txtDtEnd.AsOvcDate = BadDate then
        frmEnterDate.initDate := SysUtils.Date
      else
        frmEnterDate.initDate := txtDtEnd.AsDateTime;
    end;
  if frmEnterDate.ShowModal = mrOk then begin
     if TOvcPictureField(Sender).Name = 'txtDtBegin' then begin
        txtDtBegin.AsString := FMDateToStr(frmEnterDate.FMDate);
        txtDtBeginChange(Sender) ;    {enable OK button}
        end
     else begin
        txtDtEnd.AsString := FMDateToStr(frmEnterDate.FMDate);
     end;
  end;
end;

procedure TfrmDateRange.FormCreate(Sender: TObject);
begin
  txtDtBegin.AsOvcDate := CurrentDate;
  txtDtEnd.AsOvcDate := CurrentDate;
end;

procedure TfrmDateRange.FormResize(Sender: TObject);
begin
  ClientWidth := 310;
end;

procedure TfrmDateRange.txtDtBeginChange(Sender: TObject);
begin
  OKBtn.enabled := true;  
end;

procedure TfrmDateRange.txtDtBeginExit(Sender: TObject);
begin
  OKBtn.enabled := true;  
end;

end.
