{*****************************************************************}
{ ENTERDT.PAS                                                     }
{                                                                 }
{ Calendar Tool utility                                           }
{ Converts date from Windows form, mm/dd/yyyy, to FileMan         }
{  internal format, 2yymmdd.   Has provision for converting       }
{  date beyond 2000 (3yymmdd).                                    }
{                                                                 }
{ Scheduling ver 5.3 AUG 13, 1993                                 }
{ Management Information Products Group                           }
{ Albany NY (SCK)                                                 }
{ Dept. of Veteran Affairs                                        }
{                                                                 }
{ Last updated: 8 May 2002 (J. Peterson)                          }
{                                                                 }
{*****************************************************************}

unit Enterdt;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, OvcBase, OvcCal, StdCtrls, Buttons, Scutdef,
  Mfunstr, scut3, Scut2, OvcDT, OvcDate;

type
  TfrmEnterDate = class(TForm)
    cmdOk: TBitBtn;
    cmdCancel: TBitBtn;
    OvcCal: TOvcCalendar;
    OvcController1: TOvcController;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure cmdOkClick(Sender: TObject);
    procedure cmdCancelClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure OvcCalDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FMDate:  string[30];
    strDate: string[30];//bp/cmf 204 add
    initDate: TDateTime; {date to initially show calendar at - default is today}
  end;

var
  frmEnterDate: TfrmEnterDate;

implementation

{$R *.DFM}

procedure TfrmEnterDate.FormCreate(Sender: TObject);
begin
  OvcCal.AsStDate := CurrentDate;
  FMDate := '';
  strDate := '';
  initDate := OvcCal.AsDateTime;
end;

procedure TfrmEnterDate.FormResize(Sender: TObject);
begin
  {Scaler1.Ydevelop := Screen.Height;
  Scaler1.Xdevelop := Screen.Width;
  Clientwidth := 250;}
end;

procedure TfrmEnterDate.cmdOkClick(Sender: TObject);
var
  dts : string;
  dt: TDateTime;
  fmv : integer;
begin
  dt := encodeDate(OvcCal.Year, OvcCal.Month, OvcCal.Day);
  dts := FormatDateTime('mm/dd/yyyy', dt);

  fmv := StrToInt(Copy(dts,7,2)) - 17;

  FMDate  := IntToStr(fmv)
             + Copy(dts,9,2)
             + copy(dts,1,2)
             + copy(dts,4,2);
  strDate := dts;
  ModalResult := mrOk;
end;

procedure TfrmEnterDate.cmdCancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  close;
end;

procedure TfrmEnterDate.FormActivate(Sender: TObject);
begin
  try
    OvcCal.AsDateTime := initDate;
  except
    OvcCal.AsStDate := CurrentDate;
  end;
  initDate := SysUtils.Date;
end;

procedure TfrmEnterDate.OvcCalDblClick(Sender: TObject);
begin
  cmdOKClick(self);
end;

end.
