{*****************************************************************}
{ MTREASGN.PAS                                                    }
{                                                                 }
{ Scheduling ver 5.3 AUG 13, 1993                                 }
{ Management Information Products Group                           }
{ Albany NY                                                       }
{ Dept. of Veteran Affairs                                        }
{                                                                 }
{ Last updated: 29 May 2002 (J. Peterson)                         }
{                                                                 }
{*****************************************************************}

unit MTReAsgn;

interface

uses
  WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Trpcb, Fmlookup, Fmcmpnts, Pcmm1, Scut3, Scut2, Scutbrk,
  Mfunstr, SysUtils, Messages, Dialogs, ExtCtrls, Fmcntrls,
  Scutdef, OvcSc, OvcBase, OvcEF, OvcPB, OvcPF, OvcDT, Menus, Printers,
  OvcData,OvcTCmmn,OvcVlb,OvcTable,OvcDate
  {,Gtsize32, GTVASzr- PDR}, Diaccess, Mask, OvcCal, ComCtrls;

const
  debug = false;
  NUM_RETURN = 200;
 
type
  {basic patient id record}
  TPatientID = class(TObject)
  private
    FName       : String;
    FDfn        : String;
    FENrollDT   : String;
    FAssignIEN  : String; {PDR - IEN of team assignment or position assignment}
  public
    property Name : string read FName  write FName;
    property DFN  : string read FDfn   write FDfn;
    property EDate: string read FEnrollDT write FEnrollDT;
    property AssignIEN:string read FAssignIEN write FAssignIEN; {PDR}
  end;

  TfrmMTReAsgn = class(TForm)
    PrintDialog1: TPrintDialog;
    PopupMenu1: TPopupMenu;
    print2: TMenuItem;
    PopupMenu2: TPopupMenu;
    Print1: TMenuItem;
    ltrTeam: TFMLister;
    ltrSRCPosition: TFMLister;
    getTeamInfo: TFMGets;
    getPosAsgnInfo: TFMGets;
    pnlCalendar: TPanel;
    Calendar: TOvcCalendar;
    OvcController1: TOvcController;
    ltrDSTPosition: TFMLister;
    lblJob: TLabel;
    O1: TMenuItem;
    PageControl1: TPageControl;
    TabSheetReAsgn: TTabSheet;
    TabSheetOptions: TTabSheet;
    pnlPosFilters: TPanel;
    rgAsnStatus: TRadioGroup;
    grpAssignmentDates: TGroupBox;
    lblAssignFromDate: TLabel;
    lblAssignToDate: TLabel;
    txtFromDt: TOvcPictureField;
    txtToDt: TOvcPictureField;
    spinAssign: TOvcSpinner;
    spinDischarge: TOvcSpinner;
    grpPCTeamRestrict: TGroupBox;
    chkbxPCAssign: TCheckBox;
    chkbxRestrict: TCheckBox;
    pnlTMPosSel: TPanel;
    lbl_FromTeam: TLabel;
    lbl_FromPosition: TLabel;
    lbl_ToTeam: TLabel;
    lbl_ToPosition: TLabel;
    Bevel6: TBevel;
    lbl_from: TLabel;
    lbl_To: TLabel;
    fmCBTFrom: TFMComboBoxLookUp;
    fmCBTTo: TFMComboBoxLookUp;
    fmCBPFrom: TFMComboBoxLookUp;
    fmCBPTO: TFMComboBoxLookUp;
    pnlLists: TPanel;
    IncludeBtn: TSpeedButton;
    IncAllBtn: TSpeedButton;
    ExcludeBtn: TSpeedButton;
    ExAllBtn: TSpeedButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    lblSrcList: TLabel;
    lblDstList: TLabel;
    SrcList: TListBox;
    DstList: TListBox;
    cmdMore: TButton;
    cmdSave: TBitBtn;
    cmdCancel: TBitBtn;
    Panel1: TPanel;
    cmdClose: TBitBtn;
    HelpBtn: TBitBtn;
    grpEntries: TGroupBox;
    lbl_Count: TLabel;
    bvlCount: TBevel;
    lblCount: TLabel;
    lbl_Processed: TLabel;
    bvlProcessed: TBevel;
    lblProcessed: TLabel;
    grpPriorEntries: TGroupBox;
    lbl_PProcessed: TLabel;
    bvlPProcessed: TBevel;
    lblPProcessed: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure fmCBTFromClick(Sender: TObject);
    procedure cmdMoreClick(Sender: TObject);
    procedure IncludeBtnClick(Sender: TObject);
    procedure IncAllBtnClick(Sender: TObject);
    procedure ExcludeBtnClick(Sender: TObject);
    procedure ExAllBtnClick(Sender: TObject);
    procedure cmdCancelClick(Sender: TObject);
    procedure SrcListClick(Sender: TObject);
    procedure SrcListDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SrcListDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure SrcListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DstListClick(Sender: TObject);
    procedure DstListDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure DstListDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure DstListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmdCloseClick(Sender: TObject);
    procedure GetPatients;
    procedure fmCBTToClick(Sender: TObject);
    procedure fmCBPFromClick(Sender: TObject);
    procedure print2Click(Sender: TObject);
    procedure cmdSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure fmCBPTOClick(Sender: TObject);
    procedure fmCBPFromEnter(Sender: TObject);
    procedure fmCBPTOEnter(Sender: TObject);
    procedure PopupCalendar(Sender: TObject);
    procedure txtFromDtExit(Sender: TObject);
    procedure txtToDtExit(Sender: TObject);
    procedure rgAsnStatusClick(Sender: TObject);
    procedure CalendarClick(Sender: TObject);
    procedure CalendarKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure HelpBtnClick(Sender: TObject);
    procedure fmCBTFromChange(Sender: TObject);
    procedure fmCBTToChange(Sender: TObject);
    procedure fmCBPFromChange(Sender: TObject);
    procedure fmCBPTOChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure txtDtDblClick(Sender: TObject);
    procedure chkbxPCAssignEnter(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure chkbxPCAssignClick(Sender: TObject);
    procedure chkbxRestrictClick(Sender: TObject);
  private
    { Private declarations }
   pf: TOvcPictureField;
   PatJobID, Job : string;
   PatJobCount, {BlockCount,} LastP, StartP{, ListCount} : integer;
   {pList : TStrings;}
   procedure ResetPTList;
   procedure SetPCRole;
   procedure SetPCPosOpt(PC:Boolean);
   procedure LoadPatientBlock(s : string; SBlock, EBlock: integer);
   procedure GetData;
   procedure SetSrcItem(s : string);
   procedure SetItem(List: TListBox; Index: Integer);
   procedure MoveSelected(List: TCustomListBox; Items: TStrings);
   procedure UpdateSaveCancelBtns(status : boolean);
   procedure SetButtons;
   function GetFirstSelection(List: TCustomListBox): Integer;
   procedure UpdateCursor(Sender: TObject);
   procedure GetPositions(combo:TfmComboBoxLookup;TeamID:String);
   procedure ClearListBox(list : TListBox);
   procedure BuildAssignments( sendlist : TStrings);
   procedure FileAssignments( jobID : string);
   procedure FilePosAssignments( jobID : string);
   function ConfirmPosSave( cnt : integer) : boolean;
   function ConfirmTeamSave(cnt : integer) : boolean;
   Function SrcandDstTeamDiff(cb:TFMComboBoxLookup):Boolean;
   Function SrcandDstPosDiff(cb:TFMComboBoxLookup):Boolean;
   procedure ReplaceSelections;
   procedure DisplayProcessed(Processed : string);
   procedure ClearProcessed;
   procedure FileReassignments;
   procedure disablefmCBPFrom;
   procedure disablefmCBPTo;
   procedure NoSave;
   function TodayStr: String;
   procedure UpdateOptionsCaption;
  public
    { Public declarations }
    byTeam:Boolean;
    FromTeamID,ToTeamID,FromPositionID,ToPositionID:String;
    FromDate, ToDate:string;
    procedure SetTeamorPos;
    procedure HidePositionOptions;
  end;

var
  frmMTReAsgn: TfrmMTReAsgn;

implementation

uses dmuTeam, dmuTeamPosition, EnterDt;

{$R *.DFM}

procedure TfrmMTReAsgn.ReplaceSelections;
var {Put destination items back onto source list if can't save}
 i:integer;
begin
 for i := pred(dstlist.items.count) downto 0 do
  begin
   srclist.items.addobject(dstlist.items[i],dstlist.Items.Objects[i]);
   dstlist.Items.delete(i);
  end;
 srclist.refresh;
 dstlist.refresh;
 DisplayProcessed('0');
end;

procedure TfrmMTReAsgn.SetTeamorPos;
begin
 if byTeam then
   begin
    caption := 'Multiple Patient Team Reassignment';
    fmCBPFrom.hide;
    fmCBPTO.hide;
    lbl_FromPosition.hide;
    lbl_ToPosition.hide;
    // patch 177 grpPrimaryCareOptions.visible:=false;
    {frmMTReAsgn.height := 396;}
    // patch 177 grpPCTeamRestrict.visible:=true;
    HidePositionOptions;
    HelpContext := 70200;
   end
  else
   begin
    caption := 'Multiple Patient Position Reassignment';
    fmCBPFrom.Visible:=true;
    fmCBPTO.Visible:=true;
    lbl_FromPosition.visible:=true;
    lbl_ToPosition.visible:=true;
    {frmMTReAsgn.height := 455;}
    chkbxrestrict.visible:=false;
    // patch 177 grpPCTeamRestrict.visible:=false;
    // patch 177 grpPrimaryCareOptions.visible:=true;
    HelpContext := 70210;
    rgAsnStatusClick(nil);
   end;
  refresh;
end;

procedure TfrmMTReAsgn.HidePositionOptions;
begin
 pnlposFilters.Visible:=false;
 pnlTmPosSel.height:=lbl_FromPosition.Top + 10;{(fmcbtto.top + fmcbtto.height);}
 //pnlTopBase.height:=pnltmposSel.Height;
 //pnlBase.height:=pnlBotBase.top + pnlBotBase.Height;
 //height:=pnlBase.Top + pnlBase.Height + 40; {button1.top;}
 // patch 177 grpPrimaryCareOptions.visible:=false;
end;

procedure TfrmMTReAsgn.LoadPatientBlock(s : string; SBlock, EBlock: integer);
var
  i  : integer;
begin
  RPCBrokerMain.remoteProcedure := 'SC GET PAT BLOCK'; {CHANGED TO SCMC FROM SC FOR TESTING}
  with RPCBrokerMain.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"JOBID"']   := s;
        Mult['"JOB"']     := PatJobID;
        Mult['"BSTART"']  := IntToStr(SBlock);
        Mult['"BEND"']    := IntToStr(EBlock);
        Mult['"BLAST"']   := IntToStr(PatJobCount);
     end;
  RPCBrokerMain.Call;

  for i := 0 to RPCBrokerMain.Results.Count - 1 do
     SetSrcItem(RPCBrokerMain.Results[i]);
  cmdMore.ENabled := (SrcList.Items.Count < PatJobCount)
end;

procedure TfrmMTReAsgn.SetSrcItem(s : string);
var
  id : TPatientID;
begin
  id := TPatientID.Create;
  id.Name  := Piece(s, U, 2);
  id.DFN   := Piece(s, U, 1);
  id.EDate := Piece(s, U, 4); {pdr - erroneously set to piece 3 in original}
  id.AssignIEN := Piece(s,U,3); {PDR - conserve assignment IEN (team or position)}
  if dstList.Items.IndexOf(id.Name) = -1 then
     srcList.Items.AddObject(id.Name, id);
end;

procedure TfrmMTReAsgn.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ClearListBox(srcList);
  ClearListBox(dstList);
  Frmmain.MultipleReAssignments1.Enabled := true;
  Action := caFree;
end;

procedure TfrmMTReAsgn.fmCBTFromClick(Sender: TObject);
var
 rtn:boolean;
begin
 ClearListBox(srcList);
 ClearListBox(dstList);
 if fmCBTFrom.items.count <1 then exit;
 FromTeamID := Piece(GetFMDelimRec(fmcbTfrom.FMLister,fmCBTFrom.ItemIndex), U, 1);{Piece(cboSource.FMLister.Results[cboSource.ItemIndex], U, 1); - PDR}
 If byTeam then
  begin
   rtn := True ;
   if Piece(GetFMDelimRec(fmcbTfrom.FMLister,fmCBTFrom.ItemIndex), U, 4) = '1' then{Piece(getTeamInfo.Results[2], U, 4) = '1' then}
        rtn := (messagedlg('This team is currently closed.' + RETURN +
                      'Do you still wish to assign patients?', mtconfirmation,
                      [mbYes,mbNo], 0) = mrYes);
   rtn := SrcandDstTeamDiff(TFMComboboxLookup(sender));
   if not rtn then
    begin
     fmCBTFrom.itemindex:=-1;
     exit;
    end;
   if rtn then
     GetPatients  {Get Patients for team}
   else
    begin
     fmCBTFrom.itemindex:=-1;
     exit; {BAIL OUT - NO Team Selected}
    end;
  end
 else {Setup to get positions}
  GetPositions(fmCBPFROM,FromTeamID);
ClearProcessed;
end;

Function TfrmMTReAsgn.SrcandDstTeamDiff(cb:TFMComboBoxLookup):Boolean;
begin
 if (fmCBTFrom.itemindex < 0) or (fmCBTTo.itemindex < 0) then
  begin {can't be same, not picked yet}
   result:=true;
   exit;
  end;
 result:=fmCBTFrom.items[fmCBTFrom.Itemindex] <> fmCBTTo.items[fmCBTTo.Itemindex];
 if not result then
  begin
   Application.MessageBox('FROM and TO teams can' + #39 + 't be the same.',
                         'Re-assignment Error',
                          MB_OK);
  end;
end;

Function TfrmMTReAsgn.SrcandDstPosDiff(cb:TFMComboBoxLookup):Boolean;
begin
 result := true;
 if (fmCBPFrom.Itemindex < 0) or (fmCBPTo.Itemindex < 0) then
  begin {can't be same, not selected yet}
   result:=true;
   exit;
  end;
  {if teams are the same, then the positions have to be different}
 if fmCBTFrom.items[fmCBTFrom.Itemindex] = fmCBTTo.items[fmCBTTo.Itemindex] then
  result:=fmCBPFrom.items[fmCBPFrom.Itemindex] <> fmCBPTo.items[fmCBPTo.Itemindex];
 if not result then
  Application.MessageBox('FROM and TO positions can' + #39 + 't be the same.',
                         'Re-assignment Error',
                         MB_OK);
end;

procedure TfrmMTReAsgn.fmCBTToClick(Sender: TObject);
begin
 if (fmCBTTo.items.count > 0) then
  begin
   if Piece(GetFMDelimRec(fmCBTTo.FMLister,fmCBTTo.Itemindex),U,3)='YES' then
    begin
     with chkbxPCAssign do
      begin
       enabled := true;
       checked := true;
      end
    end
   else
    with chkbxPCAssign do
     begin
      checked := false;
      enabled := false;
     end;
   if (not ByTeam) and
      (Piece(GetFMDelimRec(fmCBTTo.FMLister,fmCBTTo.Itemindex),U,6)='NO')then
    begin
     SetPCPosOpt(False); {if "TO" Team not PC then "TO" Pos can't be}
    end;
  end;
if byteam and (not SrcandDstTeamDiff(TFMComboboxLookup(sender))) then
 begin
  fmCBTTo.itemindex:=-1;
  exit;
 end;
 ToTeamID := Piece(GetFMDelimRec(fmCBTTO.FMLister,fmCBTTO.ItemIndex), U, 1);{Piece(cboSource.FMLister.Results[cboSource.ItemIndex], U, 1); - PDR}
 GetPositions(fmCBPTO,ToTeamID);
 ClearProcessed;
end;


procedure TfrmMTReAsgn.GetPositions(combo:TfmComboBoxLookup;TeamID:string);
begin
 with combo do
  begin
   combo.clear;
   {FMLister := ltrPosition; - gave source and dest combos their own fmlisters}
   {FMLister.GetList(nil);}
   FMLister.Screen := 'IF $P(^(0),U,2)="' + TeamID +
                      '",+$$ACTTP^SCMCTPU(Y)=1';
                 {FMLister.Part := Piece(team, U, 1);}
                 {FMFile := FMLIster.FileNumber;}
   itemindex:=0;
  end;
 end;

procedure TfrmMTReAsgn.GetPatients;
Var
 S:string;
 Pos,Long: Boolean;
begin
 Long := false;
 Pos := FromPositionID <> emptyStr;

 if pos then
  begin
   dmcPosition.CreatePositionRecord(FromPositionID);
   with TeamPosition do
    begin
     if CurrentAssigned > 500 then Long := true;
     if ErrCode = 10004 then Long := true;
    end;
  end
 else
  begin
   dmcTeam.CreateTeamRecord(FromTeamID);
   with Team do
    begin
     if CurrentAssigned > 500 then Long := true;
     if ErrCode = 10004 then Long := true;
    end;
  end;

 with RPCBrokerMain do
 begin
   with Param[0] do
    begin
     Ptype := list;
     Mult['"BEGIN"']  := TodayStr;
     Mult['"END"']    := TodayStr;
     Mult['"TEAM"']   := FromTeamID;
     if pos then
     begin
       {Getting patients assigned to position}
       Mult['"FROMPOS"']   := FromPositionID;
       Mult['"ASSIGNSTAT"'] := IntToStr(rgAsnStatus.Itemindex);
       Mult['"FROMDATE"'] := FromDate;
       Mult['"TODATE"'] := ToDate;
       Mult['"POSITION"'] := FromPositionID;
       RPCBrokerMain.RemoteProcedure := 'SCMC BLD POS PAT LIST';
     end
     else
     begin
       {Getting patients assigned to team}
       Mult['"FROMTEAM"']  := FromTeamID;
       RPCBrokerMain.RemoteProcedure := 'SCMC BLD TEAM PAT LIST';
     end;
    end;

   if Long then
    begin
     //frmMain.StatusSplash(1,true,true);
     //bp/cmf 204t0 RPCTimeLimit := 300;
     Call;
     //frmMain.StatusSplash(0,false,false);
     //bp/cmf 204t0 RPCTimeLimit := 30;
    end
   else Call;

  PatJobID := Piece(Results[0], U, 1);
  s := Piece(Results[0], U, 2);
 end;


if not (s = emptyStr) then
 PatJobCount := StrToInt(s)
 else
  PatJobCount := 0;

lblCount.Caption := IntToStr(PatJobCount);

if PatJobCount = 0 then
 begin
  messagedlg('There are no patients who' + RETURN +
             'can be reassigned from this team', mtInformation, [mbOk], 0);
  ClearListBox(srcList);
 end
  else
   GetData;

SetButtons ;
end;

procedure TfrmMTReAsgn.GetData;
begin
  ClearListBox(srcList);
  ClearListBox(dstList);
  StartP := 1;
  LastP := NUM_RETURN;

 if byTeam then
  LoadPatientBlock('SCTEAM', StartP, LastP)
 else
  LoadPatientBlock('SCPOS', StartP, LastP);
end;

procedure TfrmMTReAsgn.cmdMoreClick(Sender: TObject);
begin
  if DstList.Items.Count > 0 then begin
     MessageDlg('Please save currently selected entries' + RETURN +
                'before selecting the next block of patients.', mtWarning, [mbOK], 0);
     end
  else begin
     ClearListBox(srcList);
     StartP := StartP + NUM_RETURN;
     LastP := LastP + NUM_RETURN;
     if byTeam then
      LoadPatientBlock('SCTEAM', StartP, LastP)
     else
      LoadPatientBlock('SCPOS', StartP, LastP);
     {SetButtons;}
  end;
end;

procedure TfrmMTReAsgn.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(SrcList);
  MoveSelected(SrcList, DstList.Items);
  SetItem(SrcList, Index);
  UpdateSaveCancelBtns(True);

end;

procedure TfrmMTReAsgn.MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then
    begin
      Items.AddObject(List.Items[I], List.Items.Objects[I]);
      List.Items.Delete(I);
    end;
end;

procedure TfrmMTReAsgn.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do
  begin
    SetFocus;
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    Selected[Index] := True;
  end;
  SetButtons;
end;

procedure TfrmMTReAsgn.UpdateSaveCancelBtns(status : boolean);
begin
UpdateOptionsCaption;
{set Cancel button}
with cmdCancel do
 begin
  enabled := true;
  if srclist.Items.Count < 1
   then
    if dstlist.Items.Count < 1
     then enabled := false;
 end;


{set Save button}
cmdSave.Enabled := true;
{checks for team assignments}
{. check for entry(s) in destination list}
if Dstlist.Items.Count < 1 then
 begin
  NoSave;
  exit;
 end;

{. check for valid entry in FromTeam}
with fmCBTFrom do
 begin
  if ItemIndex < 0 then
   begin
    NoSave;
    Exit;
   end;
  if Text = '' then
   begin
    NoSave;
    Exit;
   end;
 end;

{. check for valid entry in ToTeam}
with fmCBTTo do
 begin
  if ItemIndex < 0 then
   begin
    NoSave;
    Exit;
   end;
  if Text = '' then
   begin
    NoSave;
    Exit;
   end;
 end;

if ByTeam then exit;

{checks for position reassignments}
{. check for valid entry in FromPosition}
with fmCBPFrom do
 begin
   if ItemIndex < 0 then
    begin
     NoSave;
     Exit;
    end;
   if Text = '' then
    begin
     NoSave;
     Exit;
    end;
 end;
{. check for valid entry in ToPosition}
with fmCBPTo do
 begin
   if ItemIndex < 0 then
    begin
     NoSave;
     Exit;
    end;
   if Text = '' then
    begin
     NoSave;
     Exit;
    end;
 end;

end;

procedure TfrmMTReAsgn.NoSave;
begin
 cmdSave.Enabled := false;
end;


procedure TfrmMTReAsgn.IncAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to SrcList.Items.Count - 1 do
    DstList.Items.AddObject(SrcList.Items[I],
      SrcList.Items.Objects[I]);
  SrcList.Items.Clear;
  SetItem(SrcList, 0);
  UpdateSaveCancelBtns(true);
end;

procedure TfrmMTReAsgn.ExcludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(DstList);
  MoveSelected(DstList, SrcList.Items);
  SetItem(DstList, Index);
  UpdateSaveCancelBtns((DstList.items.count > 0){True - pdr});
end;

procedure TfrmMTReAsgn.ExAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to DstList.Items.Count - 1 do
    SrcList.Items.AddObject(DstList.Items[I], DstList.Items.Objects[I]);
  DstList.Items.Clear;
  SetItem(DstList, 0);
  UpdateSaveCancelBtns(False);
end;

procedure TfrmMTReAsgn.SetButtons;
var
  SrcEmpty, DstEmpty, SrcSelect, DstSelect : Boolean;
begin

  SrcEmpty := SrcList.Items.Count = 0;
  DstEmpty := DstList.Items.Count = 0;

  SrcSelect := SrcList.SelCount > 0;
  DstSelect := DstList.SelCount > 0;

  IncludeBtn.ENabled := SrcSelect;
  IncludeBtn.ENabled := not SrcEmpty;
  IncAllBtn.ENabled := not SrcEmpty;

  ExcludeBtn.ENabled := DstSelect;
  ExcludeBtn.ENabled := not DstEmpty;
  ExAllBtn.ENabled := not DstEmpty;

end;

function TfrmMTReAsgn.GetFirstSelection(List: TCustomListBox): Integer;
begin
  for Result := 0 to List.Items.Count - 1 do
    if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;

procedure TfrmMTReAsgn.cmdCancelClick(Sender: TObject);
begin
  ClearListBox(srcList);
  ClearListBox(dstList);
  UpdateSaveCancelBtns(False);
  SetButtons ;

end;

{================================================================}
{            Drag and Drop functionality                         }
{================================================================}

procedure TfrmMTReAsgn.UpdateCursor(Sender: TObject);
begin
  if Sender is TListBox then
     with TListBox(Sender) do
        if SelCount > 1 then
           DragCursor := crMultiDrag
        else
           DragCursor := crDrag;
end;

procedure TfrmMTReAsgn.SrcListClick(Sender: TObject);
begin
  UpdateCursor(Sender);
  SetButtons;
end;

procedure TfrmMTReAsgn.SrcListDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
   if (source is TListBox) and (TListBox(Source).Name = 'DstList') then
        ExcludeBtnClick(Sender);
end;

procedure TfrmMTReAsgn.SrcListDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
 if (source is TListBox) and (TListBox(Source).Name = 'DstList') then
        Accept := True;
end;


procedure TfrmMTReAsgn.DstListDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  if (source is TListBox) and
     (TListBox(Source).Name = 'SrcList') then
        IncludeBtnClick(Sender);
end;

procedure TfrmMTReAsgn.DstListDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if (source is TListBox) and
     (TListBox(Source).Name = 'SrcList') then
        Accept := True;
end;

procedure TfrmMTReAsgn.SrcListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (key = VK_F10) and (Shift = [ssShift])  then
        sendMessage(Handle, WM_RBUTTONDOWN, 0, 0)
end;

procedure TfrmMTReAsgn.DstListClick(Sender: TObject);
begin
  UpdateCursor(Sender);
  SetButtons   ;
end;

procedure TfrmMTReAsgn.DstListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (key = VK_F10) and (Shift = [ssShift])  then
        sendMessage(Handle, WM_RBUTTONDOWN, 0, 0)
end;

procedure TfrmMTReAsgn.cmdCloseClick(Sender: TObject);
begin
  close;
end;


procedure TfrmMTReAsgn.fmCBPFromClick(Sender: TObject);
begin
 ClearProcessed;
 if fmCBPFrom.Items.count < 1 then exit;
 if not SrcandDstPosDiff(TFMComboBoxLookup(sender)) then
  begin
   fmCBPFrom.itemindex:=-1;
   ClearListBox(SrcList);
   exit;
  end;
 FromPositionID := Piece(GetFMDelimRec(fmcbPFrom.FMLister,fmCBPFrom.ItemIndex), U, 1);
 GetPatients;
 SetPCRole;
end;

procedure TfrmMTReAsgn.print2Click(Sender: TObject);
var
   i: integer;
  tf: TextFile;
begin
  if PrintDialog1.Execute then
    begin
      AssignPrn(tf);
      try
        Screen.Cursor := crHourglass;
        Rewrite(tf);
        {Printer.Canvas.Font.Assign(memErrors.Font);}
        if (Sender as TMenuItem).Name = 'Print1' then begin
           writeln(tf, 'Available to Select');
           writeln(tf, '===================');
           writeln(tf,'');
           for i := 0 to SrcList.items.Count -1 do
              writeln(tf, SrcList.items[i]);
        end;

        if (Sender as TMenuItem).Name = 'Print2' then begin
           writeln(tf, 'Selected to Assign');
           writeln(tf, '===================');
           writeln(tf,'');
           for i := 0 to DstList.items.Count -1 do
              writeln(tf, DstList.items[i]);
        end;

      finally
        CloseFile(tf);
        Screen.Cursor := crDefault;
      end;
    end;

end;

procedure TfrmMTReAsgn.ClearListBox(list : TListBox);
var
  i     : integer;
  obj   : TObject;
begin
  for i := 0 to list.Items.Count - 1 do begin
     obj := list.Items.Objects[i];
     if Obj <> nil then
        TPatientID(obj).free;
  end;
  list.Items.Clear;
end;

procedure TfrmMTReAsgn.cmdSaveClick(Sender: TObject);
var
  i     : integer;
  obj   : TObject;
  AList : TStrings;
  s     : string[20];
begin
  AList := TStringList.Create;
  try
     UpdateSaveCancelBtns(False);
     for i := DstList.Items.Count - 1 downto 0 do
      begin
        obj := DstList.Items.Objects[i];
        s := TPatientID(obj).DFN +
             {PDR}'^' + TPatientID(obj).AssignIEN;
        AList.Add(s);
        {DstList.Items.Delete(i);}
      end;
  finally
     BuildAssignments(AList);
     if ByTeam then
      begin
       FileAssignments(job);
      end
     else
      begin
       FilePosAssignments(job);
      end;
  for i := DstList.Items.Count - 1 downto 0 do
  DstList.Items.Delete(i);
  DstList.items.Clear;
  AList.Free;
  SetButtons ;
 end;
cmdSave.Enabled := false;
end;

procedure TfrmMTReAsgn.BuildAssignments( sendlist : TStrings);
var
  i  : integer;
begin
  RPCBrokerMain.remoteProcedure := 'SCMC BLD REASSIGN PAT LIST'; { $$PTLSTBLD^PDMRBK - m call}
  with RPCBrokerMain.Param[0] do
     begin
        Value  := '"[Start]"'; {signal server that a new list of pt coming}
        Ptype  := literal;
     end;
  RPCBrokerMain.Call;

  if RPCBrokerMain.Results[0] = '0' then begin
     messagedlg('Unable to build patient list on server', mtWarning, [mbOk], 0);
     exit;
  end
  else
     job := RPCBrokerMain.Results[0];

  if debug then begin
     lbljob.caption := job;
     lbljob.visible := true;
     end;

  FrmMain.StatusMsg('Building Patient List...', false);

  for i := 0 to sendlist.count - 1 do begin
     RPCBrokerMain.remoteProcedure := 'SCMC BLD REASSIGN PAT LIST';
     with RPCBrokerMain.Param[0] do
        begin
           Value  := job + '^' + SendList[i]; {pdr Piece(SendList[i], U, 1) }
           Ptype  := literal;
        end;
     RPCBrokerMain.Call; {send the next pt to server to put on server list}

     if (RPCBrokerMain.Results[0] = '0') then begin
        messagedlg('Could not continue processing patients', mterror, [mbOk], 0);
        exit;
     end;
  end;
end;

procedure TfrmMTReAsgn.FileAssignments( jobID : string);
(*var
  i1, i2 : integer;
  s1, s2 : string[10];
  ErrLog : TScError;
  x      : string;*)
begin
  if fmCBTTo.Itemindex<0 then
   begin
    Application.MessageBox('Team to re-assign to required','Re-assignment Error',1);
    ReplaceSelections;
    exit;
   end;
  if not ConfirmTeamSave(DstList.Items.Count) then exit;
  {frmWait.lblWait.Caption := 'Please wait, processing your selections';
  frmWait.Show;}
  application.ProcessMessages;
  RPCBrokerMain.remoteProcedure := 'SCMC FILE PAT TM REASGN'; { $$PTFILE^SCMRBK}
  with RPCBrokerMain.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"JOB"']      := jobID;
        Mult['"TEAM"']     := ToTeamID; {TeamID.TeamIen;}
        Mult['"DATE"']     := TodayStr;
        Mult['"FROMTEAM"'] := FromTeamID; {PDR}
        Mult['"BKG"']      := '1'; {pdr - flag to run in bkg on server, equals "1": background,
                              otherwise foreground}
        {Mult['"NOP"'] := '1';} {use to prevent filing on server for testing}
        if chkbxPCAssign.Checked then
           Mult['"TYPE"'] := '1'
        else
           Mult['"TYPE"'] := '99';

        if chkbxRestrict.Checked then
           Mult['"RESTRICT"'] := '1'
        else
           Mult['"RESTRICT"'] := '0';

     end;
  FileReassignments;

end;

procedure TfrmMTReAsgn.FilePosAssignments( jobID : string);
(*var
  ErrLog : TScError;
  x      : string;*)
begin
    if (fmCBTTo.Itemindex < 0) or (fmCBpTo.Itemindex < 0)then
   begin
    Application.MessageBox('Team and Position to' + #13#10 +
                           ' re-assign to required','Re-assignment Error',1);
    ReplaceSelections;
    exit;
   end;

  if not ConfirmPosSave(dstList.items.count) then exit;

  {frmWait.lblWait.Caption := 'Please wait, processing your selections';
  frmWait.Show;}
  application.ProcessMessages;
  RPCBrokerMain.remoteProcedure := 'SCMC FILE PAT POS REASGN'; {routine: POSFILE^PDRMRBK}
  with RPCBrokerMain.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"JOB"']          := jobID;
        Mult['"TEAM"']         := ToTeamID;
        Mult['"FROMTEAM"']     := FromTeamID;
        Mult['"POSITION"']     := ToPositionID;
        Mult['"FROMPOSITION"'] := FromPositionID;
        Mult['"DATE"']         := TodayStr;
        If chkbxpcassign.checked = true then Mult['"TYPE"'] := inttostr(1)
        else Mult['"TYPE"'] := inttostr(0);
        // patch 177 Mult['"TYPE"']         := IntToStr(grpPrimaryCareOptions.ItemIndex);
        Mult['"BKG"']          := '1'; //flag to run in bkg on server, "1": background
        //Mult['"NOP"'] := '1';  //use to prevent filing on server for testing
      end;
  FileReassignments;

 end;

procedure TfrmMTReAsgn.FileReassignments;
var
x,y : string;
begin
  RPCBrokerMain.Call;
  {frmWait.close;}
  if RPCBrokerMain.results.count < 1 then
   begin
    MessageDlg('Unable to file reassignment',
     mtWarning,[mbOK],0);
    exit;
   end;
   x := RPCBrokerMain.Results[1];
   if (Piece(x,u,2)='BKG') then
    begin
     if (Piece(x,u,1)='') or (Piece(x,u,1)='0') then
      begin
       MessageDlg('Filer NOT queued on server!',
        mtWarning,[mbOK],0);
       DisplayProcessed('0');
       ExAllBtnClick(nil);
       exit;
      end
     else
      begin
       DisplayProcessed(piece(x,u,1));
      end;
     end
   else
     begin
      DisplayProcessed(Piece(x, U, 1));
     end;
 x := RPCBrokerMain.Results[0];
 y := 'Patient reassignments filed...';
 if (Piece(x, U, 1) <> emptystr) or (Piece(x, U, 1) <> '0') then
   frmMain.StatusMsg(y, true)
 else
   frmMain.StatusMsg(y, false)
end;

procedure TfrmMTReAsgn.FormCreate(Sender: TObject);
begin
  Self.top := 0;
  Self.left := 0;
  Frmmain.MultipleReAssignments1.Enabled := false;
  {TeamID := TAssignmentData.Create; }
  {cboSelectClick(nil);}
  UpdateSaveCancelBtns(False);

end;

function TfrmMTReAsgn.ConfirmTeamSave(cnt : integer) : boolean;
var
  cur, max : string[10];
begin
  getTeamInfo.IENS := ToTeamID;{TeamID.TeamIen;}
  getTeamInfo.GetData;

  cur := Piece(GetFMDelimRec(getTeamInfo,4), U, 5);{Piece(getTeamInfo.Results[3], U, 5); - PDR}
  if cur = emptystr then cur := '0';

  max := Piece(GetFMDelimRec(getTeamInfo,2), U, 5);{Piece(getTeamInfo.Results[1], U, 5); - PDR}
  if max = emptystr then max := '0';
  if (pos(',',max)>0) then
     repeat
           max := copy(max,1,pos(',',max)-1)+copy(max,pos(',',max)+1,99) ;
     until pos(',',max)=0 ;

  result := CheckTeamMax(StrToInt(cur) + cnt, StrToInt(max),'-');
end;

function TfrmMTReAsgn.ConfirmPosSave( cnt : integer) : boolean;
var
  cur, max : string[10];
  (*i : integer;*)
begin
  getPosAsgnInfo.IENS := ToPositionID;{TeamId.PositionIen;}
  getPosAsgnInfo.GetData;

  cur := Piece(GetFMDelimRec(getPosAsgnInfo,2), U, 5);{Piece(getPosAsgnInfo.Results[2], U, 5); - PDR}
  if cur = emptystr then cur := '0';

  max := Piece(GetFMDelimRec(getPosAsgnInfo,1), U, 5);{Piece(getPosAsgnInfo.Results[1], U, 5); - PDR}
  if max = emptystr then max := '0';
  if (pos(',',max)>0) then
     repeat
           max := copy(max,1,pos(',',max)-1)+copy(max,pos(',',max)+1,99) ;
     until pos(',',max)=0 ;

  result :=  CheckPositionMax(StrToInt(cur) + cnt, StrToInt(max),'-');
end;


procedure TfrmMTReAsgn.fmCBPTOClick(Sender: TObject);
begin
 SetPCRole;
 if not SrcandDstPosDiff(TFMComboBoxLookup(sender)) then
  begin
   fmCBPTO.itemindex:=-1;
   exit;
  end;
 ToPositionID := Piece(GetFMDelimRec(fmcbPTo.FMLister,fmCBPTo.ItemIndex), U, 1);
 ClearProcessed;
end;

procedure TfrmMTReAsgn.SetPCRole;
begin
 if fmcbPFrom.itemindex < 0 then exit;
 if fmcbPTo.itemindex < 0 then exit;
 if fmCBPTo.items.count < 1 then exit;
 {"TO" position cannot be set to PC if: 1. It's definition (fld 4) doesn't allow,
  or 2. The team it will be assigned to is not a PC team.}
 if (Piece(GetFMDelimRec(fmcbPTo.FMLister,fmCBPTo.ItemIndex), U, 3)<> 'YES')
    or (chkbxPCAssign.Checked=false) then
   SetPCPosOpt(false)
 else
  SetPCPosOpt(True);
end;

procedure TfrmMTReAsgn.SetPCPosOpt(PC:Boolean);
begin
 if PC then
      Chkbxpcassign.checked:=true
  //begin
   //patch 177 with grpPrimaryCareOptions do
    //begin
     //enabled := true;
     //ItemIndex := 1;
    //end
  //end
 else
      Chkbxpcassign.checked:=false;
  // patch 177 with grpPrimaryCareOptions do
   //begin
    //enabled := false;
    //ItemIndex := 0;
   //end
end;

procedure TfrmMTReAsgn.fmCBPFromEnter(Sender: TObject);
begin
 if fmCBTFrom.Itemindex < 0 then
  begin
   Application.MessageBox('Select "From" team first',
                         'Re-assignment Error',
                          MB_OK);
   Beep;

   SetFocusedControl(fmCBTFrom);
   exit;
  end;
end;

procedure TfrmMTReAsgn.fmCBPTOEnter(Sender: TObject);
begin
 if fmCBTTo.Itemindex < 0 then
  begin
   Application.MessageBox('Select "To" team first',
                         'Re-assignment Error',
                          MB_OK);
   Beep;

   SetFocusedControl(fmCBTTo);
   exit;
  end;
end;

procedure TfrmMTReAsgn.PopupCalendar(Sender: TObject);
begin
end;
(*var
  d: TOvcDate;
begin
  pf := TOvcPictureField(Sender);

  if pnlcalendar.visible then
     begin
        pnlCalendar.visible := false;
        exit;
     end;


  pnlCalendar.Top := pnlBase.top + TOvcPictureField(sender).Top
                     + TOvcPictureField(sender).Height + 10;
  pnlCalendar.left := grpAssignmentDates.left + txtFromDt.Left;
  d := pf.AsOvcDate;
  if d = BadDate then
     d := CurrentDate;
  Calendar.CalendarDate := d;
  pnlMonth.Caption := Copy(Calendar.MonthString, 1, 3) + '  ' +
                           IntToStr(Calendar.Year);

  pnlCalendar.BringToFront ;
  pnlCalendar.visible := true;
  Calendar.Setfocus;
end;*)

procedure TfrmMTReAsgn.txtFromDtExit(Sender: TObject);
var
s: string;
begin
 if ActiveControl = cmdCancel then exit;
 (*if Calendar.focused then exit;

 if pnlCalendar.Visible then
  pnlCalendar.Visible := false;*)
 s := ValStrToFMDate(txtFromDt.asString);
 if not txtFromDt.isValid or (s = '') then
  begin
   frmMain.StatusMsg('  Invalid date', true);
   txtFromDt.SetFocus;
   exit;
 end;

 if txtFromDt.asString='' then exit;

 FromDate := s;
 //FromDate := StrToFMDate(txtFromDt.asString);
 ResetPTList;
 UpdateOptionsCaption;
 txtToDt.RangeLo := txtFromDt.AsString;
end;

procedure TfrmMTReAsgn.txtToDtExit(Sender: TObject);
var
s: string;
begin
 if cmdClose.focused then exit;

  (*if Calendar.focused then exit;

  if pnlCalendar.Visible then
     pnlCalendar.Visible := false;*)
 s := ValStrToFMDate(txtFromDt.asString);
  if not txtTODt.isValid or (s = '') then
   begin
     frmMain.StatusMsg('  Invalid date', true);
     txtToDt.SetFocus;
     exit;
   end;
 if txtToDt.asString='' then exit;
 ToDate := s;
 //ToDate := StrToFMDate(txtToDt.asString);
 ResetPTList;
 UpdateOptionsCaption; 
end;

procedure TfrmMTReAsgn.ResetPTList; {Reset the Patient List}
begin
 SrcList.Clear;
 DstList.clear;
 fmCBPFrom.itemindex:=-1;
 fromPositionID:='';
end;

procedure TfrmMTReAsgn.rgAsnStatusClick(Sender: TObject);
begin
 case rgAsnStatus.Itemindex of
  0: begin
      txtFromDt.AsDateTime := now;
      txtToDt.AsDateTime := now;
      txtFromDt.Enabled := False;
      txtToDt.Enabled := False;
     end;
  1: begin
      txtFromDt.AsDateTime := now-30;
      txtToDt.AsDateTime := now-1;
      txtFromDt.Enabled := true;
      txtToDt.Enabled := true;
     end;
  2: begin
      txtFromDt.AsDateTime := now-30;
      txtToDt.AsDateTime := now;
      txtFromDt.Enabled := true;
      txtToDt.Enabled := false;
     end;
  end;
 txtToDtExit(nil);  {make sure FromDate and ToDate are set}
 txtFromDtExit(nil);
end;

procedure TfrmMTReAsgn.CalendarClick(Sender: TObject);
begin
 pf.AsOvcDate := Calendar.AsStDate;
 pnlCalendar.visible := false;
 pf.Setfocus;
 if Uppercase(pf.name)='TXTFROMDT' then {PDR}
  txtFromDtExit(Sender)
 else if Uppercase(pf.name)='TXTTODT' then
  txtToDTExit(sender);
end;

procedure TfrmMTReAsgn.CalendarKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_SPACE then CalendarClick(Sender);
end;

procedure TfrmMTReAsgn.HelpBtnClick(Sender: TObject);
begin
 if byTeam then
  Application.HelpContext(70200)
 else
  Application.HelpContext(702100);
end;

procedure TfrmMTReAsgn.DisplayProcessed(Processed : string);

var
{intPriorSumFound,}
 intPriorSumProcessed,
  intPriorProcessed{,
   intCount}: integer;

begin
 if grpEntries.Color = clHighlight then
  begin
   intPriorProcessed
    := strtoint(lblProcessed.Caption);
   intPriorSumProcessed
    := strtoint(lblPProcessed.Caption) +
     intPriorProcessed;
   lblPProcessed.Caption :=
    inttostr(intPriorSumProcessed);
   grpPriorEntries.Visible := true;
  end;
 lblProcessed.Caption := Processed;
 with grpEntries do
  begin
   color := clHighlight;
   font.color := clWhite;
  end;
 //grpEntries.Color := clHighlight;
end;

procedure TfrmMTReAsgn.ClearProcessed;
begin
if grpEntries.Color <> clBtnFace then
 begin
  lblProcessed.Caption := '0';
  lblCount.Caption := '0';
  with grpEntries do
   begin
    color := clBtnFace;
    font.color := clBlack;
   end;
  //grpEntries.Color := clBtnFace;

  grpPriorEntries.Visible := false;
  lblPProcessed.Caption := '0';

 end;
UpDateSaveCancelBtns(true);
end;

procedure TfrmMTReAsgn.fmCBTFromChange(Sender: TObject);
begin
ClearProcessed;
if not ByTeam then
 begin
  with fmCBPFrom do
   begin
    Enabled := true;
    color := clWindow;
   end;

  with fmCBTFrom do
   begin
    if ItemIndex < 0 then
     begin
     DisablefmCBPFrom;
     exit;
     end;
    if Text = '' then
     begin
      DisablefmCBPFrom;
      exit;
     end;
   end;
  end;
end;

procedure TfrmMTReAsgn.fmCBTToChange(Sender: TObject);
begin
ClearProcessed;
if not ByTeam then
 begin
  with fmCBPTo do
   begin
    Enabled := true;
    Color := clWindow;
   end;

  with fmCBTTo do
   begin
    if ItemIndex < 0 then
     begin
     DisablefmCBPTo;
     exit;
     end;
    if Text = '' then
     begin
      DisablefmCBPTo;
      exit;
     end;
   end;
 end;
end;

procedure TfrmMTReAsgn.disablefmCBPFrom;
begin
    with fmCBPFrom do
     begin
      Enabled := false;
      Color := clBtnFace;
      Text := '';
     end;
end;

procedure TfrmMTReAsgn.disablefmCBPTo;
begin
    with fmCBPTo do
     begin
      Enabled := false;
      Color := clBtnFace;
      Text := '';
     end;
end;

procedure TfrmMTReAsgn.fmCBPFromChange(Sender: TObject);
begin
 ClearProcessed;
end;

procedure TfrmMTReAsgn.fmCBPTOChange(Sender: TObject);
begin
 ClearProcessed;
end;


function TfrmMTReAsgn.TodayStr: string;
begin
 result := StrToFMDate(FormatDateTime('mm/dd/yyyy', Now));
end;

procedure TfrmMTReAsgn.txtDtDblClick(Sender: TObject);
begin
 with frmEnterDate do
  begin
   Caption := 'Select Date:';
   if TOvcPictureField(Sender).Name = 'txtFromDt' then
     begin
       if txtFromDt.AsOvcDate = BadDate then
         initDate := SysUtils.Date
       else
         initDate := txtFromDt.AsDateTime;
     end
   else
     begin
       if txtToDt.AsOvcDate = BadDate then
         initDate := SysUtils.Date
       else
         initDate := txtToDt.AsDateTime;
     end;
    if ShowModal = mrOk
     then
      if TOvcPictureField(Sender).Name = 'txtFromDt'
       then txtFromDt.AsString := strDate
       else txtToDt.AsString   := strDate;
  end;
end;



procedure TfrmMTReAsgn.Button1Click(Sender: TObject);
begin
frmMain.StatusSplash(1,true,true);
end;

procedure TfrmMTReAsgn.chkbxPCAssignEnter(Sender: TObject);
begin
UpdateOptionsCaption;
end;

procedure TfrmMTReAsgn.UpdateOptionsCaption;
var
o1,o2,o3: string;
begin
o1 := '';
if chkbxPCAssign.Checked then o1 := ' [PC Assign]';

o2 := '';
if chkbxRestrict.Checked then o2 := ' [Rest. Consult]';

o3 := '';
with rgAsnStatus do
 begin
  if ItemIndex = 1 then o3 := ' [Discharged]';
  if ItemIndex = 2 then o3 := ' [Both]';
 end;

TabSheetOptions.Caption := '&Options' + o1 + o2 + o3;
end;

procedure TfrmMTReAsgn.PageControl1Change(Sender: TObject);
begin
UpdateOptionsCaption;
end;

procedure TfrmMTReAsgn.chkbxPCAssignClick(Sender: TObject);
begin
UpdateOptionsCaption;
end;

procedure TfrmMTReAsgn.chkbxRestrictClick(Sender: TObject);
begin
UpdateOptionsCaption;
end;

end.
