{*******************************************************************}
{                                                                   }
{     Main entry point for the Primary Care Management Module.      }
{     a component of the Scheduling Redesign Project                }
{                                                                   }
{     Scheduling ver 5.3 AUG 13, 1993                               }      
{     Management Information Products Group                         }
{     Albany NY                                                     }
{     Dept. of Veteran Affairs                                      }
{     June 1995  (SCK)                                              }
{                                                                   }
{     Last updated: 28 May 2002 (J. Peterson)                       }
{                                                                   }
{*******************************************************************}

unit Pcmm1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, Buttons, ExtCtrls, StdCtrls, IniFiles,
  Fmcmpnts, Fmlookup, Scutdef, Trpcb, Fmcntrls, TabNotBk,
  Scut2, Scut3, ScutbrK, Mfunstr, Rptutl, envydcp1, Diaccess, OleCtrls,
  {OleCtrls_Resizer, OlectraResizer_TLB,} VerInfo;


type
  TfrmMain = class(TForm)
    pnlToolbar: TPanel;
    cmdClose: TSpeedButton;
    mnuMain: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Window1: TMenuItem;
    N3: TMenuItem;
    ArrangeAll1: TMenuItem;
    Cascade1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    HowtoUseHelp1: TMenuItem;
    Contents1: TMenuItem;
    Options1: TMenuItem;
    Preferences1: TMenuItem;
    cmdHelp: TSpeedButton;
    Panel1: TPanel;
    Logon1: TMenuItem;
    Logoff1: TMenuItem;
    N1: TMenuItem;
    cmdLogon: TSpeedButton;
    Patient1: TMenuItem;
    Team1: TMenuItem;
    Teamsetup1: TMenuItem;
    PositionAssignments1: TMenuItem;
    cmdTeam: TSpeedButton;
    cmdPatient: TSpeedButton;
    ToolBar1: TMenuItem;
    N2: TMenuItem;
    FontDialog1: TFontDialog;
    ColorDialog1: TColorDialog;
    Fonts1: TMenuItem;
    Colors1: TMenuItem;
    Tools1: TMenuItem;
    TableManagement1: TMenuItem;
    Default1: TMenuItem;
    RPCBroker1: TRPCBroker;
    PatientAssign: TMenuItem;
    Reports1: TMenuItem;
    pnlStatus: TPanel;
    pnlTime: TPanel;
    pnlNum: TPanel;
    pnlOvr: TPanel;
    N4: TMenuItem;
    ActiveOnly1: TMenuItem;
    cmdOpen: TSpeedButton;
    cmdNew: TSpeedButton;
    pnlConnectStatus: TPanel;
    tmrStatusMsg: TTimer;
    tmrTimeOut: TTimer;
    SelectDHCPDevice1: TMenuItem;
    SelectReport1: TMenuItem;
    cmdposition: TSpeedButton;
    TeamAssignments1: TMenuItem;
    N7: TMenuItem;
    MultipleAssignments1: TMenuItem;
    N8: TMenuItem;
    ShowAllTeams: TMenuItem;
    AssignStaff1: TMenuItem;
    TeamAssignment1: TMenuItem;
    TeamDischarge1: TMenuItem;
    PositionAssignment1: TMenuItem;
    PositionDischarge1: TMenuItem;
    FMLookUp1: TFMLookUp;
    ltrTeam: TFMLister;
    ltrPosition1: TFMLister;
    AutoLinks1: TMenuItem;
    lkpPosition: TFMLookUp;
    N10: TMenuItem;
    CopyTeamAssignments1: TMenuItem;
    CopyPositionAssignments1: TMenuItem;
    ltrPosition2: TFMLister;
    getTeamInfo: TFMGets;
    AboutBoxDlg1: TCoolAboutDlg;
    mnuPrimCare: TMenuItem;
    pnlShowColor: TPanel;
    MultipleReAssignments1: TMenuItem;
    TeamReAssignment1: TMenuItem;
    PositionReassignment1: TMenuItem;
    PCMMParameters1: TMenuItem;
    statusmemo: TMemo;
    DirectPCFTEE1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure ArrangeAll1Click(Sender: TObject);
    procedure Logon1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure PositionAsgn1Click(Sender: TObject);
    procedure cmdTeamClick(Sender: TObject);
    procedure Teamsetup1Click(Sender: TObject);
    procedure HowtoUseHelp1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ToolBar1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PatientAssignClick(Sender: TObject);
    procedure Fonts1Click(Sender: TObject);
    procedure Colors1Click(Sender: TObject);
    procedure TableManagement1Click(Sender: TObject);
    procedure Default1Click(Sender: TObject);
    procedure AppIdle(Sender: TObject; var Done: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure UpdateMenus(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmdLogonClick(Sender: TObject);
    procedure Logoff1Click(Sender: TObject);
    procedure ActiveOnly1Click(Sender: TObject);
    procedure tmrStatusMsgTimer(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure ExceptionHandler(Sender: TObject; E: Exception);
    procedure ShowAllTeamsClick(Sender: TObject);
    procedure AssignStaff1Click(Sender: TObject);
    procedure TeamAssignment1Click(Sender: TObject);
    procedure AutoLinks1Click(Sender: TObject);
    procedure SelectReport1Click(Sender: TObject);
    procedure PositionAssignment1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RPCBroker1NetError(Sender: TObject; var Error: EBrokerError);
    procedure mnuPrimCareClick(Sender: TObject);
    procedure TeamReAssignment1Click(Sender: TObject);
    procedure PositionReassignment1Click(Sender: TObject);
    procedure PCMMParameters1Click(Sender: TObject);
    procedure DirectPCFTEE1Click(Sender: TObject);
  private
    { Private declarations }
     //bp/cmf 204 remove bypass: boolean;
     MessageID: Word;
     fh,fw:double;
     VerInfoRes: TVerInfoRes;
     procedure OnAppMessage(var Msg: TMsg; var Handled: Boolean);
     function AppHelp(Command: Word; Data: Longint; var CallHelp: Boolean): Boolean;{PDR}
     procedure GetVersionInfo;
     procedure OnLogonFail(i: integer);
  public
    { Public declarations }
    MemoryErrFlag, DeleteEnabled, SetupEnabled : Boolean;
    ShowMenu, Debug, UsrClsEnabled, AlnkEnabled : boolean;
    UserRecord : TScUser;
    StaffShortcut: boolean;
    function CheckVersion: boolean;
    procedure StatusMsg(msg: string; beep: bool);
    procedure LoadSettings;
    function AppClosed: boolean;
    procedure StatusSplash(MsgNo: integer; beep,splash: boolean);
  end;

  TVersionInfoRecord = record
      viCompanyName : string[20];
      viComments : string[20];
      viFileDescription : string[20];
      viFileVersion : string[20];
      viInternalName : string[20];
      viLegalCopyright : string[20];
      viLegalTrademarks : string[20];
      viOriginalFilename : string[20];
    end;

var
  frmMain: TfrmMain;
  PcmmParams: string;
  TimeOut : Boolean;
  tp: TProfile;
  CurrentFont: TFont;
  RPCBrokerMain  : TRPCBroker;
  TeamInfo : TAssignmentData;
  clicked:  boolean ;
  ClientTimeOut: Integer;

const
  UM_CLOSEAPPLICATION = WM_USER + 24;
  DELETE_KEY = 'SC PCMM DELETE';
  SETUP_KEY = 'SC PCMM SETUP' ;

implementation

uses Teamdef1, Pstndef1, Scptpf, Enterdt, Asgnstaf, Mtassign, Autosel,
     rpttemp, rpcconf1, MTReAsgn, parameters, Asgnstaf1, dmuTeamPosition,
  PCFtee;

{$R *.DFM}
var
  VersionInfoRecord: TVersionInfoRecord;

const VerNameArray: array[1..8] of String =
      ('Company Name', 'Comments', 'File Description',
       'File Version', 'Internal Name', 'Legal Copyright',
       'Legal Trademarks', 'Original Filename');

function TfrmMain.AppHelp(Command: Word; Data: Longint; var CallHelp: Boolean): Boolean;{PDR}
begin
 Application.HelpFile := 'PCMM.hlp';
 Callhelp := True;
 Result:=true;
end;

procedure TfrmMain.OnAppMessage(var Msg: TMsg; var Handled: Boolean);
begin
  if Msg.Message = UM_CLOSEAPPLICATION then
     close;

  if Msg.Message = MessageID then
     begin
        Application.Restore;
        {SetFocus;}
     end;

  if Msg.Message = WM_EndSession then
     if WordBool(Msg.wparam) then
        Halt;

end;


procedure TfrmMain.FormCreate(Sender: TObject);
var
  i: Integer;
  msg,x: string;
begin
    Application.OnHelp := AppHelp; {PDR}
    Application.OnException := ExceptionHandler;
    if not MemoryOk then begin
     msg := 'Insufficient memory to start the PCMM application' + RETURN +
        'Please close any other open Window Applications and try again.';
     raise EInsufficientMemory.create(msg);
     end
  else
     begin
        Font.Assign(FontDialog1.Font);
        Application.OnMessage := OnAppMessage;

        if Screen.Width > 640 then
           begin
              frmMain.width := 7 * (Screen.Width div 8);
              frmMain.Height := 9 * (Screen.Height div 10);
           end
        else
           frmMain.WindowState := wsMaximized;
     end;
  UserRecord := TScUser.Create;
  TeamInfo := TAssignmentData.Create;
  Application.OnIdle := AppIdle;
  ShowMenu := true;
  MemoryErrFLag := false;
  GetVersionInfo;
  RPCBrokerMain := RPCBroker1;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  TeamInfo.Free;
end;

procedure TfrmMain.AppIdle(Sender: TObject; var Done: Boolean);
var
  KeyStates: TKeyboardState;
begin
  pnlTime.caption := FormatDateTime('h:mm am/pm', Time);
  GetKeyBoardState(KeyStates);

  if Odd(KeyStates[VK_NUMLOCK]) then
     pnlNum.caption := 'NUM'
  else
     pnlNum.Caption := '';

  if Odd(KeyStates[VK_INSERT]) then
     pnlOvr.caption := 'OVR'
  else
     pnlOvr.caption := 'INS';

end;

{
  Exception handling to close down application on a broker error, or
  insufficient memory.
}
procedure TfrmMain.ExceptionHandler(Sender: TObject; E: Exception);
var
  s: string;
begin
  s := E.ClassName;
  if s = 'EInsufficientMemory' then
     begin
        if MDIChildCount = 0 then begin
           messageDlg(E.Message, mtWarning, [mbOk,mbHelp], 0);
           halt;
           end
        else begin
           if messageDlg(E.Message, mtWarning, [mbOk,mbAbort,mbHelp], 0)
                         = mrAbort then
              halt;
           end;
     end
  else
     if messagedlg(s + RETURN + E.Message, mtWarning, [mbIgnore,mbAbort,mbHelp],
                   0) = mrAbort then
        halt;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  LoadSettings;
  pnlConnectStatus.Caption := ' No Connection';
  UpdateMenus(Sender);
  cmdLogon.Down := false;
  fh:=Height;
  fw:=width;
end;

procedure TfrmMain.LoadSettings;
var
  AppIni: TIniFile;
  fs : string ;         {new}
  fc: longint ;         {new}
  i, i1: integer ;      {new}
begin
  AppIni := TIniFile.Create('PCMM.INI');
  ToolBar1.Checked := AppIni.ReadBool('GENERAL', 'TOOLBAR', TRUE);
  pnlToolBar.Visible := ToolBar1.Checked;
  ActiveOnly1.checked := AppIni.ReadBool('GENERAL', 'TeamSelection', TRUE);
  mnuPrimCare.Checked := AppIni.ReadBool('GENERAL', 'PrimaryCare', True) ;


  frmMain.Font.Name := AppIni.ReadString('Font', 'Name', 'Arial' );
  frmMain.Font.Size := AppIni.ReadInteger('Font', 'Size', 9 );
  fs := AppIni.ReadString('Font', 'Style', '');
  frmMain.Font.Style := [] ;
  if (Pos('Bold', fs)>0) then
      frmMain.Font.Style := frmMain.Font.Style + [fsBold] ;
  if (Pos('Italic', fs)>0) then
      frmMain.Font.Style := frmMain.Font.Style + [fsItalic] ;
  frmMain.Font.Color := clBlack ;
  frmMain.Color := TColor(AppIni.ReadInteger('Color', 'Color', ColorToRGB(clInactiveBorder))) ;
  AppIni.Free;

  with frmMain do
     begin
        for i := 0 to MDIChildCount - 1 do
           for i1 := 0 to MDIChildren[i].ComponentCount - 1 do
              begin
                 MDIChildren[i].Font := Font;
                 {MDIChildren[i].Color := Color;}   {NO - main form only! - REV}
                 with MDIChildren[i] do
                    if Components[i1] is TTabbedNoteBook then
                       TTabbedNoteBook(Components[i1]).Font := Font;
              end;
  end;

end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
end;
(*var
 fhr,fwr:double;
 i:integer;
begin
{  if (fh=0) or (fw=0) then exit;
  if (abs(height - fh)>50) or (abs(width - fw)>50) then
   begin
    fhr:= height/fh;
    fwr:=width/fw;
    cmdHelp.Left := (frmMain.Width - cmdHelp.Width) - 25;
    for i:= mdichildcount-1 downto 0 do
     begin
      mdichildren[i].height := round(mdichildren[i].height * fhr);
      mdichildren[i].width := round(mdichildren[i].width * fwr);
      ReSizeFormBySides(mdichildren[i],fhr,fwr,font.name);
     end;
    fh:=height;
    fw:=width;
    fw:=width;
 end; }
end;*)

{  When the close event is initiated, the close query checks to see if the
network connection is still active.  Display dialog box if it is.  If Yes is
clicked, then close and exit, otherwise cancel the close action.}

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
   i: Integer;
begin
  if MDIChildCount > 0 then
     if messagedlg('Close all forms?', mtConfirmation, [mbYes,mbAbort], 0)
                   = mrYes then
        begin
           for i := 0 to MDIChildCount - 1 do
              begin
                 MDIChildren[i].Close;
                 RPCBrokerMain.Connected := false;
              end;
        end
     else
        CanCLose := false;

end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

{  =============  Menu actions =================================}

{  Logon menu action, makes network connection sets object properties as needed}
procedure TfrmMain.Logon1Click(Sender: TObject);
var
  err,i : integer;
  s,x   : string;
  pvsync : string;
  ServerName, PortID: string;
begin
  for i := 1 to paramcount do
   begin
    {getting parameters from the command line for server name and port}
    x := uppercase(piece(paramstr(i),'=',1));
    if (x='S') or (x='SERVER') then ServerName := piece(paramstr(i),'=',2);
    if (x='P') or (x='PORT') then PortID := piece(paramstr(i),'=',2);
   end; {for loop}
  {server and port not passed in on command line}
  if (ServerName = '') or (PortID = '') then
   begin
    err := GetServerInfo(ServerName, PortID);
    if err <> mrOk then begin
     cmdLogon.down := false;
     exit;
    end; {error condition}
   end; {getting server info when '' condition}

  RPCBrokerMain.RPCTimeLimit := 30;  //default
  RPCBrokerMain.Server := ServerName;
  RPCBrokerMain.ListenerPort := StrToInt(PortID);
  RPCBrokerMain.Connected := true;

  if RPCBrokerMain.Connected <> true then
    begin
       cmdLogon.Down := False ;
       exit;
    end ;

  if RPCBrokerMain.CreateContext('SCMC PCMM GUI WORKSTATION') then
     begin

        cmdLogon.Hint := 'Disconnect from VistA';
        UserRecord.LoadCurrentUser(RPCBrokerMain);
        with RPCBrokerMain do
             begin
              RemoteProcedure := 'SCMC VERIFY C/S SYNC';
              with param[0] do
               begin
                value := VersionInfoRecord.viInternalName
                      + U +
                      VersionInfoRecord.viFileVersion;
                PType := literal;
               end;
              pvsync := strcall;
             end;
        if pvsync = '0' then
         begin
         OnLogonFail(1);
         exit;
         end;

        RPCBrokerMain.RPCTimeLimit := StrToInt(pvsync);

        PcmmParams := GlobalNode(RPCBrokerMain, '^SD(404.91,1,"PCMM")');
        AlnkEnabled := (Piece(PcmmParams, U, 3) = '1');
        UsrClsEnabled := (Piece(PcmmParams, U, 1) = '1');
        DeleteEnabled := SecurityKeyOk(RPCBrokerMain, DELETE_KEY);
        SetupEnabled := SecurityKeyOk(RPCBrokerMain, SETUP_KEY);
        messageBeep(0);
        with UserRecord do
           pnlConnectStatus.Caption := 'Serv:' + node + '  ' + 'Acct:' +
                                        Uci + '|' + Volume;

        cmdLogon.down := true;
        UpdateMenus(Sender);
        StatusMsg(UserRecord.Name, False);
     end
  else
     begin
       OnLogonFail(0);
       exit;
     end;
end;


procedure TfrmMain.OnLogonFail(i: integer);
var
LogonMsg: string;

begin
RPCBrokerMain.Connected := false;

 case i of
  0: LogonMsg :=
     'Sorry, either you are not currently registered to use'
     + RETURN +
     'this application, or the option is currently out of '
     + RETURN +
     'order on the server.';

  1: LogonMsg :=
     'Sorry, client version  "'
     + VersionInfoRecord.viFileVersion +
     '"  of PCMM requires'
     + RETURN +
     'VISTA server patch  "'
     + VersionInfoRecord.viInternalName +
     '"  to run successfully.';

  2: LogonMsg :=
     'Sorry, client test version  "'
     + VersionInfoRecord.viFileVersion +
     '"  of PCMM is not intended'
     + RETURN +
     'for use at this facility.';
 end;

LogonMsg :=
     LogonMsg
     + RETURN +
    'Please contact your Supervisor ' +
    'or IRM staff for assistance.';

MessageDlg(LogonMsg,mtWarning,[mbOk],0);
cmdLogon.Down := false;

end;

procedure TfrmMain.cmdLogonClick(Sender: TObject);
begin
  {Added code to defeat double-click GPF problem with WinNT}
  if clicked then exit else clicked := True ;       {new}

  if cmdLogon.Down = true then
     Logon1Click(Sender)
  else
     LogOff1Click(Sender);

  UpdateMenus(nil);
  clicked := False ;    {new}
end;

procedure TfrmMain.Logoff1Click(Sender: TObject);
var
  i: integer;
begin
  if not RPCBrokerMain.Connected then exit;

  if MDIChildCount > 0 then
     if messageDlg('This will close down all PCMM windows.' + RETURN +
                   'Do you want to continue?', mtConfirmation, [mbYes, mbNo], 0)
                    = mrYes then
        for i := 0 to MDIChildCount -1 do
          begin
            MDIChildren[i].Close;
            RPCBrokerMain.Connected := false;
          end
     else
        begin
           cmdLogon.down := true;
           exit;
        end;

  RPCBrokerMain.Connected := false;
  messageBeep(0);
  pnlConnectStatus.Caption := ' Not Connected.';
  cmdLogon.Hint := 'Connect to VistA';
  UpdateMenus(nil);
  cmdLogon.down := false;
end;


{  Create the Team setup window and open as a child form.  Disable the menu
item to prevent additional team setup windows from being opened.}
procedure TfrmMain.Teamsetup1Click(Sender: TObject);
var
  new : boolean;
begin
  if not MemoryOk then
     raise EInsufficientMemory.create('Insufficient memory to open Team Setup form')
  else begin
     with FMLookUp1 do begin
        FMLister.FromList.clear; {pdr}
        FMLister.FromList.Insert(0,EmptyStr);{From := EmptyStr; - PDR}
        FMLister.FromIen := EmptyStr;
        FMLister.PartList.clear; {pdr}
        FMLister.PartList.Insert(0,EmptyStr); {Part := EmptyStr; - PDR}
        FMLister.Number := '*';
        Title := 'Select Team';
        AllowNew := true;

        if ActiveOnly1.checked then
           FMLister.Screen := 'IF $$ACTHISTB^SCAPMCU1(404.58,Y)'
        else
           FMLister.Screen := EmptyStr;

        if execute(new) then begin
           Application.CreateForm(TfrmTeamProfile, frmTeamProfile);
           Application.ProcessMessages;
           frmTeamProfile.enabled := false;
           if new then
              frmTeamProfile.TmProfile.TeamIen := NEW_ENTRY
           else
              frmTeamProfile.TmProfile.TeamIen := FMLookUp1.RecordNumber;

           frmTeamProfile.RunForm;
        end;
     end;
  end;
end;


{  Open the setup window for team positions }
procedure TfrmMain.PositionAsgn1Click(Sender: TObject);
var
  new : boolean;
begin
  if not MemoryOk then
     raise EInsufficientMemory.create('Insufficient memory to open Team Setup form')
  else begin
     with FMLookUp1 do begin
        FMLister.FromList.clear; {PDR}
        FMLister.FromList.Insert(0,EmptyStr);{From := EmptyStr; - PDR}
        FMLister.FromIen := EmptyStr;
        FMLister.PartList.clear; {PDR}
        FMLister.PartList.Insert(0,EmptyStr);{Part := EmptyStr; - PDR}
        FMLister.Number := '*';
        Title := 'Select Team';
        AllowNew := false;

        if ActiveOnly1.checked then
           FMLister.Screen := 'IF $$ACTHISTB^SCAPMCU1(404.58,Y)'
        else
           FMLister.Screen := EmptyStr;

        if execute(new) then begin
           Application.CreateForm(TfrmAssigned, frmAssigned);
           Application.ProcessMessages;
           frmAssigned.enabled := false;
           frmAssigned.PsProfile.TeamIen := FMLookUp1.RecordNumber;
           frmAssigned.PsProfile.TeamName :=
                  Piece(GlobalNode(RPCBrokerMain,'^SCTM(404.51,'+ FMLookUp1.RecordNumber + ',0)'),U,1);
           frmAssigned.RunForm;
        end;
     end;
  end;
end;

procedure TfrmMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.About1Click(Sender: TObject);

begin
//bp/cmf/169/GetVersionInfo;

 with AboutBoxDlg1 do
  begin
  Version := 'Version ' + VersionInfoRecord.viFileVersion;
  Copyright := VersionInfoRecord.viLegalCopyright;
  Comment1 := VersionInfoRecord.viCompanyName;
  Comment2 := VersionInfoRecord.viInternalName;
  Product := VersionInfoRecord.viFileDescription;
  Execute;
  end;
end;

procedure TfrmMain.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TfrmMain.ArrangeAll1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TfrmMain.HowtoUseHelp1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_HELPONHELP, 0);
end;

procedure TfrmMain.Contents1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS,100);
end;

procedure TfrmMain.ToolBar1Click(Sender: TObject);
var
  AppIni: TIniFile;
begin
  AppIni := TIniFile.Create('PCMM.INI');

  if ToolBar1.Checked then
     ToolBar1.Checked := false
  else
     ToolBar1.Checked := true;

  AppIni.WriteBool('General', 'ToolBar', ToolBar1.Checked);
  pnlToolBar.visible := ToolBar1.Checked;
  AppIni.Free;
end;

{   ==============  Speed Buttons ======================================}


{  Speedbutton to call the team setup menu action}
procedure TfrmMain.cmdTeamClick(Sender: TObject);
begin
  TeamSetup1.Click;
end;

procedure TfrmMain.PatientAssignClick(Sender: TObject);
begin
  if not MemoryOk then
     raise EInsufficientMemory.create('Insufficient memory to open Patient Assignment form')
 else
     begin
        application.CreateForm(TPatientAsgn, PatientAsgn);
     end;
end;


{   =================  Form Misc Methods =================================}

procedure TfrmMain.UpdateMenus(Sender: TObject);
begin
  with RPCBrokerMain do
     begin
        if ShowMenu then
           begin

              TeamSetup1.Enabled            := Connected and SetupEnabled;
              PositionAssignments1.enabled  := Connected and SetupEnabled;
              AssignStaff1.enabled          := connected and SetupEnabled;
              {AutoLinks1.enabled            := frmMain.AlnkEnabled; - PDR}
              cmdTeam.Enabled               := Connected and SetupEnabled;
              cmdPosition.enabled           := Connected and SetupEnabled;
              {SelectDHCPDevice1.enabled    := Connected; }
              SelectReport1.enabled         := connected and SetupEnabled;
              PatientAssign.Enabled         := connected;
              Patient1.Enabled              := connected ;
              cmdPatient.Enabled            := Connected;
              MultipleAssignments1.Enabled  := Connected and SetupEnabled;
              MultipleReassignments1.Enabled  := Connected and SetupEnabled;
              Preferences1.Enabled          := Connected and SetupEnabled;
              Team1.Enabled                 := Connected and SetupEnabled;
              Reports1.Enabled              := Connected and SetupEnabled;
              Window1.Enabled               := Connected and SetupEnabled;
              ShowAllTeams.Enabled          := SetupEnabled;
              Pcmmparameters1.enabled       := Connected and Setupenabled;
           end;

        Logon1.Enabled := not connected;
        LogOff1.Enabled := Connected;
     end;
end;

function TfrmMain.AppClosed: boolean;
var
  msg: string;
  s: string[5];
begin
  result := false;
  s := GlobalNode(RPCBrokerMain, '^TMP("PCMM","STATUS")');
  if (Comparetext(s, 'Q') = 0) then
     begin
        msg := GlobalNode(RPCBrokerMain, '^TMP("PCMM", "STATUS", "MSG")');
        if msg = UNDEFINED_NODE then
           msg := 'PCMM is currently Out of Order.  Please be patient';
        messageBeep(0);
        MessageDlg(msg, mtWarning, [mbOk,mbHelp], 0);
        result := true;
     end;
end;


function TfrmMain.CheckVersion;
var
  ver, SVer: string[10];
  msg: string;
begin
  SVer := GlobalNode(RPCBrokerMain, '^TMP("PCMM","VERSION")');
  if (Comparetext(AboutBoxDlg1.Version, SVer) < 0) then
     begin
        msg := 'Version ' + SVer + ' is now available.' + RETURN +
              'Please update as soon as possible';
           messagebeep(MB_ICONEXCLAMATION);
           Messagedlg(msg, mtInformation, [mbOk,mbHelp], 0);
        Result := False
     end
  else
     Result := True ;
end;


procedure TfrmMain.Fonts1Click(Sender: TObject);
var
  i, i1: integer;
  fs: string ;               {new}
  AppIni: TIniFile ;
begin
     FontDialog1.Font := frmMain.Font;
     fs := '' ;                              {new}
     if FontDialog1.Execute then
        begin
           Font.Assign(FontDialog1.Font);
           for i := 0 to frmMain.MDIChildCount - 1 do
              for i1 := 0 to frmMain.MDIChildren[i].ComponentCount - 1 do
                 begin
                    frmMain.MDIChildren[i].Font := Font;
                    with MDIChildren[i] do
                    if Components[i1] is TTabbedNoteBook then
                       TTabbedNoteBook(Components[i1]).Font := Font;
                 end;

           { Added 1/28/97 - SAVE font preferences }
           if ([fsBold] <= FontDialog1.Font.Style) then
              fs := fs + 'Bold' ;
           if ([fsItalic] <= FontDialog1.Font.Style) then
              fs := fs + 'Italic' ;
           AppIni := TIniFile.Create('PCMM.INI');
           AppIni.WriteString('Font', 'Name', FontDialog1.Font.Name);
           AppIni.WriteInteger('Font', 'Size', FontDialog1.Font.Size);
           AppIni.WriteString('Font', 'Style', fs);
           { end new code 1/28/97 - RV }

           AppIni.Free;
        end;
end;

procedure TfrmMain.Colors1Click(Sender: TObject);
var
   i: integer ;
   AppIni: TIniFile ;
begin
  ColorDialog1.color := frmMain.Color;
  if ColorDialog1.Execute then
     begin
     {new - 1/30/97 - RV}
        AppIni := TIniFile.Create('PCMM.INI');
        AppIni.WriteInteger('Color', 'Color', ColorToRGB(ColorDialog1.Color)) ;
        AppIni.Free;

        {with frmMain do
          for i := 0 to MDIChildCount - 1 do
              MDIChildren[i].Color := ColorDialog1.Color;} {MAIN form only - 2-10-97 - REV}

     frmMain.Color := ColorDialog1.Color;
     {flash panel to force repaint of client area of form}
     with pnlShowColor do
          begin
              Align := alClient ;
              Visible := True ;
              Visible:= False ;
              Align := alNone ;
              Height := 25 ;
              Width := 25 ;
              Left := 8 ;
              Top := 88 ;
          end ;

     end;
     { end new code 1/30/97 - RV }
end;

procedure TfrmMain.TableManagement1Click(Sender: TObject);
begin
  Notyet;
end;

{ Reset all forms' FONT and COLOR to basic defaults.
  Added COLOR reset 1/29/97 - RV
}
procedure TfrmMain.Default1Click(Sender: TObject);
var
  AppIni: TIniFile;
  i, i1: integer;
begin
  AppIni := TIniFile.Create('PCMM.INI');
  AppIni.EraseSection('Font');
  AppIni.EraseSection('Color');        {new}
  AppIni.WriteBool('General','PrimaryCare', TRUE) ;    {new}
  AppIni.Free;

  mnuPrimCare.Checked := True ;
  frmMain.Font.Name :=  'Arial';
  frmMain.Font.size := 9;
  frmMain.Font.style := [];
  frmMain.Font.Color := clBlack;
  frmMain.Color := clInactiveBorder ;   {new}
  FontDialog1.Font := frmMain.Font ;

  with frmMain do
     begin
        for i := 0 to MDIChildCount - 1 do
           for i1 := 0 to MDIChildren[i].ComponentCount - 1 do
              begin
                 MDIChildren[i].Font := Font;
                 MDIChildren[i].Color := Color;      {new}
                 with MDIChildren[i] do
                    if Components[i1] is TTabbedNoteBook then
                       TTabbedNoteBook(Components[i1]).Font := Font;
              end;
     end;

  if Screen.Width > 640 then
     begin
        frmMain.width := 7 * (Screen.Width div 8);
        frmMain.Height := 9 * (Screen.Height div 10);
     end
  else
     frmMain.WindowState := wsMaximized;

 {NEW - flash panel to force repaint of client area of form}
  with pnlShowColor do
       begin
              Align := alClient ;
              Visible := True ;
              Visible:= False ;
              Align := alNone ;
              Height := 25 ;
              Width := 25 ;
              Left := 8 ;
              Top := 88 ;
       end ;
  {End NEW}

end;

{ BEGIN status message panel timer events }

procedure TfrmMain.StatusMsg(msg: string; beep: bool);
begin
  pnlStatus.Caption := msg;
  if beep then messagebeep(0);
  tmrStatusMsg.enabled := true;
end;

procedure TfrmMain.StatusSplash(MsgNo: integer;
          beep,splash: boolean);
          //does NOT use timer mechanism!
begin
with pnlStatus do
   begin
    if splash then
     begin
      Color := clActiveCaption;
      Font.Color := clWhite;
     end
    else
     begin
      Color := clBtnFace;
      Font.Color := clBlack;
     end;
    Caption := StatusMemo.Lines[MsgNo];
   end;
if beep then messagebeep(0);

end;

procedure TfrmMain.tmrStatusMsgTimer(Sender: TObject);
begin
with pnlStatus do
   begin
    Caption := '';
    Font.Color := clBlack;
    Color := clBtnFace;
   end;
  tmrStatusMsg.Enabled := false;
end;

{ END status message panel timer events }

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_F10) and (Shift =  [ssShift]) then
     sendMessage(Handle, WM_RBUTTONDOWN, 0, 0);
end;


procedure TfrmMain.ActiveOnly1Click(Sender: TObject);
var
  AppIni: TIniFile;
begin
  if ActiveOnly1.checked then
     ActiveOnly1.checked := false
  else
     ActiveOnly1.checked := true;

  AppIni := TIniFile.Create('PCMM.INI');
  AppIni.WriteBool('General', 'TeamSelection', ActiveOnly1.checked);
  AppIni.free;
end;



procedure TfrmMain.Reset1Click(Sender: TObject);
begin
  RPCBrokerMain.Connected := false;
  Halt;
end;

procedure TfrmMain.ShowAllTeamsClick(Sender: TObject);
begin
  if ShowAllTeams.checked then
     ShowAllTeams.checked := false
  else
     ShowAllTeams.checked := true;
end;

procedure TfrmMain.AssignStaff1Click(Sender: TObject);
{begin
 StaffShortcut := true;
 PositionAsgn1Click(self);
 StaffShortcut := false;
end;}
var
  AddNew,x : boolean;
  TeamIen, PosIen, TeamName, PosName : string[15];
  cProfile,soProfile : TProfile;
  UC : string;
  frm : TfrmStaff;
begin
  StaffShortcut := true;
  FMLookup1.FMLister.PartList.Clear;//bp/cmf 177 hack
  FMLookup1.Title := 'Select Team';
  FMLookup1.FMLister.Screen := 'IF $$ACTHISTB^SCAPMCU1(404.58,Y)';

  if FMLookup1.execute(addNew) then begin
     cProfile.TeamIen := FMLookup1.RecordNumber;
     cProfile.TeamName := Piece(GetFMDelimRec(FMLookup1.FMLister,FMLookup1.RecordIndex), U, 2);
     lkpPosition.FMLister := ltrPosition2;
     lkpPosition.Title := 'Select position in Team: ' + cProfile.TeamName;
     lkpPosition.FMLister.PartList.clear;
     lkpPosition.FMLister.PartList.Insert(0,cProfile.TeamIen);
     lkpPosition.FMLister.Screen:='IF $P(^(0),U,2)='
                                  + cProfile.TeamIen
                                  + ',+$$ACTTP^SCMCTPU(Y)=1'
                                  + ',$$OKPREC4^SCMCLK(Y)=1'
                                  + ',$$OKPREC1^SCMCLK(Y,DT)=1';

     x := false;
     if lkpPosition.execute(addnew) then
      begin
        x := true;
        //bp/cmf 204 mod begin
        (*//original code begin
        cProfile.PositionName := Piece(GetFMDelimRec(lkpPosition.FMLister,lkpPosition.RecordIndex), U, 2);
        cProfile.PositionIen := lkpPosition.RecordNumber;
        if Piece(CheckUsrClass(RPCBrokerMain, '1'), U, 1) = '1' then begin
           uc := GlobalNode(RPCBrokerMain, '^SCTM(404.57,' + cProfile.PositionIen + ',0)');
           cProfile.UserClass := Piece(uc, U, 13);
           end
        else
           cProfile.UserClass := '-1';
        cProfile.Parent := nil;
        cProfile.Link := false;
        //original code end*)

        with cProfile do
         begin
          PositionIen      := lkpPosition.RecordNumber;
          dmcPosition.CreatePositionRecord(PositionIen);
          if Piece(CheckUsrClass(RPCBrokerMain, '1'), U, 1) = '1'
           then UserClass  := TeamPosition.UserClass
            else UserClass := '-1';
          PositionName     := TeamPosition.PositionName;
          Parent           := nil;
          Link             := false;
         end;
        //bp/cmf 204 mod end


      end;
     if x = false then
      showmessage('There are no selectable positions' + #13 +
                  'or  you did not select a position' + #13 +
                  'for this team.')
     else frmStaff1.Execute(cProfile);
  end;
end;

procedure TfrmMain.TeamAssignment1Click(Sender: TObject);
var
  new, rtn, PCTeam : boolean;
  msg      : string;
  cur, max : string[10];
begin
  with FMLookup1 do begin
     Title := 'Select Team to Assign to:';
     FMLister.Screen := 'IF $$ACTHISTB^SCAPMCU1(404.58,Y)';
     if Execute(new) then begin
        with getTeamInfo do begin
           IENS := FMLookup1.RecordNumber;
           GetData;

        end;

        rtn := True ;
        if Piece(GetFMDelimRec(getTeamInfo,2), U, 4) = '1' then{Piece(getTeamInfo.Results[2], U, 4) = '1' then - PDR}
          begin
           rtn := (messagedlg('This team is currently closed.' + RETURN +
                      'Do you still wish to assign patients?', mtconfirmation,
                      [mbYes,mbNo], 0) = mrYes);
          end ;

        if rtn then begin
           Application.CreateForm(TfrmMltAssign, frmMltAssign);
           TeamInfo.TeamName := piece(GlobalNode(RPCBrokerMain,'^SCTM(404.51,'+ RecordNumber + ',0)'),U,1);
           TeamInfo.TeamIen := RecordNumber;
           frmMltAssign.FormMode := AssignTm;
           frmMltAssign.TeamId := TeamInfo;

           {NEW - Set PC default based on selected team and user preference - 2/12/97 - RV }
           PCteam := (Piece(GlobalNode(RPCBrokerMain,'^SCTM(404.51,'+ RecordNumber + ',0)'),U,5) = '1');
           frmMltAssign.chkType.Enabled := PCteam ;
           frmMltAssign.chkType.Checked := frmMain.mnuPrimCare.Checked and PCteam;
           { END NEW }
           frmMltAssign.HelpContext := 70100; {PDR}
           frmMltAssign.AssignTeam;
        end;
     end;
  end;
end;

procedure TfrmMain.AutoLinks1Click(Sender: TObject);
var
  frm : TfrmAutoLinks;
begin
  frm := TfrmAutoLinks.Create(Self);
  frm.TeamIDPassed := '';
  application.ProcessMessages;
  frm.FormLoad;
end;

procedure TfrmMain.SelectReport1Click(Sender: TObject);
var
  frm : TfrmTemplate;
begin
  frm := TfrmTemplate.Create(Self);
  Application.ProcessMessages;
  frm.FormLoad;
end;

procedure TfrmMain.PositionAssignment1Click(Sender: TObject);
var
  new, rtn, PCpos     : boolean;
  s: string ;
begin
  FMLookup1.Title := 'Select Team to Assign to';
  FMLookup1.FMLister.Screen := 'IF $$ACTHISTB^SCAPMCU1(404.58,Y)';

  if FMLookup1.execute(New) then begin
     TeamInfo.TeamIen := FMLookup1.RecordNumber;
     TeamInfo.TeamName :=
        Piece(GlobalNode(RPCBrokerMain,'^SCTM(404.51,'+ FMLookup1.RecordNumber + ',0)'),U,1);
     with getTeamInfo do begin
        IENS := FMLookup1.RecordNumber;
        GetData;
     end;

     rtn := True ;
     if Piece(GetFMDelimRec(getTeamInfo,2), U, 4) = '1' then{Piece(getTeamInfo.Results[2], U, 4) = '1' then}
        rtn := (messagedlg('This team is currently closed.' + RETURN +
                      'Do you still wish to assign patients?', mtconfirmation,
                      [mbYes,mbNo], 0) = mrYes);

        if rtn then begin
           with lkpPosition do begin
              Title := 'Select position in Team: ' + TeamInfo.TeamName;
              FMLister := ltrPosition2;
              FMLister.PartList.Clear; {PDR}
              FMLister.PartList.Add(TeamInfo.TeamIen);
              FMLister.ListerFlags := [lfInternal];{Flags := 'I' ; - PDR}
              FMLister.Screen := 'IF $P(^(0),U,2)=' + TeamInfo.TeamIen + ',+$$ACTTP^SCMCTPU(Y)=1';
              if execute(new) then begin
                 TeamInfo.PositionName := Piece(GlobalNode(RPCBrokerMain,'^SCTM(404.57,'+ RecordNumber + ',0)'),U,1);

                 TeamInfo.PositionIen := RecordNumber;
                 Application.CreateForm(TfrmMltAssign, frmMltAssign);
                 frmMltAssign.TeamId := TeamInfo;
                 frmMltAssign.FormMode := AssignPos;

                 {NEW - Can this position provide primary care? - 2/12/97 - REV}
                 s := GlobalNode(RPCBrokerMain,'^SCTM(404.57,' + TeamInfo.PositionIen + ',0)') ;
                 PCpos := (Piece(s,U,4) = '1') ;
                 frmMltAssign.chkType.Enabled := PCpos ;
                 frmMltAssign.chkType.Checked := frmMain.mnuPrimCare.Checked and PCpos;

                 // patch 177 if frmMain.mnuPrimCare.Checked and PCpos then
                    //frmMltAssign.grpOptions2.ItemIndex := 1
                 //else
                    //frmMltAssign.grpOptions2.ItemIndex := 0 ;
                 //frmMltAssign.grpOptions2.Enabled := PCpos ;
                 { END NEW }
                 frmMltAssign.HelpContext := 70110; {PDR}

                 frmMltAssign.AssignToPosition;
              end;
           end;
        end;
  end;
end;

procedure TfrmMain.RPCBroker1NetError(Sender: TObject;
  var Error: EBrokerError);
begin
     {messageDlg('Broker Error', mtWarning, [mbOk], 0);}
end;


procedure TfrmMain.mnuPrimCareClick(Sender: TObject);
var
  AppIni: TIniFile;
begin
  AppIni := TIniFile.Create('PCMM.INI');

  if mnuPrimCare.Checked then
     mnuPrimCare.Checked := false
  else
     mnuPrimCare.Checked := true;

  AppIni.WriteBool('General', 'PrimaryCare', mnuPrimCare.Checked);
  AppIni.Free;
end;

procedure TfrmMain.TeamReAssignment1Click(Sender: TObject);
begin
 Application.CreateForm(TfrmMTReAsgn, frmMTReAsgn);
  frmMTReAsgn.ByTeam:=true;
  frmMTReAsgn.SetTeamorPos;
end;

procedure TfrmMain.PositionReassignment1Click(Sender: TObject);
begin
  Application.CreateForm(TfrmMTReAsgn, frmMTReAsgn);
  frmMTReAsgn.ByTeam:=false;
  frmMTReAsgn.SetTeamorPos;
end;

procedure TfrmMain.GetVersionInfo;
var
   VerString: String;
   i: integer;
begin
     try
       VerInfoRes := TVerInfoRes.Create(Application.ExeName);
        try
           for i := 1 to 8 do
               begin
                    VerString := VerInfoRes.GetVerNameString(TVerInfoType(i-1));
                    if VerString <> '' then
                       begin
                       with VersionInfoRecord do
                            case i of
                                  1: viCompanyName := VerString;
                                  2: viComments := VerString;
                                  3: viFileDescription := VerString;
                                  4: viFileVersion := VerString;
                                  5: viInternalName := VerString;
                                  6: viLegalCopyright := VerString;
                                  7: viLegalTrademarks := VerString;
                                  8: viOriginalFilename := VerString;
                                 end;
                       end;
               end;
        finally
               VerInfoRes.Free;
        end;
     except
           on ENoVerInfoError do
              messagedlg('No Version Info Available',mtError,[mbok],0);
     else Raise;
   end;
end;
procedure TfrmMain.PCMMParameters1Click(Sender: TObject);
begin
	Application.CreateForm(Tfrmparameters, frmparameters);
	frmparameters.showmodal;
end;

procedure TfrmMain.DirectPCFTEE1Click(Sender: TObject);
var
  new : boolean;
  teamname: string;
begin
if not MemoryOk then
     raise EInsufficientMemory.create('Insufficient memory to open Team Setup form')
  else begin
     with FMLookUp1 do begin
        FMLister.FromList.clear; {PDR}
        FMLister.FromList.Insert(0,EmptyStr);{From := EmptyStr; - PDR}
        FMLister.FromIen := EmptyStr;
        FMLister.PartList.clear; {PDR}
        FMLister.PartList.Insert(0,EmptyStr); {Part := EmptyStr; - PDR}
        FMLister.Number := '*';
        Title := 'Select Team';
        AllowNew := false;
        FMLister.Screen := 'IF $$ACTHISTB^SCAPMCU1(404.58,Y)'  ;


        if execute(new) then begin
     //      Application.CreateForm(TfrmPCFtee, frmPCFtee);
    //       Application.ProcessMessages;
   //        frmAssigned.enabled := false;
    //       frmAssigned.PsProfile.TeamIen := FMLookUp1.RecordNumber;
     teamname := Piece(GlobalNode(RPCBrokerMain,'^SCTM(404.51,'+ FMLookUp1.RecordNumber + ',0)'),U,1);
      with   RPCBrokerMain do
      begin

          RemoteProcedure := 'SC FTEE BUILD LIST';
          Param[0].PType := literal;
          Param[0].Value := FMLookUp1.RecordNumber;
          call;
           
          end;
          IF RPCBrokerMain.Results.Count<2 THEN BEGIN
           MessageDlg('No Primary Care Positions for this team',mtInformation,[mbok],0);
           exit
           end;
          Application.CreateForm(TfrmPCFtee, frmPCFtee);
          frmPCFtee.hdrStaff.Sections.Delete(1);
          frmPCFtee.hdrStaff.Sections.Insert(1, teamname);
           Application.ProcessMessages;
           frmPCFtee.Show;
        end;
     end;
  end;
end;




end.
