{*******************************************************************}
{                                                                   }
{    Position Information Subsidiary form for patient assignment    }
{    to a team position in Primary Care Management.                 }
{                                                                   }
{    Scheduling ver 5.3 AUG 13, 1993                                 }      
{    Management Information Products Group                          }
{    Albany NY (SCK)                                                }
{    Dept. of Veteran Affairs                                       }
{    March 1996                                                     }
{                                                                   }
{    Last updated: 8 May 2002 (J. Peterson)                         }
{                                                                   }
{*******************************************************************}

unit Posinfo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Fmcntrls, OvcSc, OvcBase,
  OvcEF, OvcPB, OvcPF, Trpcb, Scpttmf, scutdef, Scut2, Scut3, OvcDate;

type
  TfrmPosInfo = class(TForm)
    grpAsgnInfo: TGroupBox;
    Label4: TLabel;
    Label6: TLabel;
    txtPosAsgnDT: TOvcPictureField;
    txtPosUnAsgnDT: TOvcPictureField;
    cmdPosAsgnOk: TBitBtn;
    cmdPosAsgnCancel: TBitBtn;
    OvcSpinner1: TOvcSpinner;
    OvcController1: TOvcController;
    OvcSpinner2: TOvcSpinner;
    grpPositionType: TGroupBox;
    CHKPCASGN: TCheckBox;
    procedure cmdPosAsgnCancelClick(Sender: TObject);
    procedure cmdPosAsgnOkClick(Sender: TObject);
    procedure txtPosAsgnDTDblClick(Sender: TObject);
    procedure txtPosUnAsgnDTDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FormParent : TfrmTeamAssign;
  end;

var
  frmPosInfo: TfrmPosInfo;

implementation

uses Enterdt;


{$R *.DFM}

procedure TfrmPosInfo.cmdPosAsgnCancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TfrmPosInfo.cmdPosAsgnOkClick(Sender: TObject);
begin
  if not txtPosAsgnDt.isValid then begin
     txtPosAsgnDt.Setfocus;
     exit;
     end
  else if txtPosAsgnDt.AsOvcDate < FormParent.txtAssignDt.AsOvcDate then begin
     messagedlg('Assignment date cannot be earlier than ' + FormParent.txtAssignDt.AsString, mtInformation,
                [mbOk], 0);
     txtPosAsgnDt.Setfocus;
     exit;
     end;

  if not (txtPosUnAsgnDt.AsString = NULL_DATE) then
     if txtPosUnAsgnDt.AsOvcDate < txtPosAsgnDt.AsOvcDate then begin
        messagedlg('Discharge date cannot be earlier than ' + txtPosAsgnDt.AsString,
                mtInformation, [mbOk], 0);
        txtPosUnAsgnDt.Setfocus;
        exit;
     end;

  ModalResult := mrOk;
  {Close;}
end;

procedure TfrmPosInfo.txtPosAsgnDTDblClick(Sender: TObject);
begin
  frmEnterDate.Caption := 'Enter Position Activation Date:';
  if txtPosAsgnDt.AsOvcDate = BadDate then
    frmEnterDate.initDate := SysUtils.Date
  else
    frmEnterDate.initDate := txtPosAsgnDT.AsDateTime;
  frmEnterDate.ShowModal;
  if frmEnterDate.ModalResult = mrOk then
     txtPosAsgnDT.AsString := FMDateToStr(frmEnterDate.FMDate);
end;

procedure TfrmPosInfo.txtPosUnAsgnDTDblClick(Sender: TObject);
begin
  frmEnterDate.Caption := 'Enter Position Discharge Date:';
  if txtPosUnAsgnDT.AsOvcDate = BadDate then
    frmEnterDate.initDate := SysUtils.Date
  else
    frmEnterDate.initDate := txtPosUnAsgnDT.AsDateTime;
  frmEnterDate.ShowModal;
  if frmEnterDate.ModalResult = mrOk then
     txtPosUnAsgnDT.AsString := FMDateToStr(frmEnterDate.FMDate);
end;

end.
