{*******************************************************************}
{                                                                   }
{ Team Position/Assignment form for Primary Care Management         }
{ Management Information Products Group                             }
{                                                                   }
{ Scheduling ver 5.3 AUG 13, 1993                                   }      
{ Management Information Products Group                             }
{ Albany NY (SCK)                                                   }
{ Dept. of Veteran Affairs                                          }
{                                                                   }
{ Last updated: 28 May 2002 (J. Peterson)                           }
{                                                                   }
{*******************************************************************}

unit Pstndef1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, TabNotBk, Menus, FmLookUp,
  Fmcntrls, Fmcmpnts, Grids, printers, OvcDT, OvcData, Scutdef, scutbrk,
  Trpcb, IniFiles, DateTime, Mask, Spin, OvcSc, OvcBase, Enterdt,
  OvcEF, OvcPB, OvcPF, OvcCal, Pcmm1, Mfunstr, OvcNbk, OvcDate {,Gtsize32,
  GTVASzr - PDR}, Diaccess,scut3,scut2 {pdr};

type
  TfrmAssigned = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    Exit1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    Edit1: TMenuItem;
    Undo1: TMenuItem;
    N3: TMenuItem;
    N6: TMenuItem;
    PositionsList: TFMLister;
    ListRoles: TFMLister;
    LookUpList: TFMLister;
    getPositions: TFMGets;
    LookUp: TFMLookUp;
    flrPositions: TFMFiler;
    ValPosition: TFMValidator;
    Timer1: TTimer;
    ltrPreceptor: TFMLister;
    ltrClinics: TFMLister;
    cmdClose: TBitBtn;
    CmdSave: TBitBtn;
    cmdUndo: TBitBtn;
    cmdHelp: TBitBtn;
    ltrReasons: TFMLister;
    getHistory: TFMGets;
    ltrHistory: TFMLister;
    imgYes: TImage;
    imgNo: TImage;
    flrHistory: TFMFiler;
    lblPositionHdr: TLabel;
    lstPositions: TFMListBox;
    optShow: TFMRadioGroup;
    Alternate: TPopupMenu;
    Save3: TMenuItem;
    Undo3: TMenuItem;
    New2: TMenuItem;
    N1: TMenuItem;
    ExternalPosition1: TMenuItem;
    flrStaff: TFMFiler;
    ltrStaff: TFMLister;
    ltrStaffReason: TFMLister;
    getStaff: TFMGets;
    ltrAssign: TFMLister;
    ExternalPosition2: TMenuItem;
    RemovePosition2: TMenuItem;
    ltrUserClass: TFMLister;
    OvcController1: TOvcController;
    N4: TMenuItem;
    New1: TMenuItem;
    getUpdate: TFMGets;
    getPc: TFMGets;
    hdrStats: THeader;
    pnlCalendar: TPanel;
    Calendar: TOvcCalendar;
    tabPositions: TOvcNotebook;
    lblPositonHdr: TLabel;
    txtPosition: TFMEdit;
    lblRole: TLabel;
    cboRole: TFMComboBox;
    Label5: TLabel;
    txtDescription: TFMMemo;
    lblBeeper: TLabel;
    txtBeeper: TFMEdit;
    GroupBox1: TGroupBox;
    Bevel1: TBevel;
    Bevel4: TBevel;
    lblEffective: TLabel;
    lblEffectiveDate: TFMLabel;
    lblInactive: TLabel;
    lblInactivated: TFMLabel;
    GroupBox2: TGroupBox;
    chkPractioner: TFMCheckBox;
    chkPreceptor: TFMCheckBox;
    grpPatients: TGroupBox;
    lblAllowed: TLabel;
    lblActual: TLabel;
    lblActualDisplay: TFMLabel;
    txtAllowed: TFMEdit;
    grpDeathMsg: TFMRadioGroup;
    grpPatientMsg: TFMRadioGroup;
    grpConsultMsg: TFMRadioGroup;
    grpTeamMsg: TFMRadioGroup;
    lblStatusList: TLabel;
    lstStatus: TFMListBox;
    grpDate: TGroupBox;
    cboReasons: TFMComboBox;
    lblReason: TLabel;
    cboStatus: TFMComboBox;
    Label2: TLabel;
    txtStatusDate: TOvcPictureField;
    lblStatusDate: TLabel;
    txtHistoryDate: TFMLabel;
    Bevel9: TBevel;
    cmdStatusOk: TBitBtn;
    cmdStatusCancel: TBitBtn;
    cmdStatusAdd: TBitBtn;
    cmdStatusDelete: TBitBtn;
    GroupBox4: TGroupBox;
    lblClinic: TLabel;
    cboClinic: TFMComboBoxLookUp;
    lblUserClass: TLabel;
    cboUserClass: TFMComboBoxLookUp;
    cmdAssignStaff: TBitBtn;
    AssignStaff2: TMenuItem;
    AssignStaff1: TMenuItem;
    N5: TMenuItem;
    spnStatusDate: TOvcSpinner;
    DeleteHistory: TMenuItem;
    cmdNewPosition: TBitBtn;
    ltStatus: TFMLister;
    lblPreceptor: TLabel;
    Bevel2: TBevel;
    FMlblPreceptor: TFMLabel;
    cmdPreceptor: TBitBtn;
    FMlblPrecepts: TFMLabel;
    FMlblFutureAsgn: TFMLabel;
    FMRadioGroup1: TFMRadioGroup;
    FMRadioGroup2: TFMRadioGroup;
    FMRadioGroup3: TFMRadioGroup;
    FMRadioGroup4: TFMRadioGroup;
    chkPreceptorDeath: TFMCheckBox;
    chkPreceptorInpatient: TFMCheckBox;
    chkPreceptorConsult: TFMCheckBox;
    chkPreceptorTeam: TFMCheckBox;
    {GTVAForm1: GTVAForm - PDR;}
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure lstPositionsDblClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure TextExit(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure txtDescriptionExit(Sender: TObject);
    procedure optShowClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Undo1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure txtPositionExit(Sender: TObject);
    procedure CheckChange(Sender: TObject);
    procedure cboExit(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure cmdStatusOkClick(Sender: TObject);
    procedure cmdDeleteClick(Sender: TObject);
    procedure UpdateMenus(Sender: TObject);
    procedure lstStatusDblClick(Sender: TObject);
    procedure cboChangeItem(Sender: TObject);
    procedure grpMessageChange(Sender: TObject);
    procedure cboStatusChange(Sender: TObject);
    procedure cmdStatusAddClick(Sender: TObject);
    procedure cboReasonsChange(Sender: TObject);
    procedure TextChange(Sender: TObject);
    procedure lstStatusMeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure lstStatusDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ExternalPosition1Click(Sender: TObject);
    procedure cmdStatusCancelClick(Sender: TObject);
    procedure ExternalPosition2Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrintSetup1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure txtStatusDateExit(Sender: TObject);
    procedure lstPositionsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CalendarClick(Sender: TObject);
    procedure txtStatusDateKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CalendarKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PopUpCalendar(Sender: TObject);
    procedure cboKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lstStatusKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cboUserClassClick(Sender: TObject);
    procedure cboUserClassKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure cboEnter(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OldtabPositionsChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure ChangeMonth(Sender: TObject);
    procedure RPCBroker1NetError(Sender: TObject; var Error: EBrokerError);
    procedure cboReasonsEnter(Sender: TObject);
    procedure cmdAssignStaffClick(Sender: TObject);
    procedure cboRoleClick(Sender: TObject);
    procedure lstPositionsExit(Sender: TObject);
    procedure cboPreceptorClick(Sender: TObject);
    procedure AssignStaff2Click(Sender: TObject);
    procedure tabPositionsPageChange(Sender: TObject; Index: Integer;
      var AllowChange: Boolean);
    procedure lstPositionsClick(Sender: TObject);
    procedure cmdPreceptorClick(Sender: TObject);
  private
    { Private declarations }
    HList : TStringList;
    NetError, DeleteKey, UCInstalled, Debug: Boolean;
    {PDR 5/27/98}
    HistorySelected:integer;
    txtPositionFMFilerFMMode:FMModes;
    flrHistoryFMMode:FMModes;
    flrPositionsFMMode:FMModes;
    flrStaffFMMode:FMModes;
    TFMMemoFMFilerFMMode:FMModes;
    procedure StaffExecute(PrecLink: boolean);
    function RvwActFutPosAsgn(RPCBroker: TRPCBroker; FromPos, FromDate, ToDate, DtDate, AssignStat: string): boolean;

  public
    { Public declarations }
    PsProfile : TProfile;
    procedure ModifyPosition(obj: Tobject);
    function GetTeamPosition: bool;
    procedure BuildPositionList;
    procedure LoadHistory;
    procedure SetSave(status: Boolean);
    procedure LoadSettings;
    procedure UnLockPosition;
    procedure SetUpNewPosition(s1: string);
    procedure StubStatus;
    procedure SetMessages;
    procedure LoadStaff;
    procedure OpenPositions;
    procedure DisableHistory(Status: boolean);
    procedure setStatusButtons(Sok: boolean; Scan: boolean; Sadd: boolean;
              Sdel: boolean);
    procedure ClearEditFields;
    procedure GetPreceptorList;
    procedure RunForm;
    function ConfirmNewPosition(s: string): bool;
    function StatusDateChangeOk: boolean;
    function StatusChangeOk(status: integer): boolean;
    function StatusReasonChangeOk: boolean;
    function CheckRequired(var msg: string; var flag: boolean): boolean;
    function CheckReqd: boolean;
    function OkToDeleteStatus: boolean;
  end;

const
  TEAM_SCREEN =  'IF $P(^(0),U,2)="';
  ACTIVE_SCREEN =  ',+$$ACTTP^SCMCTPU(Y)=1';
  CARE_SCREEN = ',$P(^(0),U,12)="1"';

var
  frmAssigned: TfrmAssigned;
  OldProfile: TProfile;
  SaveBtn, NewInactive, NewStatusFlag: Boolean;
  OldStaff,psStaff: TStaff;
  pf: TOvcPictureField;

implementation

uses  AsgnStaf, Teamdef1, dmuTeam, dischargememo, Scpttmf;

{$R *.DFM}


{  =================  Form startup procedures  =======================}

procedure TfrmAssigned.FormResize(Sender: TObject);
begin
  Clientwidth := 625;
end;

{     TEST COMMENT
  Create the History and Staff assignment lists, set the tab page to the
  general page.
}
procedure TfrmAssigned.FormCreate(Sender: TObject);
begin
  Font.Assign(FrmMain.FontDialog1.Font);
  tabPositions.Font := Font;
  left := 0;
  Top := 0;
  HList := TStringList.Create;
  tabPositions.pageindex := 0;
  NetError := false;
  lstPositions.Height := 77;
  
  hdrStats.Sections[1] := 'None Selected';
  hdrStats.Sections[3] := 'None Selected';
  hdrStats.Sections[5] := 'None Assigned';

  frmMain.cmdPosition.enabled := false;
  frmMain.PositionAssignments1.enabled := false;
  frmMain.ShowMenu := false;
  frmMain.AssignStaff1.Enabled := false;
end;

procedure TfrmAssigned.RunForm;
begin
  {if not (PsProfile.Parent = nil) then
     frmTeamProfile.enabled := false;}

  cboRole.GetList;
  cboReasons.GetList;

  NewInactive := false;

  if PsProfile.TeamIen = '' then
     Open1click(nil)
  else
     OpenPositions;

  lstPositions.ItemIndex := -1;
  SetSave(False);
  frmAssigned.enabled := true;
end;

{
  Load default user settings from user file and/or INI file.
}
procedure TfrmAssigned.LoadSettings;
begin
  debug := FrmMain.Debug;
  DeleteKey := FrmMain.DeleteEnabled; {SecurityKeyOk(RPCBrokerMain, DELETE_KEY);}
  UCInstalled := frmMain.UsrClsEnabled; { Piece(CheckUsrClass(RPCBrokerMain, '1'), U, 1) = '1';}
end;

{
  Load lists.  If an active team was passed in, then get the positions
  for that team, otherwise call the open menu action to select a team.
}
procedure TfrmAssigned.FormShow(Sender: TObject);
begin

  LoadSettings;
  if UCInstalled then begin
     cboUserClass.Enabled := true;
     cboUserClass.FMRequired := true;
     cboUserClass.Color := clWindow;
     end
  else begin
     cboUserClass.Enabled := false;
     cboUserClass.FMRequired := false;
     cboUserClass.Color := clMenu;
     end;

end;

{

}
procedure TfrmAssigned.GetPreceptorList;
begin
  {cboPreceptor.FMLister.Screen :=
     'IF $P(^(0),U,2)="' + PsProfile.TeamIen +
     '",$P(^(0),U,12)="1",+$$ACTTP^SCMCTPU(Y)=1';
  cboPreceptor.GetList;
  if cboPreceptor.Items.Count > 0 then
     cboPreceptor.Items.Add(NONE);}
end;

{  **** Updated 1/9/96
  Clear on click events for toolbar buttons, free tstring lists, enable
  the position assignment menu item and release the forms memory resources.
}
procedure TfrmAssigned.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if not (PsProfile.Parent = nil) then begin
     (PsProfile.Parent as TForm).enabled := true;
     frmTeamProfile.cmdPosition.enabled := true;
  end;

  frmMain.cmdPosition.enabled := true;
  frmMain.PositionAssignments1.enabled := true;
  frmMain.ShowMenu := true;
  frmMain.AssignStaff1.enabled := true;
  Action := cafree;
end;

{
  WHen closing the form, check for any changes that have not been saved.  If
  there are changes, confirm with the user what action to take.  If ok to
  continue, unlock the current position. Otherwise, set the canclose var
  to false.
}
procedure TfrmAssigned.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if not NetError then
     case CheckSave(flrPositions) of
        Save: begin
               save1CLick(Sender);
              end;
        Abort: begin
                CanClose := false;
                exit;//bp/cmf 177 hack
               end;
     end;
  UnlockPosition;
  {if CanClose then
     if PsProfile.PositionIen <> '' then UnLockPosition;}
end;


procedure TfrmAssigned.FormDestroy(Sender: TObject);
begin
  Hlist.Free;
end;


{ =======================   General  Tab   =================================}

 { **** Updated 1/6/96
  process change to position name.  If next control is the undo button and
  the position name has been modified, reset the name and then exit without
  any further processing.  If the position name has been modified and the
  filer mode is EditEntry, then call the procedure to handle the modification
  to the name.
}
procedure TfrmAssigned.txtPositionExit(Sender: TObject);
begin
  if (ActiveControl = cmdUndo) or not txtPosition.FMModified then exit;

  with txtPosition do
   begin
     case txtPositionFMFilerFMMode{FMFiler.FMMode - PDR} of
        EditEntry: if Modified then ModifyPosition(Sender);
        AddEntry : if Modified then ModifyPosition(Sender); {Added 12/19/96 - RV}
        {AddEntry: exit;{AddPosition(Sender);}
     else
        text := FMTag;
     end;

     {Added 3/10/97 - Corrects SAVE/CLOSE behavior problems - RV}
     if ActiveControl = cmdSave then
        if FMModified then
           Save1Click(Sender)
        else
           txtPosition.SetFocus ;

     if ActiveControl = cmdClose then
        if FMModified then
           Exit1Click(Sender)
        else
           txtPosition.SetFocus ;
     { End of new code 3/10/97 - RV}

     txtPosition.SetFocus ;
   end ;
end;

{
  Add memo field to FMFiler for processing if the memo field has been changed
}
procedure TfrmAssigned.txtDescriptionExit(Sender: TObject);
begin
  with (Sender as TFMMemo) do
     if FMModified then
        begin
           if TFMMemoFMFilerFMMode{FMFiler.FMMode - PDR} = AddEntry then
              FMFile{FMEntry} := NEW_ENTRY;
           FMFiler.AddChgdControl(Sender);{Add(Sender); -PDR}
        end;
end;


{ ======================= Status Log tab  ==================================}

{  **** Updated 1/24/96
  On exiting the date edit field, hide the calendar if it's still
  visible.  Exit the procedure if the next active gadget is the
  cancel button.  If the date entered is valid, and is different
  from the status date, then update the status date and set the
  Ok and Cancel buttons enabled properties.
}
procedure TfrmAssigned.txtStatusDateExit(Sender: TObject);
begin

  if cmdstatuscancel.focused then exit;
  if Calendar.focused then exit;

  if pnlCalendar.Visible then
     pnlCalendar.visible := false;

 if (CompareText(StrToFMDate(txtStatusDate.asString),
          txtHistoryDate.FMCtrlInternal ) = 0) then exit;


  if txtStatusDate.isValid then begin
     if StatusDateChangeOk then begin
        if not NewStatusFlag then begin
           if messagedlg('You are changing an existing date.  This' + RETURN +
              'may cause problems with other applications.' + RETURN +
              'Please see HELP for additional information.' +  RETURN +
              'Do you wish to change it now?', mtConfirmation,
              [mbYes,mbCancel,mbHelp], 80000) = mrCancel then begin
                 txtStatusDate.AsString := FMToStr(txtHistoryDate.FMCtrlInternal);
                 exit;
           end;
        end;
        txtHistoryDate.FMCtrlInternal := ShortDateToFM(StrToDate(txtStatusDate.AsString));
        cmdStatusOk.enabled :=  ((cboReasons.ItemIndex > -1) and (cboStatus.ItemIndex > -1));
     end
     else
        if tabPositions.PageIndex = 3 then
           txtStatusDate.Setfocus;
  end
  else
     if tabPositions.PageIndex = 3 then
        txtStatusDate.Setfocus;
end;

{ **** Updated 1/9/96  Confirm API
  confirm date change is ok for position, if not, return false and diaplay
  warning message
}
function TfrmAssigned.StatusDateChangeOk: boolean;
var
  msg: string;
  newDate: string[20];
begin
  newDate := StrToFMDate(txtStatusDate.AsString);

  if NewStatusFlag then
     result := NewHistoryOk(RPCBrokerMain, cboStatus.FMFile, psProfile.PositionIen,
        StrToFMDate(txtStatusDate.AsString),  msg)
  else
     result := HistoryChangeOk(RPCBrokerMain, cboStatus.FMFile,
           psProfile.PositionIen, Piece(GetFMDelimRec(lstStatus.FMLister,lstStatus.ItemIndex), '^', 1),
           StrToFMDate(txtStatusDate.AsString), msg);

  if length(msg) > 0 then
     frmMain.StatusMsg(msg, true);
end;


{  updated 1/25/96
  On click action for the status edit field.  Enable the OK button if both the
  Reason and date fields are completed.
}
procedure TfrmAssigned.cboStatusChange(Sender: TObject);
begin
  if activeControl = cmdStatusCancel then exit;
  if cboStatus.ItemIndex < 0 then exit;

  if StatusChangeOk(cboStatus.ItemIndex) then
     begin
        cboStatus.FMCtrlInternal{FMInternal - PDR} := IntToStr(cboStatus.ItemIndex);
        if cboStatus.FMCtrlInternal{FMInternal - PDR} = '0' then
           NewInactive := true;
        cmdStatusOk.enabled := ((cboReasons.ItemIndex > -1) and
                     (txtStatusDate.AsString <> ''));
     end
  else
     begin
        cboStatus.ItemIndex := cboStatus.FMTag;
        cboStatus.FMModified := false;
        cboStatus.Setfocus;
     end;
end;

{ @@@ confirm API
  confirm status change is ok, if not, return false and display warning message
}
function TfrmAssigned.StatusChangeOk(status: integer): boolean;
var
  msg: string;
begin
  msg := '';
  result := true;

  if NewStatusFlag then
     result := HistoryStatusOk(RPCBrokerMain, cboStatus.FMFile,
              PsProfile.PositionIen, StrToFMDate(txtStatusDate.AsString),
              Status, msg);

  if result then
     if cboStatus.Text = 'INACTIVE' then
        result := InactivateHistoryOk(RPCBrokerMain, cboStatus.FMFile,
               PsProfile.PositionIen, StrToFMDate(txtStatusDate.AsString) , msg);
  {fix}

  if length(msg) > 0 then
     frmMain.StatusMsg(msg, true);
end;

{
  on click action for reason's ediit field.  set Ok button if date and
  status fields are completed.  Set FMInternal it selected reason in the
  drop down list.
}
procedure TfrmAssigned.cboReasonsChange(Sender: TObject);
begin
  if cboReasons.ItemIndex < 0 then exit;

  if StatusReasonChangeOk then
     begin
        cboReasons.FMCtrlInternal{FMInternal - PDR} :=
                 Piece(GetFMDelimRec(cboReasons.FMLister,cboReasons.ItemIndex), U, 1);{Piece(cboReasons.FMLister.Results[cboReasons.ItemIndex], U, 1); - PDR}
        cmdStatusOk.enabled := ((cboStatus.ItemIndex > -1) and
                 (txtstatusdate.AsString <> ''));
        if cmdStatusOk.enabled then cmdStatusOk.setfocus;
     end
  else
     cboReasons.ItemIndex := cboReasons.FMTag;
end;

{
  Entry point for future check of whether it's ok to change the status reason.
}
function TfrmAssigned.StatusReasonChangeOk: boolean;
begin
  result := true;
end;

{
  display data for selected item in the history status list display
}
procedure TfrmAssigned.lstStatusDblClick(Sender: TObject);
begin
  if lstStatus.Items.Count = 0 then
     exit;
  try
     HistorySelected := lstStatus.Itemindex; {pdr}
     getHistory.IENS := Piece(GetFMDelimRec(lstStatus.FMLister,lstStatus.ItemIndex), U, 1){Piece(Hlist[lstStatus.ItemIndex], U, 1) -PDR};
     getHistory.GetAndFill;
     flrHistoryFMMode{flrHistory.FMMode - PDR} := EditEntry;

     DisableHistory(False);
     cbostatus.itemindex := cbostatus.items.indexof(cbostatus.FMDBExternal); {PDR}
     cboStatus.enabled := false;

     txtStatusDate.AsOvcDate :=
            DateTimeToOvcDate(FromFMDateTime(txtHistoryDate.FMCtrlInternal{FMInternal - PDR}, false));
     setStatusButtons(false,true,false,true);
  except
     on E: Exception do
        messagedlg('Error: ' + E.Classname + ' in status list',
            mtWarning, [mbOk], 0);
  end;
end;

{
  trigger doublecklick on spacebar key press
}
procedure TfrmAssigned.lstStatusKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If Key = VK_SPACE then lstStatusDBlCLick(Sender);
end;


{  **** Updated 1/15/96
  File the status entry.  If this is a new position, enter the satus entry into
  the selection list, and disable the status log page.  Otherwise, if this is
  a new status entry for an existing position, set the key and file the entry.
  Notify the user of the result of the update.  Rebuild the position list and
  reload the status entries for the current position.
}
procedure TfrmAssigned.cmdStatusOkClick(Sender: TObject);
//bp/cmf 204t0a begin
var
dtBegin,dtEnd,dtDate,AsgnStat: string;
begin
 if cboStatus.ItemIndex = 0 then
  begin
   dtBegin  := ValStrToFMDate(txtStatusDate.AsString);
   dtEnd    := '9999999';
   dtDate   := '9999999';
   AsgnStat := '2';
   if not RvwActFutPosAsgn(RPCBrokerMain
          ,PsProfile.PositionIen,dtBegin,dtEnd,dtDate,AsgnStat) then
           begin
            cmdStatusCancelClick(self);
            exit;
           end;
  end;
//bp/cmf 204t0a end

  if newStatusFlag then
     flrHistory.AddFDA('404.59',NEW_ENTRY,'.01', PsProfile.PositionIen);
     flrHistory.AddChgdControl(txtHistoryDate);
     flrHistory.AddChgdControl(cboStatus);
     flrHistory.AddChgdControl(cboReasons);

     if flrHistory.Update then begin
        frmMain.StatusMsg('Status entry filed.', false);
        newStatusFlag := false;
        flrPositionsFMMode := EditEntry;

        getUpdate.Iens := psProfile.PositionIen;
        getUpdate.GetData;
        lblEffectiveDate.Caption := Piece(GetFMDelimRec(getUpdate,0), '^', 5);{Piece(getUpdate.Results[0], '^', 5); - PDR}
        lblInactivated.Caption := Piece(GetFMDelimRec(getUpdate,1), '^', 5);{Piece(getUpdate.Results[1], '^', 5); - PDR}

        if NewInactive then begin
           optShow.ItemIndex := 1;
        end
        else begin
           LoadHistory;
           BuildPositionList;
        end;
     end
     else
        messageDlg('Status was not updated!', mtWarning, [mbOk], 0);

  setStatusButtons(false,false,true,false);
end;


{
  Set up to add another position status entry.
}
procedure TfrmAssigned.cmdStatusAddClick(Sender: TObject);
begin
  getHistory.SetUpNewEntry(NEW_ENTRY);

  cboReasons.ItemIndex := -1;
  cboReasons.FMCtrlInternal{FMInternal - PDR} := emptystr;

  {if Hlist.Count < 0 then}
  if Hlist.Count < 1 then
     cboStatus.ItemIndex := 1
  else begin
     if Piece(GetFMDelimRec(lstStatus.FMLister,Hlist.count - 1), U, 4) = 'ACTIVE' then{Piece(HList[Hlist.count - 1], U, 4) ='ACTIVE' then - PDR}
        cboStatus.ItemIndex := 0
     else
        cboStatus.ItemIndex := 1;
     end;
  cboStatus.FMCtrlInternal{FMInternal - PDR} := IntToStr(cboStatus.ItemIndex);

  txtStatusDate.AsOvcDate := CurrentDate;

  DisableHistory(false);
  NewStatusFlag := true;
  setStatusButtons(false,true,false,false);
  flrHistory.clear;
  flrHistoryFMMode{flrHistory.FMMode - pdr} := AddEntry;
  txtStatusDate.SetFocus;
end;

{
  If it's ok to delete the status entry, then confirm the deletion with user.
  If ok, then proceed with deletion.
}
procedure TfrmAssigned.cmdDeleteClick(Sender: TObject);
var
  s: string[30];
begin
  if OkToDeleteStatus then
     begin
        s := txtStatusDate.AsString;
        if messagedlg('You are about to delete the ' + s + ' status entry!' +
                 RETURN + 'Do you want to do this?', mtConfirmation,
                 [mbYes,mbNo], 0) = mrYes then
           if Deleter(RPCBrokerMain, '^SCTM(404.59,', txtHistoryDate.FMFile{FMEntry}) then
              begin
                 frmMain.StatusMsg('The ' + s + ' entry has been deleted.', false);
                 LoadHistory;
                 getUpdate.Iens := psProfile.PositionIen;
                 getUpdate.GetData;
                 lblEffectiveDate.Caption := Piece(GetFMDelimRec(getUpdate,0), '^', 5);{Piece(getUpdate.Results[0], '^', 5); - PDR}
                 lblInactivated.Caption := Piece(GetFMDelimRec(getUpdate,1), '^', 5);{Piece(getUpdate.Results[1], '^', 5); - PDR}
              end
           else
              messageDlg('Status entry not deleted!', mtWarning, [mbOk], 0);
     end
  else
     begin
        if not frmMain.tmrStatusMsg.enabled then
           frmMain.StatusMsg('You cannot delete this status entry!', true);
        DisableHistory(true);
        SetStatusButtons(false, true, false, false);
     end;

  {cmdStatusDelete.enabled := false;}
end;

{  @@@ Check API
  confirm status deletion is ok, if not, return false and display warning message
}
function TfrmAssigned.OkToDeleteStatus: boolean;
var
  msg: string;
begin
  if not DeleteEntryOk(RPCBrokerMain, TPsHistory, psProfile.PositionIen, msg) then
     begin
        if not (length(msg) > 0) then
           msg := 'This position cannot be deleted.';
        messageDlg(msg, mtWarning, [mbOk,mbHelp], 80000);
        result := false;
        exit;
     end;

  result := DeleteHistoryOk(RPCBrokerMain, cboStatus.FMFile, psProfile.PositionIen,
     Piece(GetFMDelimRec(lstStatus.FMLister,lstStatus.ItemIndex), '^', 1), msg){Piece(Hlist[lstStatus.ItemIndex], '^', 1), msg) - PDR};

  if length(msg) > 0 then
     messagedlg(msg, mtWarning, [mbOK], 0);
end;


{
  add icon and date value to list box
}
procedure TfrmAssigned.lstStatusDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  bm: TBitmap;
begin
  with (Control as TFMListBox).Canvas do
     begin
        FillRect(Rect);
        bm := TBitmap(lstStatus.Items.Objects[Index]);

        if bm <> nil then
           begin
              BrushCopy(Bounds(Rect.Left + 2, Rect.Top + 2, bm.Width,
                 bm.Height), bm, Bounds(0, 0, bm.Width, bm.Height),
                 clBackground);
              TextOut(Rect.Left + 2 + bm.width, Rect.Top + 2,
                 lstStatus.Items[index]);
           end;
     end;
end;

{
  Set height of list items in history status list box.
}
procedure TfrmAssigned.lstStatusMeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
  Height := 20;
end;

{
  Cancel the addition of a new history status entry.
}
procedure TfrmAssigned.cmdStatusCancelClick(Sender: TObject);
begin
  try
    if pnlCalendar.Visible then
     pnlCalendar.visible := false;

     setStatusButtons(false,false,true,false);
     getHistory.ClearCtrlData{cleardata - PDR};
     txtStatusDate.AsString := emptystr;
{     txtStatusDate.AsOvcDate := CurrentDate;}
     cboStatus.FMCtrlInternal{FMInternal - PDR} := IntToStr(cboStatus.FMTag);
     cboReasons.FMCtrlInternal{FMInternal - PDR} := IntToStr(cboReasons.FMTag);
     DisableHistory(true);
  except
     on E: Exception do
        MessageDlg('Error: ' + E.ClassName + ' in status list', mtInformation,
                 [mbok], 0);
  end;
end;

{  **** New 1/15/96
  procedure to activate and inactivate status log page buttons.
}
procedure TfrmAssigned.setStatusButtons(Sok: boolean; Scan: boolean;
          Sadd: boolean; Sdel: boolean);
begin
     cmdStatusCancel.Enabled := Scan;
     cmdStatusOk.enabled := Sok;
     cmdStatusAdd.enabled := Sadd;
     if sdel then
        cmdStatusDelete.enabled := DeleteKey
     else
        cmdStatusDelete.enabled := sdel;
end;

{
  call the pop-up calendar procedure on the F2 key  press.
}
procedure TfrmAssigned.txtStatusDateKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_F2 then PopUpCalendar(txtStatusDate);
end;



{ ======================  Messages  tab  ===================================}


{
  set default message actions
}
procedure TfrmAssigned.SetMessages;
begin
  grpDeathMsg.ItemIndex := 0;
  grpDeathMsg.FMCtrlInternal{FMInternal - PDR} := 'T';
  flrPositions.AddChgdControl(grpDeathMsg);{Add(grpDeathMsg);-pdr}

  grpPatientMsg.ItemIndex := 0;
  grpPatientMsg.FMCtrlInternal{FMInternal - PDR} := 'T';
  flrPositions.AddChgdControl(grpPatientMsg);{Add(grpPatientMsg); - PDR}

  grpTeamMsg.ItemIndex := 0;
  grpTeamMsg.FMCtrlInternal{FMInternal - PDR} := 'T';
  flrPositions.AddChgdControl(grpTeamMsg);{Add(grpTeamMsg);-PDR}

  grpConsultMsg.ItemIndex := 0;
  grpConsultMsg.FMCtrlInternal{FMInternal - PDR} := 'T';
  flrPositions.AddChgdControl(grpConsultMsg);{Add(grpConsultMsg);-PDR}
end;


{
  change message group entry.  Set internal code to appropriate value and add
  to FMFiler.
}
procedure TfrmAssigned.grpMessageChange(Sender: TObject);
var
  index: integer;
begin
  case TFMRadioGroup(Sender).ItemIndex of
     0: TFMRadioGroup(Sender).FMCtrlInternal{FMInternal - PDR} := 'T';
     1: TFMRadioGroup(Sender).FMCtrlInternal{FMInternal - PDR} := 'P';
     2: TFMRadioGroup(Sender).FMCtrlInternal{FMInternal - PDR} := 'N';
  end;
  flrPositions.AddChgdControl(Sender); {Add(Sender); -PDR}
  SetSave(True);
end;



{ ==================== Form utility procedures =============================}

function TfrmAssigned.CheckReqd: boolean;
var
  i: integer;
begin
  result := true;
  for i := 0 to ComponentCount - 1 do
     begin
        if Components[i] is TFMEdit then
           begin
              if TFMEdit(Components[i]).FMRequired and
                 (TFMEdit(Components[i]).Text = '') then
                 begin
                    result := false;
                    exit;
                 end;
           end

        else if Components[i] is TFMComboBox then
           begin
              if TFMComboBox(Components[i]).FMRequired and
                (TFMComboBox(Components[i]).Text = '') then
                 begin
                    result := false;
                    exit;
                 end;
           end

        else if Components[i] is TFMComboBoxLookUp then
           begin
              if TFMComboBoxLookUp(Components[i]).FMRequired and
                (TFMComboBoxLookUp(Components[i]).Text = '') then
                 begin
                    result := false;
                    exit;
                 end;
           end;
     end;
end;

{ updated 1/24/96
  check for any missing required fields.  Build list of missing fields and
  return to calling procedure.
}
function TfrmAssigned.CheckRequired(var msg: string; var flag: boolean): boolean;
var
  i: integer;
begin
  msg := '';
  flag := false;

  for i := 0 to ComponentCount - 1 do
     begin
        if Components[i] is TFMEdit then
           begin
              if TFMEdit(Components[i]).FMRequired and
               (TFMEdit(Components[i]).Text = '') then
                 begin
                    TFMEdit(Components[i]).Color := clYellow;
                    msg := msg + RETURN + TFMEdit(Components[i]).FMDisplayName;
                 end;
           end

        else if Components[i] is TFMComboBox then
           begin
              if TFMComboBox(Components[i]).FMRequired and
                (TFMComboBox(Components[i]).Text = '') then
                 begin
                    TFMComboBox(Components[i]).Color := clYellow;
                    msg := msg + RETURN +
                           TFMComboBox(Components[i]).FMDisplayName;
                 end;
           end

        else if Components[i] is TFMComboBoxLookUp then
           begin
              if TFMComboBoxLookUp(Components[i]).FMRequired and
                (TFMComboBoxLookUp(Components[i]).Text = '') then
                 begin
                    TFMComboBoxLookUp(Components[i]).Color := clYellow;
                    msg := msg + RETURN + TFMComboBox(Components[i]).FMDisplayName;
                 end;
           end;
     end;


  if (Length(msg) > 0) then
     begin
        if length(msg) < 200 then
           msg := 'The followign fields are required:'  + msg
        else
           msg := 'Please check all edit fields to make sure they are complete.';
     end;

  result := (length(msg) > 0);
end;


{

}
procedure TfrmAssigned.PopUpCalendar(Sender: TObject);
var
  d: TOvcDate;
begin
  pf := TOvcPictureField(Sender);

  if pnlcalendar.visible then
        pnlCalendar.visible := false
  else begin
     pnlCalendar.top := TabPositions.Top + hdrStats.Height + (pf.Top + pf.Height);
     pnlCalendar.left := TabPositions.left + grpDate.Left + pf.left;
     d := pf.AsOvcDate;
     if d = BadDate then
        d := CurrentDate;
     Calendar.AsStDate := d;
     pnlCalendar.BringToFront;
     pnlCalendar.visible := true;
     Calendar.Setfocus;
  end;
end;

procedure TfrmAssigned.ChangeMonth(Sender: TObject);
begin
end;


{

}
procedure TfrmAssigned.CalendarClick(Sender: TObject);
begin
  pf.AsOvcDate := Calendar.AsStDate;
  pnlCalendar.visible := false;
  pf.Setfocus;
end;

{

}
procedure TfrmAssigned.CalendarKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_SPACE then CalendarClick(Sender);
end;


{  ***
  Build the list of positions based on the status of the All/Current option.
}
procedure TfrmAssigned.BuildPositionList;
begin
  if optShow.ItemIndex = 0 then begin
     lstPositions.FMLister.PartList.clear; {pdr}
     lstPositions.FMLister.PartList.insert(0,PsProfile.TeamIen);{Part := PsProfile.TeamIen; - PDR}
     lstPositions.FMLister.Screen := 'IF $P(^(0),U,2)=' + PsProfile.TeamIen + ',+$$ACTTP^SCMCTPU(Y)=1';
     {TEAM_SCREEN + PsProfile.TeamIen + '",+$$ACTTP^SCMCTPU(Y)=1';   }
     end
  else begin
     lstPositions.FMLister.PartList.clear; {pdr}
     lstPositions.FMLister.PartList.insert(0,PsProfile.TeamIen);{Part := PsProfile.TeamIen; - PDR}
     lstPositions.FMLister.Screen := 'IF $P(^(0),U,2)=' + PsProfile.TeamIen;
     {TEAM_SCREEN + PsProfile.TeamIen + '"';}
     end;

  lstPositions.FMLister.GetList(lstPositions.Items);
end;

{  ***
  Lock the active position and retrieve and display the positions information
}
function TfrmAssigned.GetTeamPosition: bool;
var
  lP: string[25];
begin
  Result := False ;
  //showmessage(PsProfile.PositionIen);//bp/cmf 177 hack
  if PsProfile.PositionIen = '' then exit;

  lP := '^SCTM(404.57,' + PsProfile.PositionIen + ')';

  if not Locker(RPCBrokerMain, lP, LockANode, 10) then
     begin
        messageDlg('Unable to lock this position', mtInformation, [mbOk], 0);
        result := false;
        exit;
     end;

  getPositions.IENS := PsProfile.PositionIen;
  getPositions.GetAndFill;
  flrPositionsFMMode := EditEntry;
  flrPositions.Clear;
  hdrStats.Sections[3] := txtPosition.Text;
  PsProfile.PositionName := txtPosition.Text;
  //bp/cmf 177 begin
         //bp/cmf v6
         chkPreceptorDeath.Enabled := true;
         chkPreceptorInpatient.Enabled := true;
         chkPreceptorConsult.Enabled := true;
         chkPreceptorTeam.Enabled := true;
         //bp/cmf v6

    cmdPreceptor.Enabled := true;

    with chkpractioner do
     begin
      if state = cbGrayed then state := cbUnchecked;
      enabled := false;
     end;

    with chkpreceptor do
     begin
      if state = cbGrayed then state := cbUnchecked;
      enabled := false;
     end;
     
    //initialize preceptor cboxes on message tab begin
    with chkPreceptorDeath do
     begin
      if state = cbGrayed then state := cbUnchecked;
     end;
    with chkPreceptorInpatient do
     begin
      if state = cbGrayed then state := cbUnchecked;
     end;
    with chkPreceptorConsult do
     begin
      if state = cbGrayed then state := cbUnchecked;
     end;
    with chkPreceptorTeam do
     begin
      if state = cbGrayed then state := cbUnchecked;
     end;
    //initialize preceptor cboxes on message tab end
    //check current provider MD,np etc
    if (FMLblFutureAsgn.Caption = 'YES') and
     (FMLblPrecepts.Caption = 'YES') THEN  // DO THIS FOR SCREENING AND (PCProvider(psProfile.PositionIen)='1') then
      begin
       chkPractioner.enabled := true;
       chkPreceptor.enabled := true;
      end;

    with PsProfile do
     begin
      LinkActive := false;
      PreceptorB := false;
      Link       := false;
     end;

    if FMlblPrecepts.Caption = 'NO'
     then
      begin
       cmdPreceptor.enabled  := false;
       PsProfile.LinkActive  := true;
      end;

    if FMlblFutureAsgn.Caption = 'NO'
     then
      begin
       PsProfile.PreceptorB := true;
       PsProfile.LinkActive  := true;
      end;


    if FMlblPreceptor.Caption <> ''
     then
      begin
       chkPreceptor.enabled := false;
       chkPreceptorDeath.enabled := true;
       chkPreceptorInpatient.enabled := true;
       chkPreceptorConsult.enabled := true;
       chkPreceptorTeam.enabled := true;
       if FMlblFutureAsgn.Caption = 'NO'
        then
         begin
          PsProfile.PreceptorB  := true;
         end;
      end;
  if PsProfile.TeamCanProvidePC = false
   then chkPractioner.Enabled := false;

  if chkPreceptor.Checked then
    begin
     cmdPreceptor.enabled := false;
         //bp/cmf v6
         chkPreceptorDeath.Enabled := false;
         chkPreceptorInpatient.Enabled := false;
         chkPreceptorConsult.Enabled := false;
         chkPreceptorTeam.Enabled := false;
         //bp/cmf v6

    end;
  //bp/cmf 177 end
  loadHistory;
  loadStaff;
  result := true;
end;


 { ***
  validate new position name, if valid then build new entry ( SetUpNewPosition).

  Input; s: string, new position name
  Returns: True if valid name, false if not.
}
function TfrmAssigned.ConfirmNewPosition(s: string): Bool;
var
  s1 : string;
begin
  Result := False ;
  if EntryLengthOk(s, 3, 30) then begin
     s1 :='^SCTM(404.57,"APRIMARY","' + s +'",' + PsProfile.TeamIen + ')';
     if GlobalNode(RPCBrokerMain, s1) = UNDEFINED_NODE then
        begin
           SetUpNewPosition(s);
           result := true;
        end
     else
        begin
           messagedlg('This name is already in use for this team!', mtWarning,
             [mbOk], 0);
           result := false;
        end;
  end;
end;


{ ***
  validate text change and add to filer if ok
}
procedure TfrmAssigned.TextExit(Sender: TObject);
begin
  with ( Sender as TFMEdit) do begin
     if FMModified then begin
        if (Sender=txtAllowed) and (pos(',',Text)>0) then
          repeat
                Text := copy(text,1,pos(',',text)-1)+copy(text,pos(',',text)+1,99) ;
          until pos(',',Text)=0 ;
        FMCtrlInternal{FMInternal - PDR} := Text;
        if Validate then
           FMFiler.AddChgdControl(Sender){Add(Sender)- PDR}
        else begin
           messageDlg('Entry was not validated by Data Dictionary', mtInformation, [mbOk], 0);
           text := FMTag;
        end;
     end;
  end;
end;

procedure TfrmAssigned.cboRoleClick(Sender: TObject);
begin
  with cboRole do begin
     FMCtrlInternal := Piece(GetFMDelimRec(FMLister,ItemIndex), '^', 1);{Piece(FMLister.Results[ItemIndex], '^', 1); - PDR}
     FMFiler.AddChgdControl(Sender);
     color := clWindow;
     {Font.Color := clBlack;}
     cmdSave.Enabled := CheckReqd;
     cmdUndo.Enabled := true;
  end;
end;

procedure TfrmAssigned.cboPreceptorClick(Sender: TObject);
begin
 { with cboPreceptor do begin
     if text = NONE then
        FMCtrlInternal := ''
     else
        FMCtrlInternal := Piece(GetFMDelimRec(FMLister,ItemIndex), '^', 1);

     FMFiler.AddChgdControl(Sender);
     color := clWindow;
  end;
  cmdSave.Enabled := CheckReqd;
  cmdUndo.Enabled := true;}
end;


{ modified 2/8/96
  corrected for 'list out of bounds' if none only the entry.
  Generic dropdown list change, delete entry if 'None' selected,
  otherwise add new entry to FMFiler.
}
procedure TfrmAssigned.cboChangeItem(Sender: TObject);
begin
	with (Sender as TFMComboBox) do
  	begin
        if (Sender as TFMComboBox).Text = NONE then begin
           FMCtrlInternal{FMInternal - PDR} := '';
           ItemIndex := -1;
           end
        else
           FMCtrlInternal{FMInternal - PDR} := Piece(GetFMDelimRec(FMLister,ItemIndex), '^', 1);{Piece(FMLister.Results[ItemIndex], '^', 1); - PDR}

        FMFiler.AddChgdControl(Sender);{Add(Sender);-PDR}
        color := clWindow;
        cmdSave.Enabled := CheckReqd;
        cmdUndo.Enabled := true;
     end;
end;

{ ***
  Generic Checkbox change event, set FMCtrlInternal to either 1 or 0
  depending on status of check box.
}
procedure TfrmAssigned.CheckChange(Sender: TObject);
begin
   with (Sender as TFMCheckBox) do
     begin

     if (Checked <> FMTag) then
      begin
        if checked
         then FMCtrlInternal := '1'
          else FMCtrlInternal := '0';
         FMFiler.AddChgdControl(Sender);
         cmdSave.Enabled := true;
         cmdUndo.Enabled := true;
      end; //end if (checked <> FMTag)


     if name = 'chkPreceptor' then
        begin
         //bp/cmf v6
         chkPreceptorDeath.Enabled := true;
         chkPreceptorInpatient.Enabled := true;
         chkPreceptorConsult.Enabled := true;
         chkPreceptorTeam.Enabled := true;
         //bp/cmf v6
         if checked then
          begin
           cmdPreceptor.enabled := false;
         //bp/cmf v6
         chkPreceptorDeath.Enabled := false;
         chkPreceptorInpatient.Enabled := false;
         chkPreceptorConsult.Enabled := false;
         chkPreceptorTeam.Enabled := false;
         //bp/cmf v6
          end
         else if cmdAssignStaff.enabled = true
         then cmdPreceptor.enabled := true;
        end;


{//bp/cmf 177 original code----------------------------------
        if (Checked) and (Enabled) then
           FMCtrlInternal := '1'
        else
          begin
           enabled:=true; //try to prevent checked greyed box - pdr
           checked:=false;
           enabled:=false;
           FMCtrlInternal := '0';
          end;



          if (Checked <> FMTag) then
           begin
              FMFiler.AddChgdControl(Sender);//Add(Sender); - PDR
              cmdSave.Enabled := CheckReqd;
              cmdUndo.Enabled := true;
           end;
//bp/cmf 177 end original code-------------------------------}



     end;  //with sender as FMCheckbox

end;

{ ***
  Change Combobox (Sender) entry.  On exiting, and the combobox entry has
  been deleted (Null value), then handle as a special caes. Otherwise
  get the index value of the new selection and add it to the change
  transaction list.  If a new entry was not selected, then call the
  reset method and set focus back to the combobox
}
procedure TfrmAssigned.cboExit(Sender: TObject);
begin
  if not (Sender as TFMComboBoxLookUp).FMModified then exit;

	with (Sender as TFMComboBoxLookUp) do
     begin
        try
           if (text = '') and (FMCtrlInternal{FMInternal - PDR} <> '') then
              FMCtrlInternal{FMInternal - PDR} := ''
           else if ItemIndex >= 0 then
                 FMCtrlInternal{FMInternal - PDR} := Piece(getFMDelimRec(FMLister,ItemIndex), '^', 1);{Piece(FMLister.Results[ItemIndex], '^', 1);}
        finally
           FMFiler.AddChgdControl(Sender); {Add(Sender); - PDR}
           cmdSave.Enabled := CheckReqd;
           cmdUndo.Enabled := true;
        end;
     end;
end;

{  new 1/2696
  reset the edit field colors
}
procedure TfrmAssigned.cboEnter(Sender: TObject);
begin
  with (Sender as TFMComboBoxLookUp) do
     begin
        color := clWindow;
        Font.Color := clBlack;
     end;
end;

{

}
procedure TfrmAssigned.cboUserClassKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {if Key = VK_RETURN then Key := VK_TAB;}
end;


{

}
procedure TfrmAssigned.cboKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ShowDropDown(Sender, key, shift);
end;


{ ==================  updated command/action procedures  ====================}

{ ***
  Open a new team.
}
procedure TfrmAssigned.Open1Click(Sender: TObject);
var
  new: boolean;
begin
  case CheckSave(flrPositions) of
     Save: Save1Click(Sender);
     Abort: exit;
  end;

  LookUp.AllowNew := false;
  Lookup.FMLister.FromList.Clear; {pdr}
  LookUp.FMLister.FromList.Insert(0,'');{From := ''; - PDR}
  LookUp.FMLister.FromIen := '';
  LookUp.FMLister.PartList.clear; {pdr}
  LookUp.FMLister.PartList.Insert(0,'');{Part := ''; - PDR}
  LookUp.FMLister.Number := '*';
  LookUp.Title := 'Select Team';

  tabPositions.Enabled := true;

  if frmMain.ActiveOnly1.checked then
     LookUp.FMLister.Screen := 'IF $$ACTHISTB^SCAPMCU1(404.58,Y)'
  else
     LookUp.FMLister.Screen := '';

  if LookUp.Execute(new) then
     begin
        if PsProfile.PositionIen <> '' then UnlockPosition;
        PsProfile.TeamIen := LookUp.RecordNumber;
        PsProfile.TeamName :=
                     Piece(GetFMDelimRec(LookUp.FMLister,LookUp.RecordIndex), U, 2);{Piece(LookUp.FMLister.Results[LookUp.RecordIndex], U, 2); - PDR}
        OpenPositions;
     end
  else
     if (PsProfile.PositionIen = '') then
        postmessage(Handle, WM_CLOSE, 0, 0);
end;

procedure TfrmAssigned.OpenPositions;
begin
  getPositions.ClearCtrlData{cleardata - PDR};
  getHistory.ClearCtrlData{cleardata - PDR};
  getStaff.ClearCtrlData{cleardata - PDR};

  lstStatus.Clear;

  hdrStats.Sections[1] := PsProfile.TeamName;
  hdrStats.Sections[3] := '';
  hdrStats.Sections[5] := '';

  //bp/cmf 177 new code begin
  {//bp/cmf 177 old begin
  GetPreceptorList;}

  getPc.IENS := psProfile.TeamIen;
  getPc.GetData;
  if getPc.results.count > 0 then
  //old   chkPractioner.enabled := (Piece(GetFMDelimRec(getPc,0), U, 4) = '1');
  PsProfile.TeamCanProvidePC
           := (Piece(GetFMDelimRec(getPc,0), U, 4) = '1');
  //bp/cmf 177 old end
  //dmcTeam.CreateTeamRecord(PsProfile.TeamIen);
  //PsProfile.TeamCanProvidePC := Team.PCTeam;
  //bp/cmf 177 new code end
  BuildPositionList;
  if lstPositions.Items.Count > 0 then
     begin
        cmdAssignStaff.Enabled := True ;
        AssignStaff2.Enabled := True ;
        lstPositions.ItemIndex := 0;
        PsProfile.PositionIen
          := Piece(GetResultString(lstPositions.FMLister,
                                   lstPositions.Items[0], 2), U, 1);
        GetTeamPosition;     //righthere
     end
  else if not NewInactive then
     begin
        cmdAssignStaff.Enabled := True ;
        AssignStaff2.Enabled := True ;
        New1Click(nil);
     end ;

  setSave(false);
  NewInActive := false;
end;


{  updated 1/24/96
  create a new team position.  Disable New menu item while creating new
  position.  if already in AddEntry mode, then exit.  If no position created,
  then relock old position
}
procedure TfrmAssigned.New1Click(Sender: TObject);
var
  s, lP: string;
  noPost: bool;
begin
  tabPositions.PageIndex := 0;
  cmdPreceptor.enabled := false;
         //bp/cmf v6
         chkPreceptorDeath.Enabled := true;
         chkPreceptorInpatient.Enabled := true;
         chkPreceptorConsult.Enabled := true;
         chkPreceptorTeam.Enabled := true;
         //bp/cmf v6

  case CheckSave(flrPositions) of
     Save: Save1Click(Sender);
     Abort: exit;
  end;

  if PsProfile.PositionIen <> '' then UnlockPosition;
  OldProfile := psProfile;
  if tabPositions.enabled = false then tabPositions.enabled := true;

  repeat
     s := '';
     noPost := False ;
     if not InputQuery('New Position', 'Enter name of new position:', s) then
        begin
           noPost := true;
           if lstPositions.Items.Count = 0 then
            begin
              tabPositions.enabled := false;
              cmdAssignStaff.Enabled := False;
              cmdPreceptor.enabled := false;
              AssignStaff2.Enabled := False ;
              AssignStaff1.Enabled := False ;
            end ;
           exit;
        end;
  until ConfirmNewPosition(UpperCase(s));

  if noPost then
     begin
        lP := '^SCTM(404.57,' + PsProfile.PositionIen + ')';
        {if not Locker(RPCBrokerMain, lP, LockANode, 5) then
           messagedlg('Problem re-locking active position.', mtWarning, [mbOk], 0);}
     end;
end;


{  ****
  Option for showing All or Current Team positions.  If Index = 0, Current
  only, then set screen for team and inactive date, if Index = 1, All, then
  set screen for team only. Reload team positions from file.
}
procedure TfrmAssigned.optShowClick(Sender: TObject);
begin
  UnLockPosition;//bp/cmf 177 hack
  if cmdSave.Enabled then
     if messagedlg('You have not saved your current changes!' + RETURN +
       'Do you want to save them now?', mtConfirmation, [mbYes,mbNo], 0) = mrYEs
       then Save1Click(nil);

  if optShow.ItemIndex = 0 then
     lblPositionHdr.Caption := 'Active Team Positions'
  else
     lblPositionHdr.Caption := 'All Team Positions';

  BuildPositionList;
  if lstPositions.Items.Count > 0 then
     begin
        lstPositions.ItemIndex := 0;
        PsProfile.PositionIen := Piece(GetFMDelimRec(lstPositions.FMLister,0), U, 1);
        tabPositions.enabled := true;
     end
  else if not NewInactive then
     tabPositions.enabled := false;

  GetTeamPosition;
  SetSave(False);
end;


{    ***
  display popup menu when Shift + F10 keys are pressed
}
procedure TfrmAssigned.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If (key = VK_F10) and (Shift = [ssShift]) then
     sendMessage(Handle, WM_RBUTTONDOWN, 0, 0);
end;

{ ***
  undo any changes made to the position and clear the fmfiler's
}
procedure TfrmAssigned.Undo1Click(Sender: TObject);
begin
  if not (PsProfile.PositionIen = NEW_ENTRY) then
     begin
        txtPosition.FMGets.GetAndFill;
        loadhistory;
        loadStaff;
     end
  else if not (OldProfile.PositionIen = '') then
     begin
        psProfile := OldProfile;
        txtPosition.FMGets.Iens := OldProfile.PositionIen;
        txtPosition.FMGets.GetAndFill;
        hdrStats.Sections[3] := psProfile.PositionName;
        loadhistory;
        loadStaff;
     end
  else if lstPositions.Items.Count > -1 then
     begin
        lstPositions.ItemIndex := 0;
        lstPositionsDblClick(nil);
     end
  else
     close;

  tabPositions.Pages[3].Enabled := true;
  ClearEditFields;
  cmdSave.Caption := 'Sa&ve';
  SetSave(False);
  SetStatusButtons(false, false, true, false);
  NewStatusFlag := false;

  New1.Enabled := true;
  New2.Enabled := true;
  cmdNewPosition.Enabled := true ;
  RemovePosition2.enabled := (DeleteKey and (lstPositions.Items.Count > 0)) ;
  ExternalPosition2.enabled := true;
  ExternalPosition1.enabled := true;
  {AssignStaff1.Enabled := true;
  AssignStaff2.Enabled := true;
  cmdAssignStaff.Enabled := true;  }
  AssignStaff1.Enabled := (lstPositions.Items.Count > 0) ;
  AssignStaff2.Enabled := (lstPositions.Items.Count > 0) ;
  cmdAssignStaff.Enabled := (lstPositions.Items.Count > 0) ;
  cmdPreceptor.enabled := (lstPositions.Items.Count > 0) ;

  flrPositions.Clear;
  flrPositionsFMMode{flrPositions.FMMode - pdr} := EditEntry;
  flrHistory.Clear;
  flrHistoryFMMode{flrHistory.FMMode - PDR} := EditEntry;
  flrStaffFMMode{flrStaff.FMMode - PDR}:=EditEntry;
  flrStaff.Clear;
end;

{ ***
  save changes.  If record is a new record (AddEntry), then find the
  ien of the new record and update the FMEntry values for the data components.
  Process position changes first, then process any history changes.
}
procedure TfrmAssigned.Save1Click(Sender: TObject);
var
  lp,
  ien,
  xmz   : string[30];
  msg   : string;
  flag  : boolean;
  i     : integer;
begin
tabPositions.PageIndex := 0;
  Perform(WM_NEXTDLGCTL, 0, 0);

  if CheckRequired(msg, flag) then begin
     messagedlg(msg, mtWarning, [mbOk,mbHelp], 80000);
     cmdSave.enabled := false;
     exit;
  end;

  if not (flrPositions.AnythingtoFile) then exit;

  if flrPositionsFMMode = AddEntry then
     flrPositions.AddFDA('404.57',NEW_ENTRY,'.02', PsProfile.TeamIen);


  if flrPositions.Update then begin
     frmMain.StatusMsg(' Position Saved.', false);
     if flrPositionsFMMode{flrPositions.FMMode - PDR} = AddEntry then begin
        ien := flrPositions.FindIen(NEW_ENTRY + ',');
        getPositions.StuffIENS(ien);{SetEntryNumber(ien); - PDR}
        PsProfile.PositionIen := ien;
        if not (psProfile.PositionIen = emptystr) then begin
           frmEnterDate.Caption := 'Enter Position Activation Date:';
           frmEnterDate.ShowModal;
           if frmEnterDate.ModalResult = mrOk then begin
              //bp/cmf 204 new begin
              if NewHistoryOk(RPCBrokerMain,
                                  '404.59',
                                  psProfile.PositionIen,
                                  frmEnterDate.FMDate,
                                  msg)
                     then begin

              //bp/cmf 204 new end
              txtHistoryDate.FMCtrlInternal:= frmEnterDate.FMDate;
              flrHistory.AddFDA('404.59',NEW_ENTRY,'.01', psProfile.PositionIen);{Key('404.59', '.01', psProfile.PositionIen); -PDR}
              flrHistory.AddChgdControl(cboStatus);{Add(cboStatus); - PDR}
              flrHistory.AddChgdControl(txtHistoryDate);{Add(txtHistoryDate); - PDR}
              flrHistory.AddChgdControl(cboReasons);{Add(cboReasons); - PDR}
              if flrHistory.Update then
                 frmMain.StatusMsg('Position History Saved', False);
              tabPositions.Pages[3].Enabled := true;
              end
              else
               begin
                messageDlg('Team not active on selected date.',
                            mtWarning,[mbOk],0);
                with tabPositions do
                 begin
                  Pages[3].Enabled := true;
                  PageIndex := 3;
                 end;
                txtStatusDate.SetFocus;
                SetSave(false);
                exit;
               end;
           end;
        flrPositionsFMMode := EditEntry;
        end;
     end;
     //PsProfile.Preceptor := cboPreceptor.Text;
     getPositions.IENS := psProfile.PositionIen;
     getPositions.GetAndFill;
     PsProfile.PositionName := txtPosition.text;
     BuildPositionList;
     GetTeamPosition;
     //GetPreceptorList;

     {if (PsProfile.Preceptor <> '') and (PsProfile.Preceptor <> NONE) then
        cboPreceptor.ItemIndex := cboPreceptor.Items.Indexof(PsProfile.Preceptor);}

     loadHistory;
  end
  else begin
     messageDlg('Position was not saved!', mtWarning, [mbOk], 0);
     SetSave(false);
     exit;
  end;

  New1.Enabled := true;
  New2.Enabled := true;
  cmdNewPosition.Enabled := true ;
  ExternalPosition2.enabled := true;
  ExternalPosition1.enabled := true;
  NewStatusFlag := false;
  NewInactive := false;
  SetStatusButtons(false, false, true, false);
  cmdSave.Caption := 'Sa&ve';
  {Changed to check contents of list instead of always TRUE- 1/31/97 - RV}
  RemovePosition2.enabled := (DeleteKey and (lstPositions.Items.Count > 0)) ;
  AssignStaff1.Enabled := (lstPositions.Items.Count > 0) ;
  AssignStaff2.Enabled := (lstPositions.Items.Count > 0) ;
  cmdAssignStaff.Enabled := (lstPositions.Items.Count > 0) ;
  {END of changed code  - 1/31/97 - RV}
  flrPositions.Clear;
  SetSave(False);
end;


{ ***
  check whether there are any changes to save before exiting.  If there
  are confirm action.  Unlock current position before proceeding.
}
procedure TfrmAssigned.Exit1Click(Sender: TObject);
begin
  close;
end;

{ ***
  Delete current position
}
procedure TfrmAssigned.Delete1Click(Sender: TObject);
var
  msg: string;
  s: string[30];
begin
  msg := '';
  if not DeleteEntryOk(RPCBrokerMain, TPos, psProfile.PositionIen, msg) then
     begin
        if not (length(msg) > 0) then
           msg := 'This position cannot be deleted.';
        messageDlg(msg, mtWarning, [mbOk,mbHelp], 80000);
        exit;
     end;

  s :=  txtPosition.Text;
  if messageDlg('You are about to delete the ' + s + ' position.'
       + RETURN + 'Do you want to do this?', mtConfirmation,
       [mbYes,mbCancel], 0) = mrYes then
     begin
        If PsProfile.PositionIen <> '' then UnlockPosition;
        if Deleter(RPCBrokerMain, '^SCTM(404.57,',PsProfile.PositionIen) then
           begin
              flrPositions.clear;
              hdrStats.Sections[3] := '';
              hdrStats.Sections[5] := '';
              BuildPositionList;
              GetPreceptorList;
              if lstPositions.Items.Count > 0 then
                 begin
                    lstPositions.ItemIndex := 0;
                    PsProfile.PositionIen :=
                             Piece(GetFMDelimRec(lstPositions.FMLister,0), U, 1);{Piece(lstPositions.FMLister.Results[0], U, 1); - PDR}
                    GetTeamPosition;
                 end
              else
                 begin
                    getPositions.ClearCtrlData{cleardata - PDR};
                    tabPositions.enabled := false;
                 end;
              setSave(False);
              frmMain.StatusMsg(s + ' was deleted.', false);
           end
        else
           messagedlg('Unable to delete position.', mtWarning, [mbOk], 0);
     end;
end;


{ ***
  Get information for the position which has been selected
}
procedure TfrmAssigned.lstPositionsDblClick(Sender: TObject);
begin

end;


{ ***
  Call contents page of help
}
procedure TfrmAssigned.Help1Click(Sender: TObject);
begin
  {Application.HelpFile := 'PCMM.HLP'; - PDR}
  case tabPositions.PageIndex of
     0: Application.HelpContext(41310);
     1: Application.HelpContext(41320);
     2: Application.HelpContext(41340);
     3: Application.HelpContext(41330);
     4: Application.HelpContext(41350);
  else Application.HelpContext(41300);
  end;
end;

{ ***
  call double click event when return key is pressed in the position's list
}
procedure TfrmAssigned.lstPositionsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_SPACE then lstPositionsDblCLick(Sender);
end;


{ ***
  check wether to enable the save and undo buttons.  If the text in either a
  text box, memo field, or lookup field are changed, then enable the buttons.
}
procedure TfrmAssigned.TextChange(Sender: TObject);
begin
  if (cmdSave.Enabled = true) then exit;

  if ActiveControl is TFMEdit then
     if (TFMEdit(Sender).Text <> '') then
        begin
           cmdSave.Enabled := CheckReqd;
           cmdUndo.Enabled := true;
           TFMEdit(Sender).color := clWindow;
        end;

  if ActiveControl is TFMMemo then
     if (TFMMemo(Sender).text <> '') then
        begin
           cmdSave.Enabled := CheckReqd;
           cmdUndo.Enabled := true;
        end;

  if ActiveControl is TFMComboBoxLookUp then
     if (TFMComboBoxLookUp(Sender).Text <> '') then
        begin
           TFMComboBoxLookUp(Sender).Color := clWindow;
           cmdSave.Enabled := CheckReqd;
           cmdUndo.Enabled := true;
        end

end;

{ ***
  load history status information for the position
}
procedure TfrmAssigned.LoadHistory;
var
  i: integer;
  img: TGraphic;
  s1: string[20];
begin
  getHistory.ClearCtrlData{cleardata - PDR};
  HList.clear;
  with lstStatus do
     begin
        Clear;
        FMLister.Screen := 'IF $P(^(0),U,1)="' + PsProfile.PositionIen + '"';
        FMLister.GetList(nil);
        HList.Assign(FMLister.Results);
        if HList.Count > 0 then
           begin
              for i := 0 to HList.Count - 1 do
                 begin
                    if Piece(GetFMDelimRec(FMLister,i), U, 4){Piece(HList[i], U, 4)} = 'ACTIVE' then
                       img := imgYes.picture.graphic
                    else
                       img := imgNo.picture.graphic;

                    s1 := '  ' + FMDateToStr(ExtDateToFM(Piece(GetFMDelimRec(FMLister,i), U, 3))){Piece(HList[i], U, 3))) - PDR};
                    lstStatus.Items.AddObject(s1, img);
                 end;
              {txtStatusDate.AsOvcDate := CurrentDate;}
              lstStatus.ItemIndex := 0;
           end
        else
           getHistory.ClearCtrlData{cleardata - PDR};
     end;

  DisableHistory(true);
  flrHistory.CLear;
  SetStatusButtons(false, false, true, false);
end;

{

}
procedure TfrmAssigned.DisableHistory(Status: boolean);
begin
  txtStatusDate.enabled := not status;
  cboStatus.enabled := not status;
  cboreasons.enabled := not status;
  spnStatusDate.enabled := not status;
end;

{ ***
  process modifications to the name.
}
procedure TfrmAssigned.ModifyPosition(obj: Tobject);
var
  s1 : string;
begin
  with txtPosition do begin
     if not EntryLengthOk(Text, 3, 30) then begin
        Text := FMTag;
        FMModified := false;
        setfocus;
        end
     else begin
        s1 :='^SCTM(404.57,"APRIMARY","' + text +'",' + PsProfile.TeamIen + ')';
        if GlobalNode(RPCBrokerMain, s1) = UNDEFINED_NODE then begin
           if messagedlg('You are about to change the name of the ' +
           Text + ' position.'+ RETURN + 'Do you want to do this?',
           mtConfirmation, [mbYes,MbCancel], 0) = mrYes then begin
              FMCtrlInternal{FMInternal - PDR} := text;
              hdrStats.Sections[3] := Text;
              if txtPositionFMFilerFMMode{FMFiler.FMMode - PDR} = EditEntry then       {IF added - 12/20/96 - RV}
                 FMFiler.AddChgdControl(txtPosition);{Add(txtPosition); - PDR}
              end
           else begin
              text := FMTag;
              FMModified := false;
              end;
           end
        else begin
              messagedlg('This name is already in use for this team.' + RETURN +
              'Please enter a different name.', mtInformation, [mbOk], 0);
              text := FMTag;
              FMModified := false;
              setfocus;
           end;
        end;
  end;
end;


{ ***
  set initial history status entry
}
procedure TfrmAssigned.StubStatus;
begin
  tabPositions.Pages[3].Enabled := false;
  flrHistory.Clear;
  flrHistoryFMMode{flrHistory.FMMode - PDR} := AddEntry;
  getHistory.SetUpNewEntry(NEW_ENTRY);

  txtHistoryDate.FMCtrlInternal{FMInternal - PDR} := ToFMDateTime(Date, false);
  txtStatusDate.AsOvcDate := CurrentDate;

  cboStatus.ItemIndex := 1;
  cboStatus.FMCtrlInternal{FMInternal - PDR} := '1';
  cboStatus.enabled := false;


  cboReasons.ItemIndex := cboReasons.Items.IndexOf('POSITION DEFINITION');
  cboReasons.FMCtrlInternal{FMInternal - PDR} :=
               Piece(GetFMDelimRec(cboReasons.FMLister,cboReasons.ItemIndex), U, 1);{Piece(cboReasons.FMLister.Results[cboReasons.ItemIndex], U, 1); - PDR}

  DisableHistory(true);
  txtStatusDate.enabled := true;
  spnStatusDate.enabled := true;

  SetStatusButtons(true, true, false, false);
  NewStatusFlag := true;
end;


{ ***
  Setup new position and stub in initial status entry and set message defaults.
}
procedure TfrmAssigned.SetUpNewPosition(s1: string);
var
  flag: boolean;
  msg: string;
begin

  getPositions.ClearCtrlData{cleardata - PDR};
  getHistory.ClearCtrlData{cleardata - PDR};
  getStaff.ClearCtrlData{cleardata - PDR};
  flrStaff.Clear;
  flrPositions.Clear;
  flrHistory.Clear;
  lstStatus.Clear;

  PsProfile.PositionIen := NEW_ENTRY;
  with txtPosition do
     begin
        text := s1;
        FMGets.StuffIENS(NEW_ENTRY);{SetEntryNumber(NEW_ENTRY); -PDR}
        FMCtrlInternal{FMInternal - PDR} := text;
        FMFiler.AddChgdControl(txtPosition);{Add(txtPosition); - PDR}
        flrPositionsFMMode{FMFiler.FMMode - PDR} := AddEntry;
     end;

  {Set new position's default CAN PROVIDE PRIMARY CARE? response to user preference,
    but only for a primary care team.}
  chkPractioner.Checked := frmMain.mnuPrimCare.Checked and chkPractioner.Enabled;

  { disable menu items}
  New1.Enabled := false;
  New2.Enabled := false;
  cmdNewPosition.Enabled := false ;
  RemovePosition2.enabled := false;
  ExternalPosition2.enabled := false;
  ExternalPosition1.enabled := false;
  AssignStaff1.Enabled := false;
  AssignStaff2.Enabled := false;
  CheckRequired(msg, flag);
  StubStatus;
  SetMessages;
  hdrStats.Sections[3] := txtPosition.Text;
  hdrStats.Sections[5] := '';
  cmdPreceptor.Enabled := false;
  cboRole.SetFocus;
  cmdAssignStaff.enabled := false;
  cmdSave.enabled := false;
  cmdSave.Caption := 'Sa&ve...';

  with chkPractioner do
   begin
    state := cbUnchecked;
    enabled := true;
   end;

  with chkPreceptor do
   begin
    state := cbUnchecked;
    enabled := true;
   end;

end;

{ ***
  keypress intercept for form.  If active control is a LookUp box and the
  return key is pressed, reset it to #0.  Otherwise, force uppercase letters,
  unless in the memo field.
}
procedure TfrmAssigned.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key  = #13 then
     if (ActiveControl is TFMComboBoxLookUp) then
        Key := #0;

  if not (ActiveControl is TFMMemo) then
     Key := UpCase(Key);
end;


{ ***
  unlock current position in use.
}
procedure TfrmAssigned.UnLockPosition;
var
  lp: string[30];
begin
  //showmessage('u:'+PsProfile.PositionIen);//bp/cmf 177 hack
  lp := '^SCTM(404.57,' + PsProfile.PositionIen + ')';
  Locker(RPCBrokerMain, lp, UnLockANode, 10);

end;

{ ***
  update the enable/disable status of the menu items
}
procedure TfrmAssigned.UpdateMenus(Sender: TObject);
var
  status: boolean;
begin
  status := false;
  if (flrPositions.AnythingtoFile) then
     status := true;

  Undo1.Enabled := status;
  Undo3.Enabled := status;
  Save1.Enabled := status;
  Save3.Enabled := status;
  RemovePosition2.enabled :=  (DeleteKey and (lstPositions.Items.Count > 0)) ;
  DeleteHistory.Enabled := (DeleteKey and txtStatusDate.Enabled and (lstPositions.Items.Count > 0));
end;



{ ***
  Set the enable/disable status of the save and undo buttons
}
procedure TfrmAssigned.SetSave(status: Boolean);
begin
  cmdSave.Enabled := status;
  cmdUndo.Enabled := status;
end;


{ @@@
  Load staff history for position into lstAssignment list box. Load active
  staff member into staff record and display information.

  SList:  TStringlist of staff assignments.
  string Format:
     History Ien,(#404.52) ^ .01  Position ^ .02  Effective Date ^
       .03  Staff Member ^ .04  Status ^ .05  Status Reason

  ActiveStaff Format:
}
procedure TfrmAssigned.LoadStaff;
var
  s2: string;
begin
  with hdrStats do
   begin
    Sections[5] := 'No Current Staff Member';
    s2 := GetActiveStaff(RPCBrokerMain, PsProfile.PositionIen, '', '');
    Sections[5] := Piece(s2, U, 2);
    if Sections[5] = 'No Current Staff Member' then
     cmdPreceptor.enabled := false;  //bp-cmf 177
   end;
  {hdrStats.Sections[5] := 'No Current Staff Member';
  s2 := GetActiveStaff(RPCBrokerMain, PsProfile.PositionIen, '', '');
  hdrStats.sections[5] := Piece(s2, U, 2);}
end;


{

}
procedure TfrmAssigned.ExternalPosition1Click(Sender: TObject);
begin
  notyet;
end;

{

}
procedure TfrmAssigned.ExternalPosition2Click(Sender: TObject);
begin
  notyet;
end;

{

}
procedure TfrmAssigned.Print1Click(Sender: TObject);
begin
  Notyet;
end;

{


}
procedure TfrmAssigned.PrintSetup1Click(Sender: TObject);
begin
  notyet;
end;


{

}
procedure TfrmAssigned.cboUserClassClick(Sender: TObject);
begin
  cboUserClass.Color := clWindow;
end;

{
  New 1/22/96
}
procedure TfrmAssigned.ClearEditFields;
var
  i: integer;
begin;
  for i := 0 to ComponentCount - 1 do
     begin
        if Components[i]is TFMEdit then
           begin
              TFMEdit(Components[i]).Color := clWindow;
              TFMEdit(Components[i]).font.Color := clBlack;
           end
        else if Components[i] is TFMComboBox then
           begin
              TFMComboBox(Components[i]).Color := clWindow;
              TFMComboBox(Components[i]).font.Color := clBlack;
           end
        else if Components[i] is TFMComboBoxLookUp then
           begin
              TFMComboBoxLookUp(Components[i]).Color := clwindow;
              TFMComboBoxLookUp(Components[i]).font.Color := clBlack;
           end;
     end;
end;

procedure TfrmAssigned.OldtabPositionsChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  if (NewTab = 4) and (psProfile.PositionIen = NEW_ENTRY) then begin
     messageDlg('Staff assignments cannot be made until the ' + RETURN +
                'current team position information has been saved.',
                 mtInformation, [mbOk], 0);
     AllowChange := false;
  end;

end;

procedure TfrmAssigned.RPCBroker1NetError(Sender: TObject;
  var Error: EBrokerError);
var
  msg: string;
begin
  msg := 'A Network error has been encountered.  Please make' + RETURN +
         'a note of your current entry.  You will need to' + RETURN +
         'logon to DHCP before continuing';
  messageDlg(msg, mtError, [mbOk], 0);
  NetError := true;
  Halt;
end;

procedure TfrmAssigned.cboReasonsEnter(Sender: TObject);
begin
  if (Sender as TFMComboBox).ItemIndex = -1 then
     ShowDropDown(Sender, VK_DOWN, [ssAlt]);
end;

procedure TfrmAssigned.cmdAssignStaffClick(Sender: TObject);
begin
  case CheckSave(flrPositions) of
     Save: Save1Click(Sender);
     Abort: exit;
  end;
  StaffExecute(false);
end;

procedure TfrmAssigned.AssignStaff2Click(Sender: TObject);
begin
 StaffExecute(false);
end;
{
//bp/cmf 177 old code
var
  CurProfile : TProfile;
begin
  CurProfile := psProfile;
  if UCInstalled then
     CurProfile.UserClass := cboUserClass.FMCtrlInternal + '^' + cboUserClass.Text
  else
     CurProfile.UserClass := '-1';

  if CurProfile.PositionName = '' then
     CurProfile.PositionName := hdrStats.Sections[3];

  CurProfile.Parent := frmAssigned;
  frmStaff.Execute(CurProfile);
end;}



procedure TfrmAssigned.lstPositionsExit(Sender: TObject);
begin
  lstPositions.ItemIndex := -1;
end;


procedure TfrmAssigned.tabPositionsPageChange(Sender: TObject;
  Index: Integer; var AllowChange: Boolean);
begin
  if tabPositions.pageIndex = 3 then
     AllowChange := not cmdStatusCancel.Enabled
  else if index=1 then {PDR}
   begin
  {//bp/cmf 177 original code begin--------------------------
  getPc.GetData;
  if getPc.results.count > 0 then
     chkPractioner.enabled := (Piece(GetFMDelimRec(getPc,0), U, 4) = '1');
  if cboPreceptor.Text = '' then
     chkPreceptor.enabled := true;
  if cboPreceptor.Text = '<none>' then
     chkPreceptor.enabled := true;

  if chkPractioner.FMCtrlInternal='' then
     begin
      chkPractioner.state := cbUnchecked;
      flrPositions.AddChgdControl(chkPractioner);
     end;

    if chkPreceptor.FMCtrlInternal = '' then
     begin
      chkPreceptor.state := cbUnchecked;
      flrPositions.AddChgdControl(chkPreceptor);
     end;
//bp/cmf 177 original code end------------------------}
    end;
end;

procedure TfrmAssigned.lstPositionsClick(Sender: TObject);
begin
   {formerly hung off of dblclick - PDR}
  cboRole.Color := clWindow;
  cmdAssignStaff.Enabled := true;
  cmdNewPosition.Enabled := true;
  if lstPositions.Items.Count = 0 then
     exit;

  if cmdSave.Enabled then
     if messagedlg('You have not saved your current changes!' + RETURN +
       'Do you want to save them now?', mtConfirmation, [mbYes,mbNo], 0) = mrYEs
       then
       begin
            Save1Click(nil);
            exit ;
       end;

  DisableHistory(true);
  If PsProfile.PositionIen <> '' then UnLockPosition;
  PsProfile.PositionIen := Piece(GetResultString(PositionsList, lstPositions.Items[lstPositions.ItemIndex], 2), U, 1);
  tabPositions.PageIndex := 0;
  GetTeamPosition;
  SetSave(False);

end;

procedure TfrmAssigned.cmdPreceptorClick(Sender: TObject);
begin

  case CheckSave(flrPositions) of
     Save: Save1Click(Sender);
     Abort: exit;
  end;

  StaffExecute(true);
end;

procedure TfrmAssigned.StaffExecute(PrecLink: boolean);
var
 CurProfile: TProfile;
begin

 cmdAssignStaff.enabled := false;
 cmdPreceptor.enabled   := false;

 CurProfile := PsProfile; //curProfile req'd because of conflict on frmTeamAsgn
 with CurProfile do
  begin
  if UCInstalled
   then
    UserClass := cboUserClass.FMCtrlInternal
                  + '^' + cboUserClass.Text
  else
   UserClass := '-1';

  if PositionName = '' then
     PositionName := hdrStats.Sections[3];

  Parent    := frmAssigned;
  Link      := PrecLink;
  DeleteKey := frmAssigned.DeleteKey;
 end; //with psprofile do

 frmStaff.Execute(CurProfile);
end;

function TfrmAssigned.RvwActFutPosAsgn(RPCBroker: TRPCBroker; FromPos, FromDate, ToDate, DtDate, AssignStat: string): boolean;
var
patjob,patjobcount,s,name,ssn : string;
i: integer;
begin
 result := false;
 try
  with RPCBroker do
   begin
     with Param[0] do
      begin
       Value := '.SC';
       Ptype := list;
       Mult['"FROMPOS"']   := FromPos;
       Mult['"FROMDATE"'] := FromDate;
       Mult['"TODATE"'] := ToDate;
       Mult['"DATE"'] := dtDate;
       Mult['"ASSIGNSTAT"'] := AssignStat;
      end;//with param[0] do
    RemoteProcedure := 'SCMC BLD POS PAT LIST';
    call;
    s := results[0];
    patjobcount := piece(s,'^',2);
    if strtoint(patjobcount) > 0 then
     begin
      patjob := piece(s,'^',1);
      RemoteProcedure := 'SC GET PAT BLOCK';
     with Param[0] do
      begin
       Value := '.SC';
       Ptype := list;
        Mult['"JOBID"']   := 'SCPOS';
        Mult['"JOB"']     := PatJob;
        Mult['"BSTART"']  := '1';
        Mult['"BEND"']    := '200';
        Mult['"BLAST"']   := PatJobCount;
      end;//with param[0] do
     call;
     with frmDischargeMemo do
      begin
       with dischargememo do
        begin
         lines.assign(results);
         for i := 0 to lines.count-1 do
          begin
           s := lines[i];
           ssn := piece(s,u,6);
           s := copy(piece(s,u,2),1,30);
           frmTeamAssign.pad(s, 30);
           lines[i] := s +  tab  + ssn;
          end;
         if lines.count > 6 then ScrollBars := ssVertical;
         //ReadOnly   := true;
        end;
       caption := 'Review active and future position assignments';
       label1.Caption   := 'Patient(s):';
       with lblWarn1 do
        begin
         Caption := '        Current or future position assignment(s) must be discharged';
         Alignment := taCenter;
         Visible := true;
        end;
       with lblWarn2 do
        begin
         Caption := '   before the position can be inactivated.';
         Alignment := taCenter;
         Visible := true;
        end;
       BitBtnDischargeOK.Visible := false;
       BitBtn1.Visible := false;
       ShowModal;
      end;//with frmDischargeMemo do
     end
    else result := true;
   end;//with rpcbroker do

 except
  frmMain.statusmsg('Unable to review assignments', false);
 end;// try..except
end;

end.
