{*******************************************************************}
{                                                                   }
{ File Entry Selection form for Queries in PCMM                     }
{ a component of the Scheduling Redesign Project                    }
{                                                                   }
{ Scheduling ver 5.3 AUG 13, 1993                                   }      
{ Management Information Products Group                             }
{ Albany NY (mjk)                                                   }
{ Dept. of Veteran Affairs                                          }
{                                                                   }
{    Last updated: 28 May 2002 (J. Peterson)                        }
{                                                                   }
{*******************************************************************}

{ Form Template - Source and Destination Choices Lists }
unit Rptsel;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Trpcb, ExtCtrls, mfunstr, Dialogs, SysUtils, Menus,
  Fmcmpnts, Fmlookup, Messages, autodet, autout, scutdef, rptutl, rptseldt, scuterr
  {,Gtsize32 - PDR}, Diaccess;
type
  TfrmSelections = class(TForm)
    boxCandidates: TGroupBox;
    SrcList: TListBox;
    DstList: TListBox;
    txtSearch: TEdit;
    cmdFind: TBitBtn;
    boxInclExcl: TGroupBox;
    IncludeBtn: TSpeedButton;
    IncAllBtn: TSpeedButton;
    ExcludeBtn: TSpeedButton;
    ExAllBtn: TSpeedButton;
    chkAll: TCheckBox;
    tmr: TTimer;
    popSrc: TPopupMenu;
    cmdpopSrcInclude: TMenuItem;
    popDst: TPopupMenu;
    cmdpopDstExclude: TMenuItem;
    cmdpopDstExcludeAll: TMenuItem;
    N2: TMenuItem;
    cmdpopDstSave: TMenuItem;
    cmdpopDstCancel: TMenuItem;
    FMListerDivision: TFMLister;
    FMListerTeam: TFMLister;
    FMListerPractitioner: TFMLister;
    FMListerRole: TFMLister;
    FMListerClinic: TFMLister;
    pnlStatusBar: TPanel;
    pnlStatus: TPanel;
    cmdpopSrcIncludeAll: TMenuItem;
    FMLookUp1: TFMLookUp;
    FMLister1: TFMLister;
    cmdMore: TButton;
    lblSearch: TLabel;
    Panel3: TPanel;
    cmdpopSrcDetails: TMenuItem;
    N4: TMenuItem;
    cmdpopDstDetails: TMenuItem;
    N1: TMenuItem;
    boxRadType: TGroupBox;
    radDivision: TRadioButton;
    radTeam: TRadioButton;
    radPractitioner: TRadioButton;
    radRole: TRadioButton;
    radClinic: TRadioButton;
    radUserClass: TRadioButton;
    FMListerUserClass: TFMLister;
    boxSelections: TGroupBox;
    boxLegend: TGroupBox;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    boxChanges: TGroupBox;
    cmdValidate: TBitBtn;
    cmdUndo: TBitBtn;
    boxCommon: TGroupBox;
    cmdClose: TBitBtn;
    cmdHelp: TBitBtn;
    {GTForm1: GTForm - PDR;}
    procedure IncludeBtnClick(Sender: TObject);
    procedure ExcludeBtnClick(Sender: TObject);
    procedure IncAllBtnClick(Sender: TObject);
    procedure ExcAllBtnClick(Sender: TObject);
    procedure MoveSelected(List: TCustomListBox; Items: TStrings);
    procedure SetItem(List: TListBox; Index: Integer);
    function GetFirstSelection(List: TCustomListBox): Integer;
    procedure SetButtons;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cmdValidateClick(Sender: TObject);
    procedure cmdUndoClick(Sender: TObject);
    procedure DstListDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure DstListDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SrcListDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure SrcListDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure tmrTimer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cmdpopSrcDetailsClick(Sender: TObject);
    procedure cmdFindClick(Sender: TObject);
    procedure chkAllClick(Sender: TObject);
    procedure txtSearchChange(Sender: TObject);
    procedure DstListClick(Sender: TObject);
    procedure SrcListClick(Sender: TObject);
    procedure cmdMoreClick(Sender: TObject);
    procedure cmdpopDstDetailsClick(Sender: TObject);
    procedure radDivisionClick(Sender: TObject);
    procedure radTeamClick(Sender: TObject);
    procedure radPractitionerClick(Sender: TObject);
    procedure radRoleClick(Sender: TObject);
    procedure radClinicClick(Sender: TObject);
    procedure radUserClassClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure txtSearchEnter(Sender: TObject);
  private
    { Private declarations }
    FUser    : TScUser;
    FQuery   : TScQryDef;
    FFiles          : TStrings;
    SavedSelections : TList;
    procedure GetData;
    procedure SetSrcItem(srcitem: string; SelectionText: TScStr20);
    procedure AddSelections(List: TCustomListBox);
    procedure DeleteSelections(List: TCustomListBox);
    procedure DeleteSelection(SelectionObject: TObject);
    procedure ShowSelectionDetails(source: TCustomListBox);
    procedure AddSelection(SelectionObject: TObject);
    procedure UpdateSaveCancelBtns(btnStatus: boolean);
    procedure UpdateTypeColor;
    procedure ResetTypeColors;
    procedure ResetTypeStyles;
    procedure ChangeDst(SelectionText: TScStr20);
    procedure ChangeSrc(SelectionText: TScStr20);
    procedure ChangeSrcX(SelectionText: TScStr20);
    procedure ClearListBox(list: TListBox);
    procedure UpdateCursor(Sender: TObject);
    procedure SetStatusBar(text: String ; Mode: Boolean);
    procedure CopySelections(fromList: TList; toList: TList);
  public
    { Public declarations }
    procedure Init;
    property user: TScUser   read FUser   write Fuser;
    property qry : TScQryDef read FQuery  write FQuery;
    property Files      : TStrings read FFiles      write FFiles;
  end;

var
  frmSelections : TfrmSelections;

implementation

uses scut2, pcmm1;

{$R *.DFM}

var
  currentLister    : TFMLister;
  currentFileType  : TScFileType;

procedure TfrmSelections.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  if IncludeBtn.Enabled then
     begin
       Index := GetFirstSelection(SrcList);
       AddSelections(SrcList);
       MoveSelected(SrcList, DstList.Items);
       SetItem(SrcList, Index);
     end;
end;

procedure TfrmSelections.ExcludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  if ExcludeBtn.Enabled then
     begin
       Index := GetFirstSelection(DstList);
       DeleteSelections(DstList);
       MoveSelected(DstList, SrcList.Items);
       SetItem(DstList, Index);
     end;
end;

procedure TfrmSelections.IncAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to SrcList.Items.Count - 1 do
    begin
      DstList.Items.AddObject(SrcList.Items[I],SrcList.Items.Objects[I]);
      AddSelection(SrcList.Items.Objects[I]);
    end;
  SrcList.Items.Clear;
  SetItem(SrcList, 0);
end;

procedure TfrmSelections.ExcAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to DstList.Items.Count - 1 do
    begin
      SrcList.Items.AddObject(DstList.Items[I], DstList.Items.Objects[I]);
      DeleteSelection(DstList.Items.Objects[I]);
    end;
  DstList.Items.Clear;
  SetItem(DstList, 0);
end;


procedure TfrmSelections.MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then
    begin
      Items.AddObject(List.Items[I], List.Items.Objects[I]);
      List.Items.Delete(I);
    end;
end;

procedure TfrmSelections.AddSelections(List: TCustomListBox);
var
  I: Integer;
  obj: TObject;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then
      AddSelection(List.Items.Objects[I]);
end;

{Add Selection object to qry}
procedure TfrmSelections.AddSelection(SelectionObject: TObject);
begin
  if FQuery.Selections.IndexOf(SelectionObject) = -1 then
    begin
      FQuery.Selections.Add(SelectionObject);
      UpdateSaveCancelBtns(True);
      UpdateTypeColor;
    end;
end;

procedure TfrmSelections.DeleteSelections(List: TCustomListBox);
var
  I, autoi: Integer;
  obj: TObject;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then
    begin
      obj := List.Items.Objects[I];
      DeleteSelection(obj);
    end;
end;

{Delete Selection object from qry}
procedure TfrmSelections.DeleteSelection(SelectionObject: TObject);
var
  autoi: integer;
begin
  if SelectionObject <> nil then
    begin
      autoi := FQuery.Selections.IndexOf(SelectionObject);
      if autoi <> -1 then
        begin
          FQuery.Selections.Delete(autoi);
          UpdateSaveCancelBtns(True);
          UpdateTypeColor;
        end;
    end;
end;

{Set type specific panel text color to 'modify' color.}
procedure TfrmSelections.UpdateTypeColor;
begin
  case currentFileType of
   division    : radDivision.Font.Color       := SC_CL_MOD;
   team        : radTeam.Font.Color           := SC_CL_MOD;
   practitioner: radPractitioner.Font.Color   := SC_CL_MOD;
   role        : radRole.Font.Color           := SC_CL_MOD;
   clinic      : radClinic.Font.Color         := SC_CL_MOD;
   userClass   : radUserClass.Font.Color      := SC_CL_MOD;
  end;

end;

{set all type panels to either 'assigned' or 'not assigned' color.}
procedure TfrmSelections.ResetTypeColors;
var
  i    : integer;
  ftype: TScFileType;
  hit  : Boolean;
  cl   : TColor;
  fs   : TFontStyles;
  ltype, scanType : String;
begin
  {GTForm1.FormReset - PDR} ;
  for fType := division to userclass do
    begin
      scanType := FileType[fType];
      hit      := False;
      i        := 0;

      while (not hit) and (i <> FQuery.Selections.Count) do
        begin
          ltype := TScQrySelection(FQuery.Selections[i]).FileType;
          if  ltype =  scantype then
             hit := True;
          inc(i)
        end;

      if hit then
          cl :=  SC_CL_ASSIGNED
      else
          cl :=  SC_CL_NOT_ASSIGNED;

      case fType of
        division    : radDivision.Font.Color     := cl;
        team        : radTeam.Font.Color         := cl;
        practitioner: radPractitioner.Font.Color := cl;
        role        : radRole.Font.Color         := cl;
        clinic      : radClinic.Font.Color       := cl;
        userclass   : radUserClass.Font.Color    := cl;
      end;

    end;
  {GTForm1.DynamicControls - PDR} ;
end;

procedure TfrmSelections.ResetTypeStyles;
var
  i    : integer;
  fType: TScFileType;
  hit  : Boolean;
  cl   : TColor;
  fs   : TFontStyles;
  ltype, scanType : String;
begin
  {GTForm1.FormReset - PDR} ;
  for fType := division to userClass do
    begin
      scanType := FileType[fType];
      i        := FFiles.IndexOf(scanType);

      fs := SC_FS_REGULAR;

      if i <> -1  then
        with TScRptFile(FFiles.Objects[i]) do
          begin
            if SelAllowed = one then
              fs := SC_FS_ONE_ONLY
            else if SelAllowed = oman then
              fs := SC_FS_NONE_OK;
          end;

      case fType of
        division    : radDivision.Font.Style     := fs;
        team        : radTeam.Font.Style         := fs;
        practitioner: radPractitioner.Font.Style := fs;
        role        : radRole.Font.Style         := fs;
        clinic      : radClinic.Font.Style       := fs;
        userClass   : radUserClass.Font.Style    := fs;
      end;

    end;
  {GTForm1.DynamicControls - PDR} ;
end;

procedure TfrmSelections.UpdateSaveCancelBtns(btnStatus: boolean);
begin
   if cmdValidate.Enabled <> btnStatus then
     begin
       cmdValidate.Enabled     := btnStatus;
       cmdUndo.Enabled         := btnStatus;
       cmdpopDstSave.Enabled   := btnStatus;
       cmdpopDstCancel.Enabled := btnStatus;
     end;
end;

procedure TfrmSelections.SetButtons;
var
  i   : integer;
  fle : TScRptFile;
  SrcEmpty, DstEmpty, SrcSelect, DstSelect: Boolean;
begin
  SrcEmpty := SrcList.Items.Count = 0;
  DstEmpty := DstList.Items.Count = 0;

  SrcSelect := SrcList.SelCount > 0;
  DstSelect := DstList.SelCount > 0;

  IncludeBtn.Enabled          := SrcSelect;
  cmdpopSrcInclude.Enabled    := SrcSelect;
  cmdpopSrcDetails.Enabled    := SrcSelect;
  if (SrcList.MultiSelect = false) and (SrcList.ItemIndex <> -1) then
    cmdpopSrcDetails.Enabled := True;

  IncludeBtn.Enabled          := not SrcEmpty;
  cmdpopSrcInclude.Enabled    := not SrcEmpty;
  IncAllBtn.Enabled           := not SrcEmpty;
  cmdpopSrcIncludeAll.Enabled := not SrcEmpty;

  ExcludeBtn.Enabled          := DstSelect;
  cmdpopDstExclude.Enabled    := DstSelect;
  cmdpopDstDetails.Enabled    := DstSelect;
  if (DstList.MultiSelect = false) and (DstList.ItemIndex <> -1) then
    cmdpopDstDetails.Enabled := True;

  ExcludeBtn.Enabled          := not DstEmpty;
  cmdpopDstExclude.Enabled    := not DstEmpty;
  ExAllBtn.Enabled            := not DstEmpty;
  cmdpopDstExcludeAll.Enabled := not DstEmpty;

  i := Files.IndexOf(FileType[currentFileType]);
  if i <> -1 then
    begin
      fle := TScRptFile(Files.Objects[i]);
      if fle.SelAllowed = one then
        begin
          ExAllBtn.Visible            := False;
          cmdpopDstExcludeAll.Enabled := False;
          IncAllBtn.Visible           := False;
          cmdpopSrcIncludeAll.Enabled := False;
          SrcList.MultiSelect         := False;
          DstList.MultiSelect         := False;
        end
      else
        begin
          ExAllBtn.Visible            := True;
          cmdpopDstExcludeAll.Enabled := True;
          IncAllBtn.Visible           := True;
          cmdpopSrcIncludeAll.Enabled := True;
          SrcList.MultiSelect         := True;
          DstList.MultiSelect         := True;
        end;


    end;

  if (DstList.MultiSelect = False) and (not DstEmpty) then
    begin
      IncludeBtn.Enabled       := False;
      cmdpopSrcInclude.Enabled := False;
    end;
end;

function TfrmSelections.GetFirstSelection(List: TCustomListBox): Integer;
begin
  for Result := 0 to List.Items.Count - 1 do
    if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;

procedure TfrmSelections.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do
  begin
    SetFocus;
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    if MultiSelect = True then
      Selected[Index] := True
    else
      ItemIndex := Index;
  end;
  SetButtons;
end;

{Frees Selection objects attached to 'list' and clears 'list'.}
procedure TfrmSelections.ClearListBox(list: TListBox);
var
   i  : integer;
   obj: TObject;
begin
  for i := 0 to list.Items.Count - 1 do
    begin
    obj := list.Items.Objects[i];
    if obj <> nil then
       TScQrySelection(obj).Free;
    end;
  list.Items.Clear;
end;

{Retrieve data from qry object(for DstList) and server(for SrcList).}
procedure TfrmSelections.GetData;
var
   i: integer;
   Selection: TScQrySelection;
   SelectionText: TScStr20;
   x: string;
begin
  DstList.Items.Clear;
  SelectionText    := FileType[currentFileType];
  if SelectionText = 'USER CLASS' then
    SelectionText := 'USERCLASS';

  ChangeDst(SelectionText);
  ChangeSrc(SelectionText);
end;

{Change destination(right) list. Get data from qry object.}
procedure TfrmSelections.ChangeDst(SelectionText: TScStr20);
var
   i: integer;
   Selection: TScQrySelection;
begin
  DstList.Items.Clear;
  for i :=0 to FQuery.Selections.Count - 1 do
    begin
      Selection := TScQrySelection(FQuery.Selections[i]);
      if SelectionText = Selection.FileType then
        dstList.Items.AddObject(Selection.DisplayText,Selection);
    end;
  SetButtons;
end;

{Change source(left) list. Get data from server.}
procedure TfrmSelections.ChangeSrcX(SelectionText: TScStr20);
var
   i: integer;
   Selection: TScQrySelection;
   x: string;
begin
currentLister := TFMLister(FindComponent('FMLister'+ SelectionText));
with currentLister do
  begin
    cmdMore.Enabled := False;
    ClearListBox(srcList);
    Partlist.Clear; {pdr}
    if txtSearch.Text <> '' then
      PartList.insert(0,UpperCase(txtSearch.Text)) {Part := UpperCase(txtSearch.Text) - PDR}
    else
      PartList.insert(0,'');{Part := ''; - PDR}
    SetStatusBar('Retrieving choices...', TimerOff);
    GetList(nil);

    case Results.Count of
     0: x := 'No matches found!';
     1: x := 'One match found.';
    else
        x := 'Matches found.';
    end;

    SetStatusBar(x, TimerOn);

    if FromList.count > 0{From <> ''- PDR} then
       cmdMore.Enabled := More;

    for i := 0 to Results.Count -1 do
      SetSrcItem(GetFMDelimRec(currentlister,i),SelectionText);{Results[i], SelectionText); - PDR}
  end;

  cmdFind.Default  := False;
  cmdClose.Default := True;
  SrcList.SetFocus;
  SetButtons;
end;

{Set source item and object}
procedure TfrmSelections.SetSrcItem(srcitem: string; SelectionText: TScStr20);
var
  Selection: TScQrySelection;
begin
  Selection             := TScQrySelection.Create;
  Selection.DisplayText := piece(srcItem,u,2);
  Selection.ID          := piece(srcItem,u,1);
  Selection.FileType    := piece(SelectionText,u,1);
  if dstList.Items.IndexOf(Selection.DisplayText) = -1 then
       Srclist.Items.AddObject(Selection.DisplayText,Selection);
end;

procedure TfrmSelections.cmdValidateClick(Sender: TObject);
var
  scok: boolean;
  frm: TfrmErrorRpt;
begin
  RPCBrokerMain.ClearParameters := True;
  scok := FQuery.ValidateQuery(RPCBrokerMain, vmSelections);
  if scok then
    begin
      {GTForm1.FormReset - PDR} ;
      UpdateSaveCancelbtns(False);
      CopySelections(FQuery.Selections, SavedSelections);
      SetStatusBar('Validation successful!', TimerOn);
      ResetTypeColors;
      Fquery.Modified := True;
      {GTForm1.DynamicControls - PDR;}
    end;
 end;

procedure TfrmSelections.cmdUndoClick(Sender: TObject);
begin
  UpdateSaveCancelbtns(False);
  CopySelections(SavedSelections, FQuery.Selections);
  ResetTypeColors;
  getData;
  SetStatusBar('Reset Complete!', TimerOn);
end;

procedure TfrmSelections.DstListDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
if (source is TListBox) and
   (TListBox(Source).Name = 'SrcList') then
       Accept := True;
end;

procedure TfrmSelections.DstListDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
if (source is TListBox) and
   (TListBox(Source).Name = 'SrcList') then
      IncludeBtnClick(Sender);
end;

procedure TfrmSelections.SrcListDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
if (source is TListBox) and
   (TListBox(Source).Name = 'DstList') then
       Accept := True;
end;

procedure TfrmSelections.SrcListDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
if (source is TListBox) and
   (TListBox(Source).Name = 'DstList') then
      ExcludeBtnClick(Sender);
end;

procedure TfrmSelections.tmrTimer(Sender: TObject);
begin
  pnlStatus.Caption := '';
  tmr.Enabled := False;
end;

procedure TfrmSelections.cmdFindClick(Sender: TObject);
begin
  changeSrc(FileType[currentFileType]);
end;

procedure TfrmSelections.chkAllClick(Sender: TObject);
begin
  if chkAll.Checked then
     begin
       txtSearch.Text        := '';
       txtSearch.Visible     := False;
       cmdFind.Visible       := False;
       lblSearch.Visible     := False;
       changeSrc(FileType[currentFileType]);
       cmdClose.Default      := True;
     end
  else
     begin
      txtSearch.Visible      := True;
      cmdFind.Visible        := True;
      lblSearch.Visible      := True;
      txtSearch.SetFocus;
     end;
end;

procedure TfrmSelections.txtSearchChange(Sender: TObject);
begin
  if Length(txtSearch.Text) > 0 then
    begin
      cmdFind.Default := True;
      cmdFind.Enabled := True;
    end
  else
    begin
      cmdFind.Default := False;
      cmdFind.Enabled := False;
    end;
end;

procedure TfrmSelections.SrcListClick(Sender: TObject);
begin
  UpdateCursor(Sender);
  SetButtons;
end;

procedure TfrmSelections.DstListClick(Sender: TObject);
begin
  UpdateCursor(Sender);
  SetButtons;
end;

procedure TfrmSelections.UpdateCursor(Sender: TObject);
begin
  if Sender is TListBox then
    with TListBox(Sender) do
      if SelCount > 1 then
        DragCursor := crMultiDrag
      else
        DragCursor := crDrag;
end;

procedure TfrmSelections.cmdMoreClick(Sender: TObject);
var
  i, start, last: integer;
  SelectionText: TScStr20;
begin
  cmdMore.Enabled := False;
  with currentLister do
    begin
      if More then
        begin
          start := Results.Count;
          GetMore(nil);
          cmdMore.Enabled := More;
          last  := Results.Count  - 1;
          SelectionText := FileType[currentFileType];
          for i := start to last do
            SetSrcItem(GetFMDelimRec(currentlister,i),SelectionText);{Results[i], SelectionText); - PDR}
        end;
    end;
end;

procedure TfrmSelections.cmdpopDstDetailsClick(Sender: TObject);
begin
ShowSelectionDetails(DstList);
end;

procedure TfrmSelections.cmdpopSrcDetailsClick(Sender: TObject);
begin
ShowSelectionDetails(SrcList);
end;

{Updates status bar text and turns on/off timer.
 Turning on timer will cause text to be cleared
 automatically.}
procedure TfrmSelections.SetStatusBar(text: String ; Mode: Boolean);
begin
  tmr.Enabled       := TimerOff;
  pnlStatus.Caption := ' ' + text;
  tmr.Enabled       := mode;
  Application.ProcessMessages;
end;

procedure TfrmSelections.radDivisionClick(Sender: TObject);
begin
  currentFileType := division;
  getData;
end;

procedure TfrmSelections.radTeamClick(Sender: TObject);
begin
  currentFileType := team;
  getData;
end;

procedure TfrmSelections.radPractitionerClick(Sender: TObject);
begin
  currentFileType := practitioner;
  getData;
end;

procedure TfrmSelections.radRoleClick(Sender: TObject);
begin
  currentFileType := role;
  getData;
end;

procedure TfrmSelections.radClinicClick(Sender: TObject);
begin
  currentFileType := clinic;
  getData;
end;

procedure TfrmSelections.radUserClassClick(Sender: TObject);
begin
  currentFileType := userclass;
  getdata;
end;

procedure TfrmSelections.FormCreate(Sender: TObject);
begin
  Font.Assign(FrmMain.FontDialog1.Font);
  SavedSelections := TList.Create;
end;

procedure TfrmSelections.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ClearListBox(srcList);
  Action := caFree;
end;

procedure TfrmSelections.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
 ret: Word;
begin
cmdClose.SetFocus;
ret := mrOK;
{Has Selection data been modified? If so, ask user OK.}
if (radDivision.Font.Color     = SC_CL_MOD) or
   (radTeam.Font.Color         = SC_CL_MOD) or
   (radPractitioner.Font.Color = SC_CL_MOD) or
   (radRole.Font.Color         = SC_CL_MOD) or
   (radClinic.Font.Color       = SC_CL_MOD) or
   (radUserClass.Font.Color    = SC_CL_MOD) then
     begin
       ret := MessageDlg('Changes must be validated to become part of the template.' + #13#10#13#10 +
                         'Do you wish to validate changes you have made to Selections?',
                         mtConfirmation,mbYesNoCancel , 0);
       if ret = mrYes then
         cmdValidateClick(Sender)
       else if ret = mrNo then
         cmdUndoClick(Sender);
     end;
if ret = mrCancel then
  CanClose := False;

end;

procedure TfrmSelections.FormShow(Sender: TObject);
begin
  Init;
end;

procedure TfrmSelections.FormResize(Sender: TObject);
begin
  Clientwidth := 483;
end;

{Retrieve and load qry data for qryIDPassed property or
 if blank, ask user to select qry.}
procedure TfrmSelections.Init;
begin
  Caption := 'Selection Specification (Query: ' + qry.Name + ')';
  CopySelections(FQuery.Selections, SavedSelections);

  if qry.Report = 'Practitioner Demographics' then
    begin
      chkAll.Checked := False;
      txtSearch.Text := 'A';
    end
  else
    begin
      chkAll.Checked := True;
      txtSearch.Text := '';
    end;


  ResetTypeColors;
  ResetTypeStyles;

  radDivision.Enabled     := (Files.IndexOf('DIVISION')     <> -1);
  radTeam.Enabled         := (Files.IndexOf('TEAM')         <> -1);
  radPractitioner.Enabled := (Files.IndexOf('PRACTITIONER') <> -1);
  radRole.Enabled         := (Files.IndexOf('ROLE')         <> -1);
  radClinic.Enabled       := (Files.IndexOf('CLINIC')       <> -1);
  radUserClass.Enabled    := (Files.IndexOf('USERCLASS')    <> -1);

  if      radDivision.Enabled     then
     radDivision.Checked     := True
  else if radTeam.Enabled         then
     radTeam.Checked         := True
  else if radPractitioner.Enabled then
     radPractitioner.Checked := True
  else if radRole.Enabled         then
     radRole.Checked         := True
  else if radClinic.Enabled       then
     radClinic.Checked       := True
  else if radUserClass.Enabled    then
     radUserClass.Checked    := True;

  if chkall.Checked then
    SrcList.SetFocus
  else
    txtSearch.SetFocus;
end;

procedure TFrmSelections.CopySelections(fromList: TList; toList: TList);
var
  i: integer;
  sel: TScQrySelection;
begin
  {free 'to' selection objects}
  for i := 0 to toList.Count - 1 do
    TScQrySelection(toList[i]).Free;

  toList.Clear;

  {make copies of 'from' selection objects}
  for i := 0 to fromList.Count - 1 do
    begin
      sel := TScQrySelection.Create;
      sel.CopyFrom(TScQrySelection(fromList[i]));
      toList.Add(sel);
    end;
end;

{Display to user Selection entity information.}
procedure TfrmSelections.ShowSelectionDetails(source: TCustomListBox);
var
 lst: TStringList;
 obj: TScQrySelection;
 frm: TfrmSelectionDetail;
begin
 if source.ItemIndex <> -1 then
   begin
     obj := TScQrySelection(source.Items.Objects[source.ItemIndex]);
     lst := TStringList.Create;
     try
       if obj.GetSelection(RPCBrokerMain, lst) then
         begin
           Application.CreateForm(TfrmSelectionDetail, frmSelectionDetail);
           with frmSelectionDetail do
             begin
               lblNameText.Caption := obj.DisplayText;
               lblIDText.Caption   := obj.ID;
               lblTypeText.Caption := obj.FileType;
               memInfo.Lines.Assign(lst);
               ShowModal;
               Free;
             end;
         end;
     finally
       lst.Free;
     end;
   end;
end;

procedure TfrmSelections.ChangeSrc(SelectionText: TScStr20);
var
   i, cnt: integer;
   sel: TScQrySelection;
   x: string;
begin
with RPCBrokerMain do
  begin
    ClearListBox(srcList);
    RemoteProcedure := 'SCRP SELECTION SOURCE';
    Param[0].PType := literal;
    Param[0].Value := SelectionText;
    Param[1].PType := literal;
    Param[1].Value := qry.ReportID;
    Param[2].PType := literal;
    Param[2].Value := qry.Report;
    Param[3].PType := literal;
    Param[3].Value := UpperCase(txtSearch.Text);

    cnt :=0;
    if FQuery.Selections.Count > 0 then
      begin
        Param[4].PType := list;
        for i := 0 to FQuery.Selections.Count - 1 do
           begin
             sel := TScQrySelection(FQuery.Selections[i]);
             inc(cnt);
             Param[4].Mult[IntToStr(cnt)] := sel.DisplayText + u +
                                             sel.FileType    + u +
                                             sel.ID;
           end;
      end;

    Call;
    for i := 0 to Results.Count -1 do
      begin
        x               := Results[i];
        sel             := TScQrySelection.Create;
        sel.DisplayText := piece(x,u,1);
        sel.ID          := piece(x,u,3);
        sel.FileType    := piece(x,u,2);
        if dstList.Items.IndexOf(sel.DisplayText) = -1 then
          Srclist.Items.AddObject(sel.DisplayText,sel);
      end;
  end;
  SetButtons;
  if (chkAll.Checked) or (SrcList.Items.Count > 0) then
    SrcList.SetFocus
  else
    txtSearch.SetFocus;
end;

procedure TfrmSelections.txtSearchEnter(Sender: TObject);
begin
  cmdFind.Enabled := (Length(txtSearch.Text) > 0);
end;

end.
