{*******************************************************************}
{                                                                   }
{ Patient Lookup utiltiy for Primary Care Management                }
{ This form is intended as a temporary measure until a              }
{ patient lookup component or server call is provided by            }
{ the Fileman Team                                                  }
{                                                                   }
{ Scheduling ver 5.3 AUG 13, 1993                                   }
{ Management Information Products Group                             }
{ Albany NY (SCK)                                                   }
{ Dept. of Veteran Affairs                                          }
{ Feb 1996   (SCK)                                                  }
{                                                                   }
{    Last updated: 28 May 2002 (J. Peterson)                        }
{                                                                   }
{*******************************************************************}

unit Scpatlkp;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Fmcmpnts, Trpcb, OvcBase, OvcVlb, messages, Dialogs,
  SysUtils, Scut3, Scut2, Scutdef, Mfunstr, Scutbrk, Diaccess;

type
  TfrmPatLookup = class(TForm)
    cmdOk: TBitBtn;
    cmdCancel: TBitBtn;
    HelpBtn: TBitBtn;
    lstPatients: TOvcVirtualListBox;
    OvcController1: TOvcController;
    ltrPatient: TFMLister;
    txtPatLookUp: TEdit;
    Label1: TLabel;
    bbLkUp: TBitBtn;
    procedure cmdOkClick(Sender: TObject);
    procedure txtPatLookUpKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure txtPatLookUpEnter(Sender: TObject);
    procedure lstPatientsDblClick(Sender: TObject);
    procedure lstPatientsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmdCancelClick(Sender: TObject);
    procedure txtPatLookUpKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure RPCBroker1NetError(Sender: TObject; var Error: EBrokerError);
    procedure lstPatientsGetItem(Sender: TObject; Index: Longint;
      var ItemString: string);
    procedure bbLkUpClick(Sender: TObject);
    Procedure FillText(SecMessage:Tstringlist;Var Text:String);

  private
    { Private declarations }
    DataList : TStringList;
    NetError : Boolean;

  public
    { Public declarations }
    LookUpDfn: string[25];
    LookUpPat: string[30];
    procedure Pad(var s: string);
    procedure BuildTeamList(tmlist: TStrings);
    procedure DisplayMeansTest(DFN,Pat:String);
    function DuplicateFoundStop(DFN,Pat:String):Boolean;
    function SecurityIssueStop(DFN:String):boolean;
  end;

var
  frmPatLookup: TfrmPatLookup;

implementation

uses scptpf, Pcmm1;

{$R *.DFM}

procedure TfrmPatLookup.FormCreate(Sender: TObject);
var
  TabArray: array[0..2] of Integer;
begin
  TabArray[0] := 120;
  TabArray[1] := 180;
  lstPatients.SetTabStops(TabArray);
  DataList := TStringList.Create;
  DataList.Sorted := true;
  DataList.Duplicates := DupIgnore;
  lstPatients.NumItems := 0;
  txtPatLookup.Text := '';
  NetError := false;
end;

{

}
procedure TfrmPatLookup.FormDestroy(Sender: TObject);
begin
  {ClearData}
  DataList.Free;
end;

{

}
procedure TfrmPatLookup.cmdOkClick(Sender: TObject);
var
  i: integer;
begin
  i := lstPatients.ItemIndex;
  if i < 0 then
     modalResult := mrCancel
  else begin
     LookUpDfn := (Piece(datalist[i], TAB, 6));
     LookUpPat := (Piece(datalist[i], TAB, 1));
     ModalResult := mrOk;
     If DuplicateFoundStop(LookUpDfn,LookUpPat) then
      Begin
       modalResult := mrcancel;
       exit;
      end;
      DisplayMeansTest(LookUpDFN,LookUpPat);
      If SecurityIssueStop(LookUpDFN) then
       Begin
        ModalResult:=MRCancel;
        Exit;
       End;
  end;
end;

{

}
procedure TfrmPatLookup.BuildTeamList(tmlist: TStrings);
var
  i: integer;
  pn: string;
begin
  for i := 0 to tmlist.count - 1 do begin
     pn := Piece(tmlist[i], U, 2);
     Pad(pn);
     DataList.Add(Copy(pn, 1, 23) + TAB + Piece(tmlist[i], U, 3) + TAB +
                  Piece(tmlist[i], U, 4) + TAB + TAB + TAB +
                  Piece(tmlist[i], U, 1));
     end;

  lstPatients.numItems := DataList.Count;
  lstPatients.Repaint;
  lstPatients.Setfocus;
end;

{

}
procedure TfrmPatLookup.Pad(var s: string);
var
  i: integer;
begin
  for i := Length(s) to 25 do
     s := s + ' ';
end;


procedure TfrmPatLookup.txtPatLookUpKeyPress(Sender: TObject;
  var Key: Char);
begin
  key := UpCase(key);
end;


procedure TfrmPatLookup.txtPatLookUpEnter(Sender: TObject);
begin
  cmdOk.enabled := false;
  {if DataList.Count > 0 then DataList.Clear;
  lstPatients.NumItems := 0;
  lstPatients.Refresh;}
  {txtPatLookup.Text := '';}
end;

procedure TfrmPatLookup.lstPatientsDblClick(Sender: TObject);
begin
  cmdOkClick(nil);
end;

procedure TfrmPatLookup.lstPatientsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_SPACE) then cmdOkClick(nil);
end;

procedure TfrmPatLookup.cmdCancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  {close;}
end;

procedure TfrmPatLookup.txtPatLookUpKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin  if key = VK_RETURN then bbLkUpClick(sender); {(nil) -PDR};
end;

procedure TfrmPatLookup.FormShow(Sender: TObject);
begin
  lstPatients.NumItems := 0;
  txtPatLookup.Text := '';
  txtPatLookUp.SetFocus;
end;

procedure TfrmPatLookup.RPCBroker1NetError(Sender: TObject;
  var Error: EBrokerError);
var
  msg: string;
begin
  msg := 'A Network error has been encountered.  Please make' + RETURN +
         'a note of your current entry.  You will need to' + RETURN +
         'logon to DHCP before continuing';
  messageDlg(msg, mtError, [mbOk], 0);
  NetError := true;
  Halt;
end;

procedure TfrmPatLookup.lstPatientsGetItem(Sender: TObject; Index: Longint;
  var ItemString: string);
begin
  If (index >= 0) and (Index < DataList.Count) then
     ItemString := DataList.Strings[Index];
end;

procedure TfrmPatLookup.bbLkUpClick(Sender: TObject);
var
  {i,ssn, spcl: integer;   removed to stop hint jlu 1/16}
  {s, s1, Index: string[10];    removed to stop hint jlu 1/16}
  pat: TStrings;
begin
  cmdOk.Enabled := true;
  if DataList.Count > 0 then begin
     DataList.Clear;
     lstPatients.NumItems := 0;
     lstPatients.Refresh;
  end;

  pat := TStringList.Create;

  try
     if (ActiveControl = cmdCancel) then exit;

     Screen.Cursor := crHourglass;

     if txtPatLookUp.text = '' then begin
        txtPatLookUp.setfocus;
        exit;
        end;

     if Length(txtPatLookup.Text) < 3 then begin
        Application.NormalizeTopMosts ;
        Screen.Cursor := crDefault;
        messagedlg('Must enter at least 3 characters.', mtInformation, [mbOk], 0);
        Application.RestoreTopMosts   ;
        txtPatLookUp.setfocus;
        {exit;}
        end
     else
        begin
           PatientLookup(RPCBrokerMain, '.01;.03;.363', txtPatLookup.Text, pat);
           if pat.count > 0 then
              BuildTeamList(pat)
           else begin
              {Application.NormalizeTopMosts ;
              Screen.Cursor := crDefault;     }
              messagedlg('No matching entries were found', mtInformation, [mbOk], 0);
             { Application.RestoreTopMosts   ;      }
              txtPatLookUp.setfocus;
           end;
        end;

  finally
     pat.free;
     Screen.Cursor := crDefault;
  end;
end;

Function Tfrmpatlookup.DuplicateFoundStop(DFN,PAT:String):Boolean;
{This procedure is designed to call a broker procedure to check for the existance
of a duplicate SSN and patient name.  If there is one, display this to the user.}

VAR
   Text:String;
   SSNMessage:tstringlist;

BEGIN
     SSNMessage:=Tstringlist.create;
     Result:=false;
     Try
     If GetBS5(RPCBrokerMain,DFN,SSNMessage) then {duplicate found}
     Begin
          Text:='Caution!!  '+SSNMessage[1]+CRLF+SSNMessage[2]+CRLF+SSNMessage[3];
          If application.MessageBox(PChar(text),'Similiar patient record',MB_yesno or MB_iconwarning
          or MB_DefButton1) = IDNO Then
             Result:=true {Dusplicate and Stop}
          Else
              Result:=False; {Continue}
     End;
     Finally
     SSNMessage.free;
     End;
END;

Procedure Tfrmpatlookup.DisplayMeansTest(DFN,PAT:String);
{This procedure will call a RPC to determine if a means test is required for a
Patient.  If it is, this information will be displayed to the user in a message
dialog box}

Var
   Text : String;
   Mtmessage : tstringlist;

Begin
     MtMessage := Tstringlist.Create;
     If CurrentMeansTest(RPCBrokerMain,DFN,MtMessage) then
        Begin
        Text := CRLF + Mtmessage[1] + ' for ' + Pat + CRLF + MtMessage[2];
        Application.messagebox(PChar(Text),'Means Test',Mb_iconwarning +MB_OK +
        MB_Applmodal);
        End;
      MtMessage.free;
End;

Function Tfrmpatlookup.SecurityIssueStop(DFN:String):Boolean;
{THis function call will check to see if the is a security issue with this patient.
Is this a sensitive record or not}

Var
 SecurityMessage : Tstringlist;
 MsgText,
 CaptText : string;
 return : integer;

Begin {1}
 SecurityMessage := tstringlist.create;
 Result := FALSE;
 Try
  If SecurityIssue(RPCBrokerMain,DFN,SecurityMessage) then
   Begin  {4}
   return := Strtoint(SecurityMessage[0]);
   FillText(SecurityMessage,MsgText);
   CaptText := 'Security Warning.';
   Case return of
    1: Begin {2}
        {Result:=false;}
        Application.messagebox(Pchar(MsgText),Pchar(CaptText),MB_ok+
        MB_ApplModal+MB_Iconwarning);
       End; {2}

    2: begin
        Msgtext:=MsgText+CRLF+' Do you want to continue processing this patient record?';
        If application.messagebox(Pchar(MsgText),Pchar(CaptText),MB_yesno+
       MB_Iconwarning+MB_ApplModal)=IDno Then Result:=True
        else
         firemessage(RPCBrokerMain,DFN);
       End;

    3,4: Begin {3}
          Result:=true;
          Application.messagebox(Pchar(MsgText),Pchar(CaptText),MB_ok+
          MB_ApplModal+MB_Iconwarning);
         End; {3}
     End; {end to case}
    End; {4}

 Finally
  SecurityMessage.free;
 End; {end to try finally}
End; {1}

Procedure TFrmpatlookup.FillText(SecMessage:Tstringlist; Var Text:String);
{This procedure extras the TEXT property from the Tstringlist an puts
It in the TEXT return variable.  The [0] node of the Tstring List is
deleted because it is not needed for display.  The [0] node contains
case information.  That is already used.}
Begin
 SecMessage.delete(0);
 Text:=SecMessage.Text;
End;

end.
