{*******************************************************************}
{                                                                   }
{  Patient/Team Assignment for Primary Care Management              }
{  Team assignment/discharge dates are entered here, and assignment,}
{  edit, and discharge from positions.                              }
{                                                                   }
{  Scheduling ver 5.3 AUG 13, 1993                                  }
{  Management Information Products Group                            }
{  Albany NY (sck)                                                  }
{  Dept. of Veteran Affairs                                         }
{  Feb 1996                                                         }
{                                                                   }
{  Last updated: 28 May 2002 (J. Peterson)                          }
{                                                                   }
{*******************************************************************}

unit Scpttmf;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons,ExtCtrls, Fmcmpnts, OvcBase, OvcVlb,
  Fmcntrls, Trpcb, OvcNbk, OvcEF, OvcPB, OvcPF, Mfunstr, Scut3, Scut2,
  Scutdef, Menus, Pcmm1, OvcDt, OvcSc, OvcCal, OvcData, Scutbrk,
  Fmlookup, Grids, OvcTCmmn, OvcTable, IniFiles, DateTime, 
  Scptpf, OvcDate{, Gtsize32, GTVASzr - PDR}, Diaccess;

const DEBUG=false;

type
  TAssociatedClinic = Record
     Name : string[30];
     Ien  : string[20];
  end;

  TfrmTeamAssign = class(TForm)
    cmdClose: TBitBtn;
    cmdHelp: TBitBtn;
    OvcController1: TOvcController;
    getTeamInfo: TFMGets;
    flrTeam: TFMFiler;
    ltrPositions: TFMLister;
    hdrForm: THeader;
    tabInfo: TOvcNotebook;
    Label5: TLabel;
    lblPrimaryCare: TFMLabel;
    LBLHDTMRESTRICT: TLabel;
    lblConsults: TFMLabel;
    GroupBox1: TGroupBox;
    Label10: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lblCLosed: TFMLabel;
    lblAssigned: TFMLabel;
    lblMaximum: TFMLabel;
    getTeamAsgn: TFMGets;
    ltr1: TFMLister;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Edit1: TMenuItem;
    Exit1: TMenuItem;
    pnlCalendar: TPanel;
    Calendar: TOvcCalendar;
    PositionsLookup: TFMLookUp;
    flrPosAsgn: TFMFiler;
    lstPositions: TOvcVirtualListBox;
    cmdPAssign: TBitBtn;
    cmdPSave: TBitBtn;
    cmdPCancel: TBitBtn;
    FMPosition: TFMLabel;
    FMAsgn: TFMLabel;
    FMUnAsgn: TFMLabel;
    FMRole: TFMLabel;
    getPosInfo: TFMGets;
    pnlAdd: TPanel;
    lblAdd: TLabel;
    lblAsgnDt: TFMLabel;
    lblDisDt: TFMLabel;
    Bevel1: TBevel;
    cmdSave: TBitBtn;
    cmdCancel: TBitBtn;
    chkPrimaryCare: TFMCheckBox;
    chkRestrict: TFMCheckBox;
    Bevel2: TBevel;
    Bevel3: TBevel;
    grpDates: TGroupBox;
    Label1: TLabel;
    txtAssignDt: TOvcPictureField;
    FMLabel1: TFMLabel;
    txtDischargeDt: TOvcPictureField;
    GroupBox3: TGroupBox;
    LBLHEADTEAM: TLabel;
    lblTeamName: TFMLabel;
    LBLHDPURPOSE: TLabel;
    lblTeamPurpose: TFMLabel;
    LBLHDINST: TLabel;
    lblInstitution: TFMLabel;
    LBLHDSERVICE: TLabel;
    lblService: TFMLabel;
    PopUpPos: TPopupMenu;
    NewPosition1: TMenuItem;
    SavePosition1: TMenuItem;
    CancelPosition1: TMenuItem;
    PopUpTeam: TPopupMenu;
    SaveTeam1: TMenuItem;
    Cancelteam1: TMenuItem;
    lblPUsrEntr: TFMLabel;
    lblPDtEntr: TFMLabel;
    lblPDtEdt: TFMLabel;
    lblPUsrEdt: TFMLabel;
    lblTUsrEntr: TFMLabel;
    lblTDtEntr: TFMLabel;
    lblTUsrEdt: TFMLabel;
    lblTDtEdt: TFMLabel;
    Position1: TMenuItem;
    TeamAssignment1: TMenuItem;
    NewPositionAssignment1: TMenuItem;
    SavePositionAssignment1: TMenuItem;
    CancelPositionAssignment1: TMenuItem;
    SaveTeamAssignment1: TMenuItem;
    CancelTeamAssignment1: TMenuItem;
    RemovePositionAssignment1: TMenuItem;
    N1: TMenuItem;
    Delete1: TMenuItem;
    N2: TMenuItem;
    spinAssign: TOvcSpinner;
    spinDischarge: TOvcSpinner;
    Label2: TLabel;
    getPosClinic: TFMGets;
    getPosAsgnInfo: TFMGets;
    EditPosition1: TMenuItem;
    N3: TMenuItem;
    EditAssignment1: TMenuItem;
    N4: TMenuItem;
    FMFindOneCheckClinicEnrollment: TFMFindOne;
    {GTVAForm1: GTVAForm; - PDR}
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure txtExit(Sender: TObject);
    procedure txtChange(Sender: TObject);
    procedure cmdCancelClick(Sender: TObject);
    Procedure CheckBoxClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tabInfoPageChange(Sender: TObject; Index: Integer;
      var AllowChange: Boolean);
    procedure lstPositionsGetItem(Sender: TObject; Index: Longint;
      var ItemString: String);
    procedure cmdSaveCLick(Sender: TObject);
    procedure txtDischargeDtExit(Sender: TObject);
    procedure txtAssignDtExit(Sender: TObject);
    procedure PopUpCalendar(Sender: TObject);
    procedure CalendarClick(Sender: TObject);
    procedure CalendarKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
    procedure NewPosClick(Sender: TObject);
    procedure cmdPosAsgnCancelClick(Sender: TObject);
    procedure lstPositionsDblClick(Sender: TObject);
    procedure cmdPCancelClick(Sender: TObject);
    procedure cmdPSaveClick(Sender: TObject);
    Procedure AltPopUpCalendar(Sender: TObject);
    procedure cmdHelpClick(Sender: TObject);
    procedure DelPosAsgnClick(Sender: TObject);
    procedure UpdateMenus(Sender: TObject);
    procedure grpPositionExit(Sender: TObject);
    procedure tabInfoPageChanged(Sender: TObject; Index: Integer);
    procedure NewTmAsgnClick(Sender: TObject);
    procedure RPCBroker1NetError(Sender: TObject; var Error: EBrokerError);
    procedure chkPrimaryCareClick(Sender: TObject);
    procedure cmdCloseClick(Sender: TObject);
    procedure RemovePositionAssignment1Click(Sender: TObject);
    procedure SavePositionAssignment1Click(Sender: TObject);
    procedure CancelPositionAssignment1Click(Sender: TObject);
    procedure NewPositionAssignment1Click(Sender: TObject);
    procedure SaveTeamAssignment1Click(Sender: TObject);
    procedure CancelTeamAssignment1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure chkPrimaryCareEnter(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lstPositionsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure txtDischargeDtKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure txtAssignDtKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure spinDischargeClick(Sender: TObject; State: TOvcSpinState;
      Delta: Double; Wrap: Boolean);
  private
    { Private declarations }
      entries, asgnpositions, plist: TStringList;
      ActivePositionList:TstringList; {jlu}
      pf: TOvcPictureField;
      DeleteKey, NetError : boolean;
      PCInf : string;
      Clinic : TAssociatedClinic;
      NewDischarge:Boolean; {PDR}
      {Futures:Boolean;} {PDR}
      {PDR 5/27/98}
      flrTeamFMMode:FMModes;
      flrPosAsgnFMMode:FMModes;
      procedure CheckPositionType(ien : TScStr20; Asgndate : string; var pc : boolean; var at : boolean);
      procedure SendAssignmentMsg(MsgType : TScStr20; Ien : TScStr20);
      Procedure Formatlist(Alist:Tstringlist; var Dlist:Tstringlist); {jlu}
      Procedure Posinfopcsetup(modepar:fmmodes); {jlu 6/1/99}
      Procedure Posinfohandler(modepar:fmmodes; oldinternal : integer; var changed:boolean); {jlu 6/1/99}
      Function CheckForPostoDischarge:boolean; {jlu}
      Procedure SetChkBOxes; {pdr}
      function DischargePositionsOK:boolean; {pdr}
      function ActivePositions:boolean; {pdr}
      {function FutureTeamDischarge:boolean;}
  public
    { Public declarations }
     HasPCTeam: string; {PDR - SETUP in Scptpf.pas from team list,=PCteam IEN or 0}
     TmProfile: TTeamAsgn;
     FrmParent : TPatientAsgn;
     procedure LoadTeamInfo;
     procedure GetPositionsAsgn;
     procedure SetNewEntry;
     procedure pad(var s: string; ln: integer);
     procedure LoadSettings;
     procedure GetPCInfo;
     function CheckDateOk: boolean;
     function AssignDateChangeOk: boolean;
     function DischrgDateChangeOk: boolean;
     function PCPositionOk(ien: string): boolean;
     function AtdPositionOk(ien: string): boolean;
     function MakePCTeamOk: Boolean;
     procedure LoadTeam;
     function CheckClinicEnrollment(ien,clinic: string): boolean;
  end;

  TTeamPosition = Record
     Name :      string[32];
     currPos :   string[20];
     currIen: string[20];
     NewPos :    string[20];
     NewIen : string[20];
     changed: boolean;
     end;


var
  frmTeamAssign: TfrmTeamAssign;

implementation

uses Posinfo, dischargememo;

{$R *.DFM}

{ 2/6/96 added

}

procedure TfrmTeamAssign.SetChkBoxes;   {PDR}
 {make sure boxes are checked or unchecked appropriately, and if editable
  that an unchecked box gets saved as 0 in database}
begin
 if (chkPrimaryCare.FMDBInternal <> '1') then
  begin
   chkPrimaryCare.checked:=false;
   if not chkPrimaryCare.enabled then
    begin
     chkPrimaryCare.enabled:=true;
     chkPrimaryCare.checked:=false;
     chkPrimaryCare.enabled:=false;
    end
   else
    chkPrimaryCare.checked:=false;
   {If lblPrimaryCare.caption='YES' then
    flrTeam.AddChgdControl(chkPrimaryCare); }
  end;
{ if chkPrimaryCare.FMDBInternal='1' then
  begin
   chkRestrict.checked:=true;
   {if lblConsults.caption='YES' then
    flrTeam.AddChgdControl(chkRestrict);}
  {end;The above if and begin/end were commented out by JLU and replace with the following code}

		chkrestrict.enabled:=true;
		If chkrestrict.fmdbinternal='1' then chkrestrict.checked:=true
		else chkrestrict.checked:=false;
		flrteam.addchgdcontrol(chkrestrict);

end;

procedure TfrmTeamAssign.FormCreate(Sender: TObject);
var
  TabArray: array[0..2] of Integer;
begin
  TabArray[0] := 200;
  TabArray[1] := 400;
  asgnpositions := TStringList.Create;
  plist := TStringList.Create;
  lstPositions.NumItems := 0;
  tabInfo.PageIndex := 0;
  Top := 5;
  { bp/cmf 177 remove//
  lstPositions.Header :=
   ' AT  PC    Position                  ' +
   'Standard Role             '+
   'Team Member               '+
   'Preceptor';}
end;

{
  Load default user settings from user file and/or INI file.
}
procedure TfrmTeamAssign.LoadSettings;
begin
  {Font.Assign(PatientAsgn.Font);}
  {GetPCInfo; - unnecessary and illegitimate, replaced by var HasPCTeam}
  DeleteKey := SecurityKeyOk(RPCBrokerMain, DELETE_KEY);
     {nothing yet}
end;

{ 2/6/96 added

}
procedure TfrmTeamAssign.FormResize(Sender: TObject);
begin
  ClientWidth := 625;
end;

procedure TfrmTeamAssign.LoadTeam;
begin
  LoadSettings;
  lstPositions.NumItems := 0;

  hdrForm.Sections[3] := TmProfile.Patient;
  hdrForm.Sections[1] := TmProfile.TeamName;

  getTeamInfo.IENS := TmProfile.TeamIen;
  getTeamInfo.GetAndFill;
  if lblCLosed.caption = '' then lblClosed.Caption := 'NO';
  if lblPrimaryCare.Caption = '' then lblPrimaryCare.Caption := 'NO';
  if lblConsults.Caption = '' then lblConsults.Caption := 'NO';


  if lblPrimaryCare.Caption = 'NO' then
   begin
    chkPrimaryCare.FMCtrlInternal := '99'; {PDR}
    chkPrimaryCare.enabled:=true; {pdr}
    chkPrimaryCare.Checked :=false; {PDR}
    chkPrimaryCare.Enabled := false;
   end
  else
   begin
    {if (Piece(PCInf, U, 2) = '0') or (Piece(PCInf, U, 2) = tmProfile.TeamIen) then
        chkPrimaryCare.Enabled := true
        see replacement test below using HasPCTeam }
    if (HasPCTeam = '0') or (HasPCTeam = tmProfile.TeamIen) then
     chkPrimaryCare.Enabled := true
     else
      begin
       chkPrimaryCare.enabled:=true; {pdr}
       chkPrimaryCare.FMCtrlInternal := '99';
       chkPrimaryCare.checked := false;  {pdr}
       chkPrimaryCare.Enabled := false; {pdr}
      end;
   end;

  {chkRestrict.enabled := not (lblConsults.Caption = 'YES'); This is commented out by jlu}


  if tmProfile.Mode = AddItem then
   begin
     tabInfo.Pages[1].Enabled := false;
     SetNewEntry;
   end
  else
   begin
     LoadTeamInfo;
     GetPositionsAsgn;
     cmdCancel.enabled := false;
     cmdSave.enabled := false;
     {lstPositions.ItemIndex := -1;}
  end;
  flrPosAsgn.clear;
end;

{ 2/6/96 added

}
procedure TfrmTeamAssign.FormDestroy(Sender: TObject);
begin
 if plist <> nil then
  begin
   plist.clear;
   plist.free;
  end;
 if asgnpositions<>nil then
  begin
   asgnpositions.clear;
   asgnpositions.free;
  end;
end;

procedure TfrmTeamAssign.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if not (TmProfile.Parent = nil) then
     (TmProfile.Parent as TPatientAsgn).enabled := true;

  Action := caFree;
end;


procedure TfrmTeamAssign.SetNewEntry;
begin
  getTeamAsgn.SetUpNewEntry(NEW_ENTRY);
  flrTeamFMMode{flrTeam.FMMode - PDR} := AddEntry;
  getTeamAsgn.IENS := NEW_ENTRY;
  txtAssignDt.AsOvcDate := CurrentDate;
  {lblAsgnDt.FMInternal := StrToFMDate(txtAssignDT.AsString);}
  lblTDtEntr.FMCtrlInternal{FMInternal - PDR 5/98} := ToFMDateTime(Now, true);
  lblTUsrEntr.FMCtrlInternal{FMInternal - PDR 5/98} := '.5';
  lblDisDT.FMCtrlInternal{FMInternal - PDR 5/98} := '';
  cmdSave.Enabled := true;
  cmdCancel.Enabled := true;
  txtAssignDT.Setfocus;
  Chkrestrict.enabled := true;   {jlu 9/23/98}
  Chkrestrict.checked := false; {jlu 9/23/98}
  NewDischarge := True; {PDR}
end;


{ 2/8/96 added

}
procedure TfrmTeamAssign.LoadTeamInfo;
begin
  if not (tmProfile.TeamAsgn = emptystr) then begin
     getTeamAsgn.Iens := tmProfile.TeamAsgn;
     getTeamAsgn.GetandFill;
     txtAssignDT.AsString := FMToStr(lblAsgnDt.FMCtrlInternal{FMInternal - PDR 5/98});
     txtDischargeDt.AsString := FMToStr(lblDisDt.FMCtrlInternal{FMInternal - PDR 5/98});
     if (length(lblDisDt.FMCtrlInternal)=0)  {PDR}
        {or FutureTeamDischarge} then
      NewDischarge := True
     else
      NewDischarge := False;
     {pdr 7/21/98 - make sure check boxes default to un-checked if value is nill}
     SetChkBoxes;
  end;
  flrTeam.Clear;
end;

{ 2/12/96

}
procedure TfrmTeamAssign.GetPositionsAsgn;
var
  i: integer;
  PsName, RlName, MbName, PrName: string; {removing s1 to stop hint}
  At,PC : string;
  item: string;
begin
  try
     plist.clear;
     asgnpositions.clear;
     lstPositions.NumItems := 0;
     lstPositions.Repaint;

     if frmMain.ShowAllTeams.checked then
        GetPosAssignList(RPCBrokerMain, tmProfile.TeamAsgn,
                         tmProfile.dfn, '2900101',
                         '3991231', plist)
     else
        GetPosAssignList(RPCBrokerMain, tmProfile.TeamAsgn,
                         tmProfile.dfn, '',
                         '', plist);

     for i := 0 to plist.count - 1 do
      begin
        //showmessage(plist[i]);
        Pc := '   ';
        if (Piece(plist[i], U, 11) = '1')
         and (chkPrimaryCare.checked ) then
            begin
             if Piece(plist[i], U, 10) = ''
              then Pc := ' * '
               else Pc := ' x ';
            end;


        {if Piece(plist[i], U, 11) = '2' then
           At := ' * '
        else
           At := '   ';}

        PsName := Piece(plist[i], U, 4);
        pad(PsName, 25);

        RlName := Piece(plist[i], U, 6);
        pad(RlName, 25);

        MbName := Piece(plist[i], U, 8);
        pad(MbName, 25);

        PrName := Piece(plist[i], U, 10);
        pad(PrName, 25);

        item := Pc + '    '
             + copy(mbName, 1, 25) + ' '
             + copy(PsName, 1, 25) + ' '
             + copy(PrName, 1, 25) + ' '
             + copy(RlName, 1, 25);
        asgnpositions.Add(item);
      end; // for i := o to plist.count-1 do
  finally
     lstPositions.NumItems := asgnpositions.Count;
     lstPositions.Repaint;
  end;
end;


procedure TfrmTeamAssign.pad(var s: string; ln: integer);
var
  i: integer;
begin
  for i := length(s) to ln do
     s := s + ' ';
end;

{ 2/8/96 added

}
procedure TfrmTeamAssign.txtExit(Sender: TObject);
begin
  if (ActiveControl = cmdCancel) or not (Sender as TFMEdit).FMModified then exit;

  with (Sender as TFMEdit) do begin
     if (Length(Text) < 3) and not (text = '') then begin
        messagedlg('At least three characters are required!', mtInformation,
                   [mbOk], 0);
        setfocus;
        exit;
        end;
     end;
    cmdSave.enabled := true;
end;


{ 2/8/96 added

}
procedure TfrmTeamAssign.txtChange(Sender: TObject);
begin
  cmdCancel.enabled := true;
end;


procedure TfrmTeamAssign.GetPCInfo;
var
  s, dt : string;
begin
{NOTE: Don't make call anymore. Returned potentially erroneous info since lookup
 done primarily on date=NOW, which is inappropriate for server side lookup
 algorithm. Call has been replaced by setting variable HasPCTeam from
 Scptpf.pas Team Listing. See notes - PDR}
  {dt := StrToFMDate(FormatDateTime('mm/dd/yy', Now));}
  RPCBrokerMain.remoteProcedure := 'SC PRIMARY CARE TEAM';
  with RPCBrokerMain.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"DFN"'] := tmProfile.dfn;
        Mult['"DATE"'] := StrToFMDate(FormatDateTime('mm/dd/yyyy', Now));
        Mult['"ROLE"'] := '1';
        Mult['"AST"'] := '1';
     end;
  RPCBrokerMain.Call;
  PCInf := RPCBrokerMain.Results[0];  {RETURNS: SCPT^SCTM^ASSIGNED TO PC (YES/NO) - pdr}
  {RPCBrokerMain, tmProfile.dfn, dt, '1', '1');}
end;

{ 2/8/96 added

}
function TfrmTeamAssign.PCPositionOk(ien: string): boolean;
begin
  result := true;
end;

function TfrmTeamAssign.AtdPositionOk(ien: string): boolean;
begin
  Result := true;
end;

{ 2/8/96 added

}
procedure TfrmTeamAssign.cmdCancelClick(Sender: TObject);
begin
  {cmdSave.Enabled := false; } {pdr}
  CancelTeamAssignment1Click(Sender);
  cmdSave.Enabled := false; {PDR}
  cmdcancel.Enabled := false;{PDR}
end;

{ 2/8/96 added

}
Procedure TfrmTeamAssign.CheckBoxClick(Sender: TObject);
begin
	with (Sender as TFMCheckBox) do
  	begin
        if Checked then
           FMCtrlInternal{FMInternal - PDR 5/98} := '1'
        else 
           FMCtrlInternal{FMInternal - PDR 5/98} := '0';

        if Checked <> FMTag then
           begin
              FMFiler.AddChgdControl{Add - PDR}(Sender);
              cmdSave.enabled := true;
              cmdCancel.enabled := true;
           end
        else
           FMFiler.RemoveChgdControl(Sender);
     end;
end;

procedure TfrmTeamAssign.tabInfoPageChange(Sender: TObject; Index: Integer;
  var AllowChange: Boolean);
begin if (cmdSave.Enabled) and (Index = 1) then begin
     messagedlg('Please save current Team Assignment first.', mtInformation,
                 [mbOk], 0);
     AllowChange := false;
 end;

end;

procedure TfrmTeamAssign.lstPositionsGetItem(Sender: TObject;
  Index: Longint; var ItemString: String);
begin
  If (index >= 0) and (Index < asgnpositions.Count) then
     ItemString := asgnpositions.Strings[Index];
end;

{

}
procedure TfrmTeamAssign.lstPositionsDblClick(Sender: TObject);
var
  frm      : TfrmPosInfo;
  Changed : boolean;
  OldInternal : Integer;
begin
  {Added 1/2/97 - RV}
  if (lstPositions.itemIndex = -1) then exit ;

  Changed := false;
  getPosInfo.IENS := Piece(plist[lstPositions.itemIndex], U, 2);
  getPosInfo.GetAndFill;

  application.CreateForm(TfrmPosInfo, frmPosInfo);
  frmPosInfo.FormParent := self;
  frmPosInfo.txtPosAsgnDT.AsString := FMToStr(FMAsgn.FMCtrlInternal{FMInternal - PDR 5/98});
  frmPosInfo.txtPosUnAsgnDT.AsString := FMToStr(FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98});

  if FMRole.FMCtrlInternal{FMInternal - PDR 5/98} = '' then
     FMRole.FMCtrlInternal{FMInternal - PDR 5/98} := '0';

  Case StrToInt(FMRole.FMCtrlInternal{FMInternal - PDR 5/98}) of
     0  : frmPosInfo.chkpcasgn.Checked := false;
     1  : frmPosInfo.chkpcasgn.Checked := true;
  end;

  OldInternal := StrToInt(FMRole.FMCtrlInternal{FMInternal - PDR 5/98});

  {Commenting out 6/1/99 it is at the end of this unit c2}
  posinfopcsetup(editentry);
  Posinfohandler(editentry,oldinternal,changed);
  {commented out code at c3}
end;

procedure TfrmTeamAssign.Posinfopcsetup(modepar : fmmodes);
var pc,at : boolean;

Begin //posinfopcsetup
   if chkPrimaryCare.checked then begin

     {CHANGED - 2/12/97 - REV}
     CheckPositionType(FMPosition.FMCtrlInternal{FMInternal - PDR 5/98},frmposinfo.txtposasgndt.asstring, pc, at);
     {CheckPositionType(getPosInfo.IENS, pc, at);       {problem here - wrong ien!!}

     frmPosInfo.chkpcasgn.Enabled := pc;
     if modepar=addentry then frmPosInfo.chkpcasgn.checked := pc
     else
         CASE strtoint(fmrole.fmctrlinternal) of
         0:Frmposinfo.chkpcasgn.checked := false;
         1:Frmposinfo.chkpcasgn.Checked := true;
         end;
     end
  else begin
     frmPosInfo.chkpcasgn.Enabled := false;
     IF modepar = addentry THEN frmPosInfo.chkpcasgn.checked := false
     ELSE
         CASE strtoint(Fmrole.Fmctrlinternal) of
         0:Frmposinfo.CHKPCASGN.Checked := false;
         1:Frmposinfo.CHKPCASGN.Checked := true;
         end;
  end;
end; //posinfopcsetup

Procedure tfrmteamassign.Posinfohandler(modepar:fmmodes; oldinternal : integer; var changed:boolean);
var
   s1 : string;
   
Begin
  try
    frmPosInfo.ShowModal;
    if frmPosInfo.ModalResult = mrOk then begin
        flrPosAsgnFMMode{flrPosAsgn.FMMode - PDR} := modepar;
        if not (CompareText(StrToFMDate(frmPosInfo.txtPosAsgnDT.AsString),
             FMAsgn.FMCtrlInternal{FMInternal - PDR 5/98}) = 0) then begin
           FMAsgn.FMCtrlInternal{FMInternal - PDR 5/98} := StrToFMDate(frmPosInfo.txtPosAsgnDT.AsString);
           flrPosAsgn.AddChgdControl{Add - PDR}(FMAsgn);
           cmdPSave.Enabled := true;
           cmdPCancel.ENabled := true;
           Changed := true;
        end;

        if not (frmPosInfo.txtPosUnAsgnDT.AsString = NULL_DATE) then
           if not (CompareText(StrToFMDate(frmPosInfo.txtPosUnAsgnDT.AsString),
                FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98}) = 0) then begin
              FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98} := StrToFMDate(frmPosInfo.txtPosUnAsgnDT.AsString);
              flrPosAsgn.AddChgdControl{Add - PDR}(FMUnAsgn);
              cmdPSave.Enabled := true;
              cmdPCancel.ENabled := true;
              Changed := true;
           end;

        If Frmposinfo.CHKPCASGN.Checked then Fmrole.Fmctrlinternal:='1'
        else Fmrole.FMCtrlInternal:='0';

        If (modepar=editentry) and (Strtoint(FMRole.FMCtrlInternal)<>OldInternal) or (modepar=addentry) then
          begin
           flrPosAsgn.AddChgdControl{Add - PDR}(FMRole);
           cmdPSave.Enabled := true;
           cmdPCancel.ENabled := true;
           changed := true;
          end;

        //If StrToInt(FMRole.FMCtrlInternal{FMInternal - PDR 5/98}) <> OldInternal then begin
           //flrPosAsgn.AddChgdControl{Add - PDR}(FMRole);
           //cmdPSave.Enabled := true;
           //cmdPCancel.ENabled := true;
           //changed := true;
        //end;

        if changed then begin
           s1 := FMPosition.Caption + '  ' + FMDateToStr(FMAsgn.FMCtrlInternal{FMInternal - PDR 5/98});
           if not (FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98} = emptystr) then
              s1 := s1 + '  ' + FMDateToStr(FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98});
           lblAdd.Caption := s1;
           pnlAdd.Visible := true;
        end;
     end;
     finally
        frmPosInfo.free;
     end;
    end; //posinfohandler


function TfrmTeamAssign.CheckDateOk: boolean;
begin
  result := (Length(lblAsgnDt.FMCtrlInternal{FMInternal - PDR 5/98}) > 0);
end;

{

}
procedure TfrmTeamAssign.cmdSaveCLick(Sender: TObject);
begin
  SaveTeamAssignment1Click(Sender);
end;

procedure TfrmTeamAssign.txtAssignDtExit(Sender: TObject);
begin
  if ActiveControl = cmdCancel then exit;
  if ActiveControl = tabInfo then exit;
  if Calendar.focused then exit;

  if pnlCalendar.Visible then
     pnlCalendar.Visible := false;

  if txtAssignDt.asString = NULL_DATE then exit;

  if (CompareText(StrToFMDate(txtAssignDt.asString), lblAsgnDt.FMCtrlInternal{FMInternal - PDR 5/98} )
       = 0) then exit;

  if not txtAssignDt.isValid then
     begin
        frmMain.StatusMsg('  Invalid date', true);
        txtAssignDt.SetFocus;
        exit;
     end;

 if AssignDateChangeOk then
  begin
     if (Length(lblAsgnDt.FMCtrlInternal{FMInternal - PDR 5/98}) > 0) and (flrTeamFMMode{flrTeam.FMMode - PDR} = EditEntry) then
        begin
           if messagedlg('You are changing an existing date.  This' + RETURN +
              'may cause problems with other applications.' + RETURN +
              'Please see HELP for additional information.' + RETURN +
              'Do you wish to change it now?', mtConfirmation,
               [mbYes,mbCancel,mbHelp], 80000) = mrCancel then
              begin
                 txtAssignDt.AsString := FMToStr(lblAsgnDt.FMCtrlInternal{FMInternal - PDR 5/98});
                 exit;
              end
           {ELSE?  --  how does date actually get changed?  SAVE is disabled!! }
           else
              begin
                    lblAsgnDt.FMCtrlInternal{FMInternal - PDR 5/98} := StrToFMDate(txtAssignDt.AsString);
                    flrTeam.AddChgdControl{Add - PDR}(lblAsgnDT);
                    cmdSave.enabled := True;
                    cmdCancel.enabled := true;
              end;
           {  =================  ELSE added 1/28/97 - RV  ======================}
        end
     else
        begin
           lblAsgnDt.FMCtrlInternal{FMInternal - PDR 5/98} := StrToFMDate(txtAssignDt.AsString);
           flrTeam.AddChgdControl{Add - PDR}(lblAsgnDT);
           cmdSave.enabled := True;
           cmdCancel.enabled := true;
        end;
  end
 else
  txtAssignDt.Setfocus;
end;

function TfrmTeamAssign.AssignDateChangeOk: boolean;
begin
  result := true;
end;


procedure TfrmTeamAssign.txtDischargeDtExit(Sender: TObject);
begin
  if cmdCancel.focused then exit;
  if Calendar.focused then exit;

  if pnlCalendar.Visible then
     pnlCalendar.Visible := false;

  if txtDischargeDt.asString = NULL_DATE then exit;
  if (CompareText(StrToFMDate(txtDischargeDt.asString), lblDisDt.FMCtrlInternal{FMInternal - PDR 5/98} )
      = 0) then exit;

 if not txtDischargeDt.isValid then
  begin
     frmMain.StatusMsg('  Invalid date', true);
     txtDischargeDt.SetFocus;
     exit;
  end;

 if DischrgDateChangeOk then
  begin
     if (Length(lblDisDt.FMCtrlInternal{FMInternal - PDR 5/98}) > 0) and (flrTeamFMMode{flrTeam.FMMode - PDR} = EditEntry) then
        begin
         if messagedlg('You are changing an existing date.  This' + RETURN +
              'may cause problems with other applications.' + RETURN +
              'Please see HELP for additional information.' + RETURN +
              'Do you wish to change it now?', mtConfirmation,
               [mbYes,mbCancel,mbHelp], 80000) = mrCancel then
              begin
                 txtDischargeDt.AsString := FMToStr(lblDisDt.FMCtrlInternal{FMInternal - PDR 5/98});
                 exit;
              end
            {ELSE?  --  how does date actually get changed?  SAVE is disabled!! }
           else
               begin
                    lblDisDt.FMCtrlInternal{FMInternal - PDR 5/98} := StrToFMDate(txtDischargeDt.AsString);
                    flrTeam.AddChgdControl{Add - PDR}(lblDisDT);
                    cmdSave.enabled := True;
                    cmdCancel.enabled := true;
               end;
           {===============  Else added 1/28/97 - RV  =========================}
        end
     else
        begin
           lblDisDt.FMCtrlInternal{FMInternal - PDR 5/98} := StrToFMDate(txtDischargeDt.AsString);
           flrTeam.AddChgdControl{Add - PDR}(lblDisDT);
           cmdSave.enabled := True;
           cmdCancel.enabled := true;
        end;
  end
 else
  txtDischargeDt.Setfocus;
end;

function TfrmTeamAssign.DischrgDateChangeOk: boolean;
begin
  result := true;
end;

procedure TfrmTeamAssign.PopUpCalendar(Sender: TObject);
var
  d: TOvcDate;
begin
  pf := TOvcPictureField(Sender);

  if pnlcalendar.visible then
     begin
        pnlCalendar.visible := false;
        exit;
     end;

  pnlCalendar.top := tabInfo.Top + hdrForm.Height + (pf.Top + pf.Height);
  pnlCalendar.left := tabInfo.left + grpDates.left + pf.left;

  d := pf.AsOvcDate;
  if d = BadDate then
     d := CurrentDate;
  Calendar.AsStDate := d;
  pnlCalendar.BringToFront ;
  pnlCalendar.visible := true;
  Calendar.Setfocus;
end;

Procedure TfrmTeamAssign.AltPopUpCalendar(Sender: TObject);
var
  d: TOvcDate;
begin
  pf := TOvcPictureField(Sender);

  if pnlcalendar.visible then
     begin
        pnlCalendar.visible := false;
        exit;
     end;

  pnlCalendar.BringToFront;

  d := pf.AsOvcDate;
  if d = BadDate then
     d := CurrentDate;
  Calendar.AsStDate := d;
  pnlCalendar.visible := true;
  Calendar.Setfocus;
end;

{

}
procedure TfrmTeamAssign.CalendarClick(Sender: TObject);
begin
  pf.AsOvcDate := Calendar.AsStDate;
  pnlCalendar.visible := false;
  pf.Setfocus;
  if Uppercase(pf.name)='TXTDISCHARGEDT' then {PDR}
   txtDischargeDtExit(Sender)
  else if Uppercase(pf.name)='TXTASSIGNDT' then
   txtAssignDTExit(sender);
end;

{

}
procedure TfrmTeamAssign.CalendarKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_SPACE then CalendarClick(Sender);
end;

procedure TfrmTeamAssign.NewPosClick(Sender: TObject);
begin
  NewPositionAssignment1Click(Sender);
end;

procedure TfrmTeamAssign.cmdPosAsgnCancelClick(Sender: TObject);
begin
  pnlAdd.visible := false;
  lblAdd.Caption := emptystr;
end;

procedure TfrmTeamAssign.cmdPCancelClick(Sender: TObject);
begin
  CancelPositionAssignment1Click(Sender);
end;

procedure TfrmTeamAssign.cmdPSaveClick(Sender: TObject);
begin
  SavePositionAssignment1Click(Sender);
end;

procedure TfrmTeamAssign.cmdHelpClick(Sender: TObject);
begin
 if tabinfo.pageindex=0 then
  Application.HelpContext(70500)
 else if tabinfo.pageindex=1 then
  Application.HelpContext(70400)
 else
  Application.HelpContext(70410);
end;

procedure TfrmTeamAssign.DelPosAsgnClick(Sender: TObject);
begin
  NotYet;
end;

procedure TfrmTeamAssign.UpdateMenus(Sender: TObject);
var
  status : boolean;
begin
     TeamAssignment1.enabled := (tabInfo.PageIndex = 0);
     Position1.enabled := (tabInfo.PageIndex = 1); { and (tabInfo.pagesEnabled[1]);}
     {Position1.enabled := tabInfo.pagesEnabled[1];}
     {TeamAssignment1.enabled := cmdSave.enabled;}

     {Added 1/2/97 - RV}
     EditAssignment1.Enabled := (lstPositions.ItemIndex > -1) ;
     EditPosition1.Enabled := EditAssignment1.Enabled ;

     SavePositionAssignment1.Enabled := cmdPSave.enabled;
     CancelPositionAssignment1.Enabled := cmdPCancel.enabled;
     RemovePositionAssignment1.Enabled := (lstPositions.ItemIndex > -1) and DeleteKey;
     SavePosition1.Enabled := cmdPSave.enabled;
     CancelPosition1.enabled := cmdPCancel.enabled;

     {Added 1/28/97 - RV}
     SaveTeam1.Enabled := cmdSave.Enabled;
     CancelTeam1.Enabled := cmdCancel.Enabled;

     SaveTeamAssignment1.Enabled := cmdSave.Enabled;
     CancelTeamAssignment1.Enabled := cmdCancel.Enabled;
     Delete1.Enabled := DeleteKey and (tmProfile.Mode = EditItem);
end;

procedure TfrmTeamAssign.grpPositionExit(Sender: TObject);
begin
 {grpPosition.FMInternal := IntToStr(grpPosition.ItemIndex);}
end;

procedure TfrmTeamAssign.tabInfoPageChanged(Sender: TObject;
  Index: Integer);
begin
  if Index = 0 then
     TabInfo.PopUpMenu := PopUpTeam
  else
     TabInfo.PopUpMenu := PopUpPos;
end;

procedure TfrmTeamAssign.NewTmAsgnClick(Sender: TObject);
begin
  NotYet;
end;

procedure TfrmTeamAssign.RPCBroker1NetError(Sender: TObject;
  var Error: EBrokerError);
var
  msg: string;
begin
  msg := 'A Network error has been encountered.  Please make' + RETURN +
         'a note of your current entry.  You will need to' + RETURN +
         'logon to DHCP before continuing';
  messageDlg(msg, mtError, [mbOk], 0);
  NetError := true;
  Halt;
end;


function TfrmTeamAssign.MakePCTeamOk: Boolean;
begin
  result := true;
end;

procedure TfrmTeamAssign.chkPrimaryCareEnter(Sender: TObject);
begin
  chkPrimaryCare.FMTag := chkPrimaryCare.CHecked;
end;



procedure TfrmTeamAssign.chkPrimaryCareClick(Sender: TObject);
var
 enab:boolean; {pdr}
begin
  if not MakePCTeamOk then exit;

  with (Sender as TFMCheckBox) do begin
   begin
    enab:=enabled; {pdr}
    enabled:=true;
     if Checked then
        FMCtrlInternal{FMInternal - PDR 5/98} := '1'
     else
      begin
       FMCtrlInternal{FMInternal - PDR 5/98} := '99';
       checked:=false;
      end;
    enabled:=enab; {pdr}
   end;
     FMFiler.AddChgdControl{Add - PDR}(Sender);
     cmdSave.enabled := true;
     cmdCancel.enabled := true;

  end;
end;

procedure TfrmTeamAssign.cmdCloseClick(Sender: TObject);
begin
  close;
end;

procedure TfrmTeamAssign.RemovePositionAssignment1Click(Sender: TObject);
var
  ien: string[20];
begin
  if messageDlg('Selecting YES will delete this entry.' + RETURN +
                'Do you wish to continue?', mtConfirmation, [mbYes,mbCancel], 0)
                  = mrYes then begin
     ien := Piece(plist[lstPositions.ItemIndex], U, 2);
     if Deleter(RPCBrokerMain, '^SCPT(404.43,', ien) then begin
        frmMain.StatusMsg('Positions assignment deleted', false);
        GetPositionsAsgn;
        end
     else
        frmMain.StatusMsg('Position was not deleted', true);
  end;
end;

procedure TfrmTeamAssign.SavePositionAssignment1Click(Sender: TObject);
var
  msg : string;
  i   : integer;
  ien : TScStr20;
begin
  Screen.Cursor := crHourglass;

  if flrPosAsgnFMMode{flrPosAsgn.FMMode - PDR} = AddEntry then begin
     flrPosAsgn.AddChgdControl{Add - PDR}(FMPosition);
     flrPosAsgn.AddFDA('404.43',NEW_ENTRY,'.01', TmProfile.TeamAsgn){Key('404.43', '.01', TmProfile.TeamAsgn)-pdr};
     lblPDtEntr.FMCtrlInternal{FMInternal - PDR 5/98} := ToFMDateTime(Now, true);
     flrPosAsgn.AddChgdControl{Add - PDR}(lblPDtEntr);
     lblPUsrEntr.FMCtrlInternal{FMInternal - PDR 5/98} := frmMain.UserRecord.ID;
     flrPosAsgn.AddChgdControl{Add - PDR}(lblPUsrEntr);
     end
  else
     begin
        SendAssignmentMsg('BP', lblPUsrEdt.IENS{FMEntry - PDR});
        lblPDtEdt.FMCtrlInternal{FMInternal - PDR 5/98} := ToFMDateTime(Now, true);
        flrPosAsgn.AddChgdControl{Add - PDR}(lblPDtEdt);
        lblPUsrEdt.FMCtrlInternal{FMInternal - PDR 5/98} := frmMain.UserRecord.ID;
        flrPosAsgn.AddChgdControl{Add - PDR}(lblPUsrEdt);
     end;


  if flrPosAsgn.Update then begin
     frmMain.StatusMsg('Position information saved', false);

     if flrPosAsgnFMMode{flrPosAsgn.FMMode - PDR} = AddEntry then
        ien := flrPosAsgn.FindIen(NEW_ENTRY + ',')
     else
        ien := lblPUsrEdt.IENS{FMEntry - PDR};
     SendAssignmentMsg('AP', ien);

     if CheckClinicEnrollment(tmProfile.dfn,Clinic.Name) then begin
     //;bp/cmf;7/28/98;prior code did not
     //;check to see if patient already
     //;enrolled in clinic
     //;prior code;if Clinic.Name <> emptystr then begin
        msg := 'The ' + Clinic.Name + ' clinic is associated  ' + RETURN +
               'with this position.  Do you want to enroll  ' + RETURN +
               'this patient into ' + Clinic.Name + ' now?';
        if messagedlg(msg, mtConfirmation, [mbYes,mbNo], 0) = mrYes then begin

           i := messagedlg('Is this an Outpatient enrollment?', mtConfirmation, [mbYes,mbNo], 0);
           RPCBrokerMain.remoteProcedure := 'SC PAT ENROLL CLN';
           with RPCBrokerMain.Param[0] do
              begin
                 Value := '.SC';
                 Ptype := list;

                 Mult['"DFN"']     := tmProfile.dfn;
                 Mult['"CLINIC"']  := Clinic.Ien;
                 Mult['"DATE"']    := FMAsgn.FMCtrlInternal{FMInternal - PDR 5/98};

                 case i of
                    mrYes : Mult['"ADD1"'] := 'O';
                    mrNo  : Mult['"ADD1"'] := 'A';
                 end;
              end;
           RPCBrokerMain.Call;

           if Piece(RPCBrokerMain.Results[0], U, 2) = '1' then
              frmMain.StatusMsg('Patient enrolled', false)
           else
              messagedlg('Unable to enroll patient', mtInformation, [mbOk], 0);

        end;
     end;
  end
  else
     frmMain.StatusMsg('Position information was not saved', true);

  lblAdd.Caption := emptystr;
  pnlAdd.visible := false;

  Clinic.Name := emptystr;
  Clinic.Ien  := emptystr;

  GetPositionsAsgn;
  cmdPSave.enabled := false;
  cmdPCancel.enabled := false;
  cmdPAssign.Enabled := true;
  flrPosAsgn.Clear;
  flrPosAsgnFMMode{flrPosAsgn.FMMode - PDR} := ViewEntry;
  Screen.Cursor := crDefault;
  PatientAsgn.GetTeams;
end;

function TfrmTeamAssign.CheckClinicEnrollment(ien,clinic: string): boolean;
//bp/cmf;7/28/98;if find1 does not return '0'
//      ;patient already actively enrolled
//      ;so don't ask to re-enroll!
begin
if clinic = emptystr then result := false
else
with FMFindOneCheckClinicEnrollment do
    begin
    value := clinic;
    iens := ',' + ien + ',';
    if GetIEN = '0' then
         result := true
    else result := false;
    end;
end;

procedure TfrmTeamAssign.CancelPositionAssignment1Click(Sender: TObject);
begin
  lblAdd.Caption := emptystr;
  pnlAdd.visible := false;
  flrPosAsgn.Clear;
  flrPosAsgnFMMode{flrPosAsgn.FMMode - PDR} := ViewEntry;
  cmdPSave.Enabled := false;
  cmdPCancel.Enabled := false;
  cmdPAssign.Enabled := true;
  Clinic.Name := emptystr;
  Clinic.Ien  := emptystr;
end;

procedure TfrmTeamAssign.NewPositionAssignment1Click(Sender: TObject);
var
  frm   : TfrmPosInfo;
  new, changed, pc, at   :boolean;
  cur, max : string[10];
  i, OldInternal  : integer;
  WAITLISTINFO: String;
begin
  changed := false;
  with PositionsLookup do begin
     FMLister.FromList.clear; {pdr}
     FMLister.FromList.insert(0,'*');{From := ''; -PDR}
     FMLister.FromIen := '';
     FMLister.PartList.clear; {pdr}
     FMLister.PartList.insert(0,'');{Part := '' - PDR - probably not necessary};
     FMLister.Screen := 'IF $P(^(0),U,2)="' + TmProfile.TeamIen +
                        '",+$$ACTTP^SCMCTPU(Y)=1,+$$OKPREC5^SCMCLK(Y)=1';


     FMLister.Number := '*';
     Title := 'Select Position:';
     AllowNew := false;
     end;

  if PositionsLookup.Execute(new) then begin
     with getPosAsgnInfo do begin
        IENS := PositionsLookup.RecordNumber;
        GetData;
     end;
     cur := Piece(GetFMDelimRec(getPosAsgnInfo,2), U, 5);{Piece(getPosAsgnInfo.Results[2], U, 5); - PDR}
     if cur = emptystr then cur := '0';

     max := Piece(GetFMDelimRec(getPosAsgnInfo,1), U, 5);{Piece(getPosAsgnInfo.Results[1], U, 5); - PDR}
     if max = emptystr then max := '0';
     if (pos(',',max)>0) then
        repeat
           max := copy(max,1,pos(',',max)-1)+copy(max,pos(',',max)+1,99) ;
        until pos(',',max)=0 ;
     WAITLISTINFO :=PatientAsgn.DFN+'^'+        TmProfile.TeamIen+'^'+PositionsLookup.RecordNumber;
     IF PIECE(GlobalNode(RPCBrokerMain, '^SCTM(404.57,' + PositionsLookup.RecordNumber + ',0)'),'^',4)<>'1' THEN WAITLISTINFO := '-';
     if not CheckPositionMax(StrToInt(cur), StrToInt(max),WAITLISTINFO) then exit;

     getPosInfo.SetUpNewEntry(NEW_ENTRY);
     FMPosition.FMCtrlInternal{FMInternal - PDR 5/98} := PositionsLookUp.RecordNumber;
     FMPosition.Caption :=
           Piece(GetFMDelimRec(PositionsLookUp.FMlister,PositionsLookUp.RecordIndex),
                 U, 2);
           {Piece(PositionsLookUp.FMlister.Results[PositionsLookUp.RecordIndex],
                 U, 2); - pdr}

     for i := 0 to AsgnPositions.Count - 1 do begin
        if Pos(FMPosition.Caption, AsgnPositions[i]) > 0 then begin
           messagedlg('Patient is already assigned to this position', mtInformation, [mbOk], 0);
           exit;
        end;
     end;

     with getPosClinic do begin
        IENS := FMPosition.FMCtrlInternal{FMInternal - PDR 5/98};
        GetData;
        if Piece(GetFMDelimRec(getPosClinic,1),U,4)= emptystr then begin {Results[1], U, 4) = emptystr then begin}
           Clinic.Name := emptystr;
           Clinic.Ien  := emptystr;
           end
        else begin
           Clinic.Name := Piece(GetFMDElimRec(getPosClinic,1),U,5);{Results[1], U, 5); - pdr}
           Clinic.Ien  := Piece(GetFMDElimRec(getPosClinic,1),U,4);{Results[1], U, 4); - pdr}
        end;
     end;

     application.CreateForm(TfrmPosInfo, frmPosInfo);
     frmPosInfo.FormParent := self;
     frmPosInfo.txtPosAsgnDT.AsString := FormatDateTime('mm/dd/yyyy', Now);

     FMRole.FMCtrlInternal{FMInternal - PDR 5/98} := '0';
     frmPosInfo.chkpcasgn.Checked := false;
     OldInternal := StrToInt(FMRole.FMCtrlInternal{FMInternal - PDR 5/98});
     {a section of code commemted out and is at the end of this unit c1}
     Posinfopcsetup(Addentry);
     Posinfohandler(Addentry,oldinternal,changed);
     {commented out code at c4  }
  end;
end;

procedure TfrmTeamAssign.SaveTeamAssignment1Click(Sender: TObject);
var
  flag,OKtoDischPos  : boolean;
  ien   : string[20];
  i     : integer;
 procedure UpdateForm;
 begin
  Screen.Cursor := crDefault;
  flrTeamFMMode{flrTeam.FMMode - PDR} := EditEntry;
  cmdSave.Enabled := false;
  cmdCancel.Enabled := false;
  FrmParent.GetTeams;
  TmProfile.Mode := ViewItem;
  ActivePositionList.free;
 end;
begin {-------------------------- main procedure-----------------------}
  Perform(WM_NEXTDLGCTL, 0, 0);

  if not CheckDateOk then begin
     messageDlg('Date assigned to team is required', mtWarning, [mbOk], 0);
     exit;
  end;

 {jlu - This is begining added to check for active positions for a patient on a ateam before discharge.}
Activepositionlist:=Tstringlist.create;
OKtoDischPos := CheckForPostoDischarge;
if (txtDischargeDT.text <> NULL_DATE) and
   not OKtoDischPos then
 begin
  txtdischargedt.ClearContents;
  lbldisdt.FMCtrlInternal:='';
  flrteam.removechgdcontrol(lbldisdt);
  cmdSave.enabled := False;
  messageDlg('Record was not updated!', mtWarning, [mbOk,mbHelp], 80000);
  ActivePositionList.free;
  exit;
 end;
 if (flrTeam.AnythingToFile{Status = Edited - PDR}) then begin
  if getTeamAsgn.IENS = (NEW_ENTRY + ',') then
   begin
    {Think .AddFDA is the appropriate replacement for .Key method PDR - 5/98}
    flrTeam.AddFDA('404.42',NEW_ENTRY,'.01', TmProfile.dfn){key('404.42', '.01', TmProfile.dfn) -PDR};
    flrTeam.AddFDA('404.42',NEW_ENTRY,'.03', TmProfile.TeamIen){key('404.42', '.03', TmProfile.TeamIen) - PDR};
    flrTeam.AddChgdControl{Add - PDR}(lblTDtEntr);
    lblTUsrEntr.FMCtrlInternal{FMInternal - PDR 5/98} := frmMain.UserRecord.ID;
    flrTeam.AddChgdControl{Add - PDR}(lblTUsrEntr);
   end
  else
   begin
    if (txtdischargedt.text <> null_date) and not DischargePositionsOK then
     begin
      messageDlg('Unable to discharge some or all position assignments!'+#13+
                 'Team discharge abandoned.' + #13 +
                 'Please discharge positions individually',
                  mtWarning, [mbOk,mbHelp], 80000);
      txtdischargedt.ClearContents;
      UpdateForm;
      exit; {BAIL OUT - couldn't perform position discharge}
     end;
    SendAssignmentMsg('BT', TmProfile.TeamAsgn);
    lblTDtEdt.FMCtrlInternal{FMInternal - PDR 5/98} := ToFMDateTime(Now, true);
    flrTeam.AddChgdControl{Add - PDR}(lblTDtEdt);
    lblTUsrEdt.FMCtrlInternal{FMInternal - PDR 5/98} := frmMain.UserRecord.ID;
    flrTeam.AddChgdControl{Add - PDR}(lblTUsrEdt);
   end;
 if flrTeam.Update then
  begin
   frmMain.StatusMsg('Team assignment for ' + hdrForm.Sections[3] + ' saved.', false);
   tabInfo.Pages[1].Enabled := true;
   if flrTeamFMMode{flrTeam.FMMode - PDR} = AddEntry then
    begin
     ien := flrTeam.FindIen(NEW_ENTRY + ',');
     getTeamAsgn.StuffIENS(ien); {SetEntryNumber(ien) - PDR};
     TmProfile.TeamAsgn := ien;
    end;
   SendAssignmentMsg('AT', TmProfile.TeamAsgn);
  end
 else
  messageDlg('Record was not updated!', mtWarning, [mbOk,mbHelp], 80000);
 end;
 UpdateForm;
end;


function tfrmteamassign.DischargePositionsOK:Boolean;  {PDR}
begin
 Result:=true;
 if ActivePositionList.Count = 0 then exit; {no positions to discharge}
 {if FutureTeamDischarge then exit;}
 RPCBrokerMain.remoteProcedure := 'SCMC DIS TEAM POS'; {DISCHPOS^SCMRBK}
  with RPCBrokerMain.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"DFN"'] := tmProfile.dfn;
        Mult['"TMASGN"'] := tmProfile.TeamAsgn;
        Mult['"DATE"'] := StrToFMDate(txtDischargeDT.asString); {Discharge for yesterday -PDR}
     end;
  RPCBrokerMain.Call;
  Result := RPCBrokerMain.Results[0]<>'0'; {broker returns '0' for failure, 1 otherwise}
end;

{function tfrmteamassign.FutureTeamDischarge:boolean;
begin
 result:=txtDischargeDT.asDateTime > now;
end; }

function tfrmteamassign.CheckForPostoDischarge:boolean; {jlu}
var
 Listdisplay:tstringlist;
begin
 Getactivepositions(RPCBrokerMain,TMPROFILE.TEAMIEN,TMPROFILE.DFN,'','',ACTIVEPOSITIONLIST);
 result:=true;
 IF Activepositionlist.count<1 then exit; {pdr}
 if txtDischargeDt.text = NULL_DATE then exit;   {pdr}
 {if FutureTeamDischarge then exit;} {future discharge - pdr}
 Listdisplay:=tstringlist.create;
 Formatlist(ACTIVEPOSITIONLIST,LISTDISPLAY);
 Application.createform(Tfrmdischargememo,Frmdischargememo);
 Frmdischargememo.dischargememo.lines.addstrings(Listdisplay);
 {if Futures then
  begin
   frmDischargeMemo.lblWarn1.visible := true;
   frmDischargeMemo.lblWarn2.visible := true;
   frmDischargeMemo.bitbtnDischargeOK.visible:=false;
  end; }
 result:=(Frmdischargememo.showmodal=mrOK); {PDR}
 {application.run; }
 {Result:=false; for test only}
end;

function tfrmteamassign.ActivePositions:boolean; {PDR}
begin
 result := Activepositionlist.count > 0;
end;

procedure tfrmteamassign.formatlist(Alist:tstringlist; var Dlist:Tstringlist); {jlu}
	var
		Lp:integer;
		Psname, Psrole, item :string;
BEGIN
{ Futures := false; - PDR}
	for lp:= 0 to Alist.count-1 do begin
		Psname:=piece(Alist[lp],u,2);
		Pad(Psname,35);
		Psrole:=piece(Alist[lp],u,5);
		Pad(Psrole,35);
		Item:=copy(Psname,1,25)+' '+copy(Psrole,1,25);
                {if piece(alist[lp],u,9) <>'' then
                 Futures := true; - PDR}
   Dlist.add(Item);
 end;
END;

procedure TfrmTeamAssign.CancelTeamAssignment1Click(Sender: TObject);
begin
  if pnlCalendar.visible = true then
     pnlCalendar.visible := false;

  if TmProfile.Mode = AddItem then
     postmessage(Handle, WM_Close, 0, 0)
  else begin
     getTeamAsgn.GetAndFill;
     txtAssignDT.AsString := FMtoStr(lblAsgnDT.FMCtrlInternal); {PDR}
     txtDischargeDT.AsString := FMtoStr(lblDisDT.FMCtrlInternal); {PDR}
     {cmdCancel.enabled := false;} {PDR}
     {cmdSave.enabled := false;}   {PDR}
     SetChkBoxes; {PDR 7/21/98}
  end;

end;

procedure TfrmTeamAssign.Delete1Click(Sender: TObject);
var
  ien: string[20];
begin
  ien := TmProfile.TeamIen;
  if CheckGlobal(RPCBrokerMain, '^SCPT(404.43)', 'B', tmProfile.TeamAsgn) > 0 then begin
     Messagedlg('This team assignment has position assisgnments associated ' +
                 RETURN + 'with it and cannot be deleted at this time.',
                 mtWarning, [mbOk], 0);
     exit
  end;

  if messageDlg('Selecting YES will delete this team assignment.' + RETURN +
                'Do you wish to continue?', mtConfirmation, [mbYes,mbNo], 0)
                  = mrYes then begin
     if Deleter(RPCBrokerMain, '^SCPT(404.42,', tmProfile.TeamAsgn) then begin
        frmMain.StatusMsg('Team assignment deleted', false);
        GetPositionsAsgn;
        end
     else
        frmMain.StatusMsg('Team Assignment was not deleted', true);
  end;
end;

procedure TfrmTeamAssign.CheckPositionType(ien : TScStr20; Asgndate : string; var pc : boolean; var at : boolean);
begin
  RPCBrokerMain.remoteProcedure := 'SC CHECK FOR PC POS';
  with RPCBrokerMain.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"DFN"']  := tmProfile.dfn;
        Mult['"POSITION"'] := Ien;
        //PATCH 177 Mult['"DATE"'] := StrToFMDate(FormatDateTime('mm/dd/yyyy', NOW));
        Mult['"DATE"'] := StrToFMDate(AsgnDate);
     end;
  RPCBrokerMain.Call;
  pc := (Piece(RPCBrokerMain.Results[0], U, 1) = '1');
  at := (Piece(RPCBrokerMain.Results[0], U, 2) = '1');
end;


procedure TfrmTeamAssign.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  rtn : word;
begin
  if (cmdSave.Enabled) or (cmdPsave.ENabled) then begin
     rtn := messagedlg('You have not saved your current changes!' +
                    RETURN + 'Do you want to save them now?', mtConfirmation,
                    [mbYes,mbNo,mbAbort], 0);
     if rtn = mrYes then begin
           if (flrTeam.AnythingToFile{Status = Edited - PDR}) then
              cmdSaveClick(nil);
           if (flrPosAsgn.AnythingtoFile{Status = Edited - PDR}) then
              cmdPSaveClick(nil);
        end
     else if rtn = mrAbort then
        CanClose := false;
  end;
end;

procedure TfrmTeamAssign.SendAssignmentMsg(MsgType : TScStr20; Ien : TScStr20);
var
  rtn : string;
begin
  RPCBrokerMain.remoteProcedure := 'SC PAT ASGN MAILMAN';
  with RPCBrokerMain.Param[0] do
     begin
        ien := piece(ien,',',1) ;
        Value := MsgType + '^' + ien;
        Ptype := literal;
      end;
  RPCBrokerMain.Call;
  rtn := RPCBrokerMain.Results[0];
end;

procedure TfrmTeamAssign.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key = VK_F10) and (Shift = [ssShift])  then
        sendMessage(Handle, WM_RBUTTONDOWN, 0, 0)
end;

procedure TfrmTeamAssign.lstPositionsKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_SPACE) then lstPositionsDblClick(nil);
end;

procedure TfrmTeamAssign.txtDischargeDtKeyDown(Sender: TObject; {PDR}
  var Key: Word; Shift: TShiftState);
begin
if (Key = VK_RETURN) then txtDischargeDtExit(sender);
end;

procedure TfrmTeamAssign.txtAssignDtKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (Key = VK_RETURN) then txtAssignDtExit(sender);
end;

procedure TfrmTeamAssign.spinDischargeClick(Sender: TObject;
  State: TOvcSpinState; Delta: Double; Wrap: Boolean);
begin
 cmdCancel.Enabled:=true;
 cmdSave.Enabled:=true;
end;

{c1}

    //if chkPrimaryCare.checked then begin
       //checkPositionType(FMPosition.FMCtrlInternal{FMInternal - PDR 5/98}, pc, at);
        //frmPosInfo.btnPcPractitioner.Enabled := pc;
        //frmPosInfo.btnPcAttending.Enabled := at;
        //end
    // else begin
        //frmPosInfo.btnPcPractitioner.Enabled := false;
        //frmPosInfo.btnPcAttending.Enabled := false;
     //end; .....this point jlu}

{c2     if chkPrimaryCare.checked then begin   }

     {CHANGED - 2/12/97 - REV}
     // this is part of the large commenting out     CheckPositionType(FMPosition.FMCtrlInternal{FMInternal - PDR 5/98}, pc, at);
     {CheckPositionType(getPosInfo.IENS, pc, at);       {problem here - wrong ien!!}

 {    frmPosInfo.btnPcPractitioner.Enabled := pc;
     frmPosInfo.btnPcAttending.Enabled := at;
     end
  else begin
     frmPosInfo.btnPcPractitioner.Enabled := false;
     frmPosInfo.btnPcAttending.Enabled := false;
  end;       .....this point.  A procedure was made of this posinfopcsetup
  pc and at were also removed from var list JLU}

 {c3    Commenting out on 6/1/99 from this point to .......}
  //try
    // frmPosInfo.ShowModal;
     //if frmPosInfo.ModalResult = mrOk then begin
        //flrPosAsgnFMMode{flrPosAsgn.FMMode - PDR} := EditEntry;
        //if not (CompareText(StrToFMDate(frmPosInfo.txtPosAsgnDT.AsString),
             //FMAsgn.FMCtrlInternal{FMInternal - PDR 5/98}) = 0) then begin
           //FMAsgn.FMCtrlInternal{FMInternal - PDR 5/98} := StrToFMDate(frmPosInfo.txtPosAsgnDT.AsString);
           //flrPosAsgn.AddChgdControl{Add - PDR}(FMAsgn);
           //cmdPSave.Enabled := true;
           //cmdPCancel.ENabled := true;
           //Changed := true;
        //end;

        //if not (frmPosInfo.txtPosUnAsgnDT.AsString = NULL_DATE) then
           //if not (CompareText(StrToFMDate(frmPosInfo.txtPosUnAsgnDT.AsString),
                //FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98}) = 0) then begin
              //FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98} := StrToFMDate(frmPosInfo.txtPosUnAsgnDT.AsString);
              //flrPosAsgn.AddChgdControl{Add - PDR}(FMUnAsgn);
              //cmdPSave.Enabled := true;
              //cmdPCancel.ENabled := true;
              //Changed := true;
           //end;

        {if not (frmPosInfo.grpType.ItemIndex = StrToInt(FMRole.FMInternal)) then
           begin
           FMRole.FMInternal := IntToStr(frmPosInfo.grpType.ItemIndex);
           flrPosAsgn.Add(FMRole);
           cmdPSave.Enabled := true;
           cmdPCancel.ENabled := true;
           changed := true;
        end;}

        //if frmPosInfo.btnPcOther.Checked then
           //FMRole.FMCtrlInternal{FMInternal - PDR 5/98} := '0'
        //else if frmPosInfo.btnPcPractitioner.Checked then
            //FMRole.FMCtrlInternal{FMInternal - PDR 5/98} := '1'
        //else if frmPosInfo.btnPcAttending.CHecked then
           //FMRole.FMCtrlInternal{FMInternal - PDR 5/98} := '2';

        //If StrToInt(FMRole.FMCtrlInternal{FMInternal - PDR 5/98}) <> OldInternal then begin
           //flrPosAsgn.AddChgdControl{Add - PDR}(FMRole);
           //cmdPSave.Enabled := true;
           //cmdPCancel.ENabled := true;
           //changed := true;
        //end;


        //if changed then begin
           //s1 := FMPosition.Caption + '  ' + FMDateToStr(FMAsgn.FMCtrlInternal{FMInternal - PDR 5/98});
           //if not (FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98} = emptystr) then
              //s1 := s1 + '  ' + FMDateToStr(FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98});
           //lblAdd.Caption := s1;
           //pnlAdd.Visible := true;
        //end;
     //end;
     //finally
        //frmPosInfo.free;
     //end;
     //.....this point using the double forward slashes  jlu}

 {c4    try }
        //frmPosInfo.ShowModal;

        //if frmPosInfo.ModalResult = mrOk then begin
           //flrPosAsgnFMMode{flrPosAsgn.FMMode - PDR} := AddEntry;

           //if not (CompareText(StrToFMDate(frmPosInfo.txtPosAsgnDT.AsString),
                //FMAsgn.FMCtrlInternal{FMInternal - PDR 5/98}) = 0) then begin
             //FMAsgn.FMCtrlInternal{FMInternal - PDR 5/98} := StrToFMDate(frmPosInfo.txtPosAsgnDT.AsString);
              //flrPosAsgn.AddChgdControl{Add - PDR}(FMAsgn);
              //changed := true;
              //cmdPSave.Enabled := true;
              //cmdPCancel.ENabled := true;
           //end;

           //if not (frmPosInfo.txtPosUnAsgnDT.AsString = NULL_DATE) then
              //if not (CompareText(StrToFMDate(frmPosInfo.txtPosUnAsgnDT.AsString),
                   //FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98}) = 0) then begin
                 //FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98} := StrToFMDate(frmPosInfo.txtPosUnAsgnDT.AsString);
                 //flrPosAsgn.AddChgdControl{Add - PDR}(FMUnAsgn);
                //changed := true;
                 //cmdPSave.Enabled := true;
                 //cmdPCancel.ENabled := true;
              //end;

           //if frmPosInfo.btnPcOther.Checked then
              //FMRole.FMCtrlInternal{FMInternal - PDR 5/98} := '0'
           //else if frmPosInfo.btnPcPractitioner.Checked then
              //FMRole.FMCtrlInternal{FMInternal - PDR 5/98} := '1'
           //else if frmPosInfo.btnPcAttending.CHecked then
              //FMRole.FMCtrlInternal{FMInternal - PDR 5/98} := '2';

           //If StrToInt(FMRole.FMCtrlInternal{FMInternal - PDR 5/98}) <> OldInternal then begin
              //flrPosAsgn.AddChgdControl{Add - PDR}(FMRole);
             //cmdPSave.Enabled := true;
              //cmdPCancel.ENabled := true;
              //changed := true;
           //end;

        //if changed then begin
           //s1 := FMPosition.Caption + '  ' + FMDateToStr(FMAsgn.FMCtrlInternal{FMInternal - PDR 5/98});
           //if not (FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98} = emptystr) then
              //s1 := s1 + '  ' + FMDateToStr(FMUnAsgn.FMCtrlInternal{FMInternal - PDR 5/98});
           //lblAdd.Caption := s1;
           //pnlAdd.Visible := true;
           //end;
        //end;
     //finally
        //frmPosInfo.free;
     //end;
  //end;

end.
