{********************************************************************}
{                                                                    }
{                 PCMM Broker/API utility calls                      }
{                                                                    }
{                 Created: 2/16/96                                   }
{                                                                    }
{            Version: 1T9b        Updated 3/1/96                     }
{                                                                    }
{********************************************************************}

unit Scutbrk;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, Buttons, Fmcntrls, Fmcmpnts,
  ExtCtrls, Fmlookup, Scutdef, Trpcb, Mfunstr;

procedure GetTeamList(RPCBroker: TRPCBroker; dfn, bdt, edt, purp: string;
  var Teams: TStringlist);
procedure PatientLookup(RPCBRoker: TRPCBroker; fields, val: string; var FMFind:
   TStrings);
procedure GetActivePositions(RPCBroker: TRPCBroker; Team, dfn, bdt, edt: string;
  var asgnPostions: TStringlist);{jlu}
procedure GetPosMembers(RPCBRoker: TRPCBroker; team, dfn, bdt, edt: string;
  var FMFind: TStringList);
procedure GetPosAssignList(RPCBRoker: TRPCBroker; teamIEN, dfn, bdt, edt: string;
  var FMFind: TStringList); {pdr}
function SendMailMan(RPCBroker: TRPCBroker; Subj, User, Adr: string; Msg:
  TStrings): string;
function GetActiveStaff(RPCBroker: TRPCBroker; FMIen, FMBegin, FMEnd:string):
  string;
function HistoryChangeOk(RPCBroker: TRPCBroker; fileNo, Ien, Hien, date: string;
  var msg: string): boolean;
function NewHistoryOk(RPCBroker: TRPCBroker; fileNo, fileIen, date: string;
  var msg: string): boolean;
function DeleteHistoryOk(RPCBroker: TRPCBroker; fileNo, Ien, Hien: string;
  var msg: string): boolean;
function InactivateHistoryOk(RPCBroker: TRPCBroker; fileNo, Ien, date: string;
  var msg: string): boolean;
function HistoryStatusOk(RPCBroker: TRPCBroker; fileNo, Ien, date: string;
  Status: integer; var msg: string): boolean;
function DeleteEntryOk(RPCBroker: TRPCBroker; recType: TRecType; ien: string;
  var msg: string): boolean;
function MeansTestInfo(RPCBroker: TRPCBroker; dfn: string): string;
function UpdateValue(RPCBRoker: TRPCBroker; fmFile, fmField, fmIens,
  fmValue: string): boolean;
function SecurityKeyOk(RPCBRoker: TRPCBroker; Key: string): boolean;
function CheckUsrClass(RPCBRoker: TRPCBroker; PEntry: string): string;
procedure GetStaffList(RPCBRoker: TRPCBroker; UseCl, UsrClass, val, screen,pc:string;
  var FMFind: TStringList);
function PrimaryCareInfo(RPCBroker : TRPCBroker; dfn, dt, role, ast : string):
  string;
function GetBS5(RPCBroker : TRPCBroker; DFN : String; VAR SSNMessage:Tstringlist): Boolean;
Function CurrentMeansTest(RPCBroker:TRPCBroker;DFN:String; VAR MTMessage:Tstringlist)
:Boolean;
Function SecurityIssue(RPCBroker:TRPCBroker; DFN:String; Var Security:Tstringlist):Boolean;
procedure FireMessage(RPCBroker:TRPCBroker; DFN:String);


implementation

uses xwbut1, scut2;

function PrimaryCareInfo(RPCBroker : TRPCBroker; dfn, dt, role, ast : string): string;
begin
  RPCBroker.remoteProcedure := 'SC PRIMARY CARE TEAM';
  with RPCBroker.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"DFN"'] := dfn;
        Mult['"DATE"'] := dt;
        Mult['"ROLE"'] := role;
        Mult['"AST"'] := ast;
     end;
  RPCBroker.Call;
  result := RPCBroker.Results[0];
end;


procedure GetStaffList(RPCBRoker: TRPCBroker; UseCl, UsrClass, val, screen,pc :string;
  var FMFind: TStringList);
begin
  RPCBroker.remoteProcedure := 'SC STAFF LOOKUP';
  with RPCBroker.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"USRCOK"'] := UseCl;
        if not (UsrClass = emptystr) then
           Mult['"USRCLASS"'] := UsrClass;
        if not (val = emptystr) then
           Mult['"VALUE"'] := val;
        if not (screen = emptystr) then
           Mult['"SCREEN"'] := screen;
        Mult['"PC"'] := PC;
     end;
  RPCBroker.Call;
  if RPCBroker.Results[0] = '[Data]' then begin
     FMFind.Assign(RPCBroker.Results);
     FMFind.Delete(0);
  end;

  if RPCBroker.Results[0] = '[Errors]' then begin
     {}
  end;
end;


function CheckUsrClass(RPCBRoker: TRPCBroker; PEntry: string): String;
begin
  RPCBroker.remoteProcedure := 'SC USER CLASS STATUS';
  with RPCBroker.Param[0] do
     begin
        Value := PEntry;
        Ptype := literal;
      end;
  RPCBroker.Call;
  result := RPCBroker.Results[0];

end;

function SecurityKeyOk(RPCBRoker: TRPCBroker; Key: string): boolean;
begin
  RPCBroker.remoteProcedure := 'SC KEY CHECK';
  with RPCBroker.Param[0] do
     begin
        Value := key;
        Ptype := literal;
      end;
  RPCBroker.Call;
  result := (RPCBroker.Results[0] = '1');
end;


function UpdateValue(RPCBRoker: TRPCBroker; fmFile, fmField, fmIens,
  fmValue: string): boolean;
begin
  RPCBroker.remoteProcedure := 'SC FILE SINGLE VALUE';
  with RPCBroker.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"FILE"'] := fmFile;
        Mult['"FIELD"'] := fmField;
        Mult['"IEN"'] := fmIens;
        Mult['"VALUE"'] := fmValue;
     end;
  RPCBroker.Call;
  result := (RPCBroker.Results[0] = '1');
end;

procedure GetPosMembers(RPCBRoker: TRPCBroker; team, dfn, bdt, edt: string;
  var FMFind: TStringList);
begin
  RPCBroker.remoteProcedure := 'SC POSITION MEMBERS';
  with RPCBroker.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"DFN"'] := dfn;
        if not (bdt = '') then
           Mult['"BEGIN"'] := bdt;
        if not (edt = '') then
           Mult['"END"'] := edt;
        Mult['"TEAM"'] := team;
     end;
  RPCBroker.Call;
  FMFind.Assign(RPCBroker.Results)
end;

procedure GetPosAssignList(RPCBRoker: TRPCBroker; teamIEN, dfn, bdt, edt: string;
  var FMFind: TStringList);
begin
  RPCBroker.remoteProcedure := 'SCMC POSITION ASSIGN LIST';
  with RPCBroker.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"DFN"'] := dfn;
        if not (bdt = '') then
           Mult['"BEGIN"'] := bdt;
        if not (edt = '') then
           Mult['"END"'] := edt;
        Mult['"TEAMASSIGN"'] := teamIEN;
     end;
  RPCBroker.Call;
  FMFind.Assign(RPCBroker.Results)
end;

procedure PatientLookup(RPCBRoker: TRPCBroker; fields, val: string; var FMFind: TStrings);
begin
  RPCBroker.remoteProcedure := 'SC PATIENT LOOKUP';
  with RPCBroker.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"VALUE"'] := val;
       end;

  RPCBroker.Call;
  FMFind.Assign(RPCBroker.Results)
end;

procedure GetActivePositions(RPCBroker: TRPCBroker; Team, dfn, bdt, edt: string; {jlu}
  var asgnPostions: TStringlist);
begin
  RPCBroker.remoteProcedure := 'SC ACTIVE POSITION ASSIGNMENTS';
  {returns FOR EACH ITEM IN LIST:
        ;               PIECE - Description
        ;                 1     IEN of TEAM POSITION FILE(#404.57)
        ;                 2     NAME of Position
        ;                 3     Current effective date
        ;                 4     Pointer to role (403.46)
        ;                 5     Name of Standard role
        ;                 6     Pointer to User Class
        ;                 7     Name of User Class
        ;                 8     IEN of 404.43   }


  with RPCBroker.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"DFN"'] := dfn;
        Mult['"BEGIN"'] := bdt;
        Mult['"END"'] := edt;
        Mult['"TEAM"'] := team;

     end;
  RPCBroker.Call;
  asgnPostions.Assign(RPCBroker.Results)
end;


procedure GetTeamList(RPCBroker: TRPCBroker; dfn, bdt, edt, purp: string;
  var Teams: TStringlist);
begin
  RPCBroker.remoteProcedure := 'SC TEAM LIST';
  { each element in list:
        ;               Piece     Description
        ;                 1       IEN of TEAM file entry
        ;                 2       Name of team
        ;                 3       IEN of file #404.42 (Pt Tm Assignment)
        ;                 4       current effective date
        ;                 5       current inactivate date (if any)
        ;                 6       pointer to 403.47 (purpose)
        ;                 7       Name of Purpose
        ;                 8       Is this the pt's PC Team? }
  with RPCBroker.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"DFN"'] := dfn;

        Mult['"BEGIN"'] := bdt;
       { Mult['"INCL"'] := '0';}
        Mult['"END"'] := edt;
        Mult['"PURP"'] := purp;
     end;
  RPCBroker.Call;
  Teams.Assign(RPCBroker.Results)
end;

{

}
function MeansTestInfo(RPCBroker: TRPCBroker; dfn: string): string;
var
  rtn : string;
begin
  result := '0^No Data Found';
  try
  RPCBroker.ClearParameters := true;
  RPCBroker.RemoteProcedure := 'SC MEAN TEST';
  with RPCBroker.Param[0] do
     begin
        Value  := dfn;
        Ptype  := literal;
     end;

     RPCBroker.Call;
     if RPCBroker.Results.Count > 0 then
        rtn := RPCBroker.Results[0];

     if rtn <> '0' then
        Result := rtn;  
  except
     on E: Exception do
        messagedlg(E.ClassName, mtWarning, [mbOk], 0);
  end;

end;

{
  Call the SC PRTP API to return the active staff member for a position based
  on the beginning and ending dates passed in.

  Input:   RPCBroker   - name of Broker component
           FMIen       - Position Ien
           FMBegin     - Beginning Date (FM format)
           FMEnd       - Ending Date (FM format)

  Returns: IEN^Name

  Default: -1^No Current Staff Member
}
function GetActiveStaff(RPCBroker: TRPCBroker; FMIen, FMBegin, FMEnd:string):
  string;
var
  rtn: string;
begin
  try
	   Result := '-1^No Current Staff Member';
     RPCBroker.RemoteProcedure := 'SC PRTP';
     with RPCBroker.Param[0] do
        begin
           Value       := '.SC';
           Ptype       := list;

           Mult['"IEN"']  := FMIen;
           if not (FMBegin = '') then Mult['"BEGIN"']  := FMBegin;
           if not (fmEnd = '') then Mult['"END"'] := FMEnd;
        end;

     RPCBroker.Call;
     rtn := RPCBroker.Results[0];

     if rtn <> '0' then
        Result := rtn
  except
     on E: Exception do
        begin
           messagedlg(E.ClassName, mtWarning, [mbOk], 0);
           result := '';
        end;
  end;
end;

{
  Call the SC MAILMAN API to generate a mail man message from the application.
  The message is built within the application as a TString list and passed
  into the function along with DUZ of the user currently using the application.
  The address can be either a specific individual, a group, or a lookup on the
  message fields of the Team Position File, #404.57.  The function returns the
  message number to the calling application.

  Input:   RPCBroker   - Name of Broker Component
           Subj        - Message Subject
           User        - User's DUZ
           Adr         - Address:  U^User's Name
                                   G^Group
                                   M^Team

           Msg         - Message in TStringlist

  Return:  Message number: string
}
function SendMailMan(RPCBroker: TRPCBroker; Subj, User, Adr: string; Msg:
  TStrings): string;
var
  i: integer;
begin
  RPCBroker.ClearParameters := true;
  RPCBroker.RemoteProcedure := 'SC MAILMAN';
  with RPCBroker.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

        Mult['"SUBJ"'] := Subj;
        {Mult['"DUZ"'] := User;}
        Mult['"ADDRESS"'] := Adr;
        Mult['"SENDER"'] := '.5';

        for i := 0 to msg.count - 1 do
           begin
              Mult[IntToStr(i+1)] := msg[i];
           end;
     end;

  RPCBroker.Call;

end;

{
  Call the SC CHANGE HISTORY DATE OK API to determine whether or not the date
  of the current history entry can be changed. Pass in the file, file entry,
  and the new date value for the entry.

  The date for any exisiting history entry can be changed, as long as it does
  not conflict with the history dates before and after the entry being changed.

     Input:
        RPCBroker - Name of broker component
        fileNo   - File number (File's 404.52, 404.58, or 404.59 only)
        Ien      - Team or position ien
        Hien      - IEN of the history record being checked
        date     - new date value in FM format

     Return:
        msg      - any error messages returned by the api
        result   - True if ok to change, false if not, boolean value
}
function HistoryChangeOk(RPCBroker: TRPCBroker; fileNo, Ien, Hien, date: string;
   var msg: string): boolean;
var
  rtn: string;
begin
  try
     msg := '';
     RPCBroker.ClearParameters := true;
     RPCBroker.RemoteProcedure := 'SC CHANGE HISTORY OK';
     with RPCBroker.Param[0] do
        begin
           Value       := '.SC';
           Ptype       := list;

           Mult['"FILE"']  := fileNo;
           Mult['"IEN"'] := Ien;
           Mult['"HIEN"'] := Hien;
           Mult['"DATE"'] := date;
        end;

     RPCBroker.Call;
     rtn := RPCBroker.Results[0];
     Result := (Piece(rtn, '^', 1) = '1');

     if Length(Piece(rtn, '^',2)) > 0 then
           msg:= Piece(rtn, '^', 2);
  except
     on E: Exception do
        begin
           messagedlg(E.ClassName, mtWarning, [mbOk], 0);
           result := False;
        end;
  end;
end;

{
  Call the SC NEW HISTORY DATE OK API to determine whether the new history entry
  is ok.  Pass in the file, the current team or position ien, whether this is
  a special insert case (staff positions only), and the date for the history
  entry.  Returns a status of true if ok to add,andany error message returned
  by the API.

  A history date cannot be earlier than any other history date already on file.
  It must be greater than any other existing date.

  Special case for inserting staff assignments (insert flag).

     Input:
        RPCBroker   - Name of broker component
        FileNo      - File number of history file (404.52, 404.58, and 404.59 only)
        FileIen     - current team(file 404.58) or position ien(file's 404.52 or .59)
        insert      - Insert flag. normally 0, 1 is used only with file 404.52
                       for special case of inserting a staff inactivation where
                       there is an inactive entry for a future staff member.
        date      - date of new history entry

     Return:
        msg      - any error messages returned by the api
        result   - True if ok to add, false if not, boolean value
}
function NewHistoryOk(RPCBroker: TRPCBroker; fileNo, fileIen, date: string;
  var msg: string): boolean;
var
  rtn: string;
  s: string;
begin
  try
     msg := '';
     RPCBroker.ClearParameters := true;
     RPCBroker.RemoteProcedure := 'SC NEW HISTORY OK';
     with RPCBroker.Param[0] do
        begin
           Value       := '.SC';
           Ptype       := list;

           Mult['"FILE"']  := fileNo;
           Mult['"IEN"']  := fileIen;
           Mult['"DATE"'] := date;
           {Mult['"STATUS"'] := '';}
        end;

     RPCBroker.Call;
     rtn := RPCBroker.Results[0];
     s := Piece(rtn, '^', 1);
     Result := (Piece(rtn, '^', 1) = '1');

     if Length(Piece(rtn, '^',2)) > 0 then
           msg:= Piece(rtn, '^', 2);
  except
     on E: Exception do
        begin
           messagedlg(E.ClassName, mtWarning, [mbOk], 0);
           result := False;
        end;
  end;
end;
{
  Call the SC DELETE OK API to determine whether or not the history entry can be
  deleted.  Pass in the file and the ien of the file entry. Returns a status
  of true or false, and any error message returned by the API.

     Input:
        RPCBroker - Name of broker component
        fileNo   - File number (File's 404.52, 404.58, or 404.59 only)
        Ien      - Team or position Ien,
        Hien      - IEN of the record being deleted

     Return:
        msg      - any error messages returned by the api
        result   - True if ok to delete, false if not, boolean value
}
function DeleteHistoryOk(RPCBroker: TRPCBroker; fileNo, Ien, Hien: string;
  var msg: string): boolean;
var
  rtn: string;
begin
  try
     msg := '';
     RPCBroker.ClearParameters := true;
     RPCBroker.RemoteProcedure := 'SC DELETE HISTORY';
     with RPCBroker.Param[0] do
        begin
           Value       := '.SC';
           Ptype       := list;

           Mult['"FILE"']  := fileNo;
           Mult['"IEN"']  := Ien;
           Mult['"HIEN"'] := Hien;
        end;

     RPCBroker.Call;
     rtn := RPCBroker.Results[0];

     Result := (Piece(rtn, '^', 1) = '1');

     if Length(Piece(rtn, '^',3)) > 0 then
           msg:= Piece(rtn, '^', 3);
  except
     on E: Exception do
        begin
           messagedlg(E.ClassName, mtWarning, [mbOk], 0);
           result := False;
        end;
  end;
end;

{
  Call the SC INACTIVATE ENTRY API to check whether inactivating an active
  history file entry is ok.

  Teams can only be inactivated only if all positions and staff assignments
  are inactive.

     Input:
        RPCBroker - Name of broker component
        fileNo   - File number (File's 404.58 only)
        Ien      -  Team or position IEN

     Return:
        msg      - any error messages returned by the api
        result   - True if ok to inactivate, false if not, boolean value
}
function InactivateHistoryOk(RPCBroker: TRPCBroker; fileNo, Ien, date: string;
  var msg: string): boolean;
var
  rtn: string;
begin
  try
     msg := '';
     RPCBroker.ClearParameters := true;
     RPCBroker.RemoteProcedure := 'SC INACTIVATE ENTRY';
     with RPCBroker.Param[0] do
        begin
           Value       := '.SC';
           Ptype       := list;

           Mult['"FILE"']  := fileNo;
           Mult['"IEN"']  := Ien;
           Mult['"DATE"'] := date;
        end;

     RPCBroker.Call;
     rtn := RPCBroker.Results[0];

     Result := (Piece(rtn, '^', 1) = '1');

     if Length(Piece(rtn, '^',3)) > 0 then
           msg:= Piece(rtn, '^', 3);
  except
     on E: Exception do
        begin
           messagedlg(E.ClassName, mtWarning, [mbOk], 0);
           result := False;
        end;
  end;
end;


{
  Call the SC HISTORY STATUS OK API to determine whether the new status of the
  history entry is ok.

  There cannot be two consecutive history entries with the same status.  As
  other status values are added, additional checks may need to be made.

      Input:
        RPCBroker - Name of broker component
        fileNo   - File number (File's 404.58 or 404.59)
        Ien      - Team or position IEN.
        status   - integer value of status (see TStatusType in scutdef)

     Return:
        msg      - any error messages returned by the api
        result   - True if ok to change, false if not, boolean value
}
function HistoryStatusOk(RPCBroker: TRPCBroker; fileNo, Ien, date: string;
  Status: integer; var msg: string): boolean;
var
  rtn: string;
begin
  try
     msg := '';
     RPCBroker.ClearParameters := true;
     RPCBroker.RemoteProcedure := 'SC HISTORY STATUS OK';
     with RPCBroker.Param[0] do
        begin
           Value       := '.SC';
           Ptype       := list;

           Mult['"FILE"']  := fileNo;
           Mult['"IEN"']  := Ien;
           Mult['"STATUS"'] := IntToStr(status);
           Mult['"DATE"'] := date;
        end;

     RPCBroker.Call;
     rtn := RPCBroker.results[0];

     Result := (Piece(rtn, '^', 1) = '1');

     if Length(Piece(rtn, '^',2)) > 0 then
        msg:= Piece(rtn, '^', 2);
  except
     on E: Exception do
        begin
           messagedlg(E.ClassName, mtWarning, [mbOk], 0);
           result := False;
        end;
  end;
end;

{
  Check to see if the record can be deleted.  Different record types will have
  different requirements for allowing deletion.  These may be replaced by API
  calls at a later date.
}
function DeleteEntryOk(RPCBroker: TRPCBroker; recType: TRecType; ien: string;
  var msg: string): boolean;
var
  OkToDelete: boolean;
  s: string;
begin
  OkToDelete := true;

  msg := '';

  case recType of
     TTeam: begin
        if CheckGlobal(RPCBroker, '^SCTM(404.57)', 'ATMPOS', ien) > 0 then begin
           OkToDelete := false;
           msg := msg + 'Positions are still assigned.' + RETURN;
        end;
        if CheckGlobal(RPCBroker, '^SCTM(404.58)', 'B', ien) > 0 then begin
           OkToDelete := false;
           msg := msg + 'History entries are entered.' + RETURN;
        end;
        if CheckGlobal(RPCBroker, '^SCPT(404.42)', 'ATMPT', ien) > 0 then begin
           OkToDelete := false;
           msg := msg + 'Patients are assigned to this team.' + RETURN;
        end;
     end;

     TTmHistory: begin
        if CheckGlobal(RPCBroker, '^SCTM(404.57)', 'ATMPOS', ien) > 0 then begin
           OkToDelete := false;
           msg := msg + 'Positions are still assigned.' + RETURN;
        end;

        if CheckGlobal(RPCBroker, '^SCPT(404.42)', 'ATMPT', ien) > 0 then begin
           OkToDelete := false;
           msg := msg + 'Patients are assigned to this team.' + RETURN;
        end;
     end;

     TPos:
        begin
           if CheckGlobal(RPCBroker, '^SCTM(404.59)', 'B', ien) > 0 then
              begin
                 OkToDelete := false;
                 msg := msg + 'History entries are entered.' + RETURN;
              end;
           if CheckGlobal(RPCBroker, '^SCPT(404.43)', 'APTPA', ien) > 0 then
              begin
                 OkToDelete := false;
                 msg := msg + 'Patients are assigned.' + RETURN;
              end;
           if CheckGlobal(RPCBroker, 'SCTM(404.52)', 'B', ien) > 0 then
              begin
                 OkToDelete := false;
                 msg := msg + 'A staff member is still assigned.' + RETURN;
              end;
           s := GlobalNode(RPCBroker, '^SCTM(404.57,'+ ien + ',0)');
           if not (Piece(s, '^', 9) = '') then
              begin
                 OkToDelete := false;
                 msg := msg + 'Clinic assigned.' + RETURN
              end;
        end;

     TPsHistory : begin
        if CheckGlobal(RPCBroker, '^SCPT(404.43)', 'APTPA', ien) > 0 then begin
           OkToDelete := false;
           msg := msg + 'Patients are assigned.' + RETURN;
        end;

        if CheckGlobal(RPCBroker, 'SCTM(404.52)', 'B', ien) > 0 then begin
           OkToDelete := false;
           msg := msg + 'A staff member is still assigned.' + RETURN;
        end;

        s := GlobalNode(RPCBroker, '^SCTM(404.57,'+ ien + ',0)');
        if not (Piece(s, '^', 9) = '') then begin
           OkToDelete := false;
           msg := msg + 'Clinic assigned.' + RETURN
        end;
     end;

     tPatTeam:
        begin
           if CheckGlobal(RPCBroker, '^SCPT(404.43)', 'B', ien) > 0 then
              begin
                 OkToDelete := false;
                 msg := msg + 'There are position assignments associated.' +
                 RETURN;
              end;
        end;
  end;

  if OkToDelete then
     result := true
  else
     begin
        result := false;
        msg := 'The following conditions prevent deletion:' + RETURN + msg;
     end;
end;

Function GetBS5(RPCBroker:TRPCBroker; DFN:String; Var SSNMessage:Tstringlist):boolean;
{This Fucntion will call a MUMPS RPC to determine if there is a duplicate SSN
for the patient defined in DFN.  If yes than the function will return as true.
Else the function returns as false.}


Begin
     Result:=false;
     RPCBroker.RemoteProcedure:='DG CHK BS5 XREF Y/N';
     With RPCBroker do
      Begin
       Param[0].Value:=DFN;
       Param[0].Ptype:=Literal;
       call;
       If results[0]='1' then
        Begin
         result:=true;
         SSNMessage.addstrings(results);
        End;
       End;
End;

Function CurrentMeansTest(RPCBroker:TRPCBroker; DFN:String; VAR MtMessage:
Tstringlist):Boolean;

Begin
 result := false;
 with RPCBroker do
  begin
   RemoteProcedure := 'DG CHK PAT/DIV MEANS TEST';
   Param[0].value := DFN;
   Param[0].Ptype := Literal;
   call;

   try
    if results[0] = '1' then
     begin
      result := true;
      MtMessage.Addstrings(Results);
     end;
   except
   end;
  end;
 {check the MTMessage if no MT requires set result=0}
end;

Function SecurityIssue(RPCBroker:TRPCBroker; DFN:String;
         Var Security:Tstringlist):Boolean;
{this function gets the sensitive record information for this patient.  It is
Checking to see if this patient's record is sensitive or not.}

Begin {main}
 Result:=false;
 With RPCBroker do
  Begin {1}
   Remoteprocedure:='DG SENSITIVE RECORD ACCESS';
   Param[0].value:=DFN;
   Param[0].Ptype:=Literal;
   Call;

   If STRTOINT(Results[0])>0 then
    Begin {2}
     Result:=true;
     Security.addstrings(results);
    End; {2}
   End; {1}
 End; {main}

Procedure FireMessage(RPCBroker:TRPCBroker;DFN:String);
Begin
 With RPCBroker do
  Begin
   RemoteProcedure:='DG SENSITIVE RECORD BULLETIN';
   Param[0].value:=DFN;
   Param[0].Ptype:=literal;
   Call;
  End;
End;

end.
