{*******************************************************************}
{                                                                   }
{   Team profile/setup form for Primary Care Management             }
{   Setup and define teams                                          }
{                                                                   }
{    Scheduling ver 5.3 AUG 13, 1993                                }
{    Management Information Products Group                          }
{    Albany NY (SCK)                                                }
{    Dept. of Veteran Affairs                                       }
{    March 1996                                                     }
{                                                                   }
{    Last updated: 28 May 2002 (J. Peterson)                        }
{                                                                   }
{*******************************************************************}

unit Teamdef1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, Buttons, Fmcntrls, Fmcmpnts, printers,
  Clipbrd, ExtCtrls, Fmlookup, Scut3, Scut2, Scutdef, Tabs, TabNotBk,
  IniFiles, DateTime, Trpcb, Pcmm1, Mask, OvcDT, OvcData, Enterdt,
  Spin, OvcSc, OvcBase, OvcEF, OvcPB, OvcPF, OvcCal, Mfunstr,
  Scutbrk, OvcNbk, OvcDate, ComCtrls {,Gtsize32, GTVASzr - PDR}, Diaccess;


type
  TfrmTeamProfile = class(TForm)
    TeamMenu1: TMainMenu;
    File1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Undo1: TMenuItem;
    NextTeam1: TMenuItem;
    PreviousTeam1: TMenuItem;
    N6: TMenuItem;
    N8: TMenuItem;
    ltrLook: TFMLister;
    ltrInstitution: TFMLister;
    ltrService: TFMLister;
    ltrPurpose: TFMLister;
    lkpLookUp: TFMLookUp;
    ltrReasons: TFMLister;
    getTeamData: TFMGets;
    getHistory: TFMGets;
    flrTHistory: TFMFiler;
    flrTeamData: TFMFiler;
    ValTeam: TFMValidator;
    valHistory: TFMValidator;
    cmdClose: TBitBtn;
    cmdSave: TBitBtn;
    cmdUndo: TBitBtn;
    cmdHelp: TBitBtn;
    oldtabTeam: TTabbedNotebook;
    ltrPrinter: TFMLister;
    Alternate: TPopupMenu;
    Undo3: TMenuItem;
    N5: TMenuItem;
    New2: TMenuItem;
    Open3: TMenuItem;
    NextTeam2: TMenuItem;
    PreviousTeam2: TMenuItem;
    Save3: TMenuItem;
    ltrstatus: TFMLister;
    OvcController1: TOvcController;
    imgNo: TImage;
    imgYes: TImage;
    N4: TMenuItem;
    AutoLinks1: TMenuItem;
    N2: TMenuItem;
    getUpdate: TFMGets;
    hdrTeam: THeader;
    pnlCalendar: TPanel;
    Calendar: TOvcCalendar;
    tabTeam: TOvcNotebook;
    lblName: TLabel;
    txtTeamName: TFMEdit;
    lblPhone: TLabel;
    txtPhone: TFMEdit;
    Label9: TLabel;
    txtDescription: TFMMemo;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Bevel1: TBevel;
    lblEffective: TFMLabel;
    Label4: TLabel;
    Bevel2: TBevel;
    lblCurrentInact: TFMLabel;
    cmdAutoLink: TBitBtn;
    cmdPosition: TBitBtn;
    lblPurpose: TLabel;
    cboPurpose: TFMComboBox;
    lblService: TLabel;
    cboService: TFMComboBoxLookUp;
    lblInstitution: TLabel;
    cboInstitution: TFMComboBoxLookUp;
    Label1: TLabel;
    cboDevice: TFMComboBoxLookUp;
    Bevel5: TBevel;
    chkCare: TFMCheckBox;
    chkRestrict: TFMCheckBox;
    chkClosed: TFMCheckBox;
    lstStatus: TFMListBox;
    Label6: TLabel;
    Bevel4: TBevel;
    Label2: TLabel;
    txtStatusDate: TOvcPictureField;
    lblStatusDate: TFMLabel;
    cboStatus: TFMComboBox;
    Label8: TLabel;
    Label5: TLabel;
    cboReasons: TFMComboBox;
    Bevel9: TBevel;
    cmdStatusOk: TBitBtn;
    cmdStatusCancel: TBitBtn;
    cmdStatusAdd: TBitBtn;
    cmdStatusDelete: TBitBtn;
    chkAutoAssign: TFMCheckBox;
    chkAutoDischarge: TFMCheckBox;
    GroupBox2: TGroupBox;
    lblAllowed: TLabel;
    txtAllowed: TFMEdit;
    lblActualHdr: TLabel;
    lblActual: TFMLabel;
    fwSpinDate: TOvcSpinner;
    DeleteHistory: TMenuItem;
    RemoveTeam1: TMenuItem;
    N1: TMenuItem;
    {GTVAForm1: GTVAForm - PDR; }
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure cmdPositionClick(Sender: TObject);
    procedure TextExit(Sender: TObject);
    procedure txtDescriptionExit(Sender: TObject);
    procedure txtTeamNameExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure MenuUpdate(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure CheckClick(Sender: TObject);
    procedure cboExit(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrintSetup1Click(Sender: TObject);
    procedure NextTeam1Click(Sender: TObject);
    procedure PreviousTeam1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure cmdOkClick(Sender: TObject);
    procedure lstStatusDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure lstStatusMeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure lstStatusDblClick(Sender: TObject);
    procedure cboStatusChange(Sender: TObject);
    procedure cboChangeItem(Sender: TObject);
    procedure cmdAddClick(Sender: TObject);
    procedure cboReasonsChange(Sender: TObject);
    procedure TextChange(Sender: TObject);
    procedure LookUpChange(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmdStatusCancelClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure txtStatusDateExit(Sender: TObject);
    procedure lstStatusKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure txtStatusDateDblClick(Sender: TObject);
    procedure calendarClick(Sender: TObject);
    procedure txtStatusDateKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure calendarKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cboKeyCheck(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AutoLinks1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    Procedure NewButtonClick(Sender: TObject);
    Procedure OpenButtonClick(Sender: TObject);
    procedure cboEnter(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ChangeMonth(Sender: TObject);
    procedure RPCBroker1NetError(Sender: TObject; var Error: EBrokerError);
    procedure SaveAltClick(Sender: TObject);
    procedure DeleteHistoryClick(Sender: TObject);
    procedure tabTeamPageChange(Sender: TObject; Index: Integer;
      var AllowChange: Boolean);
    procedure cboInstitutionEnter(Sender: TObject);
 private
    { Private declarations }
    HList : TStringList;
    NetError, debug, DeleteKey : boolean;
    {PDR 5/27/98}
    HistorySelected:integer;
    txtTeamNameFMFilerFMMode:FMModes;
    flrTHistoryFMMode:FMModes;
    flrTeamDataFMMode:FMModes;
    TFMMemoFMFilerFMMode:FMModes;
    procedure OpenNew;
    procedure OpenExisting;
    procedure InitFMChk;
    function RvwActFutTmAsgn(RPCBroker: TRPCBroker; FromTeam, DtBegin, DtEnd, DtDate: string): boolean;


 public
    { Public declarations }
    TmProfile : TProfile;
    Procedure ModifyName(obj: TObject);
    function GetTeam: boolean;
    procedure UnlockTeam;
    procedure LoadHistory;
    procedure GetNextTeam(s1: string; direction: char);
    procedure SetSave(status: Boolean);
    procedure SetUpNewTeam(s1: string);
    procedure StubStatus;
    procedure LoadSettings;
    procedure OpenTeam(AllowNew: Boolean);
    procedure DisableHistory(Status: boolean);
    procedure SetStatusButtons(Sok: boolean; Scnl: boolean; Sadd: boolean;
              Sdel: boolean);
    procedure ClearEditFields;
    procedure RunForm;
    function OkToDeleteStatus: boolean;
    function StatusDateChangeOk: boolean;
    function StatusReasonChangeOk: boolean;
    function StatusChangeOk(status: integer): boolean;
    function ConfirmNewName(s1: string): boolean;
    function CheckRequired(var msg: string; var flag: boolean): boolean;
    function CheckReqd: boolean;

  end;

  var
     OldProfile: TProfile;
     SaveExitProc: pointer;
     frmTeamProfile: TfrmTeamProfile;
     NewStatusFlag, NoTeam: bool;
     SendTo: string;

Const
     NUM_RETURN = 200;
implementation


uses Pstndef1, typinfo, Autosel,
  DiTypLib, dischargememo, scpttmf;

{$R *.DFM}

procedure TfrmTeamProfile.InitFMChk;  {PDR}
begin
 if chkCare.FMCtrlInternal='' then
  begin
   chkCare.State := cbUnchecked;
   flrteamdata.AddChgdControl(chkCare);
  end;
 if chkRestrict.FMCtrlInternal='' then
  begin
   chkrestrict.State := cbUnchecked;
   flrteamdata.AddChgdControl(chkRestrict);
  end;
 if chkClosed.FMCtrlInternal='' then
  begin
   chkClosed.State := cbUnchecked;
   flrteamdata.AddChgdControl(chkClosed);
  end;
 if chkAutoAssign.FMCtrlInternal='' then
  begin
   chkAutoAssign.State := cbUnchecked;
   flrteamdata.AddChgdControl(chkAutoAssign);
  end;
 if chkAutoDischarge.FMCtrlInternal='' then
  begin
   chkAutoDischarge.State := cbUnchecked;
   flrteamdata.AddChgdControl(chkAutoDischarge);
  end;
end;

{ ===============   Form Start Up  ===================================}

procedure TfrmTeamProfile.FormCreate(Sender: TObject);
begin
  Font.Assign(FrmMain.FontDialog1.Font);
  tabTeam.Font := Font;
  tabTeam.PageIndex := 0;

  top := 10;
  left := (frmMain.ClientWidth - width) div 2;
  Hlist := TStringList.create;
  NetError := false;

  frmMain.Teamsetup1.enabled := false; {change}
  frmMain.cmdTeam.enabled := false;
  frmMain.ShowMenu := false;
  
end;


procedure TfrmTeamProfile.RunForm;
begin
  cboPurpose.GetList;
  cboReasons.GetList;

  if tmProfile.TeamIen = NEW_ENTRY then
     OpenNew
  else
     OpenExisting;

  LoadSettings;
  SetSave(False);
  frmTeamProfile.enabled := true;
end;

procedure TfrmTeamProfile.FormResize(Sender: TObject);
begin
  Clientwidth := 480;
end;


{
  Load default user settings from user file and/or INI file.
}
procedure TfrmTeamProfile.LoadSettings;
begin
  debug := FrmMain.Debug;
  DeleteKey := frmMain.DeleteEnabled;{SecurityKeyOk(RPCBrokerMain, DELETE_KEY);}
  cmdAutoLink.Enabled := frmMain.AlnkEnabled;
end;

{ **** Updated  1/8/96
  Set Header
}
procedure TfrmTeamProfile.FormShow(Sender: TObject);
begin
  hdrTeam.Sections[1] := 'No Selection';
  fwSpinDate.Height := txtStatusDate.Height;
end;

{ **** Updated 1/8/96
  Disconnect from network and release the memory resources used by the
  form when the form is closed.  Disable tool bar speed buttons and
  set their on click events to  null.
}
procedure TfrmTeamProfile.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  frmMain.cmdTeam.enabled := true;
  frmMain.TeamSetup1.enabled := true;
  frmMain.ShowMenu := true;
  
  Action := cafree;
end;

{
  When closing the form, check for any changes that have not been saved.
  If it's ok to close, then unlock the team and set the CanCLose var to
  true.
}
procedure TfrmTeamProfile.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
     Case CheckSave(flrTeamData) of
        Save: begin
                 Save1Click(Sender);
                 CanClose := false;
              end;
        Abort: CanClose := false;
     end;

     if CanCLose then
        if TMProfile.TeamIen <> '' then UnLockTeam;
end;

{
  Convert letters to uppercase except for keypresses from inside memo
  components. If the active control is a Comboboxlookup, and the key
  pressed is a return key, then set the key to null (#0).
}
procedure TfrmTeamProfile.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key  = #13 then
     if (ActiveControl is TFMComboBoxLookUp) then
        Key := #0;

  if not (ActiveControl is TFMMemo) then
     Key := UpCase(Key);

end;

{
  trap when the Ctrl + Alt key combination is pressed and display the
  menu.
}
procedure TfrmTeamProfile.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key = VK_F10) and (Shift = [ssShift])  then
        sendMessage(Handle, WM_RBUTTONDOWN, 0, 0)
end;



{ ================  Menu Actions ==================================}


{ **** New procedure 1/9/96
  On click event assigned to toolbar New button when the team form is
  active
}
Procedure TfrmTeamProfile.NewButtonClick(Sender: TObject);
begin
  if New1.enabled then New1Click(Sender);
end;

{  **** New procedure 1/9/96
  On click event assigned to the toolbar Open button when the team
  form is active.
}
Procedure TfrmTeamProfile.OpenButtonClick(Sender: TObject);
begin
  if Open1.enabled then Open1Click(Sender);
end;


{ updated 1/11/96
  Check for any positions  and any history entries associated with the
  current team.  If any exist, exit without processing deletion.
  Confirm deletion before proceeding.
}
procedure TfrmTeamProfile.Delete1Click(Sender: TObject);
var
  msg: string;
  s: string[30];
begin
  MSG := '';
  if not DeleteEntryOk(RPCBrokerMain, TTeam, tmProfile.Teamien, msg) then begin
     if not (length(msg) > 0) then
        msg := 'This team cannot be deleted!';
     messagedlg(msg, mtInformation, [mbOk,mbHelp], 80000);
     exit;
  end;

  s := txtTeamName.Text;
  if messageDlg('You are about to delete the ' + s + ' Team' + RETURN +
                'Do you want to do this?', mtConfirmation, [mbYes,mbCancel], 0)
                 = mrYes then begin
     UnLockTeam;
     if Deleter(RPCBrokerMain, '^SCTM(404.51,', txtTeamName.FMFile{FMEntry - PDR}) then begin
        flrTeamData.Clear;
        getHistory.ClearCtrlData{cleardata - PDR};
        GetNextTeam(TmProfile.TeamName, 'B');
        setSave(False);
        frmMain.StatusMsg(s + ' was deleted.', false);
     end
     else
        messageDlg('There was a problem deleting this team.', mtWarning,
                  [mbOk,mbHelp], 80000);
  end;
end;

{
  Exit form after confirming any saves.
}
procedure TfrmTeamProfile.Exit1Click(Sender: TObject);
begin
  close;
end;

{
  Open another team setup.  Check to see if any current changes have
  been saved before proceeding.  Setup the team lister for the lookup
  dialog, and then call the lookup.  If a team has been selected, then
  get the teams record and fill in the data.
}
procedure TfrmTeamProfile.Open1Click(Sender: TObject);
begin
  if not (TmProfile.TeamIen = NEW_ENTRY) then
     Case CheckSave(flrTeamData) of
        Save: cmdSave.Click;
        Abort: exit;
     end;

  OpenTeam(false);

  setSave(False);
  flrTeamData.Clear;
  flrTHistory.clear;
  tabTeam.PageIndex := 0;
  if tabTeam.PageIndex = 0 then
     txtPhone.Setfocus;
end;


{  updated 1/22/96
  Saves changes.  If the record is a new record (AddEntry), then
  find the IEN for newly created record and update the FMEntry
  property of the data components to reflect the new IEN.  Once
  the team profile changes have been made, then process the history
  changes.
}
procedure TfrmTeamProfile.Save1Click(Sender: TObject);
var
  ien, LockTeam, xmz: string[25];
  msg: string;
  flag: boolean;
begin
  Perform(WM_NEXTDLGCTL, 0, 0);

  if CheckRequired(msg, flag) then
     begin
        if flag then
           begin
              if messageDlg(msg, mtWarning, [mbYes,mbCancel,mbHelp], 80000)
                           = mrYes then
                 begin
                    tabTeam.PageIndex := 2;
                 end;
           end
        else
           begin
              messageDlg(msg, mtWarning, [mbOk,mbHelp], 80000);
              cmdSave.enabled := false;
           end;

        exit;
     end;

  if (flrTeamData.AnythingToFile{Status = Edited - PDR}) then
     if flrTeamData.Update then
        begin
           frmMain.StatusMsg('>> Changes to ' + tmProfile.TeamName
              + ' saved.', false);
           if flrTeamDataFMMode{flrTeamData.FMMode - PDR} = AddEntry then
              begin
                 ien := flrTeamData.FindIen(NEW_ENTRY + ',');
                 getTeamData.StuffIENS(ien);{SetEntryNumber(ien); - PDR}
                 TmProfile.TeamIen := ien;

                 LockTeam := '^SCTM(404.51,' + TmProfile.TeamIen + ')';
                 If not locker(RPCBrokerMain, LockTeam, LockANode, 5) then
                    frmMain.StatusMsg('This team cannot be locked at this time',
                                      false);
              end;
        end
     else
        messageDlg('Record was not updated!', mtWarning, [mbOk,mbHelp], 80000);

  if not lstStatus.enabled then
     begin
        cmdOkClick(nil);
        lstStatus.enabled := true;
     end;


  { Disable controls}
  frmMain.cmdNew.enabled := true;
  frmMain.cmdOpen.enabled := true;
  cmdPosition.Enabled := true;
  if frmMain.alnkEnabled then cmdAutoLink.Enabled := true; {PDR}

  {disable menu items}

  New1.enabled := true;
  New2.enabled := true;
  NextTeam1.enabled := true;
  NextTeam2.enabled := true;
  PreviousTeam1.enabled := true;
  PreviousTeam2.enabled := true;
  AutoLinks1.enabled := frmMain.AlnkEnabled;
  RemoveTeam1.Enabled := true;
  Open1.enabled := true;
  Open3.enabled := true;

  Screen.Cursor := crDefault;
  flrTeamDataFMMode{flrTeamData.FMMod - PDR} := EditEntry;
  flrTHistoryFMMode{flrTHistory.FMMode - PDR} := EditEntry;
  NewStatusFlag := false;
  getTeamData.IENS := TmProfile.TeamIen;
  getTeamData.GetAndFill;
  SetSave(false);
  SetStatusButtons(false, false, true, false);
End;


{
     Alternate save method to try out the calendar form.
}
procedure TfrmTeamProfile.SaveAltClick(Sender: TObject);
var
  ien, LockTeam, debugstr : string[25];
  msg: string;
  flag: boolean;
  i : integer;
begin
  Perform(WM_NEXTDLGCTL, 0, 0);

  if CheckRequired(msg, flag) then begin
     if flag then begin
        if messageDlg(msg, mtWarning, [mbYes,mbCancel,mbHelp], 80000) = mrYes then
           tabTeam.PageIndex := 2;
     end
     else begin
        messageDlg(msg, mtWarning, [mbOk,mbHelp], 80000);
        cmdSave.enabled := false;
     end;
     exit;
  end;

  if not (flrTeamData.AnythingToFile{) Status = Edited - PDR}) then exit;

  if flrTeamData.Update then begin
     frmMain.StatusMsg(' Changes to ' + tmProfile.TeamName + ' saved.', false);

     if flrTeamDataFMMode{flrTeamData.FMMode - PDR} = AddEntry then begin
        ien := flrTeamData.FindIen(NEW_ENTRY + ',');
        getTeamData.StuffIENS(ien);{SetEntryNumber(ien); - PDR}
        TmProfile.TeamIen := ien;

        if not (TmProfile.TeamIen = emptystr) then begin
           frmEnterDate.Caption := 'Enter Team Activation Date:';
           frmEnterDate.ShowModal;

           if frmEnterDate.ModalResult = mrOk then begin
              lblStatusDate.FMCtrlInternal{FMInternal - PDR} := frmEnterDate.FMDate;
              flrTHistory.AddFDA('404.58',NEW_ENTRY,'.01', TmProfile.TeamIen);{key('404.58', '.01', TmProfile.TeamIen); - PDR}
              flrTHistory.AddChgdControl(cboStatus);{Add(cboStatus); - PDR}
              flrTHistory.AddChgdControl(cboReasons);{Add(cboReasons); - PDR}
              flrTHistory.AddChgdControl(lblStatusDate);{Add(lblStatusDate); - PDR}

              if (flrTHistory.Update) then
                    frmMain.StatusMsg('  History Saved', false)
              else
                 messageDlg('Unable to save History entry at this time', mtWarning,
                             [mbOk,mbHelp], 80000);

              tabTeam.Pages[2].Enabled := true;
           end;
        end;
     end;
  end
  else
        messageDlg('Record was not updated!', mtWarning, [mbOk,mbHelp], 80000);

  cmdPosition.Enabled := true;
  New1.enabled := true;
  New2.enabled := true;
  NextTeam1.enabled := true;
  NextTeam2.enabled := true;
  PreviousTeam1.enabled := true;
  PreviousTeam2.enabled := true;
  AutoLinks1.enabled := frmMain.AlnkEnabled;
  Open1.enabled := true;
  Open3.enabled := true;

  Screen.Cursor := crDefault;
  flrTeamDataFMMode{flrTeamData.FMMode - PDR} := EditEntry;
  flrTHistoryFMMode{flrTHistory.FMMode - PDR} := EditEntry;
  NewStatusFlag := false;

  if not (TmProfile.TeamIen = EmptyStr) then begin
     getTeamData.IENS := TmProfile.TeamIen;
     getTeamData.GetAndFill;
     loadHistory;
  end;

  cmdSave.Caption := 'Sa&ve';
  SetSave(false);
  SetStatusButtons(false, false, true, false);
end;


{   **** Updated 1/9/96  to use FM Required
   Check for any required fields that are not filled in.  Those fields
   missing data, turn their edit box light blue and add their name to
   the list to be displayed to the user.
}
function TfrmTeamProfile.CheckRequired(var msg: string; var flag: boolean): boolean;
var
  i: integer;
begin
  msg := '';
  result := false;
  flag := false;

  for i := 0 to ComponentCount - 1 do begin

     if Components[i]is TFMEdit then begin
        if TFMEdit(Components[i]).FMRequired and
           (TFMEdit(Components[i]).text = '') then
              begin
                 TFMEdit(Components[i]).Color := clYellow;
                 msg := msg + RETURN + TFMEdit(Components[i]).FMDisplayName;
              end;
        end

     else if Components[i] is TFMComboBox then
        begin
           if TFMComboBox(Components[i]).FMRequired and
                         (TFMComboBox(Components[i]).text = '') then
              begin
                 TFMComboBox(Components[i]).Color := clYellow;
                 msg := msg + RETURN + TFMComboBox(Components[i]).FMDisplayName;
              end;
        end

     else if Components[i] is TFMComboBoxLookUp then
        begin
           if TFMComboBoxLookUp(Components[i]).FMRequired and
                               (TFMComboBoxLookUp(Components[i]).text= '')then
              begin
                 TFMComboBoxLookUp(Components[i]).Color := clYellow;
                 msg := msg + RETURN +
                        TFMComboBoxLookUp(Components[i]).FMDisplayName;
              end;
         end;
     end;

  if Length(msg) > 0 then
     begin
        if Length(msg) < 200 then
           msg := 'The following fields are required:' + msg
        else
           msg := 'Please check all edit fields to make sure they are complete.';
     end;

  result := (Length(msg) > 0);
end;

{
  Create a new team.  Check for any current changes and save or skip
  changes.  Save off old team profile in case of an undo action.  Get
  a new team name.  If cancelled then exit without further processing,
  otherwise, validate the new team name.  If valid then continue.
}
procedure TfrmTeamProfile.New1Click(Sender: TObject);
var
  s: string;
  LockTeam: string[50];
begin
  Case CheckSave(flrTeamData) of
     Save: cmdSave.Click;
     Abort: exit;
  end;

  if txtTeamNameFMFilerFMMode{txtTeamName.FMFiler.FMMode} <> EditEntry then exit;

  if TmProfile.TeamIen <> '' then UnlockTeam;
  OldProfile := TmProfile;
  tabTeam.PageIndex := 0;

  repeat
     s := '';
     if not InputQuery('New Team Name', 'Enter name for new team:', s) then
        begin
           noteam := true;
           exit;
        end;
  until ConfirmNewName(Uppercase(s));


  if noteam then
     begin
        LockTeam := '^SCTM(404.51,' + TmProfile.TeamIen + ')';
        {if not Locker(RPCBrokerMain, LockTeam, LockANode, 5) then
           messagedlg('Problem re-locking active team', mtWarning, [mbok], 0);}
        noteam := false;
     end;
end;

{
  Undo any changes that were made to the team's profile.  Clear the
  FMFiler's transaction list, and retreive the teams original data.
  If adding a new team, then reload previous teams profile and reload
  team.
}
procedure TfrmTeamProfile.Undo1Click(Sender: TObject);
var
  i: integer;
begin
  if not (TmProfile.TeamIen = NEW_ENTRY) then
     begin
        getTeamData.GetAndFill;
        loadHistory;
        tabTeam.Pages[2].Enabled := true;
     end
  else if not (OldProfile.TeamIen = emptyStr) then
     begin
        TmProfile := OldProfile;
        getTeamData.IENS := TmProfile.TeamIen;
        getTeamData.GetAndFill;
        loadHistory;
        tabTeam.Pages[2].Enabled := true;
     end
  else
     begin
        TmProfile.TeamIen := emptyStr;
        Open1Click(sender);
     end;

  flrTeamData.Clear;
  flrTeamDataFMMode{flrTeamData.FMMode - PDR} := EditEntry;
  flrTHistory.Clear;
  flrTHistoryFMMode{flrTHistory.FMMode - PDR} := EditEntry;

  hdrTeam.Sections[1] := tmProfile.TeamName;
  ClearEditFields;
  SetStatusButtons(false, false, true, false);
  cmdSave.Caption := 'Sa&ve';
  SetSave(false);
  cmdPosition.enabled := true;
  cmdAutoLink.enabled := frmMain.AlnkEnabled;
end;


procedure TfrmTeamProfile.Print1Click(Sender: TObject);
begin
  NotYet;
end;

procedure TfrmTeamProfile.PrintSetup1Click(Sender: TObject);
begin
  NotYet;
end;

{
  Get the next team from DHCP.

  Input: s1: string, The current team name.
         direction: character value, either 'F', for the next team
         or 'B' for the previous team.
}
procedure TfrmTeamProfile.GetNextTeam(s1: string; direction: char);
begin
  with ltrLook do
     begin
        FromList.clear; {pdr}
        FromList.insert(0,s1);{From := s1; - PDR}
        PartList.clear; {pdr}
        PartList.insert(0,emptyStr);{Part := emptyStr; - PDR}
        Results.Clear;
        Number := '1';

        if direction = 'F' then
           {Flags := 'SP' - DO nothing PDR}
        else
           ListerFlags := [lfBackwards];{Flags := 'SPB';  - PDR}

        GetMore(nil);
        if Results.Count >0 then
           begin
              SetSave(False);
              UnlockTeam;
              TmProfile.TeamIen := Piece(GetFMDelimRec(ltrLook,0),U,1);{results[0], U, 1); - PDR}
              GetTeam;
           end;

        {  Reset the ltrLook component  }
        Number := '*';
        ListerFlags:=[];{Flags := 'SP'; - PDR}
        FromList.clear; {pdr}
        FromList.insert(0,emptyStr);{From := emptyStr; - PDR}
        Results.Clear;
     end;
  SetSave(False);
end;

{
  initiate call for the next team
}
procedure TfrmTeamProfile.NextTeam1Click(Sender: TObject);
begin
  GetNextTeam(txtTeamName.Text, 'F');
end;

{
  initiate call for the previous team
}
procedure TfrmTeamProfile.PreviousTeam1Click(Sender: TObject);
begin
  GetNextTeam(txtTeamName.Text, 'B');
end;

{
  Call the help file contents page.
}
procedure TfrmTeamProfile.Contents1Click(Sender: TObject);
begin
  case tabTeam.pageIndex of
     0: Application.HelpContext(41210);
     1: Application.HelpContext(41220);
     2: Application.HelpContext(41230);
     else
      Application.HelpContext(41200);
  end;

end;


{ ==================================================================}
{                   Tab page components                             }
{ ==================================================================}


{
  ====================  General   ===================================
}

{
  Process changes to the Team's name depending on whether in Edit or
  Add mode.  If not in either node, reset name to original value.  If
  the undo button is the control activated, then ignore any further
  processing and exit.
}
procedure TfrmTeamProfile.txtTeamNameExit(Sender: TObject);
begin
  if (ActiveControl = cmdUndo) or not (txtTeamName.FMModified) then exit;
	with txtTeamName do
  	     begin
              case txtTeamNameFMFilerFMMode{FMFiler.FMMode - PDR} of
                   EditEntry : if Modified then ModifyName(Sender);
                   AddEntry :  if Modified then ModifyName(Sender);  {Added 12/19/96 - RV}
                   {AddEntry : exit; }
              else
                   text := FMTag;
              end;

             {Added 1/29/97 - Corrects SAVE/CLOSE behavior problems - RV}
             if ActiveControl = cmdSave then
                  if FMModified then
                    Save1Click(Sender)
                  else
                    txtTeamName.SetFocus ;

             if ActiveControl = cmdClose then
                  if FMModified then
                    Exit1Click(Sender)
                  else
                    txtTeamName.SetFocus ;
             { End of new code 1/29/97 - RV}

     end;
end;

{
  Add the memo field to the transaction list for processing when the update
  method is called.
}
procedure TfrmTeamProfile.txtDescriptionExit(Sender: TObject);
begin
  with (Sender as TFMMemo) do
     begin
      if FMModified then
           begin
            if TFMMemoFMFilerFMMode{FMFiler.FMMode - pdr} = AddEntry then
             IENS{FMEntry - PDR} := NEW_ENTRY;
  	    FMFiler.AddchgdControl(sender);{Add(Sender); - PDR}
           end;
     end;
end;

{
  Call the team positions form to edit positions assigned to the team.
  Pass in the current team.  If the team is new and has not been saved
  (AddEntry)then save the team to generate the required IEN before
  proceeding.
}
procedure TfrmTeamProfile.cmdPositionClick(Sender: TObject);
var
  curProfile : TProfile;
begin
  cmdPosition.enabled := false;
  curProfile := TmProfile;
  curProfile.Parent := frmTeamProfile;

  Application.CreateForm(TfrmAssigned, frmAssigned);
  Application.ProcessMessages;
  {frmAssigned.enabled := false;}
  frmAssigned.PsProfile := curProfile;
  frmAssigned.RunForm;
  frmAssigned.enabled := enabled;
end;



{ =======================  Status Log  ==========================}

{
  display the status information for the date entry in the list box that
  is clicked.  trap any list errors.
}
procedure TfrmTeamProfile.lstStatusDblClick(Sender: TObject);
begin
  try
     getHistory.IENS := Piece(Hlist[lstStatus.ItemIndex], '^', 1);
     historyselected:=lstStatus.ItemIndex; {PDR}
     getHistory.GetAndFill;
     flrTHistoryFMMode{flrTHistory.FMMode - PDR} := EditEntry;

     DisableHistory(false);
     cbostatus.itemindex := cbostatus.items.indexof(cbostatus.fmdbexternal); {PDR}
     cboStatus.enabled := false;

     SetStatusButtons(false, true, false, true);
     txtStatusDate.AsOvcDate :=
             DateTimeToOvcDate(FromFMDateTime(lblStatusDate.FMCtrlInternal{FMInternal - PDR}, false));
  except
     on E: Exception do
        messagedlg('Error: ' + E.Classname + ' in status list', mtWarning,
                   [mbOk], 0);
  end;

end;

{
  display icons in the history list box.
}
procedure TfrmTeamProfile.lstStatusDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  bm: TBitmap;
begin
  with (Control as TFMListBox).Canvas do
     begin
        FillRect(Rect);
        bm := TBitmap(lstStatus.Items.Objects[Index]);

        if bm <> nil then
           begin
              BrushCopy(Bounds(Rect.Left + 2, Rect.Top + 2, bm.Width,
                 bm.Height), bm, Bounds(0, 0, bm.Width, bm.Height),
                 clBackground);
              TextOut(Rect.Left + 2 + bm.width, Rect.Top + 2,
                 lstStatus.Items[index]);
           end;
     end;
end;

{
  if the Spacebar is pressed while in the Status listbox, initiate the
  click event to select and load the highlighted entry.
}
procedure TfrmTeamProfile.lstStatusKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i: integer;
begin
  if Key = VK_SPACE then
     begin
        i := lstStatus.ItemIndex;
        lstStatusDblCLick(Sender);
        lstStatus.ItemIndex := i;
     end;
end;


{
  set the height of the entries in the status list.
}
procedure TfrmTeamProfile.lstStatusMeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
  Height := 20;
end;

{  updated 1/11/96
  On exiting the date edit field, hide the calendar if it's still
  visible.  Exit the procedure if the next active gadget is the
  cancel button.  If the date entered is valid, and is different
  from the status date, then update the status date and set the
  Ok and Cancel buttons enabled properties.
}
procedure TfrmTeamProfile.txtStatusDateExit(Sender: TObject);
begin
  if cmdStatusCancel.focused then exit;
  if Calendar.focused then exit;

  if pnlCalendar.Visible then
        pnlCalendar.visible := false;

 if (CompareText(StrToFMDate(txtStatusDate.asString),
     lblStatusDate.FMCtrlInternal{FMInternal - PDR} ) = 0) then exit;


  if txtStatusDate.isValid then begin
     if StatusDateChangeOk then begin
        if not NewStatusFlag then begin
           if messagedlg('You are changing an existing date.  This' + RETURN +
                         'may cause problems with other applications.' + RETURN +
                         'Please see HELP for additional information.' + RETURN +
                         'Do you wish to change it now?', mtConfirmation,
                         [mbYes,mbCancel,mbHelp], 80000) = mrCancel then
              begin
                 txtStatusDate.AsString := FMToStr(lblStatusDate.FMCtrlInternal{FMInternal - PDR});
                 exit;
              end;
        end;

        lblStatusDate.FMCtrlInternal{FMInternal - PDR} := ShortDateToFM(StrToDate(txtStatusDate.AsString));
        cmdStatusOk.enabled :=  ((cboReasons.ItemIndex > -1) and (cboStatus.ItemIndex > -1));
     end
  else
     if tabTeam.PageIndex = 2 then
        txtStatusDate.Setfocus;
  end
  else
     if tabTeam.PageIndex = 2 then
        txtStatusDate.Setfocus;
end;


{
  If adding a new history entry, ensure that the date entered is NOT before any
  other history date for the team.

  If changing the date for an existing history entry, check that the date
  does not conflict with any other history entries.
}
function TfrmTeamProfile.StatusDateChangeOk: boolean;
var
  msg: string;
begin
 result:=false;
 if HistorySelected < 0 then exit; {PDR}
  if NewStatusFlag then
     result := NewHistoryOk(RPCBrokerMain, cboStatus.FMFile, tmProfile.TeamIen,
                            StrToFMDate(txtStatusDate.AsString),  msg)
  else
     result := HistoryChangeOk(RPCBrokerMain, cboStatus.FMFile, tmProfile.TeamIen,
        Piece(Hlist[HistorySelected{lstStatus.ItemIndex - PDR}], '^', 1),
              StrToFMDate(txtStatusDate.AsString), msg);

  if length(msg) > 0 then
     frmMain.StatusMsg(msg, true);
end;


{
  select the appropriate reason from the list of available items.  If the
  effective date and status fields have values, and it's ok to change the
  reason, then enable the ok button.  In the present system, there are no
  restrictions on changing the reason entry.
}
procedure TfrmTeamProfile.cboReasonsChange(Sender: TObject);
begin
  with cboReasons do
     if (ItemIndex > -1) then begin
        FMCtrlInternal{FMInternal - PDR} := Piece(GetFMDelimREc(FMLister,ItemIndex), '^', 1);{Piece(FMLister.Results[ItemIndex], '^', 1); - PDR}
        if StatusReasonChangeOk then begin
           cmdStatusCancel.enabled := true;
           cmdStatusOk.enabled := ((cboStatus.ItemIndex > -1) and
                                      (txtStatusDate.AsString <> emptyStr));
        end
        else begin
           cboReasons.ItemIndex := cboReasons.FMTag;
           cboReasons.FMModified := false;
        end;
     end
  else
     setfocus;
end;

{
  future entry point for broker call to allow/disallow reason change
}
function TfrmTeamProfile.StatusReasonChangeOk: boolean;
begin
  result := true;
end;


 { updated 1/11/96
  When the history status changes, set new index value into filer and
  depending on whether the other two fields are filled or not,
  enable the OK button.
}
procedure TfrmTeamProfile.cboStatusChange(Sender: TObject);
var
  i: integer;
begin
  if cmdStatusCancel.focused then exit;

  i := cboStatus.ItemIndex;

  if cboStatus.ItemIndex < 0 then exit;

  if StatusChangeOk(i) then
     begin
        cboStatus.FMCtrlInternal{FMInternal - PDR} := IntToStr(i);
        cmdStatusOk.enabled := ((cboReasons.ItemIndex > -1) and
                               (txtStatusDate.AsString <> emptyStr));
     end
  else
     begin
        cboStatus.ItemIndex := cboStatus.FMTag;
        cboStatus.FMModified := false;
        cboStatus.Setfocus;
     end;
end;

{  updated 1/10/96   API
  Consecutive status entries cannot have the same value. If this value is
  not the same as the status of the most current history entry, then continue.

  If adding the new status is ok, and the value of the new status is INACTIVE,
  then check to see if an inactive entry is allowed.  If it is, continue.
}
function TfrmTeamProfile.StatusChangeOk(status: integer): boolean;
var
  msg: string;
begin
  msg := emptyStr;

  result := HistoryStatusOk(RPCBrokerMain, cboStatus.FMFile, tmProfile.TeamIen,
     StrToFMDate(txtStatusDate.AsString), Status, msg);

  if result and (Status = 0) then
     begin
        result := InactivateHistoryOk(RPCBrokerMain, cboStatus.FMFile,
                  tmProfile.TeamIen, StrToFMDate(txtStatusDate.AsString), msg);
     end;

  if length(msg) > 0 then
     frmMain.StatusMsg(msg, true);

end;

{
  File the status entry.  If this is a new team, the status entry
  cannot be saved until after the team has been saved, notify the user and
  exit.  If this is a new status entry, set the key.  File the entry and notify
  the user of the result of the update.  Reload the status entries for the
  team.
}
procedure TfrmTeamProfile.cmdOkClick(Sender: TObject);
//bp/cmf 204t0a begin
var
dtBegin,dtEnd,dtDate: string;
begin
 if cboStatus.ItemIndex = 0 then
  begin
   dtBegin  := ValStrToFMDate(txtStatusDate.AsString);
   dtEnd    := '9999999';
   dtDate   := '9999999';
   if not RvwActFutTmAsgn(RPCBrokerMain
          ,TmProfile.TeamIen,dtBegin,dtEnd,dtDate) then
           begin
            cmdStatusCancelClick(self);
            exit;
           end;
  end;
//bp/cmf 204t0a end
   if TmProfile.TeamIen = NEW_ENTRY then
     begin
        lstStatus.Items.AddObject('  ' + txtStatusDate.AsString,
                                  imgYes.picture.graphic);
        DisableHistory(True);
        setStatusButtons(false,false,false,false);
        lstStatus.enabled := false;
     end
  else
     begin
        if NewStatusFlag then flrTHistory.AddFDA('404.58',NEW_ENTRY,'.01', TmProfile.TeamIen);{key('404.58', '.01', TmProfile.TeamIen); - PDR}
        flrTHistory.AddChgdControl(cboStatus);{Add(cboStatus); - PDR}
        flrTHistory.AddChgdControl(cboReasons);{Add(cboReasons); - PDR}
        flrTHistory.AddChgdControl(lblStatusDate);{Add(lblStatusDate); - PDR}

        if (flrTHistory.Update) then
           begin
              if not frmMain.tmrStatusMsg.enabled then
                 frmMain.StatusMsg('History entry saved.', false);
              NewStatusFlag := false;
              LoadHistory;
              getUpdate.Iens := tmProfile.TeamIen;
              getUpdate.GetData;
              lblEffective.Caption := Piece(getFMDelimRec(getUpdate,0), '^', 5);{Piece(getUpdate.Results[0], '^', 5); - PDR}
              lblCurrentInact.Caption := Piece(GetFMDelimRec(getUpdate,1), '^', 5);{Piece(getUpdate.Results[1], '^', 5); - PDR}
           end
        else
           messageDlg('Status was not saved', mtWarning,[mbOk],0);

        SetStatusButtons(false,false,true,false);
        getHistory.ClearCtrlData{cleardata - PDR};
        DisableHistory(true);
     end;
end;

{  New 1/17/96
  Set status log page buttons.

}
procedure TfrmTeamProfile.SetStatusButtons(Sok: boolean; Scnl: boolean;
          Sadd: boolean; Sdel: boolean);
begin
  cmdStatusOk.Enabled := Sok;
  cmdStatusCancel.Enabled := Scnl;
  cmdStatusAdd.enabled := Sadd;
  if Sdel then
     cmdStatusDelete.enabled := SecurityKeyOk(RPCBrokerMain, DELETE_KEY)
  else
     cmdStatusDelete.enabled := Sdel;
end;

{
  Cancel any entries in the status data edit fields and clear and
  disable the fields for futher editing.
}
procedure TfrmTeamProfile.cmdStatusCancelClick(Sender: TObject);
begin
  try
    if pnlCalendar.Visible then
      pnlCalendar.visible := false;

     SetStatusButtons(false, false, true, false);
     getHistory.ClearCtrlData{cleardata - PDR};
     {txtStatusDate.AsOvcDate := CurrentDate;}
     txtStatusDate.AsString := emptystr;
     DisableHistory(true);
     NewStatusFlag := false;
  except
     on E: Exception do
        MessageDlg('Error: ' + E.ClassName + ' in status list', mtInformation,
                   [mbok], 0);
  end;

end;

{
  Add a new history entry.  Clear and enable the data edit fields.
  Enable the cancel button and disable the Add button.  Set the
  date to the current date.
}
procedure TfrmTeamProfile.cmdAddClick(Sender: TObject);
begin
  getHistory.SetUpNewEntry(NEW_ENTRY);

  cboReasons.ItemIndex := -1;

  if not (HList.Count > 0) then
     cboStatus.ItemIndex := 1
  else begin
     if Piece(Hlist[Hlist.count - 1], U, 4) = 'ACTIVE' then
        cboStatus.ItemIndex := 0
     else
        cboStatus.ItemIndex := 1;
     end;
  cboStatus.FMCtrlInternal{FMInternal - PDR} := IntToStr(cboStatus.ItemIndex);

  txtStatusDate.AsOvcDate := CurrentDate;

  NewStatusFlag := true;
  DisableHistory(false);
  SetStatusButtons(false, true, false, false);
  flrTHistoryFMMode{flrTHistory.FMMode - PDR} := AddEntry;
  txtStatusDate.SetFocus;
end;

{  updated 1/24/96
  Delete a history entry after confirming deletion.
}
procedure TfrmTeamProfile.DeleteHistoryClick(Sender: TObject);
begin
  if OkToDeleteStatus then
     begin
        if messageDlg('You are about to delete the ' + txtStatusDate.AsString +
         ' history entry.' + RETURN + 'Do you want to do this?',
         mtConfirmation, [mbYes,mbCancel], 0) = mrYes then
           if Deleter(RPCBrokerMain, '^SCTM(404.58,', lblStatusDate.FMFile{FMEntry - PDR}) then
              begin
                 frmMain.StatusMsg('Entry deleted.', false);
                 LoadHistory;
                 getUpdate.Iens := tmProfile.TeamIen;
                 getUpdate.GetData;
                 lblEffective.Caption := Piece(GetFMDelimRec(getUpdate,0), '^', 5);{Piece(getUpdate.Results[0], '^', 5); - PDR}
                 lblCurrentInact.Caption := Piece(GetFMDelimRec(getUpdate,1), '^', 5);{Piece(getUpdate.Results[1], '^', 5); - PDR}
              end
           else
              messagedlg('The ' + txtStatusDate.AsString +
              ' entry was not deleted', mtWarning, [mbOk], 0);
     end
  else
     begin
        frmMain.StatusMsg('You cannot delete this status entry!', true);
        DisableHistory(true);
        SetStatusButtons(false, true, false, false);
     end;
end;



{  API
  Only the last history entry can be deleted.  Check to see if it's ok to
  delete this entry.
}
function TfrmTeamProfile.OkToDeleteStatus: boolean;
var
  msg: string;
begin
  if lstStatus.Items.Count = 1 then
   if not DeleteEntryOk(RPCBrokerMain, TTmHistory, tmProfile.Teamien, msg) then begin
     if not (length(msg) > 0) then
        msg := 'This team cannot be deleted!';
     messagedlg(msg, mtInformation, [mbOk,mbHelp], 80000);
     result := false;
     exit;
  end;

  result := DeleteHistoryOk(RPCBrokerMain, cboStatus.FMFile, tmProfile.TeamIen,
     Piece(Hlist[lstStatus.ItemIndex], '^', 1), msg);

  if length(msg) > 0 then
     messagedlg(msg, mtWarning, [mbOk], 0);
end;

{
  Disable/Enable status edit fields
}
procedure TfrmTeamProfile.DisableHistory(Status: boolean);
begin
  txtStatusDate.enabled := not status;
  cboStatus.enabled := not status;
  cboreasons.enabled := not status;
  fwSpinDate.enabled := not status;
end;

{
   Position and show the calendar display for date selection.  If
   the calendar is already visible, then hide the display.  Mark the
   current date in the edit field
}
procedure TfrmTeamProfile.txtStatusDateDblClick(Sender: TObject);
var
  d: TOvcDate;
begin
  if pnlCalendar.visible then
     pnlCalendar.visible := false
  else begin
     pnlCalendar.top := TabTeam.Top + hdrTeam.Height + (txtStatusDate.Top +
                        txtStatusDate.Height);
     pnlCalendar.left := tabTeam.left + txtStatusDate.left;

     d := txtStatusDate.AsOvcDate;

     if d = BadDate then d := CurrentDate;
     Calendar.AsStDate := d;
     pnlCalendar.BringToFront;
     pnlCalendar.visible := true;
     Calendar.Setfocus;
  end;
end;

procedure TfrmTeamProfile.ChangeMonth(Sender: TObject);
begin
end;

{
  Call the double click event for the field if the F2 key is pressed
}
procedure TfrmTeamProfile.txtStatusDateKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if key = VK_F2 then txtStatusDateDblClick(sender);
end;

{
  if the spacebar is pressed while the calendar has the focus, then call
  the on click event for the calendar.
}
procedure TfrmTeamProfile.calendarKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_SPACE then CalendarClick(Sender);
end;

{
  set the date edit field to the date value clicked on the calendar, and
  hide the calendar.
}
procedure TfrmTeamProfile.calendarClick(Sender: TObject);
begin
  txtStatusDate.AsOvcDate := Calendar.AsStDate;
  pnlCalendar.visible := false;
  txtStatusDate.Setfocus;
end;



{ ================= Generic Component calls ===============================}


{
  Dropdown list box key down event to handle Spacebar select and ESC key
  presses from inside the dropdown list.
}
procedure TfrmTeamProfile.cboKeyCheck(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ShowDropDown(Sender, key, shift);
end;


{
  check wHether to enable the save and undo buttons.  If the text in
  either a text box, memo field, or lookup field are changed, then
  enable the buttons.
}
procedure TfrmTeamProfile.TextChange(Sender: TObject);
begin
  if Sender is TFMEdit then
     if (TFMEdit(Sender).Text <> EmptyStr) and not (cmdSave.Enabled) then begin
        cmdSave.Enabled := CheckReqd;
        cmdUndo.Enabled := true;
     end;

  if Sender is TFMMemo then
     if (TFMMemo(Sender).text <> EmptyStr) and not (cmdSave.Enabled) then begin
        cmdSave.Enabled := CheckReqd;
        cmdUndo.Enabled := true;
     end;

  if Sender is TFMComboBoxLookUp then
     if (TFMComboBoxLookUp(Sender).Text <> EmptyStr) and not (cmdSave.Enabled)
         then begin
           cmdSave.Enabled := CheckReqd;
           cmdUndo.Enabled := true;
         end;
end;

{
  when a selection is made in a dropdown list of other then the current item,
  then enable the save and undo buttons.
}
procedure TfrmTeamProfile.LookUpChange(Sender: TObject);
begin
  SetSave(True);
end;


{
  Generic dropdown list change event.  Load the new item selected into
  the filer and set save/undo buttons
}
procedure TfrmTeamProfile.cboChangeItem(Sender: TObject);
begin
	with (Sender as TFMComboBox) do
  	begin
        FMCtrlInternal{FMInternal - PDR} := Piece(GetFMDelimRec(FMLister,ItemIndex), '^', 1);{Piece(FMLister.Results[ItemIndex], '^', 1); - PDR}
        FMFiler.AddChgdControl(Sender); {Add(Sender); - PDR}
        cmdSave.Enabled := CheckReqd;
        cmdUndo.enabled := true;
     end;
end;

{
  When a checkbox is clicked, set the FMInternal value to Fileman
  True/False i.e. '1' or '0' based on the Checked value of the
  checkbox. if the checked value is not the same as the original
  value, FMTag, then Add the change to the filer.  If the checked
  value is the same, i.e. checked again, then remove the change
  from the filer
}
procedure TfrmTeamProfile.CheckClick(Sender: TObject);
begin
	with (Sender as TFMCheckBox) do
  	begin
        if Checked then
           FMCtrlInternal{FMInternal - PDR} := '1'
        else
           FMCtrlInternal{FMInternal - PDR} := '0';

        if Checked <> FMTag then
           begin
              FMFiler.AddChgdControl(Sender);{Add(Sender); - PDR}
              cmdSave.Enabled := CheckReqd;
              cmdUndo.Enabled := true;
           end
        else
           {FMFiler.Delete(Sender);}
     end;
end;

{
  Lookup Combobox exit.  If the combobox entry has been deleted
  Null value), then handle as a special case. Otherwise get the
  index value of the new selection and add it to the change
  transaction list.  If a new entry was not selected, then call the
  reset method and set focus back to the combobox
}
procedure TfrmTeamProfile.cboExit(Sender: TObject);
begin
  if not (Sender as TFMComboBoxLookUp).FMModified then exit;

	with (Sender as TFMComboBoxLookUp) do
     begin
        try
           if (text = EmptyStr) and (FMCtrlInternal{FMInternal - PDR} <> EmptyStr) then
              FMCtrlInternal{FMInternal - PDR} := EmptyStr
           else if ItemIndex >= 0 then
                 FMCtrlInternal{FMInternal - PDR} := Piece(GetFMDelimRec(FMLister,ItemIndex), '^', 1);{Piece(FMLister.Results[ItemIndex], '^', 1); - PDR}
        finally
           FMFiler.AddChgdControl(Sender); {Add(Sender); - PDR}
           cmdSave.Enabled := CheckReqd;
           cmdUndo.Enabled := true;
           {SetSave(true);}
        end;
     end;
end;

{  new 1/22/96
  reset the edit field colors
}
procedure TfrmTeamProfile.cboEnter(Sender: TObject);
begin
	with (Sender as TFMComboBox) do
     begin
        color := clWindow;
        Font.Color := clBlack;
     end;
end;

{  Process changes to freetext components.  Validate against the sending
  component, if valid, add the change to the transaction list, otherwise
  reset the old value.}
procedure TfrmTeamProfile.TextExit(Sender: TObject);
begin
  with ( Sender as TFMEdit) do
     begin
     	if FMModified then
           begin
                if (Sender=txtAllowed) and (pos(',',Text)>0) then
                   repeat
                     Text := copy(text,1,pos(',',text)-1)+copy(text,pos(',',text)+1,99) ;
                   until pos(',',Text)=0 ;
                FMCtrlInternal{FMInternal - PDR} := Text;
                if Validate then
                 FMFiler.AddChgdControl(Sender){Add(Sender) - PDR}
                else
           	   begin
              	     text := FMTag;
                   end;
           end;
     end;
end;

{  ================= Team methods ==================================}

procedure TfrmTeamProfile.OpenNew;
var
  DoneWithName: boolean;
  s1: string;
begin
  DoneWithName := false;
  repeat
     s1 := EmptyStr;
     if InputQuery('Team Name', 'Enter New Team Name:', s1) then
        DoneWithName := ConfirmNewName(UpperCase(s1))
     else begin
        PostMessage(Handle, WM_CLOSE, 0,0);
        exit;
     end;
  until DoneWithName;
  flrTeamDataFMMode:=AddEntry; {PDR - 7/10/98}
end;

procedure TfrmTeamProfile.OpenExisting;
begin
  if not (TmProfile.TeamIen = EmptyStr ) then UnLockTeam;
  if not GetTeam then
     PostMessage(Handle, WM_CLOSE, 0,0);
end;

{
  Setup and execute the FM Lookup to open a new team. If the lookup is
  canceled, or nothing is selected, close the form.  If new is selected
  then get the new teams name and validate it.  If a team is selected,
  then unlock the current team and get the selected teams information.
  If the team is locked by someone else for editing, open form in view
  only mode.
}
procedure TfrmTeamProfile.OpenTeam(AllowNew: Boolean);
var
  new, DoneWithName: boolean;
  s1: string[30];
begin
  lkpLookUp.FMLister.FromList.clear; {pdr}
  lkpLookUp.FMLister.FromList.insert(0,Emptystr);{From := EmptyStr; - PDR}
  lkpLookUp.FMLister.FromIen := EmptyStr;
  lkpLookUp.FMLister.PartList.clear; {pdr}
  lkpLookUp.FMLister.PartList.Insert(0,EmptyStr); {Part := EmptyStr; - PDR}
  lkpLookUp.FMLister.Number := '*';
  lkpLookUp.Title := 'Select Team';
  lkpLookUp.AllowNew := AllowNew;

  if frmMain.ActiveOnly1.checked then
     lkpLookUp.FMLister.Screen := 'IF $$ACTHISTB^SCAPMCU1(404.58,Y)'
  else
     lkpLookUp.FMLister.Screen := EmptyStr;

  if lkpLookUp.Execute(new) then begin
     if new then
        OpenNew
     else begin
        tmProfile.TeamIen := lkpLookup.RecordNumber;
        OpenExisting;
        end;
     end
  else
     if TmProfile.TeamIen = EmptyStr then
        PostMessage(Handle, WM_CLOSE, 0,0);
end;

{
  Validate the new team name to by checking for a length greater than
  three characters and that it passes the Team's FM Validator's validate
  method.  If it's a valid team name then setup a new team entry for
  editing.  Otherwise, raise a warning and return a failure.
}
function TfrmTeamProfile.ConfirmNewName(s1: string): boolean;
begin
  result := false;
  if Length(s1) < 3 then
     begin
        Messagedlg('The team name must be greater' + RETURN +
                   'than three characters!', mtWarning, [mbOk], 0);
        exit;
     end;

  try
     valTeam.FieldNumber := '.01';
     valTeam.IENS := NEW_ENTRY ;
     valTeam.Value := s1;
     if valTeam.Validate then
        begin
           SetUpNewTeam(s1);
           result := true;
        end
     else
        raise EInvalidName.create('');
  except
     on EInvalidName do
        begin
           messagedlg('Team name could not be validated!', mtinformation,
                      [mbok,mbHelp], 80000);
        end;
  end;
end;

{
  Set up and initialize team profile form for a new team.  Clear all
  FMGets and FMFiler's.  Set edit mode to AddEntry.

  Input: s1 = team name
}
procedure TfrmTeamProfile.SetUpNewTeam(s1: string);
var
  msg: string;
  flag: boolean;
begin
  tabTeam.PageIndex := 0;
  getTeamData.ClearCtrlData{cleardata - PDR};
  getHistory.ClearCtrlData{cleardata - PDR};
  flrTeamData.Clear;
  flrTHistory.Clear;

  { Disable controls}
  frmMain.cmdNew.enabled := false;
  frmMain.cmdOpen.enabled := false;
  cmdPosition.Enabled := false;
  cmdAutoLink.Enabled := false;

  {disable menu items}

  New1.enabled := false;
  New2.enabled := false;
  NextTeam1.enabled := false;
  NextTeam2.enabled := false;
  PreviousTeam1.enabled := false;
  PreviousTeam2.enabled := false;
  AutoLinks1.enabled := frmMain.AlnkEnabled;
  RemoveTeam1.Enabled := false;
  Open1.enabled := false;
  Open3.enabled := false;


  with txtTeamName do
     begin
        lstStatus.Clear;
        Text := s1;
        TmProfile.TeamName := s1;
        TmProfile.TeamIen := NEW_ENTRY;
        FMGets.StuffIENS(NEW_ENTRY);{SetEntryNumber(NEW_ENTRY); - PDR}
        FMCtrlInternal{FMInternal - PDR} := text;
        FMFiler.AddChgdControl(txtTeamName);{Add(txtTeamName); - PDR}
        txtTeamNameFMFilerFMMode{FMFiler.FMMode - PDR} := AddEntry;
      end;

  {NEW 1/30/97 - Set defaults to primary care based on user preference - RV }
  if frmMain.mnuPrimCare.Checked then
     begin
          {Set new team's default purpose to 'PRIMARY CARE' }
          cboPurpose.ItemIndex := cboPurpose.Items.IndexOf('PRIMARY CARE');
          cboChangeItem(cboPurpose) ;

          {Set new team's default PRIMARY CARE TEAM? response to YES' }
          chkCare.Checked := True ;
     end ;
  {END of new code 1/30/97 - RV}

  {NEW 1/31/97 - Set default institution to that of current user - RV }
  if frmMain.UserRecord.DefaultInst <> '' then
     with cboInstitution do
       begin
        Text := frmMain.UserRecord.DefaultInst ;
        GetList ;
        ItemIndex := Items.IndexOf(frmMain.UserRecord.DefaultInst)   ;
        FMModified := True ;
        cboExit(cboInstitution) ;
       end ;
  {END of new code 1/31/97 - RV}

  CheckRequired(msg, flag);

  StubStatus;
  NoTeam := false;
  hdrTeam.Sections[1] := tmProfile.TeamName;
  txtPhone.SetFocus;
  cmdUndo.Enabled := true;
  cmdSave.Caption := 'Sa&ve...';
end;

{
  Modify an existing team name.  If new name is confirmed, then add
  the new name to the filer.  If change is canceled, then reset old
  name, if retry is returned, then set focus to team name and clear
  value.
}
Procedure TfrmTeamProfile.ModifyName(obj: TObject);
begin
  with txtTeamName do begin
     if not EntryLengthOk(Text, 3, 30) then begin
        Text := FMTag;
        FMModified := false;
        setfocus;
        end
     else begin
        valTeam.FieldNumber := '.01';
        valTeam.IENS := TmProfile.TeamIen;
        valTeam.Value := text;
        if valTeam.Validate then begin
           if messageDlg('You are about to change the name of the ' +
                         TmProfile.TeamName + ' Team!' + RETURN +
                         'Do you want to do this?', mtConfirmation,
                         [mbYes,mbCancel,mbHelp], 80000) = mrYes then
             begin
                 FMCtrlInternal{FMInternal - PDR} := text;
                 TmProfile.TeamName := Text;
                 hdrTeam.Sections[1] := tmProfile.TeamName;
                 if txtTeamNameFMFilerFMMode{FMFiler.FMMode - PDR} = EditEntry then       {IF added - 12/20/96 - RV}
                    FMFiler.AddChgdControl(txtTeamName);{Add(txtTeamName); - PDR}
             end
           else
             begin
              text := FMTag;
              FMModified := false;
             end;
        end
        else begin
           text := TmProfile.TeamName;
           FMModified := false;
           {message added 1/29/97 - RV  }
           MessageDlg('The new team name could not be validated',mtWarning,[mbOK],0) ;
        end;
     end;
  end;
end;


{
  unlocks the currently active team
}
Procedure TfrmTeamProfile.UnlockTeam;
var
  LockTeam: string[45];
begin
  LockTeam := '^SCTM(404.51,' + TmProfile.TeamIen + ')';
  Locker(RPCBrokerMain, LockTeam, UnLockANode, 10);
end;

{
  function to lock team and get the teams information from DHCP.
  Returns true if successful in locking and retrieving the team's
  information otherwise returns false.
}
function TfrmTeamProfile.GetTeam: boolean;
var
  LockTeam: string[45];
begin
  LockTeam := '^SCTM(404.51,' + TmProfile.TeamIen + ')';
  if not Locker(RPCBrokerMain, LockTeam, LockANode, 10) then
     begin
        messageDlg('Sorry, This team is currently locked.', mtInformation,
                   [mbOk], 0);
        result := false;
        exit;
     end;

  with txtTeamName do
     begin
        FMGets.IENS := TmProfile.TeamIen;
        FMGets.GetAndFill;
        txtTeamNameFMFIlerFMMode{FMFIler.FMMode - PDR} := EditEntry;
        FMFiler.Clear;
        TmProfile.TeamName := text;
     end;

  hdrTeam.Sections[1] := tmProfile.TeamName;
  LoadHistory;
  flrTHistory.Clear;
  result := true;
end;

{ =============   general form procedures and functions ======== }


{
  Stub in today's date as the effective date for the team, set the
  current status to active, and the status reason to new team.  Set
  the editmode of the history FMFiler to AddEntry.  Called from the
  SetUpNewTeam procedure.
}
procedure TfrmTeamProfile.StubStatus;
begin
  flrTHistory.Clear;
  flrTHistoryFMMode{flrTHistory.FMMode - PDR} := AddEntry;
  getHistory.SetUpNewEntry(NEW_ENTRY);
  tabTeam.Pages[2].Enabled := false;

  txtStatusDate.AsOvcDate := CurrentDate;
  lblStatusDate.FMCtrlInternal{FMInternal - PDR} := StrToFMDate(txtstatusDate.AsString);

  cboStatus.ItemIndex := 1;
  cboStatus.FMCtrlInternal{FMInternal - PDR} := '1';
  cboStatus.Enabled := false;

  cboReasons.ItemIndex := cboReasons.Items.IndexOf('NEW TEAM');
  cboReasons.FMCtrlInternal{FMInternal - PDR} :=
               Piece(GetFMDelimRec(cboReasons.FMLister,cboReasons.ItemIndex), '^', 1);{Piece(cboReasons.FMLister.Results[cboReasons.ItemIndex], '^', 1); - PDR}

  DisableHistory(true);
  txtStatusDate.enabled := true;
  fwSpinDate.enabled := true;

  SetStatusButtons(True, false, false, false);
  NewStatusFlag := true;
end;

{
  Update the enable/disable status of menu items based on the status of
  the FMFiler's Edit status.
}
procedure TfrmTeamProfile.MenuUpdate(Sender: TObject);
var
  status: boolean;
  AddStatus: boolean;
begin
  AddStatus := (txtTeamNameFMFilerFMMode{txtTeamName.FMFiler.FMMode - PDR} = EditEntry);
  if (txtTeamName.FMFiler.AnythingToFile{Status = Edited}) or cmdSave.Enabled then
     status := true
  else
     status := false;

  { CHANGED 5/8/97 - REV }
  {NextTeam1.Enabled := AddStatus;
  PreviousTeam1.Enabled := AddStatus;
  NextTeam2.Enabled := AddStatus;
  PreviousTeam2.Enabled := AddStatus; }
  NextTeam1.Enabled := not txtStatusDate.Enabled;
  PreviousTeam1.Enabled := not txtStatusDate.Enabled;
  NextTeam2.Enabled := not txtStatusDate.Enabled;
  PreviousTeam2.Enabled := not txtStatusDate.Enabled;
  Open1.Enabled := not txtStatusDate.Enabled;
  Open3.Enabled := not txtStatusDate.Enabled;
  New1.Enabled := not txtStatusDate.Enabled;
  New2.Enabled := not txtStatusDate.Enabled;

  Undo1.Enabled := status;
  Undo3.Enabled := status;
  Save1.Enabled := status;
  Save3.Enabled := status;

  RemoveTeam1.enabled := DeleteKey;
  DeleteHistory.enabled := (DeleteKey and txtStatusDate.Enabled)
end;


{
  load the history status entries for the current team.  build the list
  and add the appropriate icon to the entry.  Then display the information
  for the first entry in the list.

  Input: string, the ien for the current team.
}
procedure TfrmTeamProfile.LoadHistory;
var
  i: integer;
  img: TGraphic;
  s1: string; {string[20]; - PDR}
begin
  getHistory.ClearCtrlData{cleardata - PDR};
  with lstStatus do
     begin
        Clear;
        Hlist.clear;
        FMLister.Screen := 'IF $P(^(0),U,1)="' + TMProfile.TeamIen + '"';
        FMLister.GetList(nil);
        HList.Assign(ltrstatus.Results);
        if HList.Count > 0 then
           begin
              for i := 0 to HList.Count - 1 do
                 begin
                    {setup the HList strings to be delimited records as in
                     previous version (quick and dirty) - PDR 6/98}
                    HList[i]:=GetFMDelimRec(ltrStatus,i);
                    if Piece(HList[i], U, 4) = 'ACTIVE' then
                       img := imgYes.picture.graphic
                    else
                       img := imgNo.picture.graphic;

                    s1 := '  ' +  FMDateToStr(ExtDateToFM(Piece(HList[i], U, 3)));
                    lstStatus.Items.AddObject(s1, img);
                 end;
              txtStatusDate.AsString := emptystr;
              {txtStatusDate.AsOvcDate := CurrentDate;}
           end;
{        else
           FMGets.ClearData;}
     end;

  DisableHistory(True);
  flrTHistory.Clear;
  SetStatusButtons(false, false, True, false);
end;

{
  set the status of the save and undo buttons.
}
procedure TfrmTeamProfile.SetSave(status: Boolean);
begin
  cmdSave.Enabled := status;
  cmdUndo.Enabled := status;
end;


procedure TfrmTeamProfile.AutoLinks1Click(Sender: TObject);
var
  frm : TfrmAutoLinks;
begin
  frm := TfrmAutoLinks.Create(Self);
  frm.TeamIDPassed := tmProfile.TeamIen;
  application.processmessages;
  frm.FormLoad;
end;

{
  New 1/22/96
}
procedure TfrmTeamProfile.ClearEditFields;
var
  i: integer;
begin;
  for i := 0 to ComponentCount - 1 do
     begin
        if Components[i]is TFMEdit then
           begin
              TFMEdit(Components[i]).Color := clWindow;
              TFMEdit(Components[i]).font.Color := clBlack;
           end
        else if Components[i] is TFMComboBox then
           begin
              TFMComboBox(Components[i]).Color := clWindow;
              TFMComboBox(Components[i]).font.Color := clBlack;
           end
        else if Components[i] is TFMComboBoxLookUp then
           begin
              TFMComboBoxLookUp(Components[i]).Color := clwindow;
              TFMComboBoxLookUp(Components[i]).font.Color := clBlack;
           end;
     end;
end;

procedure TfrmTeamProfile.FormDestroy(Sender: TObject);
begin
  HList.free;
end;

procedure TfrmTeamProfile.RPCBroker1NetError(Sender: TObject;
  var Error: EBrokerError);
var
  msg: string;
begin
  msg := 'A Network error has been encountered.  Please make' + RETURN +
         'a note of your current entry.  You will need to' + RETURN +
         'logon to DHCP before continuing';
  messageDlg(msg, mtError, [mbOk], 0);
  NetError := true;
  Halt;
end;

function TfrmTeamProfile.CheckReqd: boolean;
var
  i: integer;
begin
  result := true;
  for i := 0 to ComponentCount - 1 do
     begin
        if Components[i] is TFMEdit then begin
           if TFMEdit(Components[i]).FMRequired and
              (TFMEdit(Components[i]).Text = '') then
                 begin
                    result := false;
                    exit;
                 end;
           end

        else if Components[i] is TFMComboBox then begin
           if TFMComboBox(Components[i]).FMRequired and
              (TFMComboBox(Components[i]).Text = '') then
              begin
                 result := false;
                 exit;
              end;
           end

        else if Components[i] is TFMComboBoxLookUp then begin
           if TFMComboBoxLookUp(Components[i]).FMRequired and
              (TFMComboBoxLookUp(Components[i]).Text = '') then
              begin
                 result := false;
                 exit;
              end;
           end;
     end;
end;

procedure TfrmTeamProfile.tabTeamPageChange(Sender: TObject;
  Index: Integer; var AllowChange: Boolean);
begin
  If tabTeam.PageIndex = 2 then
     AllowChange := not cmdStatusCancel.Enabled
  else if index=1 then
       InitFMChk; {PDR}
end;

procedure TfrmTeamProfile.cboInstitutionEnter(Sender: TObject);
begin
     cboInstitution.color := clWindow;
     cboInstitution.Font.Color := clBlack;
     cboInstitution.Clear ; { - PDR 6/1/98}
     cboInstitution.FMCtrlInternal{FMInternal - PDR} := '' ;
end;

function TfrmTeamProfile.RvwActFutTmAsgn(RPCBroker: TRPCBroker; FromTeam, DtBegin, DtEnd, DtDate: string): boolean;
var
patjob,patjobcount,s,name,ssn : string;
i: integer;
begin
 result := false;
 try
  with RPCBroker do
   begin
     with Param[0] do
      begin
       Value := '.SC';
       Ptype := list;
       Mult['"FROMTEAM"'] := FromTeam;
       Mult['"BEGIN"']    := DtBegin;
       Mult['"END"']      := DtEnd;
       Mult['"DATE"']     := DtDate;
      end;//with param[0] do
    RemoteProcedure := 'SCMC BLD TEAM PAT LIST';
    call;
    s := results[0];
    patjobcount := piece(s,'^',2);
    if strtoint(patjobcount) > 0 then
     begin
      patjob := piece(s,'^',1);
      RemoteProcedure := 'SC GET PAT BLOCK';
     with Param[0] do
      begin
       Value := '.SC';
       Ptype := list;
        Mult['"JOBID"']   := 'SCTEAM';
        Mult['"JOB"']     := PatJob;
        Mult['"BSTART"']  := '1';
        Mult['"BEND"']    := '200';
        Mult['"BLAST"']   := PatJobCount;
      end;//with param[0] do
     call;
     with frmDischargeMemo do
      begin
       with dischargememo do
        begin
         lines.assign(results);
         for i := 0 to lines.count-1 do
          begin
           s := lines[i];
           ssn := piece(s,u,6);
           s := copy(piece(s,u,2),1,30);
           frmTeamAssign.pad(s, 30);
           lines[i] := s +  tab  + ssn;
          end;
         if lines.count > 6 then ScrollBars := ssVertical;
         //ReadOnly   := true;
        end;
       caption := 'Review active and future team assignments';
       label1.Caption   := 'Patient(s):';
       with lblWarn1 do
        begin
         Caption := '          Current or future team assignment(s) must be discharged';
         Alignment := taCenter;
         Visible := true;
        end;
       with lblWarn2 do
        begin
         Caption := '     before the team can be inactivated.';
         Alignment := taCenter;
         Visible := true;
        end;
       BitBtnDischargeOK.Visible := false;
       BitBtn1.Visible := false;
       ShowModal;
      end;//with frmDischargeMemo do
     end
    else result := true;
   end;//with rpcbroker do

 except
  frmMain.statusmsg('Unable to review assignments', false);
 end;// try..except
end;

end.
