{*******************************************************************}
{                                                                   }
{  Report Query Template Utility unit for PCMM                      }
{  a component of the Scheduling Redesign Project                   }
{                                                                   }
{ Scheduling ver 5.3 AUG 13, 1993                                   }      
{ Management Information Products Group                             }
{ Albany NY (mjk)                                                   }
{ Dept. of Veteran Affairs                                          }
{                                                                   }
{ Last updated: 28 May 2002 (J. Peterson)                           }
{                                                                   }
{*******************************************************************}

unit Rpttemp;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, StdCtrls, Fmcmpnts, Trpcb, Fmcntrls, ExtCtrls, rptutl,
  mfunstr, rptprint, scut3, Menus, OvcSc,
  OvcBase, OvcEF, OvcPB, OvcPF, rptSel, scutdef{, Gtsize32, GTVASzr - PDR},
  Diaccess, OvcDate;

type
  ComboBoxState = (ListDown, ListUp);

  TfrmTemplate = class(TForm)
    boxFields: TGroupBox;
    Label1: TLabel;
    txtName: TEdit;
    Label2: TLabel;
    memDescription: TMemo;
    radAccessLevel: TRadioGroup;
    pnlStatusBar: TPanel;
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    mnuSave: TMenuItem;
    mnuSaveAs: TMenuItem;
    N1: TMenuItem;
    mnuNew: TMenuItem;
    mnuPrint: TMenuItem;
    pnlToolBar: TPanel;
    spdPrint: TSpeedButton;
    spdNew: TSpeedButton;
    spdSave: TSpeedButton;
    N4: TMenuItem;
    mnuDelete: TMenuItem;
    mnuRestore: TMenuItem;
    N2: TMenuItem;
    mnuDefault: TMenuItem;
    spdDefault: TSpeedButton;
    boxCriteria: TGroupBox;
    lblSort: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    radAssigned: TRadioGroup;
    chkSummary: TCheckBox;
    cboSort: TComboBox;
    boxDates: TGroupBox;
    Label5: TLabel;
    lblEnd: TLabel;
    txtBeginDate: TOvcPictureField;
    txtEndDate: TOvcPictureField;
    spnBeginDate: TOvcSpinner;
    spnEndDate: TOvcSpinner;
    cboPrinter: TFMComboBoxLookUp;
    cboReport: TFMComboBox;
    boxSelections: TGroupBox;
    cmdSelect: TBitBtn;
    lstPrinter: TFMLister;
    lstReport: TFMLister;
    OvcController1: TOvcController;
    spdClose: TSpeedButton;
    cmdHelp: TBitBtn;
    cmdClose: TBitBtn;
    pnlDefault: TPanel;
    pnlStatus: TPanel;
    lstTemplate: TFMLister;
    cboTemplate: TFMComboBox;
    spdPrivate: TSpeedButton;
    spdPublic: TSpeedButton;
    spdAll: TSpeedButton;
    mnuOpen: TMenuItem;
    mnuPrivate: TMenuItem;
    mnuPublic: TMenuItem;
    mnuAll: TMenuItem;
    PopupMenu1: TPopupMenu;
    popNew: TMenuItem;
    popOpen: TMenuItem;
    popPrivate: TMenuItem;
    popPublic: TMenuItem;
    popAll: TMenuItem;
    popSave: TMenuItem;
    popSaveAs: TMenuItem;
    N3: TMenuItem;
    popRestore: TMenuItem;
    popDelete: TMenuItem;
    N5: TMenuItem;
    popPrint: TMenuItem;
    N6: TMenuItem;
    popDefault: TMenuItem;
    radPatStatus: TRadioGroup;
    Panel1: TPanel;
    lblCreator: TLabel;
    lblModified: TLabel;
    {GTVAForm1: GTVAForm - PDR}
    procedure FormResize(Sender: TObject);
    procedure mnuSaveClick(Sender: TObject);
    procedure mnuDeleteClick(Sender: TObject);
    procedure radAccessLevelClick(Sender: TObject);
    procedure mnuNewClick(Sender: TObject);
    procedure mnuRestoreClick(Sender: TObject);
    procedure memDescriptionExit(Sender: TObject);
    procedure txtNameExit(Sender: TObject);
    procedure mnuSaveAsClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure mnuDefaultClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure mnuPrintClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cboReportChange(Sender: TObject);
    procedure cmdSelectClick(Sender: TObject);
    procedure radAssignedClick(Sender: TObject);
    procedure chkSummaryClick(Sender: TObject);
    procedure txtBeginDateChange(Sender: TObject);
    procedure txtEndDateChange(Sender: TObject);
    procedure spdCloseClick(Sender: TObject);
    procedure cboTemplateClick(Sender: TObject);
    procedure mnuPrivateClick(Sender: TObject);
    procedure spdPrivateClick(Sender: TObject);
    procedure mnuPublicClick(Sender: TObject);
    procedure mnuAllClick(Sender: TObject);
    procedure spdPublicClick(Sender: TObject);
    procedure spdAllClick(Sender: TObject);
    procedure cboTemplateExit(Sender: TObject);
    procedure cboSortChange(Sender: TObject);
    procedure cboPrinterChange(Sender: TObject);
    procedure radPatStatusClick(Sender: TObject);
    procedure txtBeginDateDblClick(Sender: TObject);
    procedure txtEndDateDblClick(Sender: TObject);
    procedure txtBeginDateExit(Sender: TObject);
    procedure txtEndDateExit(Sender: TObject);
  private
    { Private declarations }
    FUser       : TScUser;
    FReport     : TScRptDef;
    FQuery      : TScQryDef;
    Error       : TScError;
    function  QueryModifiedCheck(Sender: TObject): Boolean;
    function  GetValue(fld: String): String;
    procedure FillFields;
    procedure FillIdFields;
    procedure ClearQryFields;
    procedure FillQryFields;
    procedure ShowQryFields;
    procedure chkUpdate(chkfld: TCheckBox);
    procedure DateUpdate(txtDate: TOvcPictureField);
    procedure SetFieldValue(fldName: TScStr50; value: TScStr100);
    procedure GetQuery(QryID: TScStr20);
    procedure ShowDropDown(cboState: ComboBoxState);
    procedure SetButtons;
    procedure CheckActive(Sender: TObject);
    procedure SetEndLo;
    procedure SetBeginHi;
  public
    { Public declarations }
    procedure FormLoad;
    procedure PostStatusMsg(msg: String; TimerStatus: Boolean);
    property user: TScUser        read FUser        write FUser;
    property qry : TScQryDef      read FQuery       write FQuery;
    property rpt : TScRptDef      read FReport      write FReport;
  end;

var
  frmTemplate: TfrmTemplate;

implementation

uses scut2, pcmm1, EnterDt;

var
  FillingFields : Boolean;

{$R *.DFM}

procedure TfrmTemplate.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  FUser.Free;
  FQuery.Free;
  Error.Free;
  FReport.Free;
  Action := caFree;
end;

procedure TfrmTemplate.FormCreate(Sender: TObject);
begin

  Font.Assign(FrmMain.FontDialog1.Font);
  FUser   := TScUser.Create;
  FQuery  := TScQryDef.Create;
  Error   := TScError.Create;
  FReport := TScRptDef.Create;
end;

procedure TfrmTemplate.FormResize(Sender: TObject);
begin
  Clientwidth      := 515;
end;

procedure TfrmTemplate.FormLoad;
var
  i: integer;
begin
  FillingFields := False;
  PostStatusMsg('Loading user information...', False);
  if not FUser.LoadCurrentUser(RPCBrokerMain) then
     begin
       PostMessage(Handle, WM_CLOSE, 0, 0);
       exit;
     end;

  lstTemplate.ListerFlags := [lfInternal];{Flags  := 'SPI'; - PDR}
  lstTemplate.Screen := 'IF $P(^(0),U,2)=' + FUSER.ID;
  lstTemplate.FMIndex:= 'AC';
  lstTemplate.PartList.clear; {pdr}
  lstTemplate.PartList.Insert(0,FUser.ID); {Part   := FUser.ID; - PDR}
  cboTemplate.GetList;

  mnuPrivate.Checked := True;
  popPrivate.Checked := True;
  spdPrivate.Down    := True;

  PostStatusMsg('Loading default query...', False);
  if FUser.DefaultQryID <> '' then
      FQuery.GetQuery(RPCBrokerMain, FUser.DefaultQryID);
  pnlDefault.Caption := 'Default: ' + FUser.DefaultQryName;

  with cboTemplate do
    if Items.IndexOf(FUser.DefaultQryName) <> -1 then
      ItemIndex := Items.IndexOf(FUser.DefaultQryName);

  PostStatusMsg('Loading report definition...', False);
  cboReport.GetList;
  FReport.GetRecord(RPCBrokerMain, FQuery.ReportID);
  PostStatusMsg('Filling in form...', False);
  FillFields;
  Application.ProcessMessages;
  Enabled := True;
  SetFocus;
  cboReport.SetFocus;
  PostStatusMsg('Form loading complete!', True);
end;

procedure TfrmTemplate.FillFields;
begin
 FillingFields := True;
 FillIdFields;
 SetButtons;
 ClearQryFields;
 ShowQryFields;
 FillQryFields;
 FQuery.Modified := False;
 FillingFields   := False;
end;

{fill in query identification fields}
procedure TfrmTemplate.FillIdFields;
begin
 txtName.Text         := FQuery.Name;
 lblCreator.Caption   := 'Creator: ' + FQuery.Creator;
 lblModified.Caption  := 'Last Saved: ' + FQuery.LastSaveDate;
 memDescription.Lines.Assign(FQuery.Description);

 if FQuery.AccessLevel = alPrivate then
   radAccessLevel.ItemIndex := 0
 else
   radAccessLevel.ItemIndex := 1;
end;

{Set button and field enable states}
procedure TfrmTemplate.SetButtons;
var
  sameUser: Boolean;
begin
 sameUser               := (FQuery.CreatorID = user.ID);
 boxFields.Enabled      := sameUser;
 if sameUser then
   boxFields.Caption    := 'Identification'
 else
   boxFields.Caption    := 'Read Only';

 if FQuery.ID = '+1' then
   begin
     mnuRestore.Enabled := False;
     popRestore.Enabled := False;

     mnuDelete.Enabled  := False;
     popDelete.Enabled  := False;

     mnuDefault.Enabled := False;
     popDefault.Enabled := False;

     mnuSave.OnClick    := mnuSaveAsClick;
     spdSave.OnClick    := mnuSaveAsClick;
     popSave.OnClick    := mnuSaveAsClick;
   end
 else if (FQuery.AccessLevel = alPublic) and (not sameUser) then
   begin
     mnuRestore.Enabled := False;
     popRestore.Enabled := False;

     mnuDefault.Enabled := True;
     popDefault.Enabled := True;

     mnuDelete.Enabled  := False;
     popDelete.Enabled  := False;

     mnuSave.OnClick    := mnuSaveAsClick;
     spdSave.OnClick    := mnuSaveAsClick;
     popSave.OnClick    := mnuSaveAsClick;
   end
 else
   begin
     mnuRestore.Enabled := True;
     popRestore.Enabled := True;

     mnuDelete.Enabled  := True;
     popDelete.Enabled  := True;

     mnuDefault.Enabled := True;
     popDefault.Enabled := True;

     mnuSave.OnClick    := mnuSaveClick;
     spdSave.OnClick    := mnuSaveClick;
     popSave.OnClick    := mnuSaveClick;
   end;
end;

procedure TfrmTemplate.mnuSaveClick(Sender: TObject);
var
  ClickOk : word;
  DupID   : TScStr20;
begin
  CheckActive(Sender);
  DupID   := FUser.CheckQueryName(RPCBrokerMain, FQuery.Name);
  ClickOk := mrOk;
  if (DupID <> '0') and (DupID <> FQuery.ID) then
    begin
      ClickOk := MessageDlg('Query with the same name found for user.' +
                             #13#10 + #13#10 +
                            'Ok to Replace?',
                          mtWarning, mbOkCancel, 0);
      if ClickOk = mrOk then
        FQuery.ID := DupID;
    end; {if}

  if ClickOk = mrOk then
    begin
      PostStatusMsg('Saving query...', False);
      if not FQuery.SaveQuery(RPCBrokerMain) then
        PostStatusMsg('Unable to save query!', True)
      else
        begin
          SetButtons;
          cboTemplate.GetList;
          cboTemplate.ItemIndex := cboTemplate.Items.IndexOf(FQuery.Name);

          if (FQuery.ID = FUser.DefaultQryID) and
             (FQuery.Name <> FUser.DefaultQryName) then
            begin
              FUser.DefaultQryName := FQuery.Name;
              pnlDefault.Caption   := 'Default: ' + FUser.DefaultQryName;
            end; {user default compare}

          FillIdFields;
          txtName.Modified        := False;
          memDescription.Modified := False;
          FQuery.Modified         := False;

          PostStatusMsg('Query saved.', True);
        end; {successful save}
    end; {ok to try to save}
end;

procedure TfrmTemplate.CheckActive(Sender: TObject);
var
  cntrl :TWinControl;
begin
  if ActiveControl <> nil then
    begin
      cntrl := ActiveControl;
      cmdClose.SetFocus;
      cntrl.SetFocus;
    end;
end;

procedure TfrmTemplate.mnuSaveAsClick(Sender: TObject);
var
  QName   : String;
  ClickOk : Boolean;
begin
  QName := txtName.Text;
  ClickOk := InputQuery('Save Query As...','Query Name:',QName);
  if (ClickOk) and (Length(QName)>2) then
    begin
      FQuery.ID        := '+1';
      FQuery.Name      := QName;
      FQuery.CreatorID := FUser.ID;
      FQuery.Creator   := FUser.Name;
      mnuSaveClick(Sender);
    end; 
end;

procedure TfrmTemplate.mnuDeleteClick(Sender: TObject);
var
   rpt: TScRptDef;
  rptID: TScStr20;
begin
  if MessageDlg('Ok to delete the "'
               + FQuery.Name
               + '" query template?', mtWarning, mbOkCancel, 0) <> mrOk then
               exit;

  PostStatusMsg('Deleting Query...', False);
  rptID := FQuery.ReportID;
  if not FQuery.DeleteQuery(RPCBrokerMain) then
    PostStatusMsg('Unable to delete query!', True)
  else
    begin
      PostStatusMsg('Query deleted.', False);
      cboTemplate.GetList;
      with cboTemplate do
        begin
          if Items.IndexOf(FUser.DefaultQryName) <> -1 then
            ItemIndex := Items.IndexOf(FUser.DefaultQryName)

          else if Items.Count > 0 then
            ItemIndex := 0;

          if ItemIndex <> -1 then
            cboTemplateClick(Sender);
        end; {with}
    end; {else}
end;

procedure TfrmTemplate.PostStatusMsg(msg: String; TimerStatus: Boolean);
begin
  Timer1.Enabled    := False;
  pnlStatus.Caption := ' ' + msg;
  Timer1.Enabled    := TimerStatus;
  Application.ProcessMessages;
end;

procedure TfrmTemplate.Timer1Timer(Sender: TObject);
begin
  pnlStatus.Caption := '';
  Timer1.Enabled    := False;
end;

procedure TfrmTemplate.mnuNewClick(Sender: TObject);
var
  rpt: TScRptDef;
begin
  CheckActive(Sender);
  if not QueryModifiedCheck(Sender) then
      exit;

  PostStatusMsg('Building new query...', False);
  ClearQryFields;
  FReport.GetRecord(RPCBrokerMain,FQuery.ReportID);
  FQuery.NewQuery(FReport, FUser);
  FillFields;
  cboPrinterChange(Sender);
  txtName.SetFocus;
  PostStatusMsg('New query created.', True);
end;

procedure TfrmTemplate.mnuRestoreClick(Sender: TObject);
begin
  PostStatusMsg('Restoring query definition...', False);
  FQuery.GetQuery(RPCBrokerMain, FQuery.ID);
  FillFields;
  PostStatusMsg('Query restored.', True);
end;

procedure TfrmTemplate.txtNameExit(Sender: TObject);
begin
  if txtName.Modified then
    begin
      FQuery.Name        := txtName.Text;
      if not FillingFields then
         FQuery.Modified := True;
    end;
end;

procedure TfrmTemplate.memDescriptionExit(Sender: TObject);
begin
  if memDescription.Modified then
    begin
      FQuery.Description.Assign(memDescription.Lines);
      if not FillingFields then
         FQuery.Modified := True;
    end;
end;

procedure TfrmTemplate.radAccessLevelClick(Sender: TObject);
begin
   FQuery.AccessLevel := TScAccessLevel(radAccessLevel.ItemIndex);
   if not FillingFields then
      FQuery.Modified := True;
end;

procedure TfrmTemplate.mnuDefaultClick(Sender: TObject);
begin
  with RPCBrokerMain do
    begin
      RemoteProcedure := 'SCUT SET USER QUERY DEFAULT';
      Param[0].PType  := literal;
      Param[0].Value  := FUser.ID;
      Param[1].PType  := literal;
      Param[1].Value  := FQuery.ID;
      Call;
      if piece(Results[0], u, 1) = '1' then
        begin
          FUser.LoadCurrentUser(RPCBrokerMain);
          pnlDefault.Caption := 'Default: ' + FUser.DefaultQryName;
          PostStatusMsg('Default query set.', True);
        end
      else
        Error.LoadAndDisplay(Results);
    end;
end;

procedure TfrmTemplate.mnuPrintClick(Sender: TObject);
var
  i,j         : integer;
  x,taskNum   : string;
  fld         : TScQryField;
begin
  CheckActive(Sender);
  Application.CreateForm(TfrmRptPrint, frmRptPrint);
  try
    with frmRptPrint do
      begin
        txtRunDate.AsDateTime := date;
        txtRunTime.AsDateTime := time;
        i := FQuery.Fields.IndexOF('cboPrinter');
        if i <> -1 then
          begin
            cboPtr.Items.Clear;
            cboPtr.ItemIndex := -1;
            fld := TScQryField(FQuery.Fields.Objects[i]);
            x := fld.Value;
            if x <> '' then
              begin
                cboPtr.FMLister.PartList.clear; {pdr}
                cboPtr.FMLister.PartList.Insert(0,x); {Part := x; - PDR}
                cboPtr.GetList;
                j := 0;
                while (cboPtr.ItemIndex = -1) and (j <> cboPtr.Items.Count) do
                  begin
                    if cboPtr.Items[j] = x then
                    cboPtr.ItemIndex := j;
                    inc(j);
                  end; {while}
              end; {x <> ''}
          end; {i <> -1}
        if ShowModal = mrOk then
           begin
              TaskNum := FQuery.ReportPrint(RPCBrokerMain,
                                            cboPtr.Items[cboPtr.ItemIndex],
                                            StrToFMDate(txtRunDate.AsString),
                                            txtRunTime.AsString);
              if TaskNum <> '0' then
                 MessageDlg('Print Task Number: ' + TaskNum,
                             mtInformation, [mbOk], 0);
           end; {ShowModal}
      end; {with}
  finally
    frmRptPrint.Free;
  end; {try}
end;

function TfrmTemplate.QueryModifiedCheck(Sender: TObject): Boolean;
var
  mrVal  : word;
begin
  Result := False;
  if FQuery.Modified then
    begin
      mrVal := MessageDlg('Current template has been modified.' + #13#10#13#10+
                 'Do you want to save the changes?', mtWarning, mbYesNoCancel, 0);

      if mrVal = mrCancel then exit;

      if mrVal = mrYes then
        begin
          if FQuery.ID = '+1' then
            mnuSaveAsClick(Sender)
          else
            mnuSaveClick(Sender);
          if FQuery.Modified then exit;
        end;
    end;
  Result := True;
end;

procedure TfrmTemplate.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := QueryModifiedCheck(Sender);
end;

procedure TfrmTemplate.GetQuery(QryID: TScStr20);
begin
 PostStatusMsg('Loading query...', False);
 if FQuery.GetQuery(RPCBrokerMain, QryID) then
    begin
      FReport.GetRecord(RPCBrokerMain,FQuery.ReportID);
      FillFields;
      cboReport.SetFocus;
      PostStatusMsg('Query loaded.', True);
    end;
end;

procedure TfrmTemplate.cboReportChange(Sender: TObject);
var
  SelectedID: TScStr20;
begin
  SelectedID := piece(GetFMDelimRec(cboReport.FMLister,cboReport.ItemIndex), u, 1);{piece(cboReport.FMLister.Results[cboReport.ItemIndex], u, 1); - PDR}
  if FQuery.ReportID <> SelectedID then
    if FReport.GetRecord(RPCBrokerMain, SelectedID) then
      begin
        FQuery.ReportID := FReport.ID;
        FQuery.Report   := FReport.Name;
        ClearQryFields;
        FQuery.ClearFields;
        FQuery.ClearSelections;
        ShowQryFields;
        FillQryFields;
        cboPrinterChange(Sender);
        FQuery.Modified := True;
      end;
end;

procedure TfrmTemplate.cmdSelectClick(Sender: TObject);
begin
  Application.CreateForm(TfrmSelections, frmSelections);
  try
    frmSelections.user       := Fuser;
    frmSelections.qry        := FQuery;
    frmSelections.Files      := FReport.Files;
    frmSelections.ShowModal;
  finally
    frmSelections.Free;
  end;
end;

procedure TfrmTemplate.radAssignedClick(Sender: TObject);
var
  value : TScStr100;
begin
  if radAssigned.ItemIndex <> -1 then
      value := radAssigned.Items[radAssigned.ItemIndex]
  else
      value := radAssigned.Items[1];
  SetFieldValue('radAssigned', value);
end;

procedure TfrmTemplate.chkSummaryClick(Sender: TObject);
begin
  chkUpdate(chkSummary);
end;

procedure TfrmTemplate.chkUpdate(chkfld: TCheckBox);
var
  value : TScStr20;
begin
  case chkfld.Checked of
    False: value := 'NO';
    True : value := 'YES';
  end;
  SetFieldValue(chkfld.Name, value);
end;

procedure TfrmTemplate.txtBeginDateChange(Sender: TObject);
begin
 if txtBeginDate.ValidateSelf then
  begin
   DateUpdate(txtBeginDate);
   SetEndLo;
  end
 else SetFocus;
end;

procedure TfrmTemplate.txtEndDateChange(Sender: TObject);
begin
  if txtEndDate.ValidateSelf then
   begin
    DateUpdate(txtEndDate);
    SetBeginHi;
   end
  else SetFocus;
end;

procedure TfrmTemplate.DateUpdate(txtDate: TOvcPictureField);
begin
  //<<orig code/bp/cmf 204>>SetFieldValue(txtDate.Name, StrToFMDate(txtDate.AsString));
  with txtDate do
   begin
    if IsValid then
     begin
      SetFieldValue(Name, StrToFMDate(AsString));
     end
    else
     begin
      frmMain.StatusMsg('Invalid Date',true);
      SetFocus;
     end;
   end;
end;

procedure TfrmTemplate.ClearQryFields;
begin
  cboSort.Items.Clear;
  cboSort.ItemIndex       := -1;
  txtBeginDate.AsDateTime := date;
  txtEndDate.AsDateTime   := date;
  SetEndLo;//bp/cmf 204
  chkSummary.Checked      := False;
  radAssigned.ItemIndex   := 1;
  ///out becuase of 177
  ///radPatStatus.ItemIndex  := 2;
end;

procedure TfrmTemplate.ShowQryFields;
var
  cnt: integer;
begin
  FillingFields        := True;
  radAssigned.Visible  := (FReport.fields.IndexOf('radAssigned')  <> -1);
  ///out because of 177
  ///radPatStatus.Visible := (FReport.fields.IndexOf('radPatStatus') <> -1);
  boxdates.Visible     := (FReport.fields.IndexOf('txtBeginDate') <> -1);
  chkSummary.Visible   := (FReport.fields.IndexOf('chkSummary')   <> -1);
  cboPrinter.Visible   := (FReport.fields.IndexOf('cboPrinter')   <> -1);

  cboReport.ItemIndex  := cboReport.Items.IndexOf(FReport.Name);

  cnt                  := FReport.Sorts.Count;
  cboSort.Enabled      := False;
  cboSort.Visible      := (cnt <> 0);
  lblSort.Visible      := (cnt <> 0);
  if cnt > 0 then
    begin
      cboSort.Items.Assign(FReport.Sorts);
      if cnt = 1 then
         begin
           cboSort.ItemIndex := 0;
           SetFieldValue('cboSort', cboSort.Items[0]);
         end
      else
        cboSort.Enabled := True;
    end;
  FillingFields := False
end;

function TfrmTemplate.GetValue(fld: String): String;
var
  q,r,i  : integer;
  value  : TScStr100;
begin
  Result := '';
  q := FQuery.fields.IndexOf(fld);
  r := FReport.fields.IndexOf(fld);
  if      q <> -1 then
    Result := TScQryField(FQuery.Fields.Objects[q]).Value
  else if r <> -1 then
    begin
      Value := TScRptField(FReport.Fields.Objects[r]).DefaultValue;
      if Value = 'TODAY' then
         Value := StrToFMDate(FormatDateTime('mm"/"dd"/"yyyy', date));
      SetFieldValue(fld, Value);
      Result := Value;
    end;
end;

procedure TfrmTemplate.FillQryFields;
var
  i   : integer;
  val : String;
begin
  FillingFields := True;
  Caption := 'Query Template Utility  (Report: ' + FQuery.Name + ')';
  if radAssigned.Visible then
      radAssigned.itemIndex := radAssigned.Items.IndexOf(GetValue('radAssigned'));

      ///out becuase of 177
  ///if radPatStatus.Visible then
     /// radPatStatus.itemIndex := radPatStatus.Items.IndexOf(GetValue('radPatStatus'));

  if chkSummary.Visible then
      chkSummary.Checked    := (GetValue('chkSummary') = 'YES');

  if cboPrinter.Visible then
    begin
      val := GetValue('cboPrinter');
      if val <> '' then
        begin
          cboPrinter.Clear;
          cboPrinter.FMLister.PartList.clear; {pdr}
          cboPrinter.FMLister.PartList.Insert(0,val);{Part := val; - PDR}
          cboPrinter.GetList;
          cboPrinter.ItemIndex := cboPrinter.Items.IndexOf(val);
        end;
    end;

  cboSort.ItemIndex := -1;
  if cboSort.Visible then
     begin
       i := cboSort.Items.IndexOf(GetValue('cboSort'));
       if i <> -1 then cboSort.itemIndex     := i;
     end;

  if txtBeginDate.Visible then
     begin
       val := GetValue('txtBeginDate');
       if val <> '' then
          txtBeginDate.AsDateTime := FMDateConvert(val)
       else
          txtBeginDate.AsDateTime := date;
     end;

  if txtEndDate.Visible then
     begin
       val := GetValue('txtEndDate');
       if val <> '' then
          txtEndDate.AsDateTime := FMDateConvert(val)
       else
          txtEndDate.AsDateTime := date;
     end;
  FillingFields := False;
 end;

procedure TfrmTemplate.SetFieldValue(fldName: TScStr50; value: TScStr100);
var
  i   : integer;
  fld : TScQryField;
begin
  i := FQuery.Fields.IndexOf(fldName);
  if i <> -1 then
    begin
      fld       := TScQryField(FQuery.Fields.Objects[i]);
      fld.Value := value;
    end
  else
    begin
      fld               := TScQryField.Create;
      fld.ComponentName := fldName;
      fld.Value         := value;
      FQuery.Fields.AddObject(fldName,fld);
    end;
  if not FillingFields then
     FQuery.Modified := True;
end;


procedure TfrmTemplate.spdCloseClick(Sender: TObject);
begin
 Close;
end;

procedure TfrmTemplate.cboTemplateClick(Sender: TObject);
var
  QryID: TScStr20;
begin
  if not QueryModifiedCheck(Sender) then
      exit;

  with cboTemplate do
    begin
      QryID := piece(GetResultString(FMLister, Items[ItemIndex], 2), u, 1);
      GetQuery(QryID);
    end;
end;

procedure TfrmTemplate.ShowDropDown(cboState: ComboBoxState);
var
wParam: word;
lParam: LongInt;
begin
  lParam :=0;
  wParam := 0;
  case cboState of
     ListUp:   wParam := 0;
     ListDown: wParam := 1;
  end;
  sendMessage(cboTemplate.Handle,CB_SHOWDROPDOWN, wParam, lParam);
end;

procedure TfrmTemplate.mnuPrivateClick(Sender: TObject);
begin
  spdPrivate.Down    := (not spdPrivate.Down);
  mnuPrivate.Checked := True;
  popPrivate.Checked := True;
  mnuPublic.Checked  := False;
  popPublic.Checked  := False;
  mnuAll.Checked     := False;
  popAll.Checked     := False;
  lstTemplate.ListerFlags := [lfInternal];{Flags  := 'SPI'; - PDR}
  lstTemplate.Screen := 'IF $P(^(0),U,2)=' + FUSER.ID;
  lstTemplate.FMIndex:= 'AC';
  lstTemplate.PartList.clear; {pdr}
  lstTemplate.PartList.Insert(0,FUser.ID); {Part   := FUser.ID; - PDR}
  cboTemplate.GetList;
  if cboTemplate.Items.Count > 0 then
    ShowDropDown(ListDown);
  if txtName.Text <> '' then
    cboTemplate.ItemIndex := cboTemplate.Items.IndexOf(txtName.Text);
  cboTemplate.SetFocus;
end;

procedure TfrmTemplate.mnuPublicClick(Sender: TObject);
begin
  spdPublic.Down     := (not spdPublic.Down);
  mnuPrivate.Checked := False;
  popPrivate.Checked := False;
  mnuPublic.Checked  := True;
  popPublic.Checked  := True;
  mnuAll.Checked     := False;
  popAll.Checked     := False;
  lstTemplate.ListerFlags := [lfInternal];{Flags  := 'SPI'; - PDR}
  lstTemplate.Screen := '';
  lstTemplate.FMIndex:= 'AD';
  lstTemplate.PartList.clear; {pdr}
  lstTemplate.PartList.Insert(0,'2'); {Part   := '2'; - PDR}
  cboTemplate.GetList;
  if cboTemplate.Items.Count > 0 then
    ShowDropDown(ListDown);
  if txtName.Text <> '' then
    cboTemplate.ItemIndex := cboTemplate.Items.IndexOf(txtName.Text);
  cboTemplate.SetFocus;
end;

procedure TfrmTemplate.mnuAllClick(Sender: TObject);
begin
  spdAll.Down        := (not spdAll.Down);
  mnuPrivate.Checked := False;
  popPrivate.Checked := False;
  mnuPublic.Checked  := False;
  popPublic.Checked  := False;
  mnuAll.Checked     := True;
  popAll.Checked     := True;
  lstTemplate.ListerFlags := []; {Flags  := 'SP'; - PDR}
  lstTemplate.Screen := 'IF $P(^(0),U,2)=' + FUser.ID + '!($P(^(0),U,3)=2)';
  lstTemplate.FMIndex:= 'B';
  lstTemplate.PartList.clear; {pdr}
  lstTemplate.PartList.Insert(0,'');{Part   := ''; - PDR}
  cboTemplate.GetList;
  if cboTemplate.Items.Count > 0 then
    ShowDropDown(ListDown);
  if txtName.Text <> '' then
    cboTemplate.ItemIndex := cboTemplate.Items.IndexOf(txtName.Text);
  cboTemplate.SetFocus;
end;

procedure TfrmTemplate.spdPrivateClick(Sender: TObject);
begin
  if mnuPrivate.Checked = False then
    mnuPrivateClick(Sender);
end;

procedure TfrmTemplate.spdPublicClick(Sender: TObject);
begin
  if mnuPublic.Checked = False then
    mnuPublicClick(Sender);
end;

procedure TfrmTemplate.spdAllClick(Sender: TObject);
begin
  if mnuAll.Checked = False then
    mnuAllClick(Sender);
end;

procedure TfrmTemplate.cboTemplateExit(Sender: TObject);
begin
  ShowDropDown(ListUp);
end;

procedure TfrmTemplate.cboSortChange(Sender: TObject);
var
  i     : integer;
  newValue, oldValue : TScStr100;
begin
  oldValue := GetValue('cboSort');
  i := cboSort.ItemIndex;
  if i <> -1 then
    newValue := cboSort.Items[i]
  else
    newValue := '';

  if newValue <> oldValue then
    SetFieldValue('cboSort', newValue);
end;

procedure TfrmTemplate.cboPrinterChange(Sender: TObject);
var
  i     : integer;
  newValue, oldValue : TScStr100;
begin
  oldValue := GetValue('cboPrinter');
  i := cboPrinter.ItemIndex;
  if i <> -1 then
    newValue := cboPrinter.Items[i]
  else
    newValue := '';

  if newValue <> oldValue then
    SetFieldValue('cboPrinter', newValue);
end;

procedure TfrmTemplate.radPatStatusClick(Sender: TObject);
var
  value : TScStr100;
begin
  if radPatStatus.ItemIndex <> -1 then
      value := radPatStatus.Items[radPatStatus.ItemIndex]
  else
      value := radPatStatus.Items[2];
  SetFieldValue('radPatStatus', value);
end;

procedure TfrmTemplate.txtBeginDateDblClick(Sender: TObject);
begin
 with frmEnterDate do
  begin
   Caption := 'Enter Begin Date:';
   if txtBeginDate.AsOvcDate = BadDate then
     initDate := SysUtils.Date
   else
     initDate := txtBeginDate.AsDateTime;
   ShowModal;
   if ModalResult = mrOk then
    begin
      txtBeginDate.AsString := frmEnterDate.strDate;
      txtBeginDateChange(self);
    end;
  end;
end;

procedure TfrmTemplate.txtEndDateDblClick(Sender: TObject);
begin
 with frmEnterDate do
  begin
   Caption := 'Enter End Date:';
   if txtEndDate.AsOvcDate = BadDate then
     initDate := SysUtils.Date
   else
     initDate := txtEndDate.AsDateTime;
   ShowModal;
   if ModalResult = mrOk then
    begin
     txtEndDate.AsString := frmEnterDate.strDate;
     txtEndDateChange(self);
    end;
  end;
end;

procedure TfrmTemplate.txtBeginDateExit(Sender: TObject);
begin
 SetEndLo;
end;

procedure TfrmTemplate.txtEndDateExit(Sender: TObject);
begin
 SetBeginHi;
end;

procedure TfrmTemplate.SetEndLo;
begin
 txtEndDate.RangeLo   := FormatDateTime('mm"/"dd"/"yyyy', txtBeginDate.AsDateTime);
end;

procedure TfrmTemplate.SetBeginHi;
begin
 txtBeginDate.RangeHi := FormatDateTime('mm"/"dd"/"yyyy', txtEndDate.AsDateTime);
end;

end.
