{*******************************************************************}
{                                                                   }
{  Patient/Team Assignment Selection for Primary Care               }
{  Management a component of the Scheduling Redesign Project        }
{  This form will show all teams a patient is assigned to and       }
{  allows additional assigments, assignment edits, and discharges.  }
{                                                                   } 
{ Scheduling ver 5.3 AUG 13, 1993                                   }      
{ Management Information Products Group                             }
{ Albany NY (SCK)                                                   }
{ Dept. of Veteran Affairs                                          }
{                                                                   }
{    Last updated: 28 May 2002 (J. Peterson)                        }
{                                                                   }
{*******************************************************************}

unit Scptpf;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons,  ExtCtrls, Scutdef, Scut2, Scutbrk,
  Scut3, Fmcmpnts, Grids, Menus, Fmcntrls, Trpcb, Fmlookup,
  OvcBase, OvcVlb, Mfunstr, DateTime, Pcmm1, IniFiles {,Gtsize32, GTVASzr - PDR},
  Diaccess;


type  TPatientAsgn = class(TForm)
    cmdClose: TBitBtn;
    Label3: TLabel;
    Label10: TLabel;
    Label5: TLabel;
    LBLHDDOB: TLabel;
    Label2: TLabel;
    LBLHDID: TLabel;
    frmPatientInfo: TPanel;
    lblPatientId: TFMLabel;
    lblPrimaryElig: TFMLabel;
    lblMeansTest: TFMLabel;
    lblDob: TFMLabel;
    lblVerified: TFMLabel;
    lblMTDate: TFMLabel;
    getPatient: TFMGets;
    PopupMenu1: TPopupMenu;
    AddToTeam2: TMenuItem;
    Bevel1: TBevel;
    Bevel2: TBevel;
    ltrTeams: TFMLister;
    FMLister2: TFMLister;
    GetPatient1: TMenuItem;
    N1: TMenuItem;
    lkpLookUp: TFMLookUp;
    ltrPatient: TFMLister;
    lstTeams: TOvcVirtualListBox;
    OvcController1: TOvcController;
    cmdHelp: TBitBtn;
    MainMenu1: TMainMenu;
    Edit1: TMenuItem;
    lblEligibiity: TFMLabel;
    Header1: THeader;
    hdrForm: THeader;
    cmdNewTeam: TBitBtn;
    EditTeam: TMenuItem;
    File1: TMenuItem;
    SelectPatient1: TMenuItem;
    SelectbyTeam1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    AddToTeam: TMenuItem;
    EditTeam1: TMenuItem;
    cmdEditTeam: TBitBtn;
    N3: TMenuItem;
    DeleteTeam1: TMenuItem;
    flrTeam: TFMFiler;
    {GTVAForm1: GTVAForm; - PDR}
    lblSSN: TFMLabel;
    lblPtID: TLabel;
    procedure FormResize(Sender: TObject);
    procedure lstTeamsGetItem(Sender: TObject; Index: Longint;
      var ItemString: String);
    procedure SelectPatient1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TeamAssign2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure UpdateMenus(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure EditTeam2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cmdCloseClick(Sender: TObject);
    procedure lstTeamsGetItemColor(Sender: TObject; Index: Longint; var FG,
      BG: TColor);
    procedure DeleteTeam1Click(Sender: TObject);
    procedure lstTeamsGetItemStatus(Sender: TObject; Index: Longint;
      var Protect: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lstTeamsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    DataList     : TStringList;
    DeleteOk     : Boolean;
    PatientName  : TScStr50;
    PatientDFN   : TScStr20;
    HasPCTeam:String; {PDR}
  public
    { Public declarations }
    DFN: string;
    procedure GetPatientData;
    procedure getTeamListRecord(strEntry: string);//LR-1298-70920
    procedure GetTeams;
    //procedure Pad(var s: string);
    procedure LoadSettings;

   { function execute:bool;}

  end;

//LR-1298-70920
type
TrcdTeam = Record
 strHasPCTeam: string;
 strForDataList: string;
 end;
//LR-1298-70920

var
  PatientAsgn: TPatientAsgn;
  TeamAsgn: TTeamAsgn;
  rcdTeam: TrcdTeam;//LR-1298-70920

implementation

uses Scpatlkp, Scpttmf, dmuTeam;

{$R *.DFM}


{
  Set the tab stops for the team display list.  Create the DataList for the
  team assignments.  Clear the display list.
}
procedure TPatientAsgn.FormCreate(Sender: TObject);
var
  TabArray: array[0..2] of Integer;
begin
  frmMain.PatientAssign.enabled := false;
  frmMain.cmdPatient.enabled := false;
  frmMain.ShowMenu := false;

  TabArray[0] := 275 {130};
  TabArray[1] := 325 {153};
  TabArray[2] := 450 {189};
  lstTeams.SetTabStops(TabArray);
  DataList := TStringList.Create;
  lstTeams.NumItems := 0;
  Top := 10;
  left := (frmMain.ClientWidth  - width) div 2;
end;

{
  Load default user settings from user file and/or INI file.
}
procedure TPatientAsgn.LoadSettings;
var
  AppIni: TIniFile;
begin
  Font.Assign(FrmMain.FontDialog1.Font);
  DeleteOk := SecurityKeyOk(RPCBrokerMain, DELETE_KEY);
  {Notyet}
end;

{
  Release memory in use by the Team assignments datalist.
}
procedure TPatientAsgn.FormDestroy(Sender: TObject);
begin
  {ClearData}
  DataList.Free;
end;

{
  release the form's memory
}
procedure TPatientAsgn.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  frmMain.PatientAssign.enabled := true;
  frmMain.cmdPatient.enabled := true;
  frmMain.ShowMenu := true;

  Action := cafree;
end;

{
  When showing the form, update the menu items status, and call the patient
  selection procedure.
}
procedure TPatientAsgn.FormShow(Sender: TObject);
begin
  LoadSettings;
  Top := 10;
  UpdateMenus(nil);
  application.CreateForm(TfrmPatLookup, frmPatLookup);

  try
     frmPatLookup.showModal;
  finally
     if frmPatLookup.ModalResult = mrOk then begin
        DFN := frmPatLookup.LookUpDfn;
        PatientName := frmPatLookup.LookUpPat;
        hdrForm.Sections[1] := PatientName;
        getPatientData;
        end
     else
        postmessage(handle, WM_CLOSE, 0, 0);
     frmPatLookup.free;
  end;
end;


procedure TPatientAsgn.FormResize(Sender: TObject);
begin
 ClientHeight := 290 ;
 ClientWidth  := 496 ;
end;

{
  Display the patient's data from file #2, and call the procedure to load
  the patient's team assignment data.  A broker utility call is required
  to retrieve the patient's  Means Test Info.
}
procedure TPatientAsgn.GetPatientData;
var
  mt: string;
  dt: string[20];
begin
  lstTeams.NumItems := 0;
  getPatient.IENS := DFN;
  getPatient.GetandFill;

  {New code 1/30/97  added .09 to getPatient in case EligibilityID missing - RV }
  if lblPatientID.Caption = '' then
     lblPtID.Caption := Copy(lblSSN.Caption,1,3) + '-' + Copy(lblSSN.Caption,4,2) +
             '-' + Copy(lblSSN.Caption,6,5)
  else
     lblPtID.Caption := lblPatientID.Caption   ;
  {End new code 1/30/97 - RV}

  {PatientName := frmPatLookup.LookUpPat;}
  {hdrForm.Sections[1] := frmPatLookup.LookUpPat;}
  {hdrForm.Sections[1] := PatientName;}
  lblPrimaryElig.Caption := Copy(lblEligibiity.Caption, 1, 40);
  mt :=MeansTestInfo(RPCBrokerMain,dfn) ;
  dt := Piece(mt, U, 2);

  if not (dt = '') then lblMTDate.Caption :=
     UpperCase(FormatDateTime('mmm dd, yyyy', FromFMDateTime(dt,false)))
  else
     lblMTDate.Caption := '';

  mt:=piece(mt,U,10);
  IF StrToInt(piece(mt,';',1))>2 then
      hdrForm.Sections[2]:='On Wait List '+ Piece(mt,';',2);

 GetTeams;
end;

{
  Get a list of teams that the patient is currently assigned to.  Create a
  temporary string list to return the team data in.  Pass it to the broker
  utility which retrieves the data from DHCP.  The team data is returned as:
  1. Team Ien
  2. Team Name
  3. File 404.42 Ien
  4. Current Eff. Date
  5. Current Inac. Date
  6. Purpose Ien
  7. Purpose Name
  8. Primary Care Team Y/N.

  If there is no current inactivation, or the Inactivation date is in the
  future, then display the team entry, otherwise, ignore the entry.

  Pad the team name to 25 char., set the primary care var to '*' if this
  team is the primary care team, otherwise set it to '-'.  Format the
  effective date to external format.  Add the name, pc var, eff. date and
  the team ien as a string entry in the DataList seperated by tabs.  The
  Team Ien is tabbed so as not to appear in the display list, but can be
  pieced out.
}
procedure TPatientAsgn.GetTeams;
var
  teams: TStringList;
  i: integer;
  mt: string;
  {pn, Adt: string;
  pc, inac: char;
  Ddt: string[15];}
begin
  try
     HasPCTeam := '0'; //PDR
     DataList.Clear;
     teams := TStringList.create;

     if frmMain.ShowAllTeams.checked then
        GetTeamList(RPCBrokerMain, dfn,'2900101', '3991231', '', teams)
     else
        GetTeamList(RPCBrokerMain, dfn, '""','""','""',teams);

    //Format entries in the DataList for display in the Team Assignment List box
     for i := 0 to Teams.Count - 1 do
      begin
       getTeamListRecord(teams[i]);
       if rcdTeam.strHasPCTeam <> '0' then
        HasPCTeam := rcdTeam.strHasPCTeam;
       DataList.Add(rcdTeam.strForDataList);
      end;

     with lstTeams do begin
        numItems := DataList.Count;
        end;

     lstTeams.Repaint;
     {if PatientAsgn.enabled then lstTeams.Setfocus;}
     cmdEditTeam.enabled := (DataList.Count > 0);
    
  finally
     teams.free;
  end;
   //recheck wait list
    mt :=MeansTestInfo(RPCBrokerMain,dfn) ;
    hdrForm.Sections[2]:= Piece(Piece(mt,U,10),';',2) ;
end;

{
  Load the OVC virtual listbox with the data in the DataList.
}
procedure TPatientAsgn.lstTeamsGetItem(Sender: TObject; Index: Longint;
  var ItemString: String);
begin
  If (index >= 0) and (Index < DataList.Count) then
     ItemString := DataList.Strings[Index];
end;

{
  Call the patient selection lookup.  If a patient is returned, then
  call the procedure to retrieve and display the patients data.
}
procedure TPatientAsgn.SelectPatient1Click(Sender: TObject);
begin
  application.Createform(TfrmPatLookup, frmPatLookup);
  try
     frmPatLookup.showModal;
     if frmPatLookup.ModalResult = mrOk then begin
        DFN := frmPatLookup.LookUpDfn;
        getPatientData;
        PatientName := frmPatLookup.LookUpPat;
        hdrForm.Sections[1] := PatientName;
        end;
  finally
     frmPatLookup.free;
  end;
end;

{
  //pad the team name to 25 characters for formatted display in the team
  //selection list box.

procedure TPatientAsgn.Pad(var s: string);
var
  i: integer;
begin
  for i := Length(s) to 25 do
     s := s + ' ';
end;}

{
  Add the patient to a new team.  Display a list of currently active teams.
  When a team has been selected, Open the team assignment data form.
}
procedure TPatientAsgn.TeamAssign2Click(Sender: TObject);
var
  TeamAsgn: TTeamAsgn;
  new, continue: boolean;
  frm : TfrmTeamAssign;
  activeonly: string[10];
  WAITLISTINFO: STRING;
  //LR-1298-70920//cur, max: string[10];
begin
  if not MemoryOk then
     raise EInsufficientMemory.Create(
                      'Insufficient memory to open the Team Assignment form.' +
                      RETURN + 'Please close PCMM and restart the application.')
  else
     with lkpLookUp do begin
        FMLister.FromList.clear; {pdr}
        FMLister.FromList.insert(0,'');{From := ''; - PDR}
        FMLister.FromIen := '';
        FMLister.PartList.clear; {pdr}
        FMLister.PartList.Insert(0,''); {Part := ''; - PDR}
        FMLister.Number := '*';
        Title := 'Select Team Assignment';
        AllowNew := false;

        {CHANGED 2/6/97 - REV}
        if frmMain.ActiveOnly1.checked then
           activeonly := '1'
        else
           activeonly := '0' ;
        FMLister.Screen := 'IF $$OKACPTTM^SCMCTMU2(' + DFN + ',Y,,'+activeonly+')' ;
        {FMLister.Screen := 'IF $$ACTHISTB^SCAPMCU1(404.58,Y)' }

        end;

        if lkpLookUp.Execute(new) then
         begin
           //LR-1298-70920 - new code begin
           TeamAsgn.TeamIen := lkpLookUp.RecordNumber;
           dmcTeam.CreateTeamRecord(TeamAsgn.TeamIen);

           with team do
            begin
             if not ErrCode = 0 then
              raise EBrokerError.Create(ErrMsg);
             if TeamClosed then
              if not CheckTeamClosed then exit;
              WAITLISTINFO:= DFN+'^'+TeamAsgn.TeamIen;
              IF PIECE(GlobalNode(RPCBrokerMain, '^SCTM(404.51,' + TeamAsgn.TeamIen + ',0)'),'^',5)<>'1' THEN WAITLISTINFO := '-';
              //IF NOT TeamAsgn. THEN WAITLISTINFO:='-' ;
             if not CheckTeamMax(CurrentAssigned,
                                 MaxAssigned,WAITLISTINFO) then exit;
            end;
           //LR-1298-70920 - new code end

           {//LR-1298-70920 - old code begin
           with getTeamInfo do begin
              IENS := lkpLookUp.RecordNumber;
              GetData;
           end;
           if Piece(GetFMDelimRec(getTeamInfo,2), U, 4) = '1' then//Piece(getTeamInfo.Results[2], U, 4) = '1' then - PDR
              if not CheckTeamClosed then exit;

           cur := Piece(GetFMDelimRec(getTeamInfo,3), U, 5);//Piece(getTeamInfo.Results[3], U, 5); - PDR
           if cur = emptystr then cur := '0';

           max := Piece(GetFMDelimRec(getTeamInfo,1), U, 5);//Piece(getTeamInfo.Results[1], U, 5); - PDR
           if max = emptystr then max := '0';
           if (pos(',',max)>0) then
              repeat
                    max := copy(max,1,pos(',',max)-1)+copy(max,pos(',',max)+1,99) ;
              until pos(',',max)=0 ;

           if not CheckTeamMax(StrToInt(cur), StrToInt(max)) then exit;}
           //LR-1298-70920 - old code end}

           TeamAsgn.TeamName :=
                 Piece(GetFMDelimRec(lkpLookup.Fmlister,lkpLookup.RecordIndex), U, 2);//Piece(lkpLookup.Fmlister.Results[lkpLookup.RecordIndex], U, 2); - PDR
           TeamAsgn.Dfn := dfn;
           TeamAsgn.Patient := PatientName; //hdrForm.Sections[1];
           TeamAsgn.TeamIen := lkpLookUp.RecordNumber;
           TeamAsgn.TeamAsgn := '';
           TeamAsgn.TeamName :=
                 Piece(GetFMDelimRec(lkpLookUp.FMLister,lkpLookUp.RecordIndex), U, 2);//Piece(lkpLookUp.FMLister.Results[lkpLookUp.RecordIndex], U, 2); - PDR
           TeamAsgn.EffDate := emptystr;
           TeamAsgn.Parent := PatientAsgn;
           TeamAsgn.Mode := AddItem;

           Application.CreateForm(TfrmTeamAssign, frmTeamAssign);
           //frm := TfrmTeamAssign.Create(application);
           application.ProcessMessages;

           frmTeamAssign.TmProfile := TeamAsgn;
           frmTeamAssign.FrmParent := self;
           frmTeamAssign.HasPCTeam := HasPCTeam;  //PDR
           frmTeamAssign.LoadTeam;

           //frmTeamAssign.Execute; //(TeamAsgn);

           end;
end;


{
  Update menu item status.
}
procedure TPatientAsgn.UpdateMenus(Sender: TObject);
begin
  EditTeam.enabled := (DataList.Count > 0) and not (dfn = emptystr);
  EditTeam1.enabled := EditTeam.enabled;

  AddToTeam.enabled := not (dfn = emptystr);
  AddtoTeam2.enabled := AddToTeam.enabled;

  DeleteTeam1.enabled := ((lstTeams.ItemIndex > -1) and DeleteOk);
end;

{
  On the exit menu selection, close the form.
}
procedure TPatientAsgn.Exit1Click(Sender: TObject);
begin
  Close;
end;

{
  When editins an existing team assignment entry, set the patient dfn, the
  team ien, and the effective date for the team assignment entry.  Call the
  team assignment data form.
}
procedure TPatientAsgn.EditTeam2Click(Sender: TObject);
{var
  frm : TfrmTeamAssign;}
begin
  if not MemoryOk then
     raise EInsufficientMemory.Create(
                      'Insufficient memory to open the Team Assignment form.' +
                      RETURN + 'Please close PCMM and restart the application.')
  else
     begin
        {Added 1/2/97 - RV}
        if (lstTeams.ItemIndex = -1) then exit ;

        TeamAsgn.Dfn := dfn;
        TeamAsgn.TeamIen := Piece(DataList[lstTeams.ItemIndex], TAB, 5);
        TeamAsgn.TeamName := Piece(DataList[lstTeams.ItemIndex], TAB, 1);
        TeamAsgn.EffDate := StrToFMDate(Piece(DataList[lstTeams.ItemIndex],
                                        TAB, 3));
        TeamAsgn.TeamAsgn := Piece(DataList[lstTeams.ItemIndex], TAB, 7);
        TeamAsgn.Patient := PatientName; {hdrForm.Sections[1];}
        TeamAsgn.PrimaryCare := (Piece(DataList[lstTeams.ItemIndex], TAB, 2) = '*');
        TeamAsgn.Parent := self;
        TeamAsgn.Mode := EditItem;

        Application.CreateForm(TfrmTeamAssign, frmTeamAssign);
        {frm := TfrmTeamAssign.Create(self);}
        {frm.execute(TeamAsgn);}
        application.ProcessMessages;
        Self.enabled := false;
        frmTeamAssign.TmProfile := TeamAsgn;
        frmTeamAssign.FrmParent := self;
        frmTeamAssign.HasPCTeam := HasPCTeam;  {PDR}
        frmTeamAssign.LoadTeam;
        frmTeamAssign.show;
     end;
end;


procedure TPatientAsgn.cmdCloseClick(Sender: TObject);
begin
  close;
end;

procedure TPatientAsgn.lstTeamsGetItemColor(Sender: TObject;
  Index: Longint; var FG, BG: TColor);
begin
  {if Piece(DataList[index], TAB, 6) = '1' then begin
     FG := clMaroon;
     end;}
end;

procedure TPatientAsgn.lstTeamsGetItemStatus(Sender: TObject;
  Index: Longint; var Protect: Boolean);
begin
  if Piece(DataList[index], TAB, 6) = '1' then
     Protect := true;
end;


procedure TPatientAsgn.DeleteTeam1Click(Sender: TObject);
var
  msg: string;
  s: string[30];
  ien: string[15];
begin
  MSG := '';
  ien := Piece(DataList[lstTeams.ItemIndex], TAB, 7);
  if not DeleteEntryOk(RPCBrokerMain, TPatTeam, ien, msg) then begin
     if not (length(msg) > 0) then msg := 'This team assignment cannot be deleted!';
     messagedlg(msg, mtInformation, [mbOk,mbHelp], 80000);
     exit;
  end;
  {hdrForm.Sections[1]}
  msg := 'You are about to delete the ' + TeamAsgn.TeamName + RETURN +
         'Team assignment for ' + PatientName  + RETURN +
         'Do you want to do this?';

  if messageDlg(msg, mtConfirmation, [mbYes,mbNo], 0) = mrYes then begin
     if Deleter(RPCBrokerMain, '^SCPT(404.42,', Ien) then begin
        frmMain.StatusMsg('The ' + TeamAsgn.TeamName + ' assignment was deleted.', false);
        getPatientData;
     end
     else
        messageDlg('There was a problem deleting this assignment.', mtWarning,
                    [mbOk,mbHelp], 80000);
  end;
end;

procedure TPatientAsgn.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key = VK_F10) and (Shift = [ssShift])  then
        sendMessage(Handle, WM_RBUTTONDOWN, 0, 0)
end;

procedure TPatientAsgn.lstTeamsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_SPACE) then EditTeam2Click(nil);
end;

procedure TPatientAsgn.getTeamListRecord(strEntry: string);
//LR-1298-70920 parse data string
var
inac,pn,Adt,Ddt,pc: string;

TeamIen,
 TeamName,
 TmAsgnIEN,
 ActiveDt,
 DischargeDt,
 PatPCTm,

frmtPatPCTm,
 frmtActiveDt,
 frmtDischargeDt,
 frmtTeamName,

Inactive: string;

begin
    //If the patient has been discharged from the team assignment tag the entry
    //with a '1', if the patient will be discharged in the future, or there is
    //no discharge date, than tag the entry with a '0'

        rcdTeam.strHasPCTeam := '0';

        TeamIen     := piece(strEntry,U,1);
        TeamName    := piece(strEntry,U,2);
        TmAsgnIen   := piece(strEntry,U,3);
        ActiveDt    := piece(piece(strEntry,U,4),'.',1);
        DischargeDt := piece(piece(strEntry,U,5),'.',1);
        PatPCTm     := piece(strEntry,U,8);


        if DischargeDt = '' then
         Inactive := '0'
         else if StrToInt(DischargeDt) >
          StrToInt(ToFMDateTime(Now, false)) then
           Inactive := '0'
        else
         Inactive := '1';

        frmtTeamName := TeamName;
        frmPatLookup.Pad(frmtTeamName);

        if PatPCTm = '1' then
         begin
          frmtPatPCTm := '*';
          if Inactive = '0' then
           rcdTeam.strHasPCTeam := TeamIen;
         end
        else
         frmtPatPCTm := '-';


     //Set the Assignment and discharge dates

        frmtActiveDt := FormatDateTime('mm/dd/yyyy',
         FromFMDateTime(ActiveDt, False));

        if Length(DischargeDt) > 1 then
           frmtDischargeDt := FormatDateTime('mm/dd/yyyy',
            FromFMDateTime(DischargeDt,false))
        else
           frmtDischargeDt := '';
        frmtActiveDt := frmtActiveDt + '  ' + frmtDischargeDt;

        rcdTeam.strForDataList :=
                frmtTeamName + TAB +
                frmtPatPCTm  + TAB +
                frmtActiveDt + TAB +
                               TAB +
                TeamIen      + TAB +
                Inactive     + TAB +
                TmAsgnIen;
end;



end.
