{*******************************************************}
{                                                       }
{       File Manager Tools for Scheduling               }
{                                                       }
{       Tool Type: Database Server Tools                }
{                                                       }
{            Date: 10/23/95                             }
{                                                       }
{         Version: 1T7                                  }
{                                                       }
{*******************************************************}

unit Scut2;

interface

uses trpcb, Classes, mfunstr, fmcmpnts, scutdef, DiAccess, DiTypLib;

type
 LockOperation = (UnLockANode, LockANode);{(UnLockNode, LockNode); changed
 names due to conflict with function by the name of LockNode in DiTypLib unit
 - PDR  Jun 98}

 TFileMan = Record
  FileNumber: string[15];
  Iens: string[15];
  Fields: string;
  Flags: string[15];
  Value: string[30];
  Number: string[15];
  Index: string[15];
  Screen: string;
  Identifier: string;
 end;

function GetResultString(FMLister: TFMLister; str: String; position: Integer): String;
function Deleter(RPCBroker: TRPCBroker; FMRoot, FMEntry: String): Boolean;
function Locker(RPCBroker: TRPCBroker; FMNode: String; LockMode: LockOperation; FMTimeOut: Integer): Boolean;
function FileNumber(RPCBroker: TRPCBroker; FMFileName: String): String;
function GlobalNode(RPCBroker: TRPCBroker; MGlobalNode: String): String;
function CheckGlobal(RPCBroker: TRPCBroker; FMNode: string; FMXref: string; FMEntry: string): integer;
function FMToStr(fmDate: string): string;
procedure FindList(RPCBroker: TRPCBroker; FMData: TFileMan; var FMFind: TStrings);
procedure NotYet;
Function GetFMDelimRec(rec:TObject; indx:integer): String; {PDR 4 Jun 98}
Function GetListerRec(List:TFMLister; indx:integer):string; {PDR}
function GetGetsRec(rec:tstrings; indx:integer; fnum:string):string; {PDR 5 Jun 98}


implementation
uses SysUtils, Dialogs, xwbut1;

function GetGetsRec(rec:tstrings; indx:integer; fnum:string):string; {PDR 5 Jun 98}
begin
 with rec.objects[indx] as TFMFieldObj do
  result:=fnum + U + IENS + U +  FMField + U + FMDBInternal + U + FMDBExternal;
end;

Function GetListerRec(List:TFMLister; indx:integer):string; {PDR}
var
 ien:string;
 Function GetRec(rec:TStrings): String; {PDR}
 Var
  i:integer;
 begin
  result:='';
  for i:= 0 to pred(rec.count) do
   begin
    if List.ListerFlags = [lfInternal] then  {return internal or external results}
     result:=result + TFMFieldOBj(rec.objects[i]).FMDBInternal + '^'
    else
     result:=result + TFMFieldOBj(rec.objects[i]).FMDBExternal + '^';;
   end;
  if result <> '' then
   result:=copy(result,1,length(result)-1); {strip last ^}
 end;
begin
 result:='';
 if indx<0 then exit;
 with list do
  begin
   ien:=results[indx];
   result:=ien + '^' + GetRec(TFMRecordObj(results.objects[indx]).FMFldValues);
  end;
end;

Function GetFMDelimRec(rec:TObject; indx:integer): String; {PDR 4 Jun 98}
{Takes either a TFMLister or a TFMGets object. Returns the appropriate results
 string in the old 16 bit delimeted format. The order of fields in the record
 string is by field number in ascending order as returned by the
 server.
 Inclusion of fields in the record string is specified by the FMGets or FMLIster
 FieldNumbers stringlist. For the FMLister which returns a record, only the
 fields included in the FMFieldNumbers stringlist will be represented in the
 record, and there will be no naked delimeters to represent unnamed field values.
 This may deviate somewhat from what the 16 bit version record string returned.
 Keep in mind also that the order of fields in the lister record is offset from
 the position in FM doc by +1 since the string returned has the ien in piece 1.}
var
 i:integer;
begin
 Result:='';
 if rec is TFMGets then
  Result := GetGetsRec(TFMGets(rec).results,indx,TFMGets(rec).FileNumber)
 else if rec is TFMLister then
  Result := GetListerRec(TFMLister(rec),indx);
end;

function FMToStr(fmDate: string): string;
var
   ce,yy,mm,dd,hh,nn,ss : string[2];
begin
    if fmDate <> '' then
      begin
           ce := IntToStr(StrToInt(Copy(fmDate,1,1))+17) ;  {century from char 1}
           yy := Copy(fmDate,2,2);  {year from chars 2-3}
           mm := Copy(fmDate,4,2);  {month from chars 4-5}
           dd := Copy(fmDate,6,2);  {day from chars 6-7}
           result := mm + '/' + dd + '/' + ce + yy;
      end
    else
           result := '' ;
end;

{GetResultString function returns the entire item in the Results list of
 'FMLister' where 'str' parameter value matches the value of the piece
 designated by the 'position' parameter.

 Warning: Only use this function if it is known that each value at the
          piece 'position' is unique within the list.}

function GetResultString(FMLister: TFMLister; str: String; position: Integer): String;
var
  i: Integer;
  x: string;
begin
  x := '';
  i := 0;
  while (FMLister.Results.Count > i) and (x = '') do
    begin
      { Original code - pdr 6/98
      if piece(FMLister.Results[i], '^', position) = str then
        x := FMLister.Results[i]; }
     x := GetFMDelimRec(FMLister,i);
     if piece(x, '^', position) <> str then
        x := '';
     inc(i);
    end;
  Result := x;
end;

procedure FindList(RPCBRoker: TRPCBroker; FMData: TFileMan; var FMFind: TStrings);
begin
  RPCBroker.remoteProcedure := 'SC FIND';
  with RPCBroker.Param[0] do
     begin
        Value := '.SC';
        Ptype := list;

           Mult['"FILE"'] := FMData.FileNumber;
           Mult['"IENS"'] := FMData.Iens;
           Mult['"FIELDS"'] := FMData.Fields;
           Mult['"FLAGS"'] := FMData.Flags;
           Mult['"VALUE"'] := FMData.Value;
           Mult['"MAX"'] := FMData.Number;
           Mult['"XREF"'] := FMData.Index;
           Mult['"SCREEN"'] := FMData.Screen;
           Mult['"ID"'] := FMData.Identifier;
       end;

  RPCBroker.Call;
  FMFind.Assign(RPCBroker.Results)
end;

{         ***************** Piece *****************

 This function works that same as the $Piece function in M

 Note: It currently does not support $P(X,U,1,3)-type calls.
}
{function Piece(x: string; del: char; piece: integer) : string;
var
delIndex,pieceNumber,startScanIndex,firstCharIndex: integer;

begin
{initialize variables}
{startScanIndex:=1;
pieceNumber :=0;
delIndex :=1;
Result :='';

repeat
      delIndex := Pos(del,Copy(x+del,startScanIndex,length(x)));
      if delIndex > 0 then
         begin
              inc(pieceNumber);
              firstCharIndex := startScanIndex;
              startScanIndex := startScanIndex + delIndex;
         end;
until (pieceNumber = piece) or (delIndex = 0);

if delIndex > 0 then Result := Copy(x, firstCharIndex, delIndex-1);

end; }

{  ********************  Global Node Count *********************************}

{  This function will return the number of entries found in a global at
  the cross-ref and value.  Pass in the root, cross-reference, and value.}

function CheckGlobal(RPCBroker: TRPCBroker; FMNode: string; FMXref: string; FMEntry: string): integer;
var
  rtn: string;
begin
  try
     RPCBroker.RemoteProcedure := 'SC GLOBAL NODE COUNT';
     with RPCBroker.Param[0] do
        begin
           Value       := '.SC';
           Ptype       := list;

           Mult['"ROOT"']  := FMNode;
           Mult['"XREF"']  := FMXref;
           Mult['"VALUE"'] := FMEntry;
        end;

     RPCBroker.Call;
     rtn := RPCBroker.Results[0];
     if rtn <> '' then
        Result := StrToInt(rtn)
     else
        Result := -1;
  except
     on E: Exception do
        begin
           messagedlg(E.ClassName, mtWarning, [mbOk], 0);
           result := -1;
        end;
  end;
end;




{         ***************** Deleter *****************
 This function will delete an entry in a FileMan file
 using ^DIK. If successful, it returns a True, otherwise
 False.
}
function Deleter(RPCBroker: TRPCBroker; FMRoot, FMEntry: String): Boolean;
begin
  try
     RPCBroker.RemoteProcedure := 'SC DELETE ENTRY';
     with RPCBroker.Param[0] do
        begin
           Value      := '.SC';
           Ptype      := list;

           Mult['"ROOT"'] := FMRoot;
           Mult['"IEN"']  := FMEntry;
           RPCBroker.Call;
           Result := (RPCBroker.results[0] = '1');
        end;
  except
     on E: Exception do
        begin
           messagedlg(E.ClassName, mtWarning, [mbOk], 0);
           result := false;
        end;
  end;
end;

{         ***************** FileNumber *****************

 This function accepts a string as input and uses this
 as a lookup value on ^DIC("B") to return the FileMan
 file number corresponding to the string value.

 M code looks like the following: S RETVAL=+$O(^DIC("B",SCNAME,""))

 SCROOT is equal to the FMFileName parameter.
}
function FileNumber(RPCBroker: TRPCBroker; FMFileName: String): String;
begin
  try
     RPCBroker.RemoteProcedure := 'SC FILE NUMBER';
     with RPCBroker.Param[0] do
        begin
           Value  := FMFileName;
           Ptype  := literal;
        end;
     Result := RPCBroker.strCall;
  except
     on E: Exception do
        begin
           messagedlg(E.ClassName, mtWarning, [mbOk], 0);
           result := '';
        end;
  end;
end;

{         ***************** GlobalNode *****************

 This function accepts a string as input and uses this
 to retreive the global node on the M server.

 Examples of input parameter: '^DPT(0)'
                              '^TMP(""TEST"")'

 M code looks like the following: S RETVAL=$G(@SCROOT)

 SCROOT is equal to the MGlobalNode parameter.
}
function GlobalNode(RPCBroker: TRPCBroker; MGlobalNode: String): String;
begin
  try
     RPCBroker.RemoteProcedure := 'SC GLOBAL NODE';
     with RPCBroker.Param[0] do
        begin
           Value  := MGlobalNode;
           Ptype  := literal;
        end;
     RPCBroker.Call;
     Result := RPCBroker.Results[0];
  except
     on E: Exception do
        begin
           messagedlg(E.ClassName, mtWarning, [mbOk], 0);
           result := '';
        end;
  end;

end;


{         ***************** Lockit(locker - PDR) *****************
 This function will lock or unlock a M global node.
 Also, this function allows the calling application
 to specify the timeout (in seconds) for a 'lock'
 operation.
}
function Locker(RPCBroker: TRPCBroker; FMNode: String; LockMode: LockOperation; FMTimeOut: Integer): Boolean;
begin
  try
     RPCBroker.RemoteProcedure := 'SC LOCK/UNLOCK NODE';
     with RPCBroker.Param[0] do
        begin
           Value          := '.SC';
           Ptype          := list;

           Mult['"NODE"']     := FMNode;
           Mult['"LOCKMODE"'] := IntToStr(Ord(LockMode));
           Mult['"TIMEOUT"']  := IntToStr(FMTimeOut);
        end;
     Result := (RPCBroker.strCall = '1');
  except
     on E: Exception do
        begin
           messagedlg(E.ClassName, mtWarning, [mbOk], 0);
           result := false;
        end;
  end;
end;


{Generic window to tell user that functionality is not ready yet.}
procedure NotYet;
begin
  MessageDlg('This functionality is under construction!', mtInformation, [mbOk], 0);
end;
end.
