{*******************************************************}
{                                                       }
{       General Utilities for PCMM                      }
{                                                       }
{       Created: 6/3/95    Update 2/1/96                }
{                                                       }
{       Last updated: 6 May 2001 (J. Peterson)          }
{                                                       }
{*******************************************************}

unit Scut3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, Buttons, Fmcntrls, Fmcmpnts,
  ExtCtrls, Fmlookup, Scutdef, Trpcb, Mfunstr, OvcCal,Scutbrk;

type SaveAction = (Save, Skip, Abort);
type FMModes = (EditEntry, AddEntry, ViewEntry); {PDR 5/27/98}

procedure ShowDropDown(Sender: TObject; key: Word; Shift: TShiftState);
procedure ChangeCalMonth(btn: TObject; cal: TObject);
procedure WaitingList(info:string);
function CheckSave(Filer: TFMFiler): SaveAction;
function FMDateConvert(DString: string): TDateTime;
function StrToFMDate(dts: string): string;
function ValStrToFMDate(dts: string): string;//bp/cmf 204
function MemoryOk: boolean;
function ExtDateToFM(DateIn: string): string;
function FMDateToStr(dt: string): string;
function EntryLengthOk(s : String; min, max : Integer): boolean;
function CheckTeamClosed : boolean;
function CheckTeamMax(cur, max : integer;info :string) : boolean;
function CheckPositionMax(cur, max : integer;info:string) : boolean;
function PCProvider(pos: string): STRING;
procedure ShowCheckStatus(obj : TFMCheckBox);

implementation

uses xwbut1, scut2,pcmm1,mtassign,waitlist,scptpf;

function CheckTeamClosed : boolean;
var
  msg : string;
begin
  msg := 'This team is closed to further patient assignments.' + RETURN +
         'While you are not currently prevented from assigning' + RETURN +
         'this patient, you may want to check before continuing.' + RETURN +
         'Do you wish to assign this patient now?';
  if messagedlg(msg, mtConfirmation, [mbYes,mbNo], 0) = mrYes then
     result := true
  else
     result := false;
end;

function CheckTeamMax(cur, max : integer;INFO:STRING) : boolean;
var
  msg : string;
  SC : STRING;
  DFN: STRING;
begin
  RESULT :=True;
  if not (cur + 1 < max)  then
   begin
   MSG:=  MeansTestInfo(RPCBrokerMain,Piece(info,'^',1)+U+PIECE(INFO,'^',2));
   SC:= Piece(MSG,'^',11);
   DFN:= PIECE(info,'^',1);
   if StrToInt(PIECE(PIECE(MSG,'^',10),';',1))<1 then
   BEGIN
  msg := 'Currently assigned to team: ' + IntToStr(cur) + RETURN +
            '       Maximum set for team: ' + IntToStr(max) + RETURN + RETURN +
            'This assignment will exceed the maximum' + RETURN +
            'set for this team.  ';



    if (PIECE(INFO,'^',1)<>'-') AND (NOT (MAX>CUR)) THEN
    BEGIN
     frmWaitList.lblNotice.Caption := msg;
     frmWaitList.SC := sc;
     frmWaitList.DFN := DFN;
 if frmwaitlist.ShowModal = mrok then BEGIN  ;
   //  if messagedlg(msg, mtConfirmation, [mbYes,mbNo], 0) = mrYes then begin
        INFO:= INFO+ '^^' + frmWaitList.FMEdit1.Text;
        frmWaitList.FMEdit1.Text :='';
        WaitingList(INFO);
        Result := False;
        exit;
        end;
        END;
     END;

   if not (cur + 1 < max) then BEGIN
     msg := 'Currently assigned to team: ' + IntToStr(cur) + RETURN +
            '      Maximum set for team: ' + IntToStr(max) + RETURN + RETURN +
            'This assignment will reach or exceed the maximum' + RETURN +
            'set for this team.  Do you wish to continue with' + RETURN +
            'the assignment?';
     if messagedlg(msg, mtConfirmation, [mbYes,mbNo], 0) = mrYes then
        result := true
     else
        result := false;
     END;
  end
  else
     result := true;
end;

function CheckPositionMax(cur, max : integer;info : string) : boolean;
var
  msg : string;
  SC : STRING;
  DFN: STRING;
begin
 RESULT := True;
  MSG:=  MeansTestInfo(RPCBrokerMain,Piece(info,'^',1)+U+Piece(info,'^',2));
  SC:= PIECE(MSG,'^',11);
  DFN:= PIECE(info,'^',1);
  if not (cur + 1 < max ) then
  if (StrToInt(PIECE(PIECE(MSG,'^',10),';',1)))<2 then
   BEGIN
  msg := 'Currently assigned to Position: ' + IntToStr(cur) + RETURN +
            '       Maximum set for Position: ' + IntToStr(max) + RETURN + RETURN +
            'This assignment will exceed the maximum' + RETURN +
            'set for this position.  ';
  IF (Piece(info,'^',1)<> '-') AND (NOT(MAX>CUR)) THEN
   Begin
  //   if messagedlg(msg, mtConfirmation, [mbYes,mbNo], 0) = mrYes then begin
  frmWaitList.lblNotice.Caption := msg;
  frmWaitList.SC := SC;
  frmWaitList.DFN := DFN;
if frmwaitlist.ShowModal = mrok then BEGIN  ;
   //  if messagedlg(msg, mtConfirmation, [mbYes,mbNo], 0) = mrYes then begin
        INFO:=INFO+'^^'+ frmWaitList.FMEdit1.Text;
        frmWaitList.FMEdit1.Text :='';
        WAITINGLIST(info) ;
        result := false ;
        EXIT
        END;
   END;
   END;

    if not (cur+1  < max ) then BEGIN
     msg := 'Currently assigned to Position: ' + IntToStr(cur) + RETURN +
            '       Maximum set for Position: ' + IntToStr(max) + RETURN + RETURN +
            'This assignment will reach or exceed the maximum' + RETURN +
            'set for this position.  Do you wish to continue' + RETURN +
            'with the assignment?';
     if messagedlg(msg, mtConfirmation, [mbYes,mbNo], 0) = mrYes then
        result := true
     else
        result := false;
     END;

end;

function EntryLengthOk(s : String; min, max : Integer): boolean;
begin
  result := true;
  if Length(s) < min then
     begin
        messagedlg('The field entry must be greater than ' + IntToStr(min) +
                   ' characters!', mtInformation, [mbOk], 0);
        result := false;
     end
  else if Length(s) > max then
     begin
        messagedlg('The field entry must be less than ' + IntToStr(Max) +
                   ' characters!', mtInformation, [mbOk], 0);
        result := false;
     end
end;

{
  If the currently available memory is below the level set by the MEM_AVAIL
  constant, then display a warning message and return a false result.
  Otherwise, return a true result.
}
function MemoryOk: boolean;
var
     MemoryStruct : TMemoryStatus;
     MemoryString : String;
     UserFree: real ;
begin
  result := true;
  GlobalMemoryStatus(MemoryStruct);
  UserFree := (MemoryStruct.dwAvailVirtual/MemoryStruct.dwTotalVirtual) * 100 ;
  if ((MemoryStruct.dwTotalPhys div 1024) < MEM_AVAIL) or (UserFree < 40) then
     result := false;
end;



{
  procedure to open or close the combobox dropdown list.  If the list is open,
  then close it, if it's closed, then open it when the F2 key, or the
  Alt + Up Arrow key combination is pressed.  Close it when the F2 key is
  pressed again or the Alt + Down Arrow key combination is pressed.

  Input:   Sender   - ComboBox,
           key      - Key pressed
           Shift    - shift state.
}
procedure ShowDropDown(Sender: TObject; key: Word; Shift: TShiftState);
var
  ndx, cbStatus: word;
begin
  cbStatus := SendMessage((Sender as TFMComboBox).Handle, CB_GETDROPPEDSTATE, 0,0);

  if ((key = VK_F2) and (cbStatus = 0)) or ((key = VK_UP) and
     (SHift = [ssAlt])) then
     begin
        ndx := SendMessage((Sender as TFMComboBox).Handle, CB_GETCURSEL, 0, 0);
        SendMessage((Sender as TFMComboBox).Handle, CB_SETCURSEL, ndx, 0);
        SendMessage((Sender as TFMComboBox).Handle, CB_SHOWDROPDOWN, 1, 0);
     end;

  if ((key = VK_F2) and (cbStatus = 1)) or ((key = VK_DOWN) and
     (SHift = [ssAlt])) then
     SendMessage((Sender as TFMComboBox).Handle, CB_SHOWDROPDOWN, 0, 0);

  if key = VK_ESCAPE then
     SendMessage((Sender as TFMComboBox).Handle, CB_SHOWDROPDOWN, 0, 0);
end;

{
  Convert date in windows short form to FM format.

     Input:   Date in mm/dd/yyyy format

     Returns: Date in 2951231 format
}
function StrToFMDate(dts: string): string;
var
  century: string ;
begin
  if length(piece(dts,'/',3)) = 2 then
     result := '2' + Piece(dts, '/', 3) + Piece(dts, '/', 1) + Piece(dts, '/', 2)
  else
     begin
       century := inttostr(strtoint(copy(piece(dts,'/',3),1,2))-17)  ;
       result := century + Copy(Piece(dts, '/', 3),3,2) + Piece(dts, '/', 1) + Piece(dts, '/', 2);
     end ;
end;


function ValStrToFMDate(dts: string): string;
//bp/cmf 204; validate date pieces before pass to StrToFMDate
var
i,j: integer;
begin
 result := '';
 for i := 1 to 3 do
  try
   j := StrToInt(piece(dts,'/',i));
  except
   exit;
 end;
 result := StrToFMDate(dts);
end;

function FMDateToStr(dt: string): string;
var
   yy,mm,dd,ce: string[2];
begin
    if dt='' then exit; {pdr 6/1/98}
    ce := IntToStr(StrToInt(Copy(DT,1,1))+17) ;  {century from char 1}
    yy := Copy(DT,2,2);  {year from chars 2-3}
    mm := Copy(DT,4,2);  {month from chars 4-5}
    dd := Copy(DT,6,2);  {day from chars 6-7}
    Result := mm + '/' + dd + '/' + ce + yy;
    {Result := mm + '/' + dd + '/' + yy;}
end;   {end function FromFMDateTime}


{
  function converts a date in FileMan internal format into a Delphi Time/Date
  field.

     Input: Date in FileMan internal format (2951205)

     Return:  TDateTime object
}
function FMDateConvert(DString: string): TDateTime;
var
  mm,dd,yy,ce:Integer;
begin
  ce := (StrToInt(Copy(DString,1,1))+17) * 100 ;
  yy := StrToInt(Copy(DString,2,2));
  mm := StrToInt(Copy(DString,4,2));
  dd := StrToInt(Copy(DString,6,2));
  result := EncodeDate(ce + yy, mm, dd)
end;

function ExtDateToFM(DateIn: string): string;     {MMM DD, YYYY --> CYYMMDD}
var
  mmm, dd, yyyy: string[10];
  i: integer;
  date: TDateTime;
begin
  mmm := Uppercase(Piece(DateIn, ' ', 1));
  dd := Piece(DateIn, ' ', 2);
  dd := Piece(dd, ',', 1);
  yyyy := Piece(DateIn, ' ', 3);

  for i := 1 to 12 do
     if (Piece(Month,'^', i) = mmm) then break;
  {PDR 6/1/98 - added check for existence of yyyy and dd, setting result to
   nill if either value is nill}
  if (yyyy <> '') and (dd <> '') then
   begin
    date := EncodeDate(StrToInt(yyyy), i, StrToInt(dd));
    result := StrToFMDate(FormatDateTime('mm/dd/yyyy', Date));
   end
  else
   result:='';
end;




 {
  Check to see if there are any changes to the Team Profile.  If there are,
  display confirmation dialog box with Yes, No, Cancel.  If yes selected,
  save the changes and continue, if No, then do not save changes and contiue,
  if cancel then return to form.  This utility assumes that the Save
  speedbutton on the MDI parent is active and has the appropriate OnClick
  event attached.

     Input:  Filer  - name of the Filer component to be checked (TFMFiler)

     Return: Type SaveAction, either Save, Skip, or Abort
 }
function CheckSave(Filer: TFMFiler): SaveAction;
var
  msg: string;
  rtn: integer;
begin
  if Filer.AnythingtoFile{Status = Edited - PDR} then
     begin
        msg := 'You have not saved your current changes!' +
              RETURN + 'Do you want to save them now?';
        rtn := messagedlg(msg, mtConfirmation, [mbYes,mbNo,mbAbort], 0);

        if rtn = mrYes then
           result := Save
        else if rtn = mrNo then
           result := Skip
        else
           result := Abort;
     end
  else
     result := Skip;
end;

procedure ChangeCalMonth(btn: TObject; cal: TObject);
begin
  with (btn as TSpeedButton) do
    begin
      if Name = 'cmdNextMonth' then
        (Cal as TOvcCalendar).IncMonth(1)
      else
        (Cal as TOvcCalendar).IncMonth(-1);
    end;
end;

procedure ShowCheckStatus(obj : TFMCheckBox);
var
  s: string;
begin
  s := obj.Caption + RETURN + RETURN;
  if obj.FMtag then
     s := s + '  FMtag:    True'
  else
     s := s + '  FMtag:    False';
  s := s + RETURN;
  if obj.Checked then
     s := s + '  Checked:  True'
  else
     s := s + '  Checked:  False';
  s := s + RETURN;
  if obj.FMModified then
     s := s + '  Modified: True'
  else
     s := s + '  Modified: False';
  s := s + RETURN + '  FMInternal:  ' + obj.FMCtrlInternal{FMInternal - PDR};
  messagedlgpos(s, mtInformation, [mbOk], 0, 20,20);
end;

procedure WaitingList(INFO:STRING);
begin
  //place patient on waiting list
  with  frmMain.RPCBroker1 do
   begin
     with Param[0] do
      begin
       Value := '.SC';
       Ptype := list;
       Mult['"TEAM"'] := Piece(INFO,'^',2);
       Mult['"POSITION"']    := Piece(INFO,'^',3);
       Mult['"DFN"'] := Piece(INFO,'^',1);
       Mult['"COMMENT"'] := Piece(INFO,'^',4);
      // if frmWaitList.rbYes.Checked then Mult['"SC"']:='Y';
      // IF frmWaitList.rbNo.Checked then Mult['"SC"']:='N';

      end;
    RemoteProcedure := 'SCMC WAIT LIST ENTRY';
    call;
    frmMain.StatusMsg('Placed on Waiting List',False);
    PatientAsgn.getTEAMS;
   // s := results[0];
   end;
end;

function PCProvider(pos: string): STRING;
begin
with  frmMain.RPCBroker1 do
   begin
     with Param[0] do
      begin
       Value := pos;
       Ptype := LITERAL;
      END;
       RemoteProcedure := 'SC PC PROVIDER';
    call;
   result := RESULTS[0]
  END;
end;
    



end.
